// package cn.zgfxrc.boot.common.config.base;
//
// import cn.zgfxrc.boot.common.core.entity.base.BaseModel;
// import cn.zgfxrc.boot.common.core.entity.interfaces.AddGroup;
// import cn.zgfxrc.boot.common.core.entity.interfaces.DelGroup;
// import cn.zgfxrc.boot.common.core.entity.interfaces.EditGroup;
// import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
// import com.baomidou.mybatisplus.core.mapper.BaseMapper;
// import com.baomidou.mybatisplus.core.metadata.IPage;
// import com.baomidou.mybatisplus.core.toolkit.Wrappers;
// import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
// import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
// import com.seepine.secret.annotation.Log;
// import com.seepine.secret.annotation.Permission;
// import com.seepine.wrap.WrapException;
// import io.swagger.annotations.ApiOperation;
// import io.swagger.annotations.ApiParam;
// import org.springframework.beans.factory.annotation.Autowired;
// import org.springframework.lang.Nullable;
// import org.springframework.validation.annotation.Validated;
// import org.springframework.web.bind.annotation.PostMapping;
// import org.springframework.web.bind.annotation.RequestBody;
//
// import java.util.List;
//
/// **
// * 包含基础crud接口 若有权限需要一定重写方法并加上鉴权
// *
// * @author huanghs
// */
// public class BaseController<
//    S extends ServiceImpl<M, T>, M extends BaseMapper<T>, T extends BaseModel<T>> {
//  @Autowired(required = false)
//  protected S service;
//
//  /**
//   * 分页查询
//   *
//   * @param page 分页对象
//   * @param entity 实体类
//   * @return IPage
//   */
//  @ApiOperation("获取分页")
//  @PostMapping("page")
//  @Permission("view")
//  public IPage<T> page(Page<T> page, @RequestBody T entity) {
//    LambdaQueryWrapper<T> wrapper = Wrappers.lambdaQuery(entity);
//    return service.page(page, wrapper);
//  }
//
//  /**
//   * 分页查询
//   *
//   * @param entity 实体类
//   * @return List
//   */
//  @ApiOperation("获取数组")
//  @PostMapping("list")
//  @Permission("view")
//  public List<T> list(@RequestBody @Nullable T entity) {
//    LambdaQueryWrapper<T> wrapper = Wrappers.lambdaQuery(entity);
//    return service.list(wrapper);
//  }
//
//  /**
//   * 新增
//   *
//   * @param entity 实体类
//   */
//  @Log("新增")
//  @ApiOperation("新增")
//  @PostMapping("add")
//  @Permission("add")
//  public void save(@RequestBody @Validated(AddGroup.class) T entity) {
//    if (!service.save(entity)) {
//      throw new WrapException("保存失败");
//    }
//  }
//
//  /**
//   * 修改
//   *
//   * @param entity 实体类
//   */
//  @Log("修改")
//  @ApiOperation("修改")
//  @PostMapping("edit")
//  @Permission("edit")
//  public void updateById(@RequestBody @Validated(EditGroup.class) T entity) {
//    if (!service.updateById(entity)) {
//      throw new WrapException("修改失败");
//    }
//  }
//
//  /**
//   * 通过id删除
//   *
//   * @param entity 实体类
//   */
//  @Log("删除")
//  @ApiOperation("根据id删除")
//  @PostMapping("del")
//  @Permission("del")
//  public void removeById(@ApiParam("主键") @RequestBody @Validated(DelGroup.class) T entity) {
//    if (!service.removeById(entity.getId())) {
//      throw new WrapException("删除失败");
//    }
//  }
// }
