package cn.zgfxrc.boot.common.config.thread;

import com.alibaba.ttl.threadpool.TtlExecutors;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ForkJoinPool;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @author huanghs
 * @date 2022.4.12
 */
@Configuration
public class ExecutorConfigurer {

  @Bean
  public ExecutorService executorService() {
    return TtlExecutors.getTtlExecutorService(
        new ForkJoinPool(
            Math.max(Runtime.getRuntime().availableProcessors() - 4, 4),
            ForkJoinPool.defaultForkJoinWorkerThreadFactory,
            null,
            true));
  }
}
