package cn.zgfxrc.boot.common.config.thread;

import cn.hutool.core.thread.ThreadUtil;
import com.alibaba.ttl.threadpool.TtlExecutors;
import java.util.concurrent.ScheduledThreadPoolExecutor;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.SchedulingConfigurer;
import org.springframework.scheduling.config.ScheduledTaskRegistrar;

/**
 * @author huanghs
 * @date 2022.4.12
 */
@Configuration
public class MySchedulingConfigurer implements SchedulingConfigurer {

  @Override
  public void configureTasks(ScheduledTaskRegistrar taskRegistrar) {
    ScheduledThreadPoolExecutor executorService =
        new ScheduledThreadPoolExecutor(
            Math.max(Runtime.getRuntime().availableProcessors() - 4, 4),
            ThreadUtil.newNamedThreadFactory("schedule-", true));
    taskRegistrar.setScheduler(TtlExecutors.getTtlScheduledExecutorService(executorService));
  }
}
