package cn.zgfxrc.boot.common.core.entity.base;

import cn.zgfxrc.boot.common.core.entity.interfaces.DelGroup;
import cn.zgfxrc.boot.common.core.entity.interfaces.EditGroup;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotNull;
import java.time.LocalDateTime;

/**
 * BaseModel
 *
 * @author huanghs@zgfxrc.cn
 * @date 2021.11.1
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class BaseModel<T extends Model<?>> extends Model<T> {
  private static final long serialVersionUID = 1L;

  @TableId(type = IdType.ASSIGN_ID)
  @ApiModelProperty("主键")
  @NotNull(
      message = "主键id不能为空",
      groups = {EditGroup.class, DelGroup.class})
  private Long id;

  @TableLogic
  @TableField(fill = FieldFill.INSERT)
  @ApiModelProperty("是否删除")
  private Boolean isDelete;

  @TableField(fill = FieldFill.INSERT)
  @ApiModelProperty("创建时间")
  private LocalDateTime createTime;

  @TableField(fill = FieldFill.INSERT)
  @ApiModelProperty("创建者id")
  private Long createId;

  @TableField(fill = FieldFill.INSERT)
  @ApiModelProperty("创建者名称")
  private String createName;

  @TableField(fill = FieldFill.UPDATE)
  @ApiModelProperty("更新时间")
  private LocalDateTime updateTime;

  @TableField(fill = FieldFill.UPDATE)
  @ApiModelProperty("更新者id")
  private Long updateId;

  @TableField(fill = FieldFill.UPDATE)
  @ApiModelProperty("更新者名称")
  private String updateName;
}
