package cn.zgfxrc.boot.common.core.entity.base;

import cn.zgfxrc.boot.common.core.entity.interfaces.DragGroup;
import cn.zgfxrc.boot.common.core.enums.DropPosition;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * 拖拽用
 *
 * @author huanghs
 * @date 2022.12.2
 */
@Data
public class DragModel implements Serializable {
  private static final long serialVersionUID = 1L;

  @NotNull(message = "拖拽对象id不能为空", groups = DragGroup.class)
  @ApiModelProperty("拖拽对象id")
  Long dragId;

  @NotNull(message = "释放对象id不能为空", groups = DragGroup.class)
  @ApiModelProperty("释放对象id")
  Long dropId;

  @NotNull(message = "释放位置不能为空", groups = DragGroup.class)
  @ApiModelProperty("释放位置")
  DropPosition dropPosition;
}
