package cn.zgfxrc.boot.common.core.entity.base;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.Serial;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import lombok.Data;

/**
 * @author huanghs
 * @date 2021.4.8
 */
@Data
@ApiModel(value = "树形节点")
public class TreeNode<T> implements Serializable {

  @Serial private static final long serialVersionUID = 1L;

  @ApiModelProperty(value = "当前节点id")
  protected Long id;

  @ApiModelProperty(value = "名称")
  protected String name;

  @ApiModelProperty(value = "父节点id")
  protected Long parentId;

  @ApiModelProperty(value = "是否可拖拽")
  protected Boolean draggable;

  @ApiModelProperty("是否显示复选框")
  protected Boolean checkable;

  @ApiModelProperty("排序值")
  protected Integer sort;

  @ApiModelProperty(value = "子节点列表")
  protected List<T> children = new ArrayList<>();

  public void add(T node) {
    children.add(node);
  }
}
