package cn.zgfxrc.boot.common.core.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;

/**
 * 活动状态(账号或租户)
 *
 * @author huanghs@zgfxrc.cn
 * @date 2022.12.13
 */
@AllArgsConstructor
public enum ActiveStatus implements IEnum<String> {
  /** 拖拽类型 */
  NOT_ACTIVE("not_active", "未激活"),
  NORMAL("normal", "正常"),
  SUSPEND("suspend", "已停用");

  private final String value;
  private final String label;

  @Override
  public String getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return value;
  }

  @JsonCreator
  static ActiveStatus jsonCreator(Object data) {
    String str = data.toString();
    for (ActiveStatus item : ActiveStatus.values()) {
      if (item.getValue().equals(str) || item.name().equals(str)) {
        return item;
      }
    }
    return null;
  }
}
