package cn.zgfxrc.boot.common.core.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;

@AllArgsConstructor
public enum DistrictType implements IEnum<String> {
  /** 省份 */
  PROVINCE("province"),
  /** 市区 */
  CITY("city"),
  /** 区县 */
  DISTRICT("district");

  private final String value;

  @Override
  public String getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return value;
  }

  @JsonCreator
  static DistrictType jsonCreator(Object data) {
    String str = data.toString();
    for (DistrictType item : DistrictType.values()) {
      if (item.getValue().equals(str) || item.name().equals(str)) {
        return item;
      }
    }
    return null;
  }
}
