package cn.zgfxrc.boot.common.core.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2021.11.1
 */
@AllArgsConstructor
public enum Gender implements IEnum<String> {
  /** 性别 */
  UNKNOWN("unknown", "未知"),
  MALE("male", "男"),
  FEMALE("female", "女");

  private final String value;
  private final String label;

  @Override
  public String getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return value;
  }

  @JsonCreator
  static Gender jsonCreator(Object data) {
    String str = data.toString();
    for (Gender item : Gender.values()) {
      if (item.getValue().equals(str) || item.name().equals(str)) {
        return item;
      }
    }
    return null;
  }
}
