package cn.zgfxrc.boot.common.core.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import lombok.AllArgsConstructor;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2021.11.2
 */
@AllArgsConstructor
public enum MenuType implements IEnum<String> {
  /** 菜单类型 */
  MENU("menu"),
  BUTTON("button");

  @JsonValue public final String value;

  @Override
  public String getValue() {
    return this.value;
  }

  @JsonCreator
  static MenuType jsonCreator(Object data) {
    for (MenuType item : MenuType.values()) {
      if (item.getValue().equals(data.toString())) {
        return item;
      }
    }
    return null;
  }
}
