package cn.zgfxrc.boot.common.core.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import lombok.AllArgsConstructor;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2022.3.24
 */
@AllArgsConstructor
public enum PlatformType implements IEnum<String> {
  /** 平台类型:平台端/园区端/企业端 */
  SYS("sys", "平台端", 0L),
  ENTERPRISE("enterprise", "企业端", 1L),
  MEMBER("member", "会员端", 2L);
  @JsonValue public final String value;
  public final String label;
  public final Long id;

  @Override
  public String getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return this.name();
  }

  @JsonCreator
  static PlatformType jsonCreator(Object data) {
    return from(data);
  }

  public static PlatformType from(Object data) {
    for (PlatformType item : PlatformType.values()) {
      if (data instanceof PlatformType) {
        if (item.equals(data)) {
          return item;
        }
      } else if (data instanceof Long) {
        if (item.id.equals(data)) {
          return item;
        }
      } else {
        if (item.name().equals(data) || item.getValue().equals(data)) {
          return item;
        }
      }
    }
    return null;
  }

  /**
   * 是否相等
   *
   * @param data 值，可以是value字符串，也可以是label，也可以是name
   * @return 是否相等
   */
  public boolean eq(Object data) {
    return this.equals(from(data));
  }
}
