package cn.zgfxrc.boot.common.core.util;

import cn.zgfxrc.boot.common.core.entity.base.TreeNode;
import com.seepine.tool.util.Trees;
import java.util.List;
import lombok.experimental.UtilityClass;

/**
 * @author huanghs
 * @date 2021.4.8
 */
@UtilityClass
public class TreeUtil {
  public <T extends TreeNode<T>> List<T> build(List<T> treeNodes) {
    return build(treeNodes, 0L);
  }
  /**
   * 两层循环实现建树
   *
   * @param treeNodes 传入的树节点列表
   * @return List
   */
  public <T extends TreeNode<T>> List<T> build(List<T> treeNodes, Object rootId) {
    return Trees.build(treeNodes, T::getId, T::getParentId, rootId, T::getSort, T::setChildren);
  }
}
