package cn.zgfxrc.boot.common.feign;

import feign.Response;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author huanghs
 * @date 2022.7.1
 */
public class FeignUtil {
  /**
   * feign获取byteOutputStream
   *
   * @param response feignResponse
   * @return ByteArrayOutputStream
   * @throws IOException e
   */
  public static ByteArrayOutputStream getOutputStream(Response response) throws IOException {
    ByteArrayOutputStream os = new ByteArrayOutputStream();
    getOutputStream(response, os);
    return os;
  }

  /**
   * feign获取byteOutputStream
   *
   * @param response feignResponse
   * @param os 输出流
   * @throws IOException e
   */
  public static void getOutputStream(Response response, OutputStream os) throws IOException {
    Response.Body body = response.body();
    InputStream inputStream = body.asInputStream();
    byte[] c = new byte[8096];
    int length;
    while ((length = inputStream.read(c)) > 0) {
      os.write(c, 0, length);
    }
  }
}
