package cn.zgfxrc.boot.common.feign;

import feign.codec.Encoder;
import feign.form.spring.SpringFormEncoder;
import org.springframework.beans.factory.ObjectFactory;
import org.springframework.boot.autoconfigure.http.HttpMessageConverters;
import org.springframework.cloud.openfeign.support.SpringEncoder;
import org.springframework.context.annotation.Bean;

/**
 * 关键内部类，此处制定了注入的feignFormEncoder可以覆盖掉原本的encoder 该方式可以让发送multipartFile成为可能
 *
 * @author huanghs
 */
public class MultipartSupportConfig {
  private final ObjectFactory<HttpMessageConverters> messageConverters;

  public MultipartSupportConfig(ObjectFactory<HttpMessageConverters> messageConverters) {
    this.messageConverters = messageConverters;
  }

  @Bean
  public Encoder feignFormEncoder() {
    return new SpringFormEncoder(new SpringEncoder(messageConverters));
  }
}
