package cn.zgfxrc.boot.common.mybatis.converter;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Locale;
import org.springframework.core.convert.converter.Converter;

/**
 * @author seepins
 */
public class LocalDateTimeConverter {
  public static final String NORM_DATETIME_PATTERN = "yyyy-MM-dd HH:mm:ss";
  public static final String NORM_DATE_PATTERN = "yyyy-MM-dd";
  public static final String NORM_TIME_PATTERN = "HH:mm:ss";

  public static class StringToLocalDateTimeConverter implements Converter<String, LocalDateTime> {
    @Override
    public LocalDateTime convert(String s) {
      DateTimeFormatter formatter =
          DateTimeFormatter.ofPattern(NORM_DATETIME_PATTERN, Locale.CHINESE);
      return LocalDateTime.parse(s, formatter);
    }
  }

  public static class StringToLocalDateConverter implements Converter<String, LocalDate> {
    @Override
    public LocalDate convert(String s) {
      DateTimeFormatter formatter = DateTimeFormatter.ofPattern(NORM_DATE_PATTERN, Locale.CHINESE);
      return LocalDate.parse(s, formatter);
    }
  }
}
