package cn.zgfxrc.boot.common.mybatis.tenant;

import cn.zgfxrc.boot.common.core.util.TenantUtil;
import cn.zgfxrc.boot.common.mybatis.properties.TenantProperties;
import com.baomidou.mybatisplus.extension.plugins.handler.TenantLineHandler;
import net.sf.jsqlparser.expression.Expression;
import net.sf.jsqlparser.expression.StringValue;

/**
 * @author seepine
 */
public class TenantHandler implements TenantLineHandler {
  TenantProperties tenantProperties;

  public TenantHandler(TenantProperties tenantProperties) {
    this.tenantProperties = tenantProperties;
  }

  @Override
  public Expression getTenantId() {
    String tenantId = TenantUtil.getTenantId();
    if (tenantId == null) {
      throw new IllegalArgumentException("租户id为空");
    }
    return new StringValue(tenantId);
  }

  @Override
  public boolean ignoreTable(String tableName) {
    return !TenantUtil.getTables().contains(tableName);
  }

  @Override
  public String getTenantIdColumn() {
    return tenantProperties.getDbField();
  }
}
