package cn.zgfxrc.boot.common.mybatis.tenant.interceptor.config;

import cn.zgfxrc.boot.common.mybatis.properties.TenantProperties;
import cn.zgfxrc.boot.common.mybatis.tenant.interceptor.TenantFilterService;
import cn.zgfxrc.boot.common.mybatis.tenant.interceptor.TenantHandlerInterceptor;
import javax.annotation.Resource;
import org.springframework.boot.autoconfigure.AutoConfigureAfter;
import org.springframework.context.annotation.Configuration;
import org.springframework.lang.NonNull;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @author seepine
 * @since 0.1.0
 */
@Configuration
@AutoConfigureAfter(TenantServiceConfiguration.class)
public class TenantInterceptorConfiguration implements WebMvcConfigurer {
  @Resource private TenantProperties tenantProperties;
  @Resource private TenantFilterService tenantFilterService;

  @Override
  public void addInterceptors(@NonNull InterceptorRegistry registry) {
    if (tenantProperties.getEnabled()) {
      registry
          .addInterceptor(new TenantHandlerInterceptor(tenantFilterService))
          .addPathPatterns("/**")
          .excludePathPatterns("/error")
          .order(tenantProperties.getTenantInterceptorOrder());
    }
  }
}
