package cn.zgfxrc.boot.upms.api.entity;

import cn.zgfxrc.boot.common.core.enums.DistrictType;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2023.8.7
 */
@Data
@ApiModel("地区表")
@EqualsAndHashCode(callSuper = true)
public class SysDistrict extends Model<SysDistrict> {
  @TableId(type = IdType.INPUT)
  @ApiModelProperty("邮政编码")
  String id;

  @ApiModelProperty("省/市/区")
  DistrictType type;

  @ApiModelProperty("名称")
  String name;

  @ApiModelProperty("简称")
  String shortName;

  @ApiModelProperty("拼音，检索用")
  String[] pinyin;

  @ApiModelProperty("经度")
  BigDecimal longitude;

  @ApiModelProperty("纬度")
  BigDecimal latitude;

  @ApiModelProperty("父邮政编码")
  String parentId;
}
