package cn.zgfxrc.boot.upms.api.entity;

import cn.zgfxrc.boot.common.core.entity.base.BaseModel;
import cn.zgfxrc.boot.common.core.enums.PlatformType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDate;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2021.11.2
 */
@Data
@ApiModel("租户")
@EqualsAndHashCode(callSuper = true)
public class SysTenant extends BaseModel<SysTenant> {
  @ApiModelProperty("名称")
  String name;

  @ApiModelProperty("简称")
  String shortName;

  @ApiModelProperty("租户logo")
  String logo;

  @ApiModelProperty("平台类型")
  PlatformType platformType;

  @ApiModelProperty("套餐ids")
  Long[] packageIds;

  @ApiModelProperty("是否系统内置")
  Boolean isSystem;

  @ApiModelProperty("是否锁定")
  Boolean isLock;

  @ApiModelProperty("到期时间")
  LocalDate expirationDate;

  @ApiModelProperty("活跃用户数限制(0表示不限制)")
  Integer activeUserNumberLimit;

  @ApiModelProperty("父id")
  Long parentId;
}
