package cn.zgfxrc.boot.upms.api.entity.res;

import cn.zgfxrc.boot.common.core.entity.base.TreeNode;
import cn.zgfxrc.boot.common.core.enums.MenuType;
import cn.zgfxrc.boot.common.core.enums.PlatformType;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2021.11.3
 */
@EqualsAndHashCode(callSuper = true)
@Data
public class SysMenuTreeNode extends TreeNode<SysMenuTreeNode> {
  @ApiModelProperty("菜单路径")
  String path;

  @ApiModelProperty("菜单图标")
  String icon;

  @ApiModelProperty("是否路由缓冲")
  Boolean isKeepAlive;

  @ApiModelProperty("是否禁用")
  Boolean disabled;

  @ApiModelProperty("是否禁用选择")
  Boolean disableCheckbox;

  @ApiModelProperty("菜单类型")
  MenuType menuType;

  @ApiModelProperty("按钮权限值")
  String permission;

  @ApiModelProperty("平台类型")
  PlatformType platformType;
}
