package cn.zgfxrc.boot.upms.api.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;
import org.springframework.lang.NonNull;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2022.12.2
 */
@AllArgsConstructor
public enum DictType implements IEnum<String> {
  /** 仅平台端可配置，作用于所有租户，例如存放性别等 */
  GLOBAL("global", "全局字典"),
  /** 仅平台端可配置，租户创建时初始化会取值作为普通字典 */
  DEFAULT("default", "默认字典，租户创建时会初始化，字典不可删，但字典内容可删除"),
/* （暂未用到，因为普通租户不允许自己增加字典）普通字典，无法增删，但字典内容可自由删减 */
//  NORMAL("normal", "普通字典，作用于创建")
;

  public final String value;
  public final String label;

  @Override
  public String getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return value;
  }

  @JsonCreator
  static DictType jsonCreator(@NonNull Object data) {
    String str = data.toString();
    for (DictType item : DictType.values()) {
      if (item.getValue().equals(str) || item.name().equals(str)) {
        return item;
      }
    }
    return null;
  }
}
