package cn.zgfxrc.boot.upms.api.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;
import org.springframework.lang.NonNull;

/**
 * @author huanghs@zgfxrc.cn
 */
@AllArgsConstructor
public enum GroupVisibleScope implements IEnum<String> {
  /** 候选人状态状态 */
  PUBLIC("public", "所有人可见"),
  INNER("inner", "仅组内成员可见");

  public final String value;
  public final String label;

  @Override
  public String getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return value;
  }

  @JsonCreator
  static GroupVisibleScope jsonCreator(@NonNull Object data) {
    String str = data.toString();
    for (GroupVisibleScope item : GroupVisibleScope.values()) {
      if (item.getValue().equals(str) || item.name().equals(str)) {
        return item;
      }
    }
    return null;
  }
}
