package cn.zgfxrc.boot.upms.api.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;
import org.springframework.lang.NonNull;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2022.12.2
 */
@AllArgsConstructor
public enum PositionType implements IEnum<String> {
  /** 候选人状态状态 */
  PRIMARY("primary", "主要职位"),
  SECONDARY("secondary", "次要职位");

  public final String value;
  public final String label;

  @Override
  public String getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return value;
  }

  @JsonCreator
  static PositionType jsonCreator(@NonNull Object data) {
    String str = data.toString();
    for (PositionType item : PositionType.values()) {
      if (item.getValue().equals(str) || item.name().equals(str)) {
        return item;
      }
    }
    return null;
  }
}
