package cn.zgfxrc.boot.upms.api.feign;

import cn.zgfxrc.boot.upms.api.dto.NotifyDto;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;

/**
 * upmsTenantFeign
 *
 * @author huanghs
 */
@FeignClient(name = "upms-notify", url = "http://127.0.0.1:${server.port}/sys/notify/feign")
public interface RemoteNotifyService {
  /**
   * 发送消息通知
   *
   * @see cn.zgfxrc.boot.upms.biz.feign.SysNotifyFeignController#send
   * @param notifyDto {type,to,title,content}
   * @return true/false
   */
  @PostMapping("send")
  Boolean send(NotifyDto notifyDto);
}
