package cn.zgfxrc.boot.upms.biz.controller;

import cn.zgfxrc.boot.common.core.enums.PlatformType;
import cn.zgfxrc.boot.upms.api.entity.SysTenant;
import cn.zgfxrc.boot.upms.api.entity.req.SysTenantReq;
import cn.zgfxrc.boot.upms.api.entity.res.SysTenantRes;
import cn.zgfxrc.boot.upms.biz.service.SysTenantService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.seepine.secret.annotation.Log;
import com.seepine.secret.annotation.Permission;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2022.3.28
 */
@RestController
@Api(tags = "租户管理")
@RequestMapping("sys/tenant")
@AllArgsConstructor
public class SysTenantController {
  private final SysTenantService sysTenantService;

  @ApiOperation("获取租户分页")
  @PostMapping("page/res")
  @Permission("sys_tenant_view")
  public IPage<SysTenantRes> getPageRes(Page<SysTenant> page, @RequestBody SysTenant entity) {
    return sysTenantService.getPageRes(page, entity);
  }

  @ApiOperation("新增租户")
  @PostMapping("add")
  @Permission("sys_tenant_add")
  @Log(module = "upms", title = "新增租户")
  public void addEnterprise(@RequestBody SysTenantReq entity) {
    sysTenantService.add(entity, PlatformType.ENTERPRISE);
  }

  @ApiOperation("删除租户")
  @PostMapping("{id}")
  @Permission("sys_tenant_del")
  @Log(module = "upms", title = "删除租户")
  public void delEnterprise(@PathVariable Long id) {
    sysTenantService.removeById(id);
  }

  @ApiOperation("编辑租户")
  @PostMapping("edit")
  @Permission("sys_tenant_edit")
  @Log(module = "upms", title = "编辑租户")
  public void editEnterprise(@RequestBody SysTenantReq entity) {
    sysTenantService.updateById(entity);
  }
}
