package cn.zgfxrc.boot.upms.biz.mapper;

import cn.zgfxrc.boot.common.mybatis.base.MpBaseMapper;
import cn.zgfxrc.boot.upms.api.entity.SysPackageMenu;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.seepine.tool.util.ListUtil;
import com.seepine.tool.util.Objects;
import java.util.ArrayList;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;

/**
 * @author huanghs@zgafxrc.cn
 * @date 2021.11.2
 */
@Mapper
public interface SysPackageMenuMapper extends MpBaseMapper<SysPackageMenu> {
  /**
   * 通过packageId获取所关联的菜单id
   *
   * @param packageId packageId
   * @return menuIds
   */
  default List<Long> getMenuIds(Long packageId) {
    return ListUtil.map(
        selectList(
            Wrappers.<SysPackageMenu>lambdaQuery().eq(SysPackageMenu::getPackageId, packageId)),
        SysPackageMenu::getMenuId);
  }
  /**
   * 通过packageIds获取所关联的菜单id
   *
   * @param packageIds packageIds
   * @return menuIds
   * @date 2022.3.11 huanghs
   */
  default List<Long> getMenuIds(List<Long> packageIds) {
    if (Objects.isEmpty(packageIds)) {
      return new ArrayList<>();
    }
    return ListUtil.map(
        selectList(
            Wrappers.<SysPackageMenu>lambdaQuery().in(SysPackageMenu::getPackageId, packageIds)),
        SysPackageMenu::getMenuId);
  }
}
