package cn.zgfxrc.boot.upms.biz.util;

import cn.hutool.crypto.Mode;
import cn.hutool.crypto.Padding;
import cn.hutool.crypto.symmetric.AES;
import lombok.experimental.UtilityClass;

import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

/**
 * 密码加密专用
 *
 * @author huanghs
 * @date 2021.11.11
 */
@UtilityClass
public class SecureUtil extends cn.hutool.crypto.SecureUtil {
  private static final String KEY_ALGORITHM = "AES";

  /** !!! 不可修改 */
  private static final String SECRET_KEY = "hcmhcm@edpedpedp";
  /** !!! 不可修改 */
  private static final String SECRET_IV = "edpedp@hcmhcmhcm";

  public static final AES AES_CBC =
      new AES(
          Mode.CBC,
          Padding.PKCS5Padding,
          new SecretKeySpec(SECRET_KEY.getBytes(), KEY_ALGORITHM),
          new IvParameterSpec(SECRET_IV.getBytes()));

  /**
   * aes 加密
   *
   * @param str 明文
   * @return 密文
   */
  public String encodeAes(String str) {
    return AES_CBC.encryptHex(str);
  }

  /**
   * aes 解密
   *
   * @param secret 密文
   * @return 明文
   */
  public String decodeAes(String secret) {
    return AES_CBC.decryptStr(secret);
  }

  /**
   * 不可逆加密，先md5加密，再sha256
   *
   * @param originPassword 原明文密码
   * @return 加密后密码
   */
  public String encrypt(String originPassword) {
    return cn.hutool.crypto.SecureUtil.sha256(cn.hutool.crypto.SecureUtil.md5(originPassword));
  }
}
