/*
 Navicat Premium Data Transfer

 Source Server         : localhost_3306
 Source Server Type    : MySQL
 Source Server Version : 80100 (8.1.0)
 Source Host           : 127.0.0.1:3306
 Source Schema         : fxboot

 Target Server Type    : MySQL
 Target Server Version : 80100 (8.1.0)
 File Encoding         : 65001

 Date: 16/11/2023 10:31:53
*/

SET NAMES utf8mb4;
SET
FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for recruit_resume
-- ----------------------------
DROP TABLE IF EXISTS `recruit_resume`;
CREATE TABLE `recruit_resume`
(
  `id`            bigint                                                        NOT NULL COMMENT '主键',
  `create_time`   datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`     bigint                                                        NOT NULL COMMENT '创建人',
  `create_name`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time`   datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`     bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`     tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`     bigint                                                        NOT NULL COMMENT '租户id',
  `full_name`     varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '姓名',
  `files`         text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci COMMENT '附件',
  `resume_source` varchar(100) COLLATE utf8mb4_general_ci                       NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- ----------------------------
-- Records of recruit_resume
-- ----------------------------
BEGIN;
INSERT INTO `recruit_resume` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`,
                              `update_name`, `is_delete`, `tenant_id`, `full_name`, `files`, `resume_source`)
VALUES (114818208474595333, '2023-08-10 10:46:18', 384098815189061, '库克', NULL, NULL, NULL, 0, 384098814992453,
        '张三丰', NULL, 'boss');
INSERT INTO `recruit_resume` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`,
                              `update_name`, `is_delete`, `tenant_id`, `full_name`, `files`, `resume_source`)
VALUES (123695769418989573, '2023-11-16 10:31:20', 123695733730705413, '库克', NULL, NULL, NULL, 0, 123695733642625029,
        '张三丰', NULL, 'boss');
COMMIT;

-- ----------------------------
-- Table structure for sys_dept
-- ----------------------------
DROP TABLE IF EXISTS `sys_dept`;
CREATE TABLE `sys_dept`
(
  `id`          bigint                                                        NOT NULL COMMENT '主键',
  `create_time` datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`   bigint                                                        NOT NULL COMMENT '创建人',
  `create_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time` datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`   bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`   tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`   bigint                                                        NOT NULL COMMENT '租户id',
  `name`        varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '名称',
  `sort`        int                                                           NOT NULL COMMENT '排序值默认0',
  `parent_id`   bigint                                                        NOT NULL COMMENT '父id,默认0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- ----------------------------
-- Records of sys_dept
-- ----------------------------
BEGIN;
INSERT INTO `sys_dept` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `name`, `sort`, `parent_id`)
VALUES (123621492771520517, '2023-11-15 14:50:45', 384098815180000, '平台管理员', '2023-11-15 16:12:28',
        384098815180000, '平台管理员', 0, 0, '研发部', 0, 0);
COMMIT;

-- ----------------------------
-- Table structure for sys_dept_user
-- ----------------------------
DROP TABLE IF EXISTS `sys_dept_user`;
CREATE TABLE `sys_dept_user`
(
  `id`          bigint                                                    NOT NULL COMMENT '主键',
  `create_time` datetime                                                      DEFAULT NULL COMMENT '创建时间',
  `create_id`   bigint                                                        DEFAULT NULL COMMENT '创建人',
  `create_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '创建人名称',
  `update_time` datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`   bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`   tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`   bigint                                                    NOT NULL COMMENT '租户id',
  `dept_id`     bigint                                                    NOT NULL COMMENT '部门id',
  `user_id`     bigint                                                    NOT NULL COMMENT '用户id',
  `type`        char(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '类型(member,charge)',
  PRIMARY KEY (`dept_id`, `user_id`, `type`, `id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- ----------------------------
-- Records of sys_dept_user
-- ----------------------------
BEGIN;
INSERT INTO `sys_dept_user` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                             `is_delete`, `tenant_id`, `dept_id`, `user_id`, `type`)
VALUES (123624016369942533, '2023-11-15 15:30:51', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, 0, 0,
        384098815180000, 'normal');
INSERT INTO `sys_dept_user` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                             `is_delete`, `tenant_id`, `dept_id`, `user_id`, `type`)
VALUES (123695733748531205, '2023-11-16 10:30:46', 123695733730705413, '库克', NULL, NULL, NULL, 0, 123695733642625029,
        0, 123695733730705413, 'normal');
COMMIT;

-- ----------------------------
-- Table structure for sys_dict
-- ----------------------------
DROP TABLE IF EXISTS `sys_dict`;
CREATE TABLE `sys_dict`
(
  `id`          bigint                                                        NOT NULL COMMENT '主键',
  `create_time` datetime                                                      DEFAULT NULL COMMENT '创建时间',
  `create_id`   bigint                                                        DEFAULT NULL COMMENT '创建人',
  `create_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '创建人名称',
  `update_time` datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`   bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`   tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`   bigint                                                        NOT NULL COMMENT '租户id',
  `name`        varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '名称',
  `dic_code`    varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '字典编码',
  `description` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '描述',
  `type`        char(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci     NOT NULL COMMENT '字典类型',
  `sort`        int                                                           NOT NULL COMMENT '排序值默认0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='字典表';

-- ----------------------------
-- Records of sys_dict
-- ----------------------------
BEGIN;
INSERT INTO `sys_dict` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `name`, `dic_code`, `description`, `type`, `sort`)
VALUES (112387094452633605, '2023-07-14 14:44:47', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, 0, '性别',
        'gender', NULL, 'global', 0);
INSERT INTO `sys_dict` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `name`, `dic_code`, `description`, `type`, `sort`)
VALUES (114819265395163141, '2023-08-10 11:03:06', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, 0, '简历来源',
        'resume_source', NULL, 'default', 1);
INSERT INTO `sys_dict` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `name`, `dic_code`, `description`, `type`, `sort`)
VALUES (121173176982962181, '2023-10-19 14:15:49', 384098815180000, '平台管理员', NULL, NULL, NULL, 0,
        121173176636932101, '简历来源', 'resume_source', NULL, 'default', 1);
INSERT INTO `sys_dict` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `name`, `dic_code`, `description`, `type`, `sort`)
VALUES (123695738016235525, '2023-11-16 10:30:50', 384098815180000, '平台管理员', NULL, NULL, NULL, 0,
        123695733642625029, '简历来源', 'resume_source', NULL, 'default', 1);
COMMIT;

-- ----------------------------
-- Table structure for sys_dict_item
-- ----------------------------
DROP TABLE IF EXISTS `sys_dict_item`;
CREATE TABLE `sys_dict_item`
(
  `id`          bigint                                                        NOT NULL COMMENT '主键',
  `create_time` datetime                                                      DEFAULT NULL COMMENT '创建时间',
  `create_id`   bigint                                                        DEFAULT NULL COMMENT '创建人',
  `create_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '创建人名称',
  `update_time` datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`   bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`   tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`   bigint                                                        NOT NULL COMMENT '租户id',
  `dict_id`     bigint                                                        NOT NULL COMMENT '字典id',
  `label`       varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '字典标签',
  `value`       varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '字典值',
  `description` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '描述',
  `disabled`    tinyint(1) NOT NULL COMMENT '是否禁用',
  `editable`    tinyint                                                       NOT NULL,
  `sort`        int                                                           NOT NULL COMMENT '排序值默认0',
  `parent_id`   bigint                                                        DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='字典项表';

-- ----------------------------
-- Records of sys_dict_item
-- ----------------------------
BEGIN;
INSERT INTO `sys_dict_item` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                             `is_delete`, `tenant_id`, `dict_id`, `label`, `value`, `description`, `disabled`,
                             `editable`, `sort`, `parent_id`)
VALUES (114561499446378501, '2023-08-07 14:46:02', 384098815180000, '平台管理员', '2023-08-07 14:53:58',
        384098815180000, '平台管理员', 0, 0, 112387094452633605, '男', 'male', NULL, 0, 1, 0, NULL);
INSERT INTO `sys_dict_item` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                             `is_delete`, `tenant_id`, `dict_id`, `label`, `value`, `description`, `disabled`,
                             `editable`, `sort`, `parent_id`)
VALUES (114562008621252613, '2023-08-07 14:54:07', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, 0,
        112387094452633605, '女', 'female', NULL, 0, 1, 1, NULL);
INSERT INTO `sys_dict_item` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                             `is_delete`, `tenant_id`, `dict_id`, `label`, `value`, `description`, `disabled`,
                             `editable`, `sort`, `parent_id`)
VALUES (114841269061025797, '2023-08-10 16:52:51', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, 0,
        114819265395163141, 'BOSS直聘', 'boss', NULL, 0, 0, 0, NULL);
INSERT INTO `sys_dict_item` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                             `is_delete`, `tenant_id`, `dict_id`, `label`, `value`, `description`, `disabled`,
                             `editable`, `sort`, `parent_id`)
VALUES (118733946116636677, '2023-09-22 16:05:17', 384098815180000, '平台管理员', '2023-10-19 14:03:28',
        384098815180000, '平台管理员', 0, 0, 114819265395163141, '智联招聘', 'zhilianzhaopin', NULL, 0, 1, 1, NULL);
INSERT INTO `sys_dict_item` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                             `is_delete`, `tenant_id`, `dict_id`, `label`, `value`, `description`, `disabled`,
                             `editable`, `sort`, `parent_id`)
VALUES (121173176996593669, '2023-10-19 14:15:49', 384098815180000, '平台管理员', NULL, NULL, NULL, 0,
        121173176636932101, 121173176982962181, 'BOSS直聘', 'boss', NULL, 0, 0, 0, NULL);
INSERT INTO `sys_dict_item` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                             `is_delete`, `tenant_id`, `dict_id`, `label`, `value`, `description`, `disabled`,
                             `editable`, `sort`, `parent_id`)
VALUES (121173176996593670, '2023-10-19 14:15:49', 384098815180000, '平台管理员', NULL, NULL, NULL, 0,
        121173176636932101, 121173176982962181, '智联招聘', 'zhilianzhaopin', NULL, 0, 1, 1, NULL);
INSERT INTO `sys_dict_item` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                             `is_delete`, `tenant_id`, `dict_id`, `label`, `value`, `description`, `disabled`,
                             `editable`, `sort`, `parent_id`)
VALUES (123695738030915589, '2023-11-16 10:30:50', 384098815180000, '平台管理员', NULL, NULL, NULL, 0,
        123695733642625029, 123695738016235525, 'BOSS直聘', 'boss', NULL, 0, 0, 0, NULL);
INSERT INTO `sys_dict_item` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                             `is_delete`, `tenant_id`, `dict_id`, `label`, `value`, `description`, `disabled`,
                             `editable`, `sort`, `parent_id`)
VALUES (123695738031964165, '2023-11-16 10:30:50', 384098815180000, '平台管理员', NULL, NULL, NULL, 0,
        123695733642625029, 123695738016235525, '智联招聘', 'zhilianzhaopin', NULL, 0, 1, 1, NULL);
COMMIT;

-- ----------------------------
-- Table structure for sys_district
-- ----------------------------
DROP TABLE IF EXISTS `sys_district`;
CREATE TABLE `sys_district`
(
  `id`         varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci  NOT NULL COMMENT '邮政编码',
  `type`       char(8) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci      NOT NULL COMMENT '省/市/区',
  `name`       varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '名称',
  `short_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '简称',
  `pinyin`     varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '拼音，检索用',
  `latitude`   decimal(64, 8)                                                NOT NULL COMMENT '纬度',
  `longitude`  decimal(64, 8)                                                NOT NULL COMMENT '经度',
  `parent_id`  varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci  NOT NULL COMMENT '父邮政编码',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=DYNAMIC COMMENT='省市区表';

-- ----------------------------
-- Records of sys_district
-- ----------------------------
BEGIN;
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110000', '0', '北京市', '北京', 'bei,jing', 39.90502300, 116.72450200, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101', '1', '东城区', '东城', 'dong,cheng', 39.92835900, 116.41633400, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101001', '2', '东华门街道', NULL, NULL, 39.91614600, 116.40724000, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101002', '2', '景山街道', NULL, NULL, 39.92677500, 116.41056000, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101003', '2', '交道口街道', NULL, NULL, 39.93589400, 116.40092800, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101004', '2', '安定门街道', NULL, NULL, 39.94430700, 116.41283500, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101005', '2', '北新桥街道', NULL, NULL, 39.94249700, 116.42449700, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101006', '2', '东四街道', NULL, NULL, 39.93054600, 116.42393900, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101007', '2', '朝阳门街道', NULL, NULL, 39.92071500, 116.43041900, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101008', '2', '建国门街道', NULL, NULL, 39.91414300, 116.42755100, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101009', '2', '东直门街道', NULL, NULL, 39.93084100, 116.44181400, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101010', '2', '和平里街道', NULL, NULL, 39.95624600, 116.42366700, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101011', '2', '前门街道', NULL, NULL, 39.89392100, 116.40718600, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101012', '2', '崇文门外街道', NULL, NULL, 39.89462600, 116.42741200, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101013', '2', '东花市街道', NULL, NULL, 39.89924300, 116.43108600, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101014', '2', '龙潭街道', NULL, NULL, 39.88286800, 116.43602100, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101015', '2', '体育馆路街道', NULL, NULL, 39.88695800, 116.42252800, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101016', '2', '天坛街道', NULL, NULL, 39.88932900, 116.39913600, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110101017', '2', '永定门外街道', NULL, NULL, 39.86563100, 116.40203100, '110101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102', '1', '西城区', '西城', 'xi,cheng', 39.91260000, 116.36585000, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102001', '2', '西长安街街道', NULL, NULL, 39.90443200, 116.38358500, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102003', '2', '新街口街道', NULL, NULL, 39.94035300, 116.36652200, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102007', '2', '月坛街道', NULL, NULL, 39.91501400, 116.34470600, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102009', '2', '展览路街道', NULL, NULL, 39.93283600, 116.34254800, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102010', '2', '德胜街道', NULL, NULL, 39.95431700, 116.38161300, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102011', '2', '金融街街道', NULL, NULL, 39.91327000, 116.36294800, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102012', '2', '什刹海街道', NULL, NULL, 39.93350600, 116.38222000, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102013', '2', '大栅栏街道', NULL, NULL, 39.89287900, 116.39300100, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102014', '2', '天桥街道', NULL, NULL, 39.88377600, 116.39607600, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102015', '2', '椿树街道', NULL, NULL, 39.89385300, 116.37958600, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102016', '2', '陶然亭街道', NULL, NULL, 39.88017500, 116.38272200, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102017', '2', '广安门内街道', NULL, NULL, 39.89632300, 116.36524400, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102018', '2', '牛街街道', NULL, NULL, 39.88734100, 116.36389000, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102019', '2', '白纸坊街道', NULL, NULL, 39.88111600, 116.36123300, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110102020', '2', '广安门外街道', NULL, NULL, 39.87931400, 116.34006100, '110102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105', '1', '朝阳区', '朝阳', 'chao,yang', 39.92144400, 116.44313600, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105001', '2', '建外街道', NULL, NULL, 39.90663700, 116.47751600, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105002', '2', '朝外街道', NULL, NULL, 39.92061100, 116.44852900, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105003', '2', '呼家楼街道', NULL, NULL, 39.92233900, 116.46679400, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105004', '2', '三里屯街道', NULL, NULL, 39.93761000, 116.44721900, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105005', '2', '左家庄街道', NULL, NULL, 39.94941800, 116.45118700, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105006', '2', '香河园街道', NULL, NULL, 39.96121800, 116.43732500, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105007', '2', '和平街街道', NULL, NULL, 39.96652400, 116.41691700, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105008', '2', '安贞街道', NULL, NULL, 39.96697900, 116.40047800, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105009', '2', '亚运村街道', NULL, NULL, 39.98499000, 116.40964400, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105010', '2', '小关街道', NULL, NULL, 39.98697700, 116.42150900, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105011', '2', '酒仙桥街道', NULL, NULL, 39.96512300, 116.49074700, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105012', '2', '麦子店街道', NULL, NULL, 39.93551900, 116.46931000, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105013', '2', '团结湖街道', NULL, NULL, 39.93162900, 116.46381400, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105014', '2', '六里屯街道', NULL, NULL, 39.92929500, 116.47951800, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105015', '2', '八里庄街道', NULL, NULL, 39.91515900, 116.47899800, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105016', '2', '双井街道', NULL, NULL, 39.89710400, 116.46651500, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105017', '2', '劲松街道', NULL, NULL, 39.88619700, 116.46479300, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105018', '2', '潘家园街道', NULL, NULL, 39.87167000, 116.46810900, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105019', '2', '垡头街道', NULL, NULL, 39.86771300, 116.50996900, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105025', '2', '大屯街道', NULL, NULL, 39.99869900, 116.41183800, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105026', '2', '望京街道', NULL, NULL, 39.99320000, 116.48853700, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105031', '2', '奥运村街道', NULL, NULL, 40.02655200, 116.41273900, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105043', '2', '首都机场街道', NULL, NULL, 40.04796000, 116.59151200, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105044', '2', '东湖街道', NULL, NULL, 40.00343900, 116.47433100, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105221', '2', '南磨房乡', NULL, NULL, 39.88338300, 116.47807400, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105222', '2', '高碑店乡', NULL, NULL, 39.91184100, 116.52154400, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105223', '2', '将台乡', NULL, NULL, 39.96875400, 116.48901700, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105224', '2', '太阳宫乡', NULL, NULL, 39.97382500, 116.44214400, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105227', '2', '小红门乡', NULL, NULL, 39.82791400, 116.47576100, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105228', '2', '十八里店乡', NULL, NULL, 39.85124400, 116.48281100, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105229', '2', '平房乡', NULL, NULL, 39.93533600, 116.53169500, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105230', '2', '东风乡', NULL, NULL, 39.94612600, 116.49982500, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105232', '2', '来广营乡', NULL, NULL, 40.03197200, 116.43369100, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105233', '2', '常营回族乡', NULL, NULL, 39.92333900, 116.59400200, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105234', '2', '三间房乡', NULL, NULL, 39.90809400, 116.55417000, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105235', '2', '管庄乡', NULL, NULL, 39.90988700, 116.59585200, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105236', '2', '金盏乡', NULL, NULL, 40.00348500, 116.56873800, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105237', '2', '孙河乡', NULL, NULL, 40.04134900, 116.52359500, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105238', '2', '崔各庄乡', NULL, NULL, 39.99976000, 116.51542000, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105239', '2', '东坝乡', NULL, NULL, 39.96405100, 116.55555400, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105240', '2', '黑庄户乡', NULL, NULL, 39.85333600, 116.59681100, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105241', '2', '豆各庄乡', NULL, NULL, 39.87304800, 116.57228400, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110105242', '2', '王四营乡', NULL, NULL, 39.87518400, 116.53088000, '110105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106', '1', '丰台区', '丰台', 'feng,tai', 39.85853800, 116.28672600, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106001', '2', '右安门街道', NULL, NULL, 39.85745400, 116.36668100, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106002', '2', '太平桥街道', NULL, NULL, 39.87436800, 116.31308200, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106003', '2', '西罗园街道', NULL, NULL, 39.86354200, 116.38354600, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106004', '2', '大红门街道', NULL, NULL, 39.83877800, 116.40747800, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106005', '2', '南苑街道', NULL, NULL, 39.80903500, 116.37769500, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106006', '2', '东高地街道', NULL, NULL, 39.80813400, 116.42165400, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106007', '2', '东铁匠营街道', NULL, NULL, 39.86298200, 116.41946500, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106008', '2', '六里桥街道', NULL, NULL, 39.85961000, 116.25249000, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106009', '2', '丰台街道', NULL, NULL, 39.84924600, 116.28691100, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106010', '2', '新村街道', NULL, NULL, 39.84000100, 116.30868100, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106011', '2', '长辛店街道', NULL, NULL, 39.82635400, 116.21048700, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106012', '2', '云岗街道', NULL, NULL, 39.81138800, 116.16390600, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106013', '2', '方庄街道', NULL, NULL, 39.86154900, 116.42753700, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106014', '2', '宛平城街道', NULL, NULL, 39.84031500, 116.23741200, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106015', '2', '马家堡街道', NULL, NULL, 39.84285600, 116.36537200, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106016', '2', '和义街道', NULL, NULL, 39.80965300, 116.40099800, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106018', '2', '花乡街道', NULL, NULL, 39.81242800, 116.30240600, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106020', '2', '成寿寺街道', NULL, NULL, 39.85536400, 116.43578000, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106021', '2', '石榴庄街道', NULL, NULL, 39.83923500, 116.42054500, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106100', '2', '北宫镇', NULL, NULL, 39.84104300, 116.20962900, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106101', '2', '王佐镇', NULL, NULL, 39.80190400, 116.15607100, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110106201', '2', '卢沟桥乡', NULL, NULL, 39.87030000, 116.28151000, '110106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110107', '1', '石景山区', '石景山', 'shi,jing,shan', 39.90630400, 116.22301500, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110107001', '2', '八宝山街道', NULL, NULL, 39.90140400, 116.23643800, '110107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110107002', '2', '老山街道', NULL, NULL, 39.91089800, 116.22256800, '110107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110107003', '2', '八角街道', NULL, NULL, 39.91569100, 116.19624600, '110107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110107004', '2', '古城街道', NULL, NULL, 39.91476800, 116.19076900, '110107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110107005', '2', '苹果园街道', NULL, NULL, 39.93038300, 116.19497500, '110107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110107006', '2', '金顶街街道', NULL, NULL, 39.92586800, 116.16862300, '110107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110107009', '2', '广宁街道', NULL, NULL, 39.92838300, 116.14543000, '110107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110107010', '2', '五里坨街道', NULL, NULL, 39.95644900, 116.12610100, '110107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110107011', '2', '鲁谷街道', NULL, NULL, 39.89850200, 116.22535900, '110107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108', '1', '海淀区', '海淀', 'hai,dian', 39.95989300, 116.29770000, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108001', '2', '万寿路街道', NULL, NULL, 39.90602800, 116.26331100, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108002', '2', '永定路街道', NULL, NULL, 39.91023300, 116.26373900, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108003', '2', '羊坊店街道', NULL, NULL, 39.90208500, 116.32169700, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108004', '2', '甘家口街道', NULL, NULL, 39.92052400, 116.32114300, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108005', '2', '八里庄街道', NULL, NULL, 39.92692600, 116.30161600, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108006', '2', '紫竹院街道', NULL, NULL, 39.94452000, 116.31193300, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108007', '2', '北下关街道', NULL, NULL, 39.95813100, 116.33903800, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108008', '2', '北太平庄街道', NULL, NULL, 39.95101800, 116.36177000, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108010', '2', '学院路街道', NULL, NULL, 39.99361800, 116.35187200, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108011', '2', '中关村街道', NULL, NULL, 39.97791700, 116.31808900, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108012', '2', '海淀街道', NULL, NULL, 39.97511600, 116.31358100, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108013', '2', '青龙桥街道', NULL, NULL, 39.99685100, 116.26018400, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108014', '2', '清华园街道', NULL, NULL, 39.99960200, 116.32481900, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108015', '2', '燕园街道', NULL, NULL, 39.99454200, 116.30240800, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108016', '2', '香山街道', NULL, NULL, 39.99396800, 116.20627400, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108017', '2', '清河街道', NULL, NULL, 40.03562400, 116.33412600, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108018', '2', '花园路街道', NULL, NULL, 39.97778100, 116.37254200, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108019', '2', '西三旗街道', NULL, NULL, 40.02900300, 116.35058500, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108020', '2', '马连洼街道', NULL, NULL, 40.03261900, 116.27532800, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108021', '2', '田村路街道', NULL, NULL, 39.92149900, 116.25321300, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108022', '2', '上地街道', NULL, NULL, 40.04234200, 116.29486000, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108025', '2', '曙光街道', NULL, NULL, 39.96577100, 116.27942800, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108101', '2', '温泉镇', NULL, NULL, 40.04876000, 116.18103000, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108102', '2', '四季青镇', NULL, NULL, 39.95455900, 116.27467500, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108103', '2', '西北旺镇', NULL, NULL, 40.04863300, 116.26366900, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108104', '2', '苏家坨镇', NULL, NULL, 40.07983800, 116.15740900, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108105', '2', '上庄镇', NULL, NULL, 40.09658200, 116.21520800, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108123', '2', '海淀镇', NULL, NULL, 39.99094400, 116.29562300, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110108124', '2', '东升镇', NULL, NULL, 39.99511900, 116.33439100, '110108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109', '1', '门头沟区', '门头沟', 'men,tou,gou', 39.94084200, 116.10166800, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109001', '2', '大峪街道', NULL, NULL, 39.93013400, 116.11460100, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109002', '2', '城子街道', NULL, NULL, 39.94522700, 116.07949200, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109003', '2', '东辛房街道', NULL, NULL, 39.88613000, 116.10493700, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109004', '2', '大台街道', NULL, NULL, 39.96300100, 115.93846400, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109101', '2', '潭柘寺镇', NULL, NULL, 39.87852100, 116.03007300, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109102', '2', '永定镇', NULL, NULL, 39.90681000, 116.10280800, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109103', '2', '龙泉镇', NULL, NULL, 39.94455600, 116.09422500, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109104', '2', '军庄镇', NULL, NULL, 40.00379900, 116.10328000, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109105', '2', '雁翅镇', NULL, NULL, 40.01793900, 115.83210100, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109106', '2', '斋堂镇', NULL, NULL, 39.97272100, 115.69611300, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109107', '2', '清水镇', NULL, NULL, 39.94324100, 115.61236300, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109108', '2', '妙峰山镇', NULL, NULL, 39.97573800, 116.04987500, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110109109', '2', '王平镇', NULL, NULL, 39.97072800, 115.99117100, '110109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111', '1', '房山区', '房山', 'fang,shan', 39.74888900, 116.14342600, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111001', '2', '城关街道', NULL, NULL, 39.70545600, 116.01402000, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111002', '2', '新镇街道', NULL, NULL, 39.73381400, 116.06098200, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111004', '2', '向阳街道', NULL, NULL, 39.71782200, 115.98420300, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111005', '2', '东风街道', NULL, NULL, 39.75317000, 115.96127900, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111006', '2', '迎风街道', NULL, NULL, 39.72565200, 115.95988400, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111007', '2', '星城街道', NULL, NULL, 39.65196600, 116.06794100, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111011', '2', '拱辰街道', NULL, NULL, 39.73151400, 116.14348900, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111012', '2', '西潞街道', NULL, NULL, 39.72211000, 116.12839100, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111101', '2', '阎村镇', NULL, NULL, 39.71619200, 116.09247400, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111103', '2', '窦店镇', NULL, NULL, 39.65196600, 116.06794100, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111104', '2', '石楼镇', NULL, NULL, 39.65624500, 115.98492700, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111105', '2', '长阳镇', NULL, NULL, 39.76618500, 116.21699100, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111107', '2', '河北镇', NULL, NULL, 39.82001000, 115.93847800, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111108', '2', '长沟镇', NULL, NULL, 39.58023000, 115.90029500, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111109', '2', '大石窝镇', NULL, NULL, 39.55265500, 115.82592300, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111110', '2', '张坊镇', NULL, NULL, 39.57675900, 115.71678600, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111111', '2', '十渡镇', NULL, NULL, 39.63997800, 115.58863300, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111112', '2', '青龙湖镇', NULL, NULL, 39.77790200, 116.03987200, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111115', '2', '韩村河镇', NULL, NULL, 39.60406500, 115.96300300, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111116', '2', '良乡镇', NULL, NULL, 39.70427600, 116.15240700, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111117', '2', '周口店镇', NULL, NULL, 39.68148700, 115.95206600, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111118', '2', '琉璃河镇', NULL, NULL, 39.61053000, 116.03095800, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111208', '2', '霞云岭乡', NULL, NULL, 39.72882500, 115.74679100, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111209', '2', '南窖乡', NULL, NULL, 39.76873300, 115.84203900, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111210', '2', '佛子庄乡', NULL, NULL, 39.82084100, 115.89030600, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111211', '2', '大安山乡', NULL, NULL, 39.88802900, 115.78626000, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111212', '2', '史家营乡', NULL, NULL, 39.85915200, 115.67082700, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110111213', '2', '蒲洼乡', NULL, NULL, 39.73399200, 115.53570700, '110111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112', '1', '通州区', '通州', 'tong,zhou', 39.91640300, 116.72923000, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112001', '2', '中仓街道', NULL, NULL, 39.90557000, 116.66363000, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112002', '2', '新华街道', NULL, NULL, 39.91046000, 116.66521700, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112003', '2', '北苑街道', NULL, NULL, 39.90336600, 116.64928600, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112004', '2', '玉桥街道', NULL, NULL, 39.89370700, 116.68202400, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112005', '2', '潞源街道', NULL, NULL, 39.91716000, 116.72532700, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112006', '2', '通运街道', NULL, NULL, 39.91340600, 116.69800300, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112009', '2', '文景街道', NULL, NULL, 39.85270700, 116.65383000, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112010', '2', '九棵树街道', NULL, NULL, 39.89021400, 116.64808400, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112011', '2', '临河里街道', NULL, NULL, 39.88126600, 116.68624400, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112012', '2', '杨庄街道', NULL, NULL, 39.90527200, 116.63173200, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112013', '2', '潞邑街道', NULL, NULL, 39.93445000, 116.67325000, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112104', '2', '宋庄镇', NULL, NULL, 39.94095000, 116.72742000, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112105', '2', '张家湾镇', NULL, NULL, 39.85871000, 116.72060800, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112106', '2', '漷县镇', NULL, NULL, 39.78005300, 116.79338700, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112109', '2', '马驹桥镇', NULL, NULL, 39.74939600, 116.56042300, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112110', '2', '西集镇', NULL, NULL, 39.80045000, 116.83978000, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112114', '2', '台湖镇', NULL, NULL, 39.83270800, 116.65208700, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112117', '2', '永乐店镇', NULL, NULL, 39.70942200, 116.79680100, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112119', '2', '潞城镇', NULL, NULL, 39.85402100, 116.78658200, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112120', '2', '永顺镇', NULL, NULL, 39.91790700, 116.65575400, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112121', '2', '梨园镇', NULL, NULL, 39.86690100, 116.66305300, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110112209', '2', '于家务回族乡', NULL, NULL, 39.71937800, 116.69847200, '110112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113', '1', '顺义区', '顺义', 'shun,yi', 40.14989100, 116.66147400, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113001', '2', '胜利街道', NULL, NULL, 40.12027000, 116.65056900, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113002', '2', '光明街道', NULL, NULL, 40.13039900, 116.66193300, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113010', '2', '石园街道', NULL, NULL, 40.11238000, 116.66009000, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113011', '2', '空港街道', NULL, NULL, 40.10045100, 116.55575900, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113012', '2', '双丰街道', NULL, NULL, 40.16756000, 116.66256100, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113013', '2', '旺泉街道', NULL, NULL, 40.12412000, 116.64186000, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113101', '2', '高丽营镇', NULL, NULL, 40.14792300, 116.55093500, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113104', '2', '李桥镇', NULL, NULL, 40.06061300, 116.64431600, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113105', '2', '李遂镇', NULL, NULL, 40.09097400, 116.75728600, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113106', '2', '南彩镇', NULL, NULL, 40.13501100, 116.71129400, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113108', '2', '北务镇', NULL, NULL, 40.07012500, 116.82863200, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113109', '2', '大孙各庄镇', NULL, NULL, 40.08718100, 116.91949600, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113110', '2', '张镇', NULL, NULL, 40.15230300, 116.95104100, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113111', '2', '龙湾屯镇', NULL, NULL, 40.23213000, 116.85790000, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113112', '2', '木林镇', NULL, NULL, 40.24655800, 116.78095900, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113113', '2', '北小营镇', NULL, NULL, 40.20067400, 116.72867600, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113115', '2', '北石槽镇', NULL, NULL, 40.24884000, 116.53594800, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113116', '2', '赵全营镇', NULL, NULL, 40.21269800, 116.59322400, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113117', '2', '仁和镇', NULL, NULL, 40.11817800, 116.65315900, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113118', '2', '后沙峪镇', NULL, NULL, 40.10529300, 116.54387900, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113119', '2', '天竺镇', NULL, NULL, 40.05861100, 116.57658500, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113120', '2', '杨镇镇', NULL, NULL, 40.15341300, 116.83111400, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113121', '2', '牛栏山镇', NULL, NULL, 40.21030000, 116.65443200, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113122', '2', '南法信镇', NULL, NULL, 40.11919300, 116.61073600, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110113123', '2', '马坡镇', NULL, NULL, 40.17146600, 116.65783300, '110113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114', '1', '昌平区', '昌平', 'chang,ping', 40.22095200, 116.23103400, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114001', '2', '城北街道', NULL, NULL, 40.22242500, 116.26315200, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114005', '2', '城南街道', NULL, NULL, 40.21283800, 116.25459400, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114006', '2', '天通苑北街道', NULL, NULL, 40.07163200, 116.41718300, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114007', '2', '天通苑南街道', NULL, NULL, 40.06852800, 116.40442500, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114008', '2', '霍营街道', NULL, NULL, 40.08367600, 116.36586100, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114009', '2', '回龙观街道', NULL, NULL, 40.06469100, 116.32455400, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114010', '2', '龙泽园街道', NULL, NULL, 40.08096000, 116.34741700, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114011', '2', '史各庄街道', NULL, NULL, 40.09686700, 116.28938000, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114104', '2', '阳坊镇', NULL, NULL, 40.13848300, 116.13812100, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114110', '2', '小汤山镇', NULL, NULL, 40.17780600, 116.39975800, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114111', '2', '南邵镇', NULL, NULL, 40.20774600, 116.28625000, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114112', '2', '崔村镇', NULL, NULL, 40.22051300, 116.35305400, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114113', '2', '百善镇', NULL, NULL, 40.19260400, 116.31867500, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114115', '2', '北七家镇', NULL, NULL, 40.11793500, 116.42460200, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114116', '2', '兴寿镇', NULL, NULL, 40.21559000, 116.40933700, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114118', '2', '流村镇', NULL, NULL, 40.18297300, 116.06463100, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114119', '2', '十三陵镇', NULL, NULL, 40.27265000, 116.22507400, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114120', '2', '延寿镇', NULL, NULL, 40.28391600, 116.36334600, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114121', '2', '南口镇', NULL, NULL, 40.23044100, 116.14746500, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114122', '2', '马池口镇', NULL, NULL, 40.18335000, 116.16815700, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114123', '2', '沙河镇', NULL, NULL, 40.14862400, 116.29085200, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110114125', '2', '东小口镇', NULL, NULL, 40.05861700, 116.40845900, '110114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115', '1', '大兴区', '大兴', 'da,xing', 39.72691700, 116.34148300, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115001', '2', '兴丰街道', NULL, NULL, 39.73211400, 116.34219700, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115002', '2', '林校路街道', NULL, NULL, 39.72699900, 116.34558400, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115003', '2', '清源街道', NULL, NULL, 39.75197700, 116.33856100, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115009', '2', '观音寺街道', NULL, NULL, 39.74205600, 116.34613700, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115010', '2', '天宫院街道', NULL, NULL, 39.69538900, 116.33115200, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115011', '2', '高米店街道', NULL, NULL, 39.76557100, 116.31625600, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115012', '2', '荣华街道', NULL, NULL, 39.78241400, 116.49606600, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115013', '2', '博兴街道', NULL, NULL, 39.76292500, 116.49922000, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115103', '2', '青云店镇', NULL, NULL, 39.68582100, 116.50183500, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115104', '2', '采育镇', NULL, NULL, 39.65299600, 116.66604600, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115105', '2', '安定镇', NULL, NULL, 39.61809000, 116.49973400, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115106', '2', '礼贤镇', NULL, NULL, 39.56527600, 116.43092500, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115107', '2', '榆垡镇', NULL, NULL, 39.51135100, 116.31551100, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115108', '2', '庞各庄镇', NULL, NULL, 39.63533100, 116.32327300, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115109', '2', '北臧村镇', NULL, NULL, 39.68615900, 116.30311000, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115110', '2', '魏善庄镇', NULL, NULL, 39.63208700, 116.41454800, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115111', '2', '长子营镇', NULL, NULL, 39.68570700, 116.59626600, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115112', '2', '亦庄镇', NULL, NULL, 39.80022700, 116.48203900, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115113', '2', '黄村镇', NULL, NULL, 39.74326100, 116.34010900, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115114', '2', '旧宫镇', NULL, NULL, 39.81288900, 116.43644200, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115115', '2', '西红门镇', NULL, NULL, 39.79056100, 116.35057600, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110115116', '2', '瀛海镇', NULL, NULL, 39.75654400, 116.45223700, '110115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116', '1', '怀柔区', '怀柔', 'huai,rou', 40.31700300, 116.63197400, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116001', '2', '泉河街道', NULL, NULL, 40.32144000, 116.63397500, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116002', '2', '龙山街道', NULL, NULL, 40.31579500, 116.63715700, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116102', '2', '北房镇', NULL, NULL, 40.32642100, 116.70270400, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116103', '2', '杨宋镇', NULL, NULL, 40.29615700, 116.68494600, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116105', '2', '桥梓镇', NULL, NULL, 40.29013600, 116.57433000, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116106', '2', '怀北镇', NULL, NULL, 40.38911100, 116.68938800, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116107', '2', '汤河口镇', NULL, NULL, 40.73734100, 116.64480900, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116108', '2', '渤海镇', NULL, NULL, 40.41533200, 116.46702300, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116109', '2', '九渡河镇', NULL, NULL, 40.36121300, 116.45952200, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116110', '2', '琉璃庙镇', NULL, NULL, 40.62834700, 116.65052600, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116111', '2', '宝山镇', NULL, NULL, 40.69473100, 116.56989900, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116112', '2', '怀柔镇', NULL, NULL, 40.30187300, 116.64049500, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116113', '2', '雁栖镇', NULL, NULL, 40.36027300, 116.65775000, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116114', '2', '庙城镇', NULL, NULL, 40.29289100, 116.63461300, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116211', '2', '长哨营满族乡', NULL, NULL, 40.79406400, 116.75047300, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110116213', '2', '喇叭沟门满族乡', NULL, NULL, 40.90242600, 116.62204200, '110116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117', '1', '平谷区', '平谷', 'ping,gu', 40.14080500, 117.12158900, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117001', '2', '滨河街道', NULL, NULL, 40.14111900, 117.11922100, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117002', '2', '兴谷街道', NULL, NULL, 40.15409800, 117.11757800, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117101', '2', '东高村镇', NULL, NULL, 40.10373000, 117.11386400, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117102', '2', '山东庄镇', NULL, NULL, 40.18806900, 117.15877400, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117104', '2', '南独乐河镇', NULL, NULL, 40.17290200, 117.22701700, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117105', '2', '大华山镇', NULL, NULL, 40.27796200, 117.06546400, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117106', '2', '夏各庄镇', NULL, NULL, 40.13739800, 117.14235000, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117108', '2', '马昌营镇', NULL, NULL, 40.13452300, 117.02128600, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117110', '2', '王辛庄镇', NULL, NULL, 40.16134500, 117.10396400, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117111', '2', '大兴庄镇', NULL, NULL, 40.14608700, 117.04186900, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117112', '2', '刘家店镇', NULL, NULL, 40.24047100, 117.02159000, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117114', '2', '镇罗营镇', NULL, NULL, 40.34537200, 117.14931400, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117115', '2', '平谷镇', NULL, NULL, 40.13932900, 117.10033800, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117116', '2', '峪口镇', NULL, NULL, 40.18514800, 117.00856700, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117117', '2', '马坊镇', NULL, NULL, 40.06058300, 117.01182800, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117118', '2', '金海湖镇', NULL, NULL, 40.18027400, 117.26641600, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117213', '2', '黄松峪乡', NULL, NULL, 40.22587500, 117.26453700, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110117214', '2', '熊儿寨乡', NULL, NULL, 40.28502800, 117.13426400, '110117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118', '1', '密云区', '密云', 'mi,yun', 40.37705800, 116.84335100, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118001', '2', '鼓楼街道', NULL, NULL, 40.36875500, 116.84046700, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118002', '2', '果园街道', NULL, NULL, 40.37896700, 116.83573200, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118100', '2', '密云镇', NULL, NULL, 40.38772900, 116.84362400, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118101', '2', '溪翁庄镇', NULL, NULL, 40.47530900, 116.85400300, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118102', '2', '西田各庄镇', NULL, NULL, 40.36714900, 116.75480300, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118103', '2', '十里堡镇', NULL, NULL, 40.35850900, 116.80151600, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118104', '2', '河南寨镇', NULL, NULL, 40.33161600, 116.82681700, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118105', '2', '巨各庄镇', NULL, NULL, 40.38230400, 116.94811400, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118106', '2', '穆家峪镇', NULL, NULL, 40.41191400, 116.94362900, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118107', '2', '太师屯镇', NULL, NULL, 40.53798900, 117.12840500, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118108', '2', '高岭镇', NULL, NULL, 40.60445100, 117.11096500, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118109', '2', '不老屯镇', NULL, NULL, 40.56742500, 116.97731600, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118110', '2', '冯家峪镇', NULL, NULL, 40.62054300, 116.87588100, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118111', '2', '古北口镇', NULL, NULL, 40.69187800, 117.16377700, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118112', '2', '大城子镇', NULL, NULL, 40.39357400, 117.10957000, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118113', '2', '东邵渠镇', NULL, NULL, 40.29408300, 116.96782300, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118114', '2', '北庄镇', NULL, NULL, 40.50948700, 117.18098100, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118115', '2', '新城子镇', NULL, NULL, 40.64388100, 117.33471200, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118116', '2', '石城镇', NULL, NULL, 40.54147700, 116.82018300, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110118203', '2', '檀营满族蒙族乡', NULL, NULL, 40.38517100, 116.86775400, '110118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119', '1', '延庆区', '延庆', 'yan,qing', 40.45703300, 115.97460900, '110000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119001', '2', '百泉街道', NULL, NULL, 40.44829500, 115.99113300, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119002', '2', '香水园街道', NULL, NULL, 40.45701900, 115.97986800, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119003', '2', '儒林街道', NULL, NULL, 40.45577900, 115.97065700, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119100', '2', '延庆镇', NULL, NULL, 40.45892200, 115.98454800, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119101', '2', '康庄镇', NULL, NULL, 40.38322700, 115.90006600, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119102', '2', '八达岭镇', NULL, NULL, 40.36208700, 115.97791500, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119103', '2', '永宁镇', NULL, NULL, 40.52904300, 116.16295000, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119104', '2', '旧县镇', NULL, NULL, 40.55064900, 116.08710200, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119105', '2', '张山营镇', NULL, NULL, 40.47660000, 115.84430000, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119106', '2', '四海镇', NULL, NULL, 40.53163700, 116.41315100, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119107', '2', '千家店镇', NULL, NULL, 40.69389700, 116.34670400, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119108', '2', '沈家营镇', NULL, NULL, 40.48195700, 116.04549000, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119109', '2', '大榆树镇', NULL, NULL, 40.43541500, 116.02930200, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119110', '2', '井庄镇', NULL, NULL, 40.47156900, 116.09359400, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119207', '2', '大庄科乡', NULL, NULL, 40.43193000, 116.23543200, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119209', '2', '刘斌堡乡', NULL, NULL, 40.56773300, 116.22596900, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119210', '2', '香营乡', NULL, NULL, 40.57115200, 116.14542600, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('110119214', '2', '珍珠泉乡', NULL, NULL, 40.56057500, 116.42537400, '110119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120000', '0', '天津市', '天津', 'tian,jin', 39.08531800, 117.20150900, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120101', '1', '和平区', '和平', 'he,ping', 39.11688400, 117.21471300, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120101001', '2', '劝业场街道', NULL, NULL, 39.12721400, 117.19211800, '120101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120101002', '2', '小白楼街道', NULL, NULL, 39.12099400, 117.21241900, '120101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120101003', '2', '五大道街道', NULL, NULL, 39.11217800, 117.19649300, '120101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120101004', '2', '新兴街道', NULL, NULL, 39.10287300, 117.18864500, '120101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120101005', '2', '南营门街道', NULL, NULL, 39.11593500, 117.19151000, '120101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120101006', '2', '南市街道', NULL, NULL, 39.12757300, 117.18143400, '120101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102', '1', '河东区', '河东', 'he,dong', 39.12852400, 117.25139700, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102001', '2', '大王庄街道', NULL, NULL, 39.12659700, 117.22208100, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102002', '2', '大直沽街道', NULL, NULL, 39.10974500, 117.24667100, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102003', '2', '中山门街道', NULL, NULL, 39.10226800, 117.27071000, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102004', '2', '富民路街道', NULL, NULL, 39.09282400, 117.24521000, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102005', '2', '二号桥街道', NULL, NULL, 39.10097600, 117.28175900, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102006', '2', '春华街道', NULL, NULL, 39.13992300, 117.20825200, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102007', '2', '唐家口街道', NULL, NULL, 39.12874700, 117.24168200, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102008', '2', '向阳楼街道', NULL, NULL, 39.13459700, 117.24504700, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102009', '2', '常州道街道', NULL, NULL, 39.15826100, 117.25819900, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102010', '2', '上杭路街道', NULL, NULL, 39.12671400, 117.24998400, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102011', '2', '东新街道', NULL, NULL, 39.14231600, 117.27658700, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120102012', '2', '鲁山道街道', NULL, NULL, 39.15046400, 117.28203500, '120102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103', '1', '河西区', '河西', 'he,xi', 39.10967900, 117.22337900, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103001', '2', '大营门街道', NULL, NULL, 39.10882700, 117.21449700, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103002', '2', '下瓦房街道', NULL, NULL, 39.10616600, 117.22525700, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103003', '2', '桃园街道', NULL, NULL, 39.10183800, 117.21357600, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103004', '2', '挂甲寺街道', NULL, NULL, 39.09847700, 117.22212400, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103005', '2', '马场街道', NULL, NULL, 39.09547900, 117.18879500, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103006', '2', '越秀路街道', NULL, NULL, 39.09684800, 117.21405700, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103007', '2', '友谊路街道', NULL, NULL, 39.07773300, 117.20393300, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103008', '2', '天塔街道', NULL, NULL, 39.08159300, 117.18527200, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103009', '2', '尖山街道', NULL, NULL, 39.04343300, 117.23240400, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103010', '2', '陈塘庄街道', NULL, NULL, 39.07897400, 117.25315200, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103011', '2', '柳林街道', NULL, NULL, 39.05042400, 117.28398700, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103012', '2', '东海街道', NULL, NULL, 39.05371100, 117.25570700, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103013', '2', '梅江街道', NULL, NULL, 39.06408000, 117.21424000, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120103014', '2', '太湖路街道', NULL, NULL, 39.03658400, 117.24033200, '120103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104', '1', '南开区', '南开', 'nan,kai', 39.13855100, 117.15063800, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104001', '2', '长虹街道', NULL, NULL, 39.14082100, 117.15269900, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104002', '2', '鼓楼街道', NULL, NULL, 39.14300500, 117.17546900, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104003', '2', '兴南街道', NULL, NULL, 39.12621200, 117.17652000, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104004', '2', '广开街道', NULL, NULL, 39.13554900, 117.16662500, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104005', '2', '万兴街道', NULL, NULL, 39.11603200, 117.16131100, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104006', '2', '学府街道', NULL, NULL, 39.11282400, 117.16616300, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104007', '2', '向阳路街道', NULL, NULL, 39.13869200, 117.13129400, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104008', '2', '嘉陵道街道', NULL, NULL, 39.12756700, 117.14116200, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104009', '2', '王顶堤街道', NULL, NULL, 39.10289100, 117.14472900, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104010', '2', '水上公园街道', NULL, NULL, 39.09555200, 117.15350200, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104011', '2', '体育中心街道', NULL, NULL, 39.06788400, 117.17788400, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120104012', '2', '华苑街道', NULL, NULL, 39.08572700, 117.12672100, '120104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105', '1', '河北区', '河北', 'he,bei', 39.14801800, 117.19687400, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105001', '2', '光复道街道', NULL, NULL, 39.14715800, 117.20949100, '120105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105002', '2', '望海楼街道', NULL, NULL, 39.16103500, 117.20790500, '120105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105003', '2', '鸿顺里街道', NULL, NULL, 39.15838500, 117.19539300, '120105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105004', '2', '新开河街道', NULL, NULL, 39.17547800, 117.18427200, '120105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105005', '2', '铁东路街道', NULL, NULL, 39.18895100, 117.20385400, '120105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105006', '2', '建昌道街道', NULL, NULL, 39.17111400, 117.23008900, '120105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105007', '2', '宁园街道', NULL, NULL, 39.16146800, 117.21864100, '120105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105008', '2', '王串场街道', NULL, NULL, 39.15436800, 117.21992000, '120105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105009', '2', '江都路街道', NULL, NULL, 39.16327100, 117.23604900, '120105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120105010', '2', '月牙河街道', NULL, NULL, 39.16403700, 117.24654100, '120105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120106', '1', '红桥区', '红桥', 'hong,qiao', 39.16734900, 117.15156600, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120106001', '2', '西于庄街道', NULL, NULL, 39.16650600, 117.16438100, '120106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120106003', '2', '咸阳北路街道', NULL, NULL, 39.18491900, 117.14672000, '120106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120106004', '2', '丁字沽街道', NULL, NULL, 39.17449500, 117.16440900, '120106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120106005', '2', '西沽街道', NULL, NULL, 39.16518600, 117.13579600, '120106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120106006', '2', '三条石街道', NULL, NULL, 39.15457700, 117.17097300, '120106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120106008', '2', '邵公庄街道', NULL, NULL, 39.15346000, 117.13656600, '120106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120106009', '2', '芥园街道', NULL, NULL, 39.14862100, 117.15519700, '120106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120106010', '2', '铃铛阁街道', NULL, NULL, 39.14440300, 117.15841200, '120106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120106011', '2', '大胡同街道', NULL, NULL, 39.14819223, 117.18703473, '120106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110', '1', '东丽区', '东丽', 'dong,li', 39.08678900, 117.31356700, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110001', '2', '张贵庄街道', NULL, NULL, 39.08364700, 117.31396400, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110002', '2', '丰年村街道', NULL, NULL, 39.08170300, 117.33424100, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110003', '2', '万新街道', NULL, NULL, 39.11969000, 117.28353700, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110004', '2', '无瑕街道', NULL, NULL, 39.04297000, 117.49977800, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110005', '2', '新立街道', NULL, NULL, 39.07773700, 117.33597500, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110006', '2', '华明街道', NULL, NULL, 39.16542300, 117.39886500, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110007', '2', '金钟街道', NULL, NULL, 39.21029700, 117.26792800, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110008', '2', '军粮城街道', NULL, NULL, 39.04453900, 117.45827500, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110009', '2', '金桥街道', NULL, NULL, 39.07076600, 117.42007700, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110010', '2', '东丽湖街道', NULL, NULL, 39.16609600, 117.43692300, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110400', '2', '天津开发区西区', NULL, NULL, 39.09088100, 117.55182300, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110401', '2', '天津航空物流区', NULL, NULL, 39.11929500, 117.33839100, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110402', '2', '天津空港经济区', NULL, NULL, 39.15450300, 117.39171600, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110403', '2', '东丽区开发区', NULL, NULL, 39.07623200, 117.35959800, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110405', '2', '综合保税区', NULL, NULL, 39.10542500, 117.40592500, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120110407', '2', '滨海新区建设管理委员会', NULL, NULL, 39.11621000, 117.33436000, '120110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111', '1', '西青区', '西青', 'xi,qing', 39.14181100, 117.00899400, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111001', '2', '西营门街道', NULL, NULL, 39.15197100, 117.09483800, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111002', '2', '李七庄街道', NULL, NULL, 39.06708000, 117.14583100, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111005', '2', '津门湖街道', NULL, NULL, 39.04708600, 117.20152500, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111100', '2', '中北镇', NULL, NULL, 39.12638400, 117.09174800, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111101', '2', '杨柳青镇', NULL, NULL, 39.12848800, 117.01404200, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111102', '2', '辛口镇', NULL, NULL, 39.09044700, 116.97070200, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111103', '2', '张家窝镇', NULL, NULL, 39.05762900, 117.04217200, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111104', '2', '精武镇', NULL, NULL, 39.04355400, 117.11472500, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111105', '2', '大寺镇', NULL, NULL, 39.02012700, 117.24002700, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111106', '2', '王稳庄镇', NULL, NULL, 38.89453700, 117.26562800, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111400', '2', '开发区西青微电子小区', NULL, NULL, 38.99939800, 117.24038600, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111401', '2', '新技术产业园区', NULL, NULL, 39.09667800, 117.12479100, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120111450', '2', '西青区开发区', NULL, NULL, 39.01978800, 117.21519800, '120111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112', '1', '津南区', '津南', 'jin,nan', 38.93697100, 117.35668300, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112002', '2', '双林街道', NULL, NULL, 39.04856300, 117.29502100, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112100', '2', '咸水沽镇', NULL, NULL, 38.97891300, 117.39515100, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112101', '2', '葛沽镇', NULL, NULL, 38.99193800, 117.49097600, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112102', '2', '小站镇', NULL, NULL, 38.92462800, 117.44420100, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112103', '2', '双港镇', NULL, NULL, 39.04284000, 117.31842600, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112104', '2', '辛庄镇', NULL, NULL, 39.02626500, 117.35004000, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112106', '2', '双桥河镇', NULL, NULL, 38.99217000, 117.44413700, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112107', '2', '八里台镇', NULL, NULL, 38.94719300, 117.34335300, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112108', '2', '北闸口镇', NULL, NULL, 38.95057800, 117.40594300, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112401', '2', '铁路十八局', NULL, NULL, 39.06224300, 117.29817800, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112404', '2', '津南开发区东区', NULL, NULL, 38.98810700, 117.45609900, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112405', '2', '津南开发区西区', NULL, NULL, 39.03249400, 117.30452500, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120112407', '2', '海河教育园区', NULL, NULL, 38.99499300, 117.33577900, '120112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113', '1', '北辰区', '北辰', 'bei,chen', 39.22463800, 117.13561400, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113001', '2', '果园新村街道', NULL, NULL, 39.22119700, 117.13844200, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113002', '2', '集贤里街道', NULL, NULL, 39.23060200, 117.13220600, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113003', '2', '普东街道', NULL, NULL, 39.20602500, 117.20669100, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113004', '2', '瑞景街道', NULL, NULL, 39.19562600, 117.10636000, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113005', '2', '佳荣里街道', NULL, NULL, 39.19421700, 117.12193500, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113100', '2', '天穆镇', NULL, NULL, 39.20161900, 117.14958200, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113101', '2', '北仓镇', NULL, NULL, 39.23187200, 117.12581500, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113102', '2', '双街镇', NULL, NULL, 39.26207500, 117.13164900, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113103', '2', '双口镇', NULL, NULL, 39.22803100, 117.03642300, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113104', '2', '青光镇', NULL, NULL, 39.21548600, 117.03820400, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113106', '2', '宜兴埠镇', NULL, NULL, 39.21672100, 117.20962700, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113107', '2', '小淀镇', NULL, NULL, 39.24815000, 117.22596000, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113108', '2', '大张庄镇', NULL, NULL, 39.29089300, 117.22821100, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113111', '2', '西堤头镇', NULL, NULL, 39.25433300, 117.35337700, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113400', '2', '科技园区北区', NULL, NULL, 39.25681800, 117.13174700, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113401', '2', '科技园区南区', NULL, NULL, 39.22726400, 117.27120200, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113402', '2', '天津医药医疗器械工业园', NULL, NULL, 39.21230600, 117.02808800, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113403', '2', '天津陆路港物流装备产业园', NULL, NULL, 39.24866700, 117.31780000, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113404', '2', '天津风电产业园', NULL, NULL, 39.29952200, 117.17769500, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120113501', '2', '曙光农场', NULL, NULL, 39.26885000, 117.35944500, '120113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114', '1', '武清区', '武清', 'wu,qing', 39.38410800, 117.04456000, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114001', '2', '杨村街道', NULL, NULL, 39.39315400, 117.06248700, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114002', '2', '下朱庄街道', NULL, NULL, 39.33586200, 117.09133800, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114003', '2', '东蒲洼街道', NULL, NULL, 39.39376400, 117.00696100, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114004', '2', '黄庄街道', NULL, NULL, 39.35914000, 117.04578600, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114005', '2', '徐官屯街道', NULL, NULL, 39.39794600, 117.08546800, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114006', '2', '运河西街道', NULL, NULL, 39.38416800, 117.04453400, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114101', '2', '梅厂镇', NULL, NULL, 39.37033800, 117.20084200, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114102', '2', '大碱厂镇', NULL, NULL, 39.47262700, 117.09108000, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114103', '2', '崔黄口镇', NULL, NULL, 39.51855700, 117.18195900, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114104', '2', '大良镇', NULL, NULL, 39.54351200, 117.09527000, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114105', '2', '下伍旗镇', NULL, NULL, 39.61693600, 117.06136000, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114106', '2', '南蔡村镇', NULL, NULL, 39.48233300, 117.01688300, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114107', '2', '大孟庄镇', NULL, NULL, 39.52716600, 116.99100700, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114108', '2', '泗村店镇', NULL, NULL, 39.48010200, 116.95400300, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114109', '2', '河西务镇', NULL, NULL, 39.62359000, 116.95932900, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114110', '2', '城关镇', NULL, NULL, 39.53220800, 116.87325600, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114111', '2', '东马圈镇', NULL, NULL, 39.44923500, 116.84224100, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114112', '2', '黄花店镇', NULL, NULL, 39.35213400, 116.90828300, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114113', '2', '石各庄镇', NULL, NULL, 39.29933100, 116.90557500, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114114', '2', '王庆坨镇', NULL, NULL, 39.17205400, 116.93186700, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114115', '2', '汊沽港镇', NULL, NULL, 39.27120100, 116.93905300, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114116', '2', '河北屯镇', NULL, NULL, 39.58020300, 117.12882300, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114117', '2', '上马台镇', NULL, NULL, 39.37843500, 117.24948300, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114118', '2', '大王古庄镇', NULL, NULL, 39.57167600, 116.82608100, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114119', '2', '陈咀镇', NULL, NULL, 39.29315600, 117.00804300, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114120', '2', '白古屯镇', NULL, NULL, 39.55037500, 116.90704900, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114121', '2', '曹子里镇', NULL, NULL, 39.41394200, 117.13668200, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114122', '2', '大黄堡镇', NULL, NULL, 39.45127600, 117.25794200, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114123', '2', '豆张庄镇', NULL, NULL, 39.39999400, 116.94806800, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114124', '2', '高村镇', NULL, NULL, 39.63855900, 116.88186200, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114400', '2', '天津开发区逸仙科学工业园', NULL, NULL, 39.40756000, 117.03518700, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114401', '2', '武清区开发区', NULL, NULL, 39.41695200, 117.02101600, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114402', '2', '武清商务区', NULL, NULL, 39.62242900, 116.84279400, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114403', '2', '武清京滨园', NULL, NULL, 39.55286000, 116.81350600, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114405', '2', '武清汽车园', NULL, NULL, 39.37933700, 117.23796800, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114406', '2', '武清科技谷', NULL, NULL, 39.26261800, 116.94841600, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120114500', '2', '武清农场', NULL, NULL, 39.31132900, 117.13717600, '120114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115', '1', '宝坻区', '宝坻', 'bao,di', 39.71705400, 117.30974800, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115001', '2', '海滨街道', NULL, NULL, 39.72843600, 117.31658100, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115002', '2', '宝平街道', NULL, NULL, 39.71782200, 117.29763800, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115003', '2', '钰华街道', NULL, NULL, 39.69912400, 117.30956100, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115004', '2', '周良街道', NULL, NULL, 39.56350900, 117.38081300, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115007', '2', '朝霞街道', NULL, NULL, 39.74130600, 117.28482000, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115008', '2', '潮阳街道', NULL, NULL, 39.65517200, 117.28344700, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115101', '2', '大口屯镇', NULL, NULL, 39.58519800, 117.23802300, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115103', '2', '王卜庄镇', NULL, NULL, 39.68644500, 117.44731300, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115104', '2', '方家庄镇', NULL, NULL, 39.73035600, 117.42980500, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115105', '2', '林亭口镇', NULL, NULL, 39.63504600, 117.51507300, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115106', '2', '八门城镇', NULL, NULL, 39.57950900, 117.61358300, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115107', '2', '大钟庄镇', NULL, NULL, 39.69015000, 117.57153500, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115108', '2', '新安镇', NULL, NULL, 39.75640500, 117.53997800, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115111', '2', '霍各庄镇', NULL, NULL, 39.75795400, 117.39011000, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115113', '2', '新开口镇', NULL, NULL, 39.68055200, 117.20539200, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115115', '2', '大唐庄镇', NULL, NULL, 39.40664600, 117.44265100, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115119', '2', '牛道口镇', NULL, NULL, 39.79336500, 117.26167300, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115120', '2', '史各庄镇', NULL, NULL, 39.74695200, 117.22168000, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115121', '2', '郝各庄镇', NULL, NULL, 39.63214200, 117.32047700, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115123', '2', '牛家牌镇', NULL, NULL, 39.52282400, 117.29783600, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115124', '2', '尔王庄镇', NULL, NULL, 39.39848700, 117.36652500, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115125', '2', '黄庄镇', NULL, NULL, 39.49694700, 117.52544000, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115126', '2', '口东镇', NULL, NULL, 39.65822800, 117.37008100, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115127', '2', '大白庄镇', NULL, NULL, 39.44876200, 117.38944300, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115453', '2', '天宝工业园区', NULL, NULL, 39.76899000, 117.25900300, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115454', '2', '九园工业园区', NULL, NULL, 39.44670400, 117.43590500, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115455', '2', '京津新城', NULL, NULL, 39.54280800, 117.36311200, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115500', '2', '里自沽农场', NULL, NULL, 39.48849400, 117.34766700, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120115502', '2', '大钟农场', NULL, NULL, 39.70514100, 117.53836900, '120115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116', '1', '滨海新区', '滨海', 'bin,hai', 39.01780900, 117.69641000, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116005', '2', '杭州道街道', NULL, NULL, 39.04074000, 117.65876100, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116006', '2', '新河街道', NULL, NULL, 39.03870100, 117.63243000, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116007', '2', '大沽街道', NULL, NULL, 38.98569900, 117.66722900, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116008', '2', '新北街道', NULL, NULL, 39.05536300, 117.66152500, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116009', '2', '北塘街道', NULL, NULL, 39.10008600, 117.71197900, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116011', '2', '胡家园街道', NULL, NULL, 39.01176700, 117.58201600, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116012', '2', '泰达街道', NULL, NULL, 39.05065700, 117.70821500, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116021', '2', '汉沽街道', NULL, NULL, 39.25650600, 117.80193900, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116022', '2', '寨上街道', NULL, NULL, 39.24401100, 117.82570800, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116033', '2', '古林街道', NULL, NULL, 38.85791600, 117.49554300, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116034', '2', '海滨街道', NULL, NULL, 38.67202600, 117.39110800, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116036', '2', '塘沽街道', NULL, NULL, 39.00158300, 117.71148800, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116037', '2', '茶淀街道', NULL, NULL, 39.24537900, 117.78233300, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116038', '2', '大港街道', NULL, NULL, 38.85094000, 117.45908000, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116100', '2', '新城镇', NULL, NULL, 38.98827400, 117.61330600, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116102', '2', '杨家泊镇', NULL, NULL, 39.29935800, 117.90617000, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116105', '2', '太平镇', NULL, NULL, 38.61772000, 117.33656300, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116106', '2', '小王庄镇', NULL, NULL, 38.75413500, 117.17226400, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116107', '2', '中塘镇', NULL, NULL, 38.86201800, 117.39118600, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116401', '2', '保税区', NULL, NULL, 39.10542500, 117.40592500, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116402', '2', '天津滨海新区高新技术产业开发区', NULL, NULL, 39.09520000, 117.12476000, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116403', '2', '东疆保税港区', NULL, NULL, 39.03198000, 117.79738700, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116405', '2', '临港经济区', NULL, NULL, 38.95568700, 117.71563500, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116406', '2', '中新天津生态城', NULL, NULL, 39.12552800, 117.74265600, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120116408', '2', '南港工业区', NULL, NULL, 38.74208700, 117.55803000, '120116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117', '1', '宁河区', '宁河', 'ning,he', 39.32974900, 117.82667400, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117001', '2', '芦台街道', NULL, NULL, 39.32822200, 117.82250500, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117002', '2', '桥北街道', NULL, NULL, 39.34065800, 117.80158000, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117101', '2', '宁河镇', NULL, NULL, 39.46298500, 117.76313400, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117102', '2', '苗庄镇', NULL, NULL, 39.42900200, 117.81787000, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117103', '2', '丰台镇', NULL, NULL, 39.54739200, 117.75715800, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117104', '2', '岳龙镇', NULL, NULL, 39.57365400, 117.86192200, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117105', '2', '板桥镇', NULL, NULL, 39.48701300, 117.80846800, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117106', '2', '潘庄镇', NULL, NULL, 39.34534000, 117.47602100, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117107', '2', '造甲城镇', NULL, NULL, 39.28375700, 117.43177900, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117108', '2', '七里海镇', NULL, NULL, 39.30991000, 117.67374500, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117109', '2', '大北涧沽镇', NULL, NULL, 39.34152100, 117.74176900, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117110', '2', '东棘坨镇', NULL, NULL, 39.41989800, 117.55678500, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117111', '2', '俵口镇', NULL, NULL, 39.33005600, 117.57535100, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117112', '2', '廉庄镇', NULL, NULL, 39.40553000, 117.76877900, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117113', '2', '北淮淀镇', NULL, NULL, 39.26331400, 117.58089700, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117400', '2', '宁河区贸易开发区', NULL, NULL, 39.34954700, 117.81184800, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117401', '2', '宁河区经济开发区', NULL, NULL, 39.29979000, 117.81837000, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117451', '2', '宁河县现代产业园区', NULL, NULL, 39.24520200, 117.41051700, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117452', '2', '天津潘庄工业区', NULL, NULL, 39.29945900, 117.41036900, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120117500', '2', '潘庄农场', NULL, NULL, 39.31719500, 117.43708100, '120117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118', '1', '静海区', '静海', 'jing,hai', 38.94777200, 116.97547400, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118100', '2', '静海镇', NULL, NULL, 38.93008300, 116.92240200, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118101', '2', '唐官屯镇', NULL, NULL, 38.70849100, 116.90993800, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118102', '2', '独流镇', NULL, NULL, 39.02167100, 116.91165700, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118103', '2', '王口镇', NULL, NULL, 38.93383700, 116.76024300, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118104', '2', '台头镇', NULL, NULL, 39.02220900, 116.78872600, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118105', '2', '子牙镇', NULL, NULL, 38.82336800, 116.77552800, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118106', '2', '陈官屯镇', NULL, NULL, 38.82052400, 116.91323300, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118107', '2', '中旺镇', NULL, NULL, 38.63819000, 117.13658800, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118108', '2', '大邱庄镇', NULL, NULL, 38.83279300, 117.06444500, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118109', '2', '蔡公庄镇', NULL, NULL, 38.78959100, 117.08196400, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118110', '2', '梁头镇', NULL, NULL, 38.93532600, 116.85447500, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118111', '2', '团泊镇', NULL, NULL, 38.90309500, 117.16422300, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118112', '2', '双塘镇', NULL, NULL, 38.87241200, 116.91222300, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118113', '2', '大丰堆镇', NULL, NULL, 38.89697900, 117.00677300, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118114', '2', '沿庄镇', NULL, NULL, 38.81639900, 116.83285100, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118115', '2', '西翟庄镇', NULL, NULL, 38.76496600, 117.01217400, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118200', '2', '良王庄乡', NULL, NULL, 39.02582600, 116.97544600, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118201', '2', '杨成庄乡', NULL, NULL, 38.94563800, 117.05295800, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118400', '2', '天津静海经济开发区', NULL, NULL, 38.94010000, 116.96639000, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118402', '2', '天津子牙工业园区', NULL, NULL, 38.86544600, 116.80461900, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120118403', '2', '团泊新城', NULL, NULL, 38.89001000, 117.15232400, '120118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119', '1', '蓟州区', '蓟州', 'ji,zhou', 40.04654400, 117.40843200, '120000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119001', '2', '文昌街道', NULL, NULL, 40.04168800, 117.42764700, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119100', '2', '渔阳镇', NULL, NULL, 40.03494300, 117.40682000, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119101', '2', '洇溜镇', NULL, NULL, 39.98490900, 117.40565400, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119102', '2', '官庄镇', NULL, NULL, 40.06251400, 117.31017500, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119103', '2', '马伸桥镇', NULL, NULL, 40.08380500, 117.60466800, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119104', '2', '下营镇', NULL, NULL, 40.18403300, 117.44988700, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119105', '2', '邦均镇', NULL, NULL, 39.99074300, 117.29991500, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119106', '2', '别山镇', NULL, NULL, 39.95999900, 117.49490100, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119108', '2', '尤古庄镇', NULL, NULL, 39.90982800, 117.25182300, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119109', '2', '上仓镇', NULL, NULL, 39.90621800, 117.40159400, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119111', '2', '下仓镇', NULL, NULL, 39.78943200, 117.42345300, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119112', '2', '罗庄子镇', NULL, NULL, 40.13943900, 117.41945500, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119113', '2', '白涧镇', NULL, NULL, 39.99819300, 117.22271300, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119115', '2', '侯家营镇', NULL, NULL, 39.85619000, 117.25442200, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119116', '2', '桑梓镇', NULL, NULL, 39.91026700, 117.17229800, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119117', '2', '东施古镇', NULL, NULL, 39.88708300, 117.32917000, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119118', '2', '下窝头镇', NULL, NULL, 39.86420700, 117.40591300, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119119', '2', '杨津庄镇', NULL, NULL, 39.87114100, 117.42616800, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119120', '2', '出头岭镇', NULL, NULL, 40.07550600, 117.67697000, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119121', '2', '西龙虎峪镇', NULL, NULL, 40.00248000, 117.72283100, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119122', '2', '穿芳峪镇', NULL, NULL, 40.09884100, 117.54285400, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119123', '2', '东二营镇', NULL, NULL, 39.96011000, 117.29323500, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119124', '2', '许家台镇', NULL, NULL, 40.03499500, 117.27098500, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119125', '2', '礼明庄镇', NULL, NULL, 39.95768100, 117.44123900, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119126', '2', '东赵各庄镇', NULL, NULL, 39.96359500, 117.35350000, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119127', '2', '州河湾镇', NULL, NULL, 40.01098900, 117.42562600, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('120119203', '2', '孙各庄满族乡', NULL, NULL, 40.13646200, 117.59763000, '120119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130000', '0', '河北省', '河北', 'he,bei', 38.03770700, 114.53039900, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130100', '1', '石家庄市', '石家庄', 'shi,jia,zhuang', 38.04200700, 114.51497600, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130102', '2', '长安区', NULL, NULL, 38.03682000, 114.53895500, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130104', '2', '桥西区', NULL, NULL, 38.02522400, 114.44992500, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130105', '2', '新华区', NULL, NULL, 38.05074900, 114.46390400, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130107', '2', '井陉矿区', NULL, NULL, 38.06544600, 114.06225800, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130108', '2', '裕华区', NULL, NULL, 38.00700200, 114.53159900, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130109', '2', '藁城区', NULL, NULL, 38.02217700, 114.84656200, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130110', '2', '鹿泉区', NULL, NULL, 38.08653600, 114.31355900, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130111', '2', '栾城区', NULL, NULL, 37.90091500, 114.64792200, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130121', '2', '井陉县', NULL, NULL, 38.03236600, 114.14566900, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130123', '2', '正定县', NULL, NULL, 38.14699000, 114.57043000, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130125', '2', '行唐县', NULL, NULL, 38.43753500, 114.55304400, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130126', '2', '灵寿县', NULL, NULL, 38.30790800, 114.38301300, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130127', '2', '高邑县', NULL, NULL, 37.61590500, 114.61165900, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130128', '2', '深泽县', NULL, NULL, 38.18457200, 115.20089000, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130129', '2', '赞皇县', NULL, NULL, 37.66654900, 114.38611400, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130130', '2', '无极县', NULL, NULL, 38.17885200, 114.97625600, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130131', '2', '平山县', NULL, NULL, 38.26031200, 114.18598800, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130132', '2', '元氏县', NULL, NULL, 37.76733200, 114.52550800, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130133', '2', '赵县', NULL, NULL, 37.75693500, 114.77591400, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130181', '2', '辛集市', NULL, NULL, 37.94323900, 115.21762600, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130183', '2', '晋州市', NULL, NULL, 38.03436400, 115.04426800, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130184', '2', '新乐市', NULL, NULL, 38.34395200, 114.68374500, '130100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130200', '1', '唐山市', '唐山', 'tang,shan', 39.63068000, 118.18014900, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130202', '2', '路南区', NULL, NULL, 39.62498800, 118.15434800, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130203', '2', '路北区', NULL, NULL, 39.62507900, 118.20108500, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130204', '2', '古冶区', NULL, NULL, 39.73392000, 118.44713400, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130205', '2', '开平区', NULL, NULL, 39.67163400, 118.26224600, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130207', '2', '丰南区', NULL, NULL, 39.57588500, 118.08498500, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130208', '2', '丰润区', NULL, NULL, 39.83291900, 118.16242600, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130209', '2', '曹妃甸区', NULL, NULL, 39.27352800, 118.46019700, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130224', '2', '滦南县', NULL, NULL, 39.52027200, 118.68363000, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130225', '2', '乐亭县', NULL, NULL, 39.42574800, 118.91245000, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130227', '2', '迁西县', NULL, NULL, 40.14186200, 118.31464600, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130229', '2', '玉田县', NULL, NULL, 39.90182700, 117.73819600, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130271', '2', '芦台经济开发区', NULL, NULL, 39.38095100, 117.74737900, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130281', '2', '遵化市', NULL, NULL, 40.18911900, 117.96587800, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130283', '2', '迁安市', NULL, NULL, 39.99886100, 118.70102100, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130284', '2', '滦州市', NULL, NULL, 39.74096300, 118.70301000, '130200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130300', '1', '秦皇岛市', '秦皇岛', 'qin,huang,dao', 39.88824300, 119.52022000, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130302', '2', '海港区', NULL, NULL, 39.94846200, 119.56430000, '130300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130303', '2', '山海关区', NULL, NULL, 39.97888200, 119.77518700, '130300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130304', '2', '北戴河区', NULL, NULL, 39.83491200, 119.48449000, '130300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130306', '2', '抚宁区', NULL, NULL, 39.87621400, 119.24560700, '130300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130321', '2', '青龙满族自治县', NULL, NULL, 40.40747300, 118.94985000, '130300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130322', '2', '昌黎县', NULL, NULL, 39.69967700, 119.19984600, '130300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130324', '2', '卢龙县', NULL, NULL, 39.89256400, 118.89193100, '130300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130400', '1', '邯郸市', '邯郸', 'han,dan', 36.62584900, 114.53915000, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130402', '2', '邯山区', NULL, NULL, 36.59457000, 114.53106200, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130403', '2', '丛台区', NULL, NULL, 36.63643400, 114.49287500, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130404', '2', '复兴区', NULL, NULL, 36.63908600, 114.46228700, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130406', '2', '峰峰矿区', NULL, NULL, 36.41929800, 114.21257100, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130407', '2', '肥乡区', NULL, NULL, 36.54854500, 114.80019900, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130408', '2', '永年区', NULL, NULL, 36.77057600, 114.49677500, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130423', '2', '临漳县', NULL, NULL, 36.32250400, 114.58551400, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130424', '2', '成安县', NULL, NULL, 36.44533100, 114.67009400, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130425', '2', '大名县', NULL, NULL, 36.28640600, 115.14798500, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130426', '2', '涉县', NULL, NULL, 36.58607300, 113.69215700, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130427', '2', '磁县', NULL, NULL, 36.37507000, 114.37396500, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130430', '2', '邱县', NULL, NULL, 36.81178300, 115.20004900, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130431', '2', '鸡泽县', NULL, NULL, 36.91152500, 114.88995100, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130432', '2', '广平县', NULL, NULL, 36.48382000, 114.94863800, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130433', '2', '馆陶县', NULL, NULL, 36.54829500, 115.28181800, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130434', '2', '魏县', NULL, NULL, 36.35926000, 114.93921700, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130435', '2', '曲周县', NULL, NULL, 36.76634700, 114.95754900, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130481', '2', '武安市', NULL, NULL, 36.69726900, 114.20343200, '130400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130500', '1', '邢台市', '邢台', 'xing,tai', 37.05880400, 114.49732100, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130502', '2', '襄都区', NULL, NULL, 37.07131400, 114.50744300, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130503', '2', '信都区', NULL, NULL, 37.09379800, 114.46822900, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130505', '2', '任泽区', NULL, NULL, 37.12195800, 114.67133900, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130506', '2', '南和区', NULL, NULL, 37.00562600, 114.68368300, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130522', '2', '临城县', NULL, NULL, 37.44451200, 114.49865100, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130523', '2', '内丘县', NULL, NULL, 37.28761200, 114.51222600, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130524', '2', '柏乡县', NULL, NULL, 37.48288000, 114.69344700, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130525', '2', '隆尧县', NULL, NULL, 37.35123200, 114.77050900, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130528', '2', '宁晋县', NULL, NULL, 37.62452400, 114.94000600, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130529', '2', '巨鹿县', NULL, NULL, 37.22129300, 115.03788400, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130530', '2', '新河县', NULL, NULL, 37.52089100, 115.25100500, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130531', '2', '广宗县', NULL, NULL, 37.07479500, 115.14276600, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130532', '2', '平乡县', NULL, NULL, 37.06377100, 115.03008000, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130533', '2', '威县', NULL, NULL, 36.97516400, 115.26682900, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130534', '2', '清河县', NULL, NULL, 37.04600100, 115.66504200, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130535', '2', '临西县', NULL, NULL, 36.87131200, 115.50125800, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130581', '2', '南宫市', NULL, NULL, 37.35890700, 115.40866000, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130582', '2', '沙河市', NULL, NULL, 36.85554800, 114.50302300, '130500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130600', '1', '保定市', '保定', 'bao,ding', 38.87447600, 115.46452300, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130602', '2', '竞秀区', NULL, NULL, 38.87731800, 115.45867100, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130606', '2', '莲池区', NULL, NULL, 38.88352800, 115.49715300, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130607', '2', '满城区', NULL, NULL, 38.94973200, 115.32224600, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130608', '2', '清苑区', NULL, NULL, 38.76527000, 115.48988000, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130609', '2', '徐水区', NULL, NULL, 39.01878100, 115.65577200, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130623', '2', '涞水县', NULL, NULL, 39.39447100, 115.71388600, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130624', '2', '阜平县', NULL, NULL, 38.84978100, 114.19510300, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130626', '2', '定兴县', NULL, NULL, 39.26321900, 115.80818300, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130627', '2', '唐县', NULL, NULL, 38.74847700, 114.98296800, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130628', '2', '高阳县', NULL, NULL, 38.70084600, 115.77914900, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130629', '2', '容城县', NULL, NULL, 39.04332100, 115.86163500, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130630', '2', '涞源县', NULL, NULL, 39.36062200, 114.69441600, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130631', '2', '望都县', NULL, NULL, 38.69622100, 115.15542000, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130632', '2', '安新县', NULL, NULL, 38.93610200, 115.93568800, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130633', '2', '易县', NULL, NULL, 39.35021900, 115.49748700, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130634', '2', '曲阳县', NULL, NULL, 38.61440900, 114.74047600, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130635', '2', '蠡县', NULL, NULL, 38.48806400, 115.58370100, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130636', '2', '顺平县', NULL, NULL, 38.83798800, 115.13513300, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130637', '2', '博野县', NULL, NULL, 38.45804800, 115.46429500, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130638', '2', '雄县', NULL, NULL, 38.99482500, 116.10862400, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130681', '2', '涿州市', NULL, NULL, 39.48568400, 115.97444000, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130682', '2', '定州市', NULL, NULL, 38.51674600, 114.99032100, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130683', '2', '安国市', NULL, NULL, 38.41898500, 115.32708800, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130684', '2', '高碑店市', NULL, NULL, 39.32723300, 115.87361200, '130600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130700', '1', '张家口市', '张家口', 'zhang,jia,kou', 40.76893100, 114.88589500, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130702', '2', '桥东区', NULL, NULL, 40.78847200, 114.89411400, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130703', '2', '桥西区', NULL, NULL, 40.81955300, 114.86860400, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130705', '2', '宣化区', NULL, NULL, 40.60944400, 115.09951500, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130706', '2', '下花园区', NULL, NULL, 40.50262800, 115.28712700, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130708', '2', '万全区', NULL, NULL, 40.76737700, 114.74058400, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130709', '2', '崇礼区', NULL, NULL, 40.97474100, 115.28234500, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130722', '2', '张北县', NULL, NULL, 41.15903900, 114.71992700, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130723', '2', '康保县', NULL, NULL, 41.85301600, 114.60018000, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130724', '2', '沽源县', NULL, NULL, 41.67049700, 115.68854400, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130725', '2', '尚义县', NULL, NULL, 41.07658800, 113.96876300, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130726', '2', '蔚县', NULL, NULL, 39.84015400, 114.58913600, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130727', '2', '阳原县', NULL, NULL, 40.10430300, 114.15026700, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130728', '2', '怀安县', NULL, NULL, 40.67527000, 114.38648800, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130730', '2', '怀来县', NULL, NULL, 40.41562500, 115.51786800, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130731', '2', '涿鹿县', NULL, NULL, 40.38268100, 115.19683500, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130732', '2', '赤城县', NULL, NULL, 40.91334800, 115.83125600, '130700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130800', '1', '承德市', '承德', 'cheng,de', 40.95324000, 117.96285900, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130802', '2', '双桥区', NULL, NULL, 40.97467900, 117.94312100, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130803', '2', '双滦区', NULL, NULL, 40.95948500, 117.79941900, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130804', '2', '鹰手营子矿区', NULL, NULL, 40.54608700, 117.65937600, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130821', '2', '承德县', NULL, NULL, 40.76808200, 118.17416600, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130822', '2', '兴隆县', NULL, NULL, 40.41737400, 117.50094500, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130824', '2', '滦平县', NULL, NULL, 40.94164400, 117.33265200, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130825', '2', '隆化县', NULL, NULL, 41.31440200, 117.73902600, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130826', '2', '丰宁满族自治县', NULL, NULL, 41.20995100, 116.64579800, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130827', '2', '宽城满族自治县', NULL, NULL, 40.61166300, 118.48502100, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130828', '2', '围场满族蒙古族自治县', NULL, NULL, 41.93837200, 117.75934000, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130881', '2', '平泉市', NULL, NULL, 41.01848200, 118.70203200, '130800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130900', '1', '沧州市', '沧州', 'cang,zhou', 38.30467600, 116.83871500, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130902', '2', '新华区', NULL, NULL, 38.31409400, 116.86630900, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130903', '2', '运河区', NULL, NULL, 38.28345600, 116.84296400, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130921', '2', '沧县', NULL, NULL, 38.19811658, 116.78446772, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130922', '2', '青县', NULL, NULL, 38.58365700, 116.80413700, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130923', '2', '东光县', NULL, NULL, 37.88884400, 116.53713800, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130924', '2', '海兴县', NULL, NULL, 38.14330800, 117.49754500, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130925', '2', '盐山县', NULL, NULL, 38.05807400, 117.23068100, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130926', '2', '肃宁县', NULL, NULL, 38.42304400, 115.82961900, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130927', '2', '南皮县', NULL, NULL, 38.03876100, 116.70860300, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130928', '2', '吴桥县', NULL, NULL, 37.62822500, 116.39155700, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130929', '2', '献县', NULL, NULL, 38.23147900, 116.37029500, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130930', '2', '孟村回族自治县', NULL, NULL, 38.05343800, 117.10451400, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130981', '2', '泊头市', NULL, NULL, 38.08426200, 116.57832200, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130982', '2', '任丘市', NULL, NULL, 38.68532500, 116.08441200, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130983', '2', '黄骅市', NULL, NULL, 38.37226600, 117.33004300, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('130984', '2', '河间市', NULL, NULL, 38.44665600, 116.09936200, '130900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131000', '1', '廊坊市', '廊坊', 'lang,fang', 39.53830400, 116.68354600, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131002', '2', '安次区', NULL, NULL, 39.49152200, 116.70912700, '131000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131003', '2', '广阳区', NULL, NULL, 39.52343000, 116.71066700, '131000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131022', '2', '固安县', NULL, NULL, 39.43879700, 116.29869600, '131000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131023', '2', '永清县', NULL, NULL, 39.33098300, 116.50608000, '131000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131024', '2', '香河县', NULL, NULL, 39.76392300, 117.00615800, '131000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131025', '2', '大城县', NULL, NULL, 38.70523200, 116.65391700, '131000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131026', '2', '文安县', NULL, NULL, 38.87365300, 116.45789600, '131000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131028', '2', '大厂回族自治县', NULL, NULL, 39.88656900, 116.98961000, '131000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131081', '2', '霸州市', NULL, NULL, 39.12523800, 116.39148800, '131000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131082', '2', '三河市', NULL, NULL, 39.98293300, 117.07826900, '131000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131100', '1', '衡水市', '衡水', 'heng,shui', 37.73936700, 115.66898700, '130000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131102', '2', '桃城区', NULL, NULL, 37.73515200, 115.67520800, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131103', '2', '冀州区', NULL, NULL, 37.55092200, 115.57939200, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131121', '2', '枣强县', NULL, NULL, 37.51421700, 115.72436500, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131122', '2', '武邑县', NULL, NULL, 37.80203600, 115.88749800, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131123', '2', '武强县', NULL, NULL, 38.04144700, 115.98211900, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131124', '2', '饶阳县', NULL, NULL, 38.23531300, 115.72589800, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131125', '2', '安平县', NULL, NULL, 38.23476900, 115.51891800, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131126', '2', '故城县', NULL, NULL, 37.34787300, 115.96587700, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131127', '2', '景县', NULL, NULL, 37.69283100, 116.27055800, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131128', '2', '阜城县', NULL, NULL, 37.86298400, 116.17542400, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('131182', '2', '深州市', NULL, NULL, 38.00134100, 115.55975700, '131100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140000', '0', '山西省', '山西', 'shan,xi', 37.81218200, 112.57911600, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140100', '1', '太原市', '太原', 'tai,yuan', 37.87045100, 112.54965600, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140105', '2', '小店区', NULL, NULL, 37.73686500, 112.56552400, '140100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140106', '2', '迎泽区', NULL, NULL, 37.86334500, 112.56341200, '140100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140107', '2', '杏花岭区', NULL, NULL, 37.89424100, 112.57041200, '140100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140108', '2', '尖草坪区', NULL, NULL, 37.94005200, 112.48614100, '140100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140109', '2', '万柏林区', NULL, NULL, 37.85973800, 112.51563800, '140100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140110', '2', '晋源区', NULL, NULL, 37.71551900, 112.47786900, '140100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140121', '2', '清徐县', NULL, NULL, 37.60875100, 112.35936700, '140100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140122', '2', '阳曲县', NULL, NULL, 38.05851100, 112.67292000, '140100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140123', '2', '娄烦县', NULL, NULL, 38.06756900, 111.79715000, '140100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140181', '2', '古交市', NULL, NULL, 37.90741400, 112.17503400, '140100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140200', '1', '大同市', '大同', 'da,tong', 40.09711000, 113.36674900, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140212', '2', '新荣区', NULL, NULL, 40.25635500, 113.13962800, '140200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140213', '2', '平城区', NULL, NULL, 40.07524600, 113.29801100, '140200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140214', '2', '云冈区', NULL, NULL, 40.00488500, 113.14957200, '140200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140215', '2', '云州区', NULL, NULL, 40.04090400, 113.61237200, '140200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140221', '2', '阳高县', NULL, NULL, 40.36052700, 113.74950600, '140200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140222', '2', '天镇县', NULL, NULL, 40.42087000, 114.09087100, '140200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140223', '2', '广灵县', NULL, NULL, 39.76040400, 114.28270300, '140200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140224', '2', '灵丘县', NULL, NULL, 39.44246500, 114.23451200, '140200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140225', '2', '浑源县', NULL, NULL, 39.70649200, 113.69182200, '140200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140226', '2', '左云县', NULL, NULL, 40.01450600, 112.70333400, '140200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140300', '1', '阳泉市', '阳泉', 'yang,quan', 37.85709400, 113.58042600, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140302', '2', '城区', NULL, NULL, 37.84745700, 113.60069400, '140300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140303', '2', '矿区', NULL, NULL, 37.86849400, 113.55527900, '140300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140311', '2', '郊区', NULL, NULL, 37.94370300, 113.59399800, '140300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140321', '2', '平定县', NULL, NULL, 37.80498600, 113.62977700, '140300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140322', '2', '盂县', NULL, NULL, 38.08604100, 113.41227900, '140300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140400', '1', '长治市', '长治', 'chang,zhi', 36.19514200, 113.11739400, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140403', '2', '潞州区', NULL, NULL, 36.20328300, 113.12274900, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140404', '2', '上党区', NULL, NULL, 36.05315200, 113.05134800, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140405', '2', '屯留区', NULL, NULL, 36.31620000, 112.89230100, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140406', '2', '潞城区', NULL, NULL, 36.33459700, 113.22889700, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140423', '2', '襄垣县', NULL, NULL, 36.53562900, 113.05129800, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140425', '2', '平顺县', NULL, NULL, 36.20037000, 113.43585900, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140426', '2', '黎城县', NULL, NULL, 36.50225200, 113.38716500, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140427', '2', '壶关县', NULL, NULL, 36.11564500, 113.20683600, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140428', '2', '长子县', NULL, NULL, 36.12225800, 112.87792200, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140429', '2', '武乡县', NULL, NULL, 36.83786500, 112.86396000, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140430', '2', '沁县', NULL, NULL, 36.75615200, 112.69917600, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140431', '2', '沁源县', NULL, NULL, 36.49998900, 112.33772600, '140400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140500', '1', '晋城市', '晋城', 'jin,cheng', 35.49131500, 112.85202200, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140502', '2', '城区', NULL, NULL, 35.50248000, 112.85345200, '140500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140521', '2', '沁水县', NULL, NULL, 35.69011900, 112.18672600, '140500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140522', '2', '阳城县', NULL, NULL, 35.48627500, 112.41479800, '140500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140524', '2', '陵川县', NULL, NULL, 35.77523900, 113.28075500, '140500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140525', '2', '泽州县', NULL, NULL, 35.50706100, 112.92224300, '140500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140581', '2', '高平市', NULL, NULL, 35.79877500, 112.92379800, '140500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140600', '1', '朔州市', '朔州', 'shuo,zhou', 39.33173400, 112.43290600, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140602', '2', '朔城区', NULL, NULL, 39.32019600, 112.43207100, '140600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140603', '2', '平鲁区', NULL, NULL, 39.51221900, 112.28827000, '140600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140621', '2', '山阴县', NULL, NULL, 39.52744500, 112.81642100, '140600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140622', '2', '应县', NULL, NULL, 39.55447100, 113.19095200, '140600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140623', '2', '右玉县', NULL, NULL, 39.98919800, 112.46692600, '140600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140681', '2', '怀仁市', NULL, NULL, 39.82052200, 113.13306100, '140600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140700', '1', '晋中市', '晋中', 'jin,zhong', 37.68800600, 112.75263300, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140702', '2', '榆次区', NULL, NULL, 37.69863700, 112.70756400, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140703', '2', '太谷区', NULL, NULL, 37.42176000, 112.55126400, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140721', '2', '榆社县', NULL, NULL, 37.07120900, 112.97537800, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140722', '2', '左权县', NULL, NULL, 37.08274600, 113.37941200, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140723', '2', '和顺县', NULL, NULL, 37.32969600, 113.57029500, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140724', '2', '昔阳县', NULL, NULL, 37.61257700, 113.70715100, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140725', '2', '寿阳县', NULL, NULL, 37.89540800, 113.17684700, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140727', '2', '祁县', NULL, NULL, 37.35842500, 112.33522600, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140728', '2', '平遥县', NULL, NULL, 37.18961400, 112.17582500, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140729', '2', '灵石县', NULL, NULL, 36.84808500, 111.77869200, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140781', '2', '介休市', NULL, NULL, 37.02753800, 111.91645100, '140700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140800', '1', '运城市', '运城', 'yun,cheng', 35.02667000, 111.00705100, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140802', '2', '盐湖区', NULL, NULL, 35.01554900, 110.99813500, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140821', '2', '临猗县', NULL, NULL, 35.14434700, 110.77403500, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140822', '2', '万荣县', NULL, NULL, 35.41580500, 110.83795700, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140823', '2', '闻喜县', NULL, NULL, 35.35666400, 111.22448500, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140824', '2', '稷山县', NULL, NULL, 35.60451500, 110.98327300, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140825', '2', '新绛县', NULL, NULL, 35.61600700, 111.22476700, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140826', '2', '绛县', NULL, NULL, 35.49152200, 111.56784200, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140827', '2', '垣曲县', NULL, NULL, 35.29829700, 111.67021500, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140828', '2', '夏县', NULL, NULL, 35.14073300, 111.21994600, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140829', '2', '平陆县', NULL, NULL, 34.82959500, 111.19395700, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140830', '2', '芮城县', NULL, NULL, 34.69417300, 110.69441800, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140881', '2', '永济市', NULL, NULL, 34.86649900, 110.44777100, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140882', '2', '河津市', NULL, NULL, 35.59635700, 110.71203200, '140800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140900', '1', '忻州市', '忻州', 'xin,zhou', 38.41595800, 112.73414900, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140902', '2', '忻府区', NULL, NULL, 38.40349800, 112.74635700, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140921', '2', '定襄县', NULL, NULL, 38.47172500, 112.95723400, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140922', '2', '五台县', NULL, NULL, 38.72867300, 113.25520400, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140923', '2', '代县', NULL, NULL, 39.06692200, 112.96027200, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140924', '2', '繁峙县', NULL, NULL, 39.18883500, 113.26546400, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140925', '2', '宁武县', NULL, NULL, 39.00163200, 112.30458500, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140926', '2', '静乐县', NULL, NULL, 38.35954700, 111.93944100, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140927', '2', '神池县', NULL, NULL, 39.09107900, 112.21099700, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140928', '2', '五寨县', NULL, NULL, 38.91111000, 111.84680800, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140929', '2', '岢岚县', NULL, NULL, 38.70398900, 111.57296400, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140930', '2', '河曲县', NULL, NULL, 39.38452000, 111.13824700, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140931', '2', '保德县', NULL, NULL, 39.02261600, 111.08594400, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140932', '2', '偏关县', NULL, NULL, 39.43691700, 111.50892200, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('140981', '2', '原平市', NULL, NULL, 38.73141200, 112.71102500, '140900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141000', '1', '临汾市', '临汾', 'lin,fen', 36.08858100, 111.51931000, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141002', '2', '尧都区', NULL, NULL, 36.08246300, 111.57879700, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141021', '2', '曲沃县', NULL, NULL, 35.64188300, 111.47578300, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141022', '2', '翼城县', NULL, NULL, 35.73946400, 111.71904400, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141023', '2', '襄汾县', NULL, NULL, 35.87629300, 111.44172500, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141024', '2', '洪洞县', NULL, NULL, 36.25408700, 111.67571000, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141025', '2', '古县', NULL, NULL, 36.26676700, 111.92031000, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141026', '2', '安泽县', NULL, NULL, 36.14792100, 112.25024200, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141027', '2', '浮山县', NULL, NULL, 35.96812400, 111.84888300, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141028', '2', '吉县', NULL, NULL, 36.09683300, 110.68051300, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141029', '2', '乡宁县', NULL, NULL, 35.97083400, 110.84658500, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141030', '2', '大宁县', NULL, NULL, 36.46512600, 110.75291400, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141031', '2', '隰县', NULL, NULL, 36.69334500, 110.94075200, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141032', '2', '永和县', NULL, NULL, 36.75952400, 110.63198100, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141033', '2', '蒲县', NULL, NULL, 36.41183000, 111.09645700, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141034', '2', '汾西县', NULL, NULL, 36.65283300, 111.56399300, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141081', '2', '侯马市', NULL, NULL, 35.61910500, 111.37200200, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141082', '2', '霍州市', NULL, NULL, 36.56904600, 111.75511100, '141000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141100', '1', '吕梁市', '吕梁', 'lv,liang', 37.51899600, 111.14454000, '140000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141102', '2', '离石区', NULL, NULL, 37.51779700, 111.15032500, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141121', '2', '文水县', NULL, NULL, 37.43808300, 112.02880400, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141122', '2', '交城县', NULL, NULL, 37.55089300, 112.15628100, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141123', '2', '兴县', NULL, NULL, 38.46181800, 111.12748600, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141124', '2', '临县', NULL, NULL, 37.95100800, 110.99271200, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141125', '2', '柳林县', NULL, NULL, 37.42981600, 110.88899300, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141126', '2', '石楼县', NULL, NULL, 36.99846100, 110.83471200, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141127', '2', '岚县', NULL, NULL, 38.27958700, 111.67215600, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141128', '2', '方山县', NULL, NULL, 37.89501700, 111.24430900, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141129', '2', '中阳县', NULL, NULL, 37.35781600, 111.17884100, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141130', '2', '交口县', NULL, NULL, 36.98220900, 111.18126600, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141181', '2', '孝义市', NULL, NULL, 37.14605100, 111.77893500, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('141182', '2', '汾阳市', NULL, NULL, 37.26149300, 111.77083400, '141100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150000', '0', '内蒙古自治区', '内蒙古', 'nei,meng,gu', 40.81823300, 111.76522600, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150100', '1', '呼和浩特市', '呼和浩特', 'hu,he,hao,te', 40.84212700, 111.74881400, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150102', '2', '新城区', NULL, NULL, 40.85827100, 111.66532500, '150100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150103', '2', '回民区', NULL, NULL, 40.80890600, 111.62348500, '150100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150104', '2', '玉泉区', NULL, NULL, 40.75305400, 111.67415700, '150100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150105', '2', '赛罕区', NULL, NULL, 40.79250800, 111.70116600, '150100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150121', '2', '土默特左旗', NULL, NULL, 40.72904400, 111.16373000, '150100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150122', '2', '托克托县', NULL, NULL, 40.27770300, 111.19387900, '150100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150123', '2', '和林格尔县', NULL, NULL, 40.37922600, 111.82169500, '150100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150124', '2', '清水河县', NULL, NULL, 39.92122400, 111.64735100, '150100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150125', '2', '武川县', NULL, NULL, 41.09644900, 111.45122000, '150100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150200', '1', '包头市', '包头', 'bao,tou', 40.62132700, 109.95315000, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150202', '2', '东河区', NULL, NULL, 40.57626000, 110.04400800, '150200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150203', '2', '昆都仑区', NULL, NULL, 40.65807500, 109.84024900, '150200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150204', '2', '青山区', NULL, NULL, 30.61418104, 114.45401920, '150200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150205', '2', '石拐区', NULL, NULL, 40.67700700, 110.06132500, '150200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150206', '2', '白云鄂博矿区', NULL, NULL, 41.76995600, 109.97319500, '150200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150207', '2', '九原区', NULL, NULL, 40.61134600, 109.96808200, '150200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150221', '2', '土默特右旗', NULL, NULL, 40.57825300, 110.52783100, '150200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150222', '2', '固阳县', NULL, NULL, 41.03475700, 110.06005500, '150200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150223', '2', '达尔罕茂明安联合旗', NULL, NULL, 41.69875400, 110.43254400, '150200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150300', '1', '乌海市', '乌海', 'wu,hai', 39.65504800, 106.79415000, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150302', '2', '海勃湾区', NULL, NULL, 39.69087300, 106.82280000, '150300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150303', '2', '海南区', NULL, NULL, 39.44180300, 106.89147200, '150300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150304', '2', '乌达区', NULL, NULL, 39.50560900, 106.72604300, '150300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150400', '1', '赤峰市', '赤峰', 'chi,feng', 42.25687600, 118.88761300, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150402', '2', '红山区', NULL, NULL, 42.29631700, 118.95398900, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150403', '2', '元宝山区', NULL, NULL, 42.03960200, 119.28847500, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150404', '2', '松山区', NULL, NULL, 42.29979500, 118.91615600, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150421', '2', '阿鲁科尔沁旗', NULL, NULL, 43.87239800, 120.06553300, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150422', '2', '巴林左旗', NULL, NULL, 43.96154700, 119.36283200, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150423', '2', '巴林右旗', NULL, NULL, 43.53417100, 118.66423500, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150424', '2', '林西县', NULL, NULL, 43.61796500, 118.05543400, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150425', '2', '克什克腾旗', NULL, NULL, 43.26504800, 117.54549500, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150426', '2', '翁牛特旗', NULL, NULL, 42.93652900, 119.00618700, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150428', '2', '喀喇沁旗', NULL, NULL, 41.92710300, 118.70193400, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150429', '2', '宁城县', NULL, NULL, 41.60019300, 119.32005600, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150430', '2', '敖汉旗', NULL, NULL, 42.29073100, 119.92141300, '150400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150500', '1', '通辽市', '通辽', 'tong,liao', 43.65356600, 122.24330900, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150502', '2', '科尔沁区', NULL, NULL, 43.62313300, 122.25545000, '150500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150521', '2', '科尔沁左翼中旗', NULL, NULL, 44.12660600, 123.31220200, '150500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150522', '2', '科尔沁左翼后旗', NULL, NULL, 42.93510500, 122.35677000, '150500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150523', '2', '开鲁县', NULL, NULL, 43.60144600, 121.31921600, '150500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150524', '2', '库伦旗', NULL, NULL, 42.73555600, 121.81062900, '150500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150525', '2', '奈曼旗', NULL, NULL, 42.86743300, 120.65781300, '150500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150526', '2', '扎鲁特旗', NULL, NULL, 44.55392200, 120.89281400, '150500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150581', '2', '霍林郭勒市', NULL, NULL, 45.53359800, 119.68124200, '150500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150600', '1', '鄂尔多斯市', '鄂尔多斯', 'e,er,duo,si', 39.60874400, 109.78247300, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150602', '2', '东胜区', NULL, NULL, 39.82306600, 109.96340300, '150600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150603', '2', '康巴什区', NULL, NULL, 39.60793000, 109.85858600, '150600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150621', '2', '达拉特旗', NULL, NULL, 40.41276600, 110.03413300, '150600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150622', '2', '准格尔旗', NULL, NULL, 39.86492300, 111.23943600, '150600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150623', '2', '鄂托克前旗', NULL, NULL, 38.18240200, 107.47733000, '150600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150624', '2', '鄂托克旗', NULL, NULL, 39.08954900, 107.97594800, '150600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150625', '2', '杭锦旗', NULL, NULL, 39.83307900, 108.73591500, '150600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150626', '2', '乌审旗', NULL, NULL, 38.60453000, 108.81948500, '150600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150627', '2', '伊金霍洛旗', NULL, NULL, 39.56506400, 109.74743500, '150600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150700', '1', '呼伦贝尔市', '呼伦贝尔', 'hu,lun,bei,er', 49.16653600, 119.77845000, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150702', '2', '海拉尔区', NULL, NULL, 49.23492900, 119.82462000, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150703', '2', '扎赉诺尔区', NULL, NULL, 49.51121300, 117.66993900, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150721', '2', '阿荣旗', NULL, NULL, 48.12655300, 123.45894300, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150722', '2', '莫力达瓦达斡尔族自治旗', NULL, NULL, 48.47772800, 124.51902300, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150723', '2', '鄂伦春自治旗', NULL, NULL, 50.59163100, 123.72583000, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150724', '2', '鄂温克族自治旗', NULL, NULL, 49.14669100, 119.75575100, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150725', '2', '陈巴尔虎旗', NULL, NULL, 49.32891600, 119.42402600, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150726', '2', '新巴尔虎左旗', NULL, NULL, 48.21827000, 118.26978200, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150727', '2', '新巴尔虎右旗', NULL, NULL, 48.67186500, 116.82370000, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150781', '2', '满洲里市', NULL, NULL, 49.59862000, 117.37913400, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150782', '2', '牙克石市', NULL, NULL, 49.28594700, 120.71163900, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150783', '2', '扎兰屯市', NULL, NULL, 48.02839600, 122.70847500, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150784', '2', '额尔古纳市', NULL, NULL, 50.24310200, 120.18050600, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150785', '2', '根河市', NULL, NULL, 50.77975800, 121.52016500, '150700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150800', '1', '巴彦淖尔市', '巴彦淖尔', 'ba,yan,nao,er', 40.74298700, 107.38776700, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150802', '2', '临河区', NULL, NULL, 40.75096900, 107.36353600, '150800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150821', '2', '五原县', NULL, NULL, 41.08844600, 108.26746600, '150800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150822', '2', '磴口县', NULL, NULL, 40.33053400, 107.00828800, '150800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150823', '2', '乌拉特前旗', NULL, NULL, 40.73701800, 108.65211400, '150800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150824', '2', '乌拉特中旗', NULL, NULL, 41.58813000, 108.51365300, '150800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150825', '2', '乌拉特后旗', NULL, NULL, 41.08412000, 107.07474800, '150800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150826', '2', '杭锦后旗', NULL, NULL, 40.88659600, 107.15129700, '150800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150900', '1', '乌兰察布市', '乌兰察布', 'wu,lan,cha,bu', 40.99452600, 113.13222700, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150902', '2', '集宁区', NULL, NULL, 41.00074200, 113.16897300, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150921', '2', '卓资县', NULL, NULL, 40.89468000, 112.57769800, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150922', '2', '化德县', NULL, NULL, 41.90412300, 114.01029000, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150923', '2', '商都县', NULL, NULL, 41.56217600, 113.57777800, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150924', '2', '兴和县', NULL, NULL, 40.87238200, 113.83397200, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150925', '2', '凉城县', NULL, NULL, 40.53235800, 112.50424300, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150926', '2', '察哈尔右翼前旗', NULL, NULL, 40.78380700, 113.21309500, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150927', '2', '察哈尔右翼中旗', NULL, NULL, 41.29077100, 112.62083600, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150928', '2', '察哈尔右翼后旗', NULL, NULL, 41.43593700, 113.19150500, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150929', '2', '四子王旗', NULL, NULL, 41.53354200, 111.70666300, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('150981', '2', '丰镇市', NULL, NULL, 40.43702200, 113.10987500, '150900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152200', '1', '兴安盟', '兴安', 'xing,an', 46.08240300, 122.03777500, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152201', '2', '乌兰浩特市', NULL, NULL, 46.07223300, 122.09330900, '152200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152202', '2', '阿尔山市', NULL, NULL, 47.17744000, 119.94357700, '152200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152221', '2', '科尔沁右翼前旗', NULL, NULL, 46.07966500, 121.95263900, '152200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152222', '2', '科尔沁右翼中旗', NULL, NULL, 45.06072800, 121.47635700, '152200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152223', '2', '扎赉特旗', NULL, NULL, 46.72315400, 122.89962700, '152200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152224', '2', '突泉县', NULL, NULL, 45.38228100, 121.59395100, '152200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152500', '1', '锡林郭勒盟', '锡林郭勒', 'xi,lin,guo,le', 43.93321200, 116.04738700, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152501', '2', '二连浩特市', NULL, NULL, 43.64290900, 111.95037100, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152502', '2', '锡林浩特市', NULL, NULL, 43.93333500, 116.08590700, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152522', '2', '阿巴嘎旗', NULL, NULL, 44.02254300, 114.95038300, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152523', '2', '苏尼特左旗', NULL, NULL, 43.85971800, 113.66717100, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152524', '2', '苏尼特右旗', NULL, NULL, 42.74241700, 112.64180600, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152525', '2', '东乌珠穆沁旗', NULL, NULL, 45.49732900, 116.97526000, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152526', '2', '西乌珠穆沁旗', NULL, NULL, 44.58774600, 117.60866800, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152527', '2', '太仆寺旗', NULL, NULL, 41.87688900, 115.28317300, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152528', '2', '镶黄旗', NULL, NULL, 42.23239500, 113.84705300, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152529', '2', '正镶白旗', NULL, NULL, 42.28749300, 115.02974800, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152530', '2', '正蓝旗', NULL, NULL, 42.24181500, 115.99164800, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152531', '2', '多伦县', NULL, NULL, 42.20345400, 116.48554900, '152500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152900', '1', '阿拉善盟', '阿拉善', 'a,la,shan', 38.85155900, 105.72913900, '150000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152921', '2', '阿拉善左旗', NULL, NULL, 38.83384000, 105.66604700, '152900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152922', '2', '阿拉善右旗', NULL, NULL, 39.21618500, 101.66691700, '152900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('152923', '2', '额济纳旗', NULL, NULL, 41.95396300, 101.05586100, '152900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210000', '0', '辽宁省', '辽宁', 'liao,ning', 41.83674300, 123.43509300, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210100', '1', '沈阳市', '沈阳', 'shen,yang', 41.67757600, 123.46467500, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210102', '2', '和平区', NULL, NULL, 41.78976600, 123.42040100, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210103', '2', '沈河区', NULL, NULL, 41.79568800, 123.45884000, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210104', '2', '大东区', NULL, NULL, 41.80529200, 123.46982800, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210105', '2', '皇姑区', NULL, NULL, 41.82457400, 123.44146800, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210106', '2', '铁西区', NULL, NULL, 41.82172100, 123.33478100, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210111', '2', '苏家屯区', NULL, NULL, 41.66515300, 123.34393700, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210112', '2', '浑南区', NULL, NULL, 41.71472900, 123.44959700, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210113', '2', '沈北新区', NULL, NULL, 41.91307100, 123.58420900, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210114', '2', '于洪区', NULL, NULL, 41.79392500, 123.30806200, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210115', '2', '辽中区', NULL, NULL, 41.51744900, 122.76615900, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210123', '2', '康平县', NULL, NULL, 42.72724900, 123.34370100, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210124', '2', '法库县', NULL, NULL, 42.50110000, 123.44008900, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210181', '2', '新民市', NULL, NULL, 41.98575700, 122.83596400, '210100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210200', '1', '大连市', '大连', 'da,lian', 38.91396200, 121.61478600, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210202', '2', '中山区', NULL, NULL, 38.91835700, 121.64499600, '210200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210203', '2', '西岗区', NULL, NULL, 38.91475100, 121.61246100, '210200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210204', '2', '沙河口区', NULL, NULL, 38.90477100, 121.59420100, '210200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210211', '2', '甘井子区', NULL, NULL, 38.95299800, 121.52546900, '210200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210212', '2', '旅顺口区', NULL, NULL, 38.85171800, 121.26188000, '210200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210213', '2', '金州区', NULL, NULL, 39.05021100, 121.78251300, '210200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210214', '2', '普兰店区', NULL, NULL, 39.39156500, 121.93829900, '210200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210224', '2', '长海县', NULL, NULL, 39.27277900, 122.58848700, '210200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210281', '2', '瓦房店市', NULL, NULL, 39.62701000, 121.97946300, '210200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210283', '2', '庄河市', NULL, NULL, 39.68082500, 122.96588100, '210200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210300', '1', '鞍山市', '鞍山', 'an,shan', 41.10823900, 122.99418300, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210302', '2', '铁东区', NULL, NULL, 41.08957800, 122.99088800, '210300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210303', '2', '铁西区', NULL, NULL, 41.11981600, 122.96963400, '210300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210304', '2', '立山区', NULL, NULL, 41.15019000, 123.02907100, '210300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210311', '2', '千山区', NULL, NULL, 40.98649316, 122.95204413, '210300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210321', '2', '台安县', NULL, NULL, 41.41286600, 122.43603700, '210300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210323', '2', '岫岩满族自治县', NULL, NULL, 40.29099500, 123.28093300, '210300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210381', '2', '海城市', NULL, NULL, 40.88254800, 122.68517600, '210300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210400', '1', '抚顺市', '抚顺', 'fu,shun', 41.88131100, 123.95705300, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210402', '2', '新抚区', NULL, NULL, 41.86192200, 123.91293000, '210400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210403', '2', '东洲区', NULL, NULL, 41.85300100, 124.03849100, '210400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210404', '2', '望花区', NULL, NULL, 41.85348400, 123.78423500, '210400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210411', '2', '顺城区', NULL, NULL, 41.88359400, 123.94489600, '210400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210421', '2', '抚顺县', NULL, NULL, 41.65066000, 123.98517800, '210400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210422', '2', '新宾满族自治县', NULL, NULL, 41.73403100, 125.03999400, '210400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210423', '2', '清原满族自治县', NULL, NULL, 42.10080400, 124.92402800, '210400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210500', '1', '本溪市', '本溪', 'ben,xi', 41.48683400, 123.68498400, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210502', '2', '平山区', NULL, NULL, 41.29969500, 123.76903600, '210500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210503', '2', '溪湖区', NULL, NULL, 41.32931000, 123.76781700, '210500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210504', '2', '明山区', NULL, NULL, 41.34362400, 123.86174700, '210500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210505', '2', '南芬区', NULL, NULL, 41.10027300, 123.74482200, '210500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210521', '2', '本溪满族自治县', NULL, NULL, 41.30155300, 124.11954500, '210500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210522', '2', '桓仁满族自治县', NULL, NULL, 41.26713400, 125.36124800, '210500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210600', '1', '丹东市', '丹东', 'dan,dong', 40.00064600, 124.35441900, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210602', '2', '元宝区', NULL, NULL, 40.13654900, 124.39557700, '210600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210603', '2', '振兴区', NULL, NULL, 40.12973600, 124.38335000, '210600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210604', '2', '振安区', NULL, NULL, 40.20169800, 124.47045200, '210600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210624', '2', '宽甸满族自治县', NULL, NULL, 40.73131900, 124.78367400, '210600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210681', '2', '东港市', NULL, NULL, 39.86319300, 124.15258100, '210600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210682', '2', '凤城市', NULL, NULL, 40.45218000, 124.06687300, '210600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210700', '1', '锦州市', '锦州', 'jin,zhou', 41.09611400, 121.12685900, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210702', '2', '古塔区', NULL, NULL, 41.11737900, 121.12827200, '210700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210703', '2', '凌河区', NULL, NULL, 41.11484400, 121.15099500, '210700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210711', '2', '太和区', NULL, NULL, 41.10923200, 121.10344500, '210700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210726', '2', '黑山县', NULL, NULL, 41.65355200, 122.12664500, '210700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210727', '2', '义县', NULL, NULL, 41.53355300, 121.23955800, '210700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210781', '2', '凌海市', NULL, NULL, 41.16063600, 121.35499000, '210700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210782', '2', '北镇市', NULL, NULL, 41.58865700, 121.77750300, '210700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210800', '1', '营口市', '营口', 'ying,kou', 40.62502700, 122.21914800, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210802', '2', '站前区', NULL, NULL, 40.67306300, 122.25905800, '210800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210803', '2', '西市区', NULL, NULL, 40.66670700, 122.20643100, '210800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210804', '2', '鲅鱼圈区', NULL, NULL, 40.22682100, 122.12164700, '210800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210811', '2', '老边区', NULL, NULL, 40.67127900, 122.30795600, '210800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210881', '2', '盖州市', NULL, NULL, 40.40025900, 122.34845000, '210800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210882', '2', '大石桥市', NULL, NULL, 40.64448200, 122.50900600, '210800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210900', '1', '阜新市', '阜新', 'fu,xin', 42.02202800, 121.67005200, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210902', '2', '海州区', NULL, NULL, 42.01779400, 121.66259400, '210900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210903', '2', '新邱区', NULL, NULL, 42.08754900, 121.79206700, '210900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210904', '2', '太平区', NULL, NULL, 42.01050700, 121.67821800, '210900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210905', '2', '清河门区', NULL, NULL, 41.78310000, 121.41610500, '210900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210911', '2', '细河区', NULL, NULL, 42.02583100, 121.67978600, '210900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210921', '2', '阜新蒙古族自治县', NULL, NULL, 42.06524800, 121.75745100, '210900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('210922', '2', '彰武县', NULL, NULL, 42.38626400, 122.53856300, '210900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211000', '1', '辽阳市', '辽阳', 'liao,yang', 41.26739600, 123.23966900, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211002', '2', '白塔区', NULL, NULL, 41.27033300, 123.17432800, '211000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211003', '2', '文圣区', NULL, NULL, 41.28340300, 123.23166700, '211000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211004', '2', '宏伟区', NULL, NULL, 41.21785200, 123.19672500, '211000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211005', '2', '弓长岭区', NULL, NULL, 41.15178700, 123.41956700, '211000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211011', '2', '太子河区', NULL, NULL, 41.32117795, 123.08929658, '211000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211021', '2', '辽阳县', NULL, NULL, 41.20624600, 123.10642600, '211000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211081', '2', '灯塔市', NULL, NULL, 41.42653700, 123.33939800, '211000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211100', '1', '盘锦市', '盘锦', 'pan,jin', 40.71956000, 122.17072900, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211102', '2', '双台子区', NULL, NULL, 41.21240200, 122.07597000, '211100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211103', '2', '兴隆台区', NULL, NULL, 41.12026100, 122.07068500, '211100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211104', '2', '大洼区', NULL, NULL, 41.00267900, 122.08222700, '211100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211122', '2', '盘山县', NULL, NULL, 41.24336700, 121.99640800, '211100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211200', '1', '铁岭市', '铁岭', 'tie,ling', 42.22370900, 123.72600800, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211202', '2', '银州区', NULL, NULL, 42.28657500, 123.84247200, '211200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211204', '2', '清河区', NULL, NULL, 42.54716100, 124.15975800, '211200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211221', '2', '铁岭县', NULL, NULL, 42.22339500, 123.72893300, '211200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211223', '2', '西丰县', NULL, NULL, 42.73817800, 124.72749100, '211200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211224', '2', '昌图县', NULL, NULL, 42.77933300, 124.08662800, '211200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211281', '2', '调兵山市', NULL, NULL, 42.46800700, 123.56703900, '211200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211282', '2', '开原市', NULL, NULL, 42.57778900, 124.05186000, '211200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211300', '1', '朝阳市', '朝阳', 'chao,yang', 41.60185500, 120.48880100, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211302', '2', '双塔区', NULL, NULL, 41.56605300, 120.45368900, '211300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211303', '2', '龙城区', NULL, NULL, 41.59229400, 120.43773400, '211300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211321', '2', '朝阳县', NULL, NULL, 41.49792300, 120.39000100, '211300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211322', '2', '建平县', NULL, NULL, 41.40289100, 119.64328000, '211300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211324', '2', '喀喇沁左翼蒙古族自治县', NULL, NULL, 41.12815000, 119.74122300, '211300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211381', '2', '北票市', NULL, NULL, 41.80111700, 120.77138900, '211300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211382', '2', '凌源市', NULL, NULL, 41.24513100, 119.40140500, '211300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211400', '1', '葫芦岛市', '葫芦岛', 'hu,lu,dao', 40.71097400, 120.83678300, '210000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211402', '2', '连山区', NULL, NULL, 40.77478400, 120.86915700, '211400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211403', '2', '龙港区', NULL, NULL, 40.73571700, 120.89405400, '211400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211404', '2', '南票区', NULL, NULL, 41.10709600, 120.74975800, '211400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211421', '2', '绥中县', NULL, NULL, 40.32557600, 120.34432000, '211400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211422', '2', '建昌县', NULL, NULL, 40.82448400, 119.83666900, '211400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('211481', '2', '兴城市', NULL, NULL, 40.60999000, 120.75666100, '211400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220000', '0', '吉林省', '吉林', 'ji,lin', 43.89694200, 125.32580200, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220100', '1', '长春市', '长春', 'chang,chun', 43.81699600, 125.32364300, '220000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220102', '2', '南关区', NULL, NULL, 43.86382000, 125.35034100, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220103', '2', '宽城区', NULL, NULL, 43.94352200, 125.32661400, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220104', '2', '朝阳区', NULL, NULL, 43.83384500, 125.28816800, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220105', '2', '二道区', NULL, NULL, 43.86591200, 125.37419000, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220106', '2', '绿园区', NULL, NULL, 43.88104700, 125.25621400, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220112', '2', '双阳区', NULL, NULL, 43.52536700, 125.66458300, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220113', '2', '九台区', NULL, NULL, 44.15224600, 125.83955700, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220122', '2', '农安县', NULL, NULL, 44.43238600, 125.18403100, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220182', '2', '榆树市', NULL, NULL, 44.84026300, 126.53312600, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220183', '2', '德惠市', NULL, NULL, 44.52178800, 125.72855200, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220184', '2', '公主岭市', NULL, NULL, 43.49528500, 124.79368200, '220100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220200', '1', '吉林市', '吉林', 'ji,lin', 43.83813200, 126.54971900, '220000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220202', '2', '昌邑区', NULL, NULL, 43.88189600, 126.57441400, '220200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220203', '2', '龙潭区', NULL, NULL, 43.91074300, 126.56213100, '220200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220204', '2', '船营区', NULL, NULL, 43.83380600, 126.54090900, '220200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220211', '2', '丰满区', NULL, NULL, 43.82119200, 126.56135100, '220200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220221', '2', '永吉县', NULL, NULL, 43.67219800, 126.49789900, '220200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220281', '2', '蛟河市', NULL, NULL, 43.72439100, 127.34420500, '220200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220282', '2', '桦甸市', NULL, NULL, 42.97227200, 126.74624500, '220200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220283', '2', '舒兰市', NULL, NULL, 44.40592200, 126.96551500, '220200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220284', '2', '磐石市', NULL, NULL, 42.94660800, 126.06032800, '220200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220300', '1', '四平市', '四平', 'si,ping', 43.16676400, 124.35059900, '220000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220302', '2', '铁西区', NULL, NULL, 43.14615200, 124.34612700, '220300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220303', '2', '铁东区', NULL, NULL, 43.16266400, 124.40985200, '220300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220322', '2', '梨树县', NULL, NULL, 43.30660800, 124.33559600, '220300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220323', '2', '伊通满族自治县', NULL, NULL, 43.34575400, 125.30539300, '220300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220382', '2', '双辽市', NULL, NULL, 43.51808300, 123.50291100, '220300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220400', '1', '辽源市', '辽源', 'liao,yuan', 42.88796100, 125.14467600, '220000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220402', '2', '龙山区', NULL, NULL, 42.90219400, 125.13703000, '220400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220403', '2', '西安区', NULL, NULL, 42.92725200, 125.14948800, '220400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220421', '2', '东丰县', NULL, NULL, 42.67725300, 125.53096000, '220400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220422', '2', '东辽县', NULL, NULL, 42.92563900, 124.99101000, '220400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220500', '1', '通化市', '通化', 'tong,hua', 41.72831200, 125.93972100, '220000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220502', '2', '东昌区', NULL, NULL, 41.70287200, 125.92718700, '220500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220503', '2', '二道江区', NULL, NULL, 41.77398900, 126.04254600, '220500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220521', '2', '通化县', NULL, NULL, 41.68013500, 125.75892700, '220500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220523', '2', '辉南县', NULL, NULL, 42.68470600, 126.04600600, '220500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220524', '2', '柳河县', NULL, NULL, 42.28486500, 125.74469000, '220500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220581', '2', '梅河口市', NULL, NULL, 42.53918300, 125.71112900, '220500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220582', '2', '集安市', NULL, NULL, 41.12580500, 126.19317200, '220500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220600', '1', '白山市', '白山', 'bai,shan', 41.94413200, 126.41427400, '220000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220602', '2', '浑江区', NULL, NULL, 41.94525600, 126.41588700, '220600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220605', '2', '江源区', NULL, NULL, 42.05633900, 126.59157400, '220600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220621', '2', '抚松县', NULL, NULL, 42.22104500, 127.44943200, '220600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220622', '2', '靖宇县', NULL, NULL, 42.38890200, 126.81326200, '220600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220623', '2', '长白朝鲜族自治县', NULL, NULL, 41.42067300, 128.20063300, '220600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220681', '2', '临江市', NULL, NULL, 41.81197900, 126.91808600, '220600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220700', '1', '松原市', '松原', 'song,yuan', 45.14190800, 124.82531000, '220000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220702', '2', '宁江区', NULL, NULL, 45.18631100, 124.79253700, '220700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220721', '2', '前郭尔罗斯蒙古族自治县', NULL, NULL, 45.11818600, 124.82343000, '220700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220722', '2', '长岭县', NULL, NULL, 44.27629300, 123.96724400, '220700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220723', '2', '乾安县', NULL, NULL, 45.00353900, 124.04065100, '220700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220781', '2', '扶余市', NULL, NULL, 44.98905700, 126.04953400, '220700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220800', '1', '白城市', '白城', 'bai,cheng', 45.62013100, 122.83810200, '220000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220802', '2', '洮北区', NULL, NULL, 45.62154500, 122.85110500, '220800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220821', '2', '镇赉县', NULL, NULL, 45.84819500, 123.19967000, '220800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220822', '2', '通榆县', NULL, NULL, 44.81371700, 123.08775700, '220800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220881', '2', '洮南市', NULL, NULL, 45.35684900, 122.79845000, '220800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('220882', '2', '大安市', NULL, NULL, 45.50700400, 124.29103200, '220800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('222400', '1', '延边朝鲜族自治州', '延边', 'yan,bian', 42.90942600, 129.47060500, '220000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('222401', '2', '延吉市', NULL, NULL, 42.89103400, 129.50765500, '222400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('222402', '2', '图们市', NULL, NULL, 42.96803900, 129.84380700, '222400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('222403', '2', '敦化市', NULL, NULL, 43.37301700, 128.23259500, '222400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('222404', '2', '珲春市', NULL, NULL, 42.86255100, 130.36582900, '222400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('222405', '2', '龙井市', NULL, NULL, 42.76717200, 129.42652900, '222400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('222406', '2', '和龙市', NULL, NULL, 42.54643400, 129.01093200, '222400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('222424', '2', '汪清县', NULL, NULL, 43.31721500, 129.78513700, '222400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('222426', '2', '安图县', NULL, NULL, 43.11197800, 128.89974400, '222400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230000', '0', '黑龙江省', '黑龙江', 'hei,long,jiang', 45.74225300, 126.66199800, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230100', '1', '哈尔滨市', '哈尔滨', 'ha,er,bin', 45.80298100, 126.53505000, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230102', '2', '道里区', NULL, NULL, 45.75583200, 126.61691200, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230103', '2', '南岗区', NULL, NULL, 45.75996700, 126.66882000, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230104', '2', '道外区', NULL, NULL, 45.79235100, 126.64909400, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230108', '2', '平房区', NULL, NULL, 45.59752900, 126.63675000, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230109', '2', '松北区', NULL, NULL, 45.79499100, 126.51660200, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230110', '2', '香坊区', NULL, NULL, 45.70784300, 126.66300500, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230111', '2', '呼兰区', NULL, NULL, 45.88955700, 126.58770400, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230112', '2', '阿城区', NULL, NULL, 45.54867100, 126.95798400, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230113', '2', '双城区', NULL, NULL, 45.38287300, 126.31279000, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230123', '2', '依兰县', NULL, NULL, 46.32553600, 129.56777700, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230124', '2', '方正县', NULL, NULL, 45.85167300, 128.82951300, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230125', '2', '宾县', NULL, NULL, 45.74631300, 127.46637200, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230126', '2', '巴彦县', NULL, NULL, 46.08619400, 127.40351600, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230127', '2', '木兰县', NULL, NULL, 45.95016600, 128.04323700, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230128', '2', '通河县', NULL, NULL, 45.99021400, 128.74629000, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230129', '2', '延寿县', NULL, NULL, 45.44595600, 128.31107100, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230183', '2', '尚志市', NULL, NULL, 45.20919900, 128.00921800, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230184', '2', '五常市', NULL, NULL, 44.93216400, 127.16750100, '230100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230200', '1', '齐齐哈尔市', '齐齐哈尔', 'qi,qi,ha,er', 47.35489200, 123.91819300, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230202', '2', '龙沙区', NULL, NULL, 47.31710300, 123.95844700, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230203', '2', '建华区', NULL, NULL, 47.35436900, 123.95598500, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230204', '2', '铁锋区', NULL, NULL, 47.34039700, 123.97826200, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230205', '2', '昂昂溪区', NULL, NULL, 47.15480600, 123.82213700, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230206', '2', '富拉尔基区', NULL, NULL, 47.20873000, 123.62892600, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230207', '2', '碾子山区', NULL, NULL, 47.51661400, 122.88754800, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230208', '2', '梅里斯达斡尔族区', NULL, NULL, 47.30958300, 123.75251700, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230221', '2', '龙江县', NULL, NULL, 47.33851200, 123.20495300, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230223', '2', '依安县', NULL, NULL, 47.89344200, 125.30616100, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230224', '2', '泰来县', NULL, NULL, 46.39298300, 123.41671000, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230225', '2', '甘南县', NULL, NULL, 47.92169800, 123.50793500, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230227', '2', '富裕县', NULL, NULL, 47.77403800, 124.47441100, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230229', '2', '克山县', NULL, NULL, 48.03774800, 125.87510300, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230230', '2', '克东县', NULL, NULL, 48.04156200, 126.24912400, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230231', '2', '拜泉县', NULL, NULL, 47.59586000, 126.09905000, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230281', '2', '讷河市', NULL, NULL, 48.46682900, 124.88293000, '230200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230300', '1', '鸡西市', '鸡西', 'ji,xi', 45.29508700, 130.96938500, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230302', '2', '鸡冠区', NULL, NULL, 45.30410900, 130.98085300, '230300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230303', '2', '恒山区', NULL, NULL, 45.21099400, 130.90461500, '230300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230304', '2', '滴道区', NULL, NULL, 45.34906800, 130.84419300, '230300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230305', '2', '梨树区', NULL, NULL, 45.09204600, 130.69699000, '230300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230306', '2', '城子河区', NULL, NULL, 45.33834200, 131.01150400, '230300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230307', '2', '麻山区', NULL, NULL, 45.21171900, 130.47747600, '230300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230321', '2', '鸡东县', NULL, NULL, 45.25984700, 131.12412300, '230300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230381', '2', '虎林市', NULL, NULL, 45.76326200, 132.93700200, '230300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230382', '2', '密山市', NULL, NULL, 45.52948200, 131.84682400, '230300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230400', '1', '鹤岗市', '鹤岗', 'he,gang', 47.35065900, 130.29768700, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230402', '2', '向阳区', NULL, NULL, 47.34247800, 130.29433100, '230400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230403', '2', '工农区', NULL, NULL, 47.31871900, 130.27447300, '230400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230404', '2', '南山区', NULL, NULL, 47.31518500, 130.28632700, '230400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230405', '2', '兴安区', NULL, NULL, 47.25280500, 130.23928900, '230400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230406', '2', '东山区', NULL, NULL, 47.33867100, 130.31679100, '230400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230407', '2', '兴山区', NULL, NULL, 47.35769800, 130.30359800, '230400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230421', '2', '萝北县', NULL, NULL, 47.57910100, 130.82073400, '230400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230422', '2', '绥滨县', NULL, NULL, 47.28952200, 131.85286300, '230400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230500', '1', '双鸭山市', '双鸭山', 'shuang,ya,shan', 46.67615700, 131.14156300, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230502', '2', '尖山区', NULL, NULL, 46.64608300, 131.15837200, '230500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230503', '2', '岭东区', NULL, NULL, 46.59261100, 131.16536300, '230500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230505', '2', '四方台区', NULL, NULL, 46.59714300, 131.33763600, '230500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230506', '2', '宝山区', NULL, NULL, 46.57716700, 131.40158900, '230500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230521', '2', '集贤县', NULL, NULL, 46.72844800, 131.14145200, '230500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230522', '2', '友谊县', NULL, NULL, 46.76729900, 131.80781500, '230500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230523', '2', '宝清县', NULL, NULL, 46.32733500, 132.19690700, '230500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230524', '2', '饶河县', NULL, NULL, 46.79726000, 134.01412500, '230500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230600', '1', '大庆市', '大庆', 'da,qing', 46.58949800, 125.10407800, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230602', '2', '萨尔图区', NULL, NULL, 46.62928100, 125.13526900, '230600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230603', '2', '龙凤区', NULL, NULL, 46.56236900, 125.13509300, '230600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230604', '2', '让胡路区', NULL, NULL, 46.64256700, 124.88985800, '230600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230605', '2', '红岗区', NULL, NULL, 46.39856700, 124.89104100, '230600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230606', '2', '大同区', NULL, NULL, 46.03997200, 124.81222100, '230600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230621', '2', '肇州县', NULL, NULL, 45.69954300, 125.26844900, '230600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230622', '2', '肇源县', NULL, NULL, 45.51898200, 125.07831100, '230600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230623', '2', '林甸县', NULL, NULL, 47.17131300, 124.86358600, '230600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230624', '2', '杜尔伯特蒙古族自治县', NULL, NULL, 46.86272600, 124.44214000, '230600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230700', '1', '伊春市', '伊春', 'yi,chun', 47.72833200, 128.84086300, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230717', '2', '伊美区', NULL, NULL, 47.72852700, 128.90699700, '230700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230718', '2', '乌翠区', NULL, NULL, 47.72649900, 128.66945800, '230700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230719', '2', '友好区', NULL, NULL, 47.84126600, 128.83706500, '230700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230722', '2', '嘉荫县', NULL, NULL, 48.88861300, 130.40240600, '230700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230723', '2', '汤旺县', NULL, NULL, 48.45463900, 129.57093500, '230700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230724', '2', '丰林县', NULL, NULL, 48.29056600, 129.53366100, '230700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230725', '2', '大箐山县', NULL, NULL, 47.02831300, 129.02051900, '230700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230726', '2', '南岔县', NULL, NULL, 47.13900900, 129.28358400, '230700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230751', '2', '金林区', NULL, NULL, 47.41301900, 129.42883900, '230700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230781', '2', '铁力市', NULL, NULL, 46.98659600, 128.03237800, '230700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230800', '1', '佳木斯市', '佳木斯', 'jia,mu,si', 46.80000200, 130.31891600, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230803', '2', '向阳区', NULL, NULL, 46.80780800, 130.36526300, '230800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230804', '2', '前进区', NULL, NULL, 46.81391900, 130.37508100, '230800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230805', '2', '东风区', NULL, NULL, 46.82260900, 130.40358800, '230800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230811', '2', '郊区', NULL, NULL, 46.80984200, 130.32718700, '230800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230822', '2', '桦南县', NULL, NULL, 46.23931400, 130.55347200, '230800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230826', '2', '桦川县', NULL, NULL, 47.02339400, 130.71893400, '230800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230828', '2', '汤原县', NULL, NULL, 46.73062300, 129.90474700, '230800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230881', '2', '同江市', NULL, NULL, 47.64247500, 132.51011300, '230800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230882', '2', '富锦市', NULL, NULL, 47.25050600, 132.03679300, '230800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230883', '2', '抚远市', NULL, NULL, 48.36487200, 134.30785700, '230800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230900', '1', '七台河市', '七台河', 'qi,tai,he', 45.77117800, 131.00301500, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230902', '2', '新兴区', NULL, NULL, 45.81672800, 130.93225200, '230900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230903', '2', '桃山区', NULL, NULL, 45.76602600, 131.02009000, '230900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230904', '2', '茄子河区', NULL, NULL, 45.78588900, 131.06742500, '230900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('230921', '2', '勃利县', NULL, NULL, 45.75582500, 130.59205700, '230900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231000', '1', '牡丹江市', '牡丹江', 'mu,dan,jiang', 44.55148600, 129.63292800, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231002', '2', '东安区', NULL, NULL, 44.58125000, 129.62665100, '231000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231003', '2', '阳明区', NULL, NULL, 44.59585100, 129.63583600, '231000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231004', '2', '爱民区', NULL, NULL, 44.59589700, 129.59122700, '231000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231005', '2', '西安区', NULL, NULL, 44.57746100, 129.61614200, '231000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231025', '2', '林口县', NULL, NULL, 45.27975400, 130.28228600, '231000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231081', '2', '绥芬河市', NULL, NULL, 44.41263500, 131.15217900, '231000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231083', '2', '海林市', NULL, NULL, 44.59401700, 129.38075600, '231000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231084', '2', '宁安市', NULL, NULL, 44.34057100, 129.48249200, '231000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231085', '2', '穆棱市', NULL, NULL, 44.91911100, 130.52423300, '231000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231086', '2', '东宁市', NULL, NULL, 44.09036100, 131.12483900, '231000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231100', '1', '黑河市', '黑河', 'hei,he', 50.24488700, 127.52822600, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231102', '2', '爱辉区', NULL, NULL, 50.25247500, 127.50070400, '231100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231123', '2', '逊克县', NULL, NULL, 49.56429000, 128.47869800, '231100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231124', '2', '孙吴县', NULL, NULL, 49.42564500, 127.33616300, '231100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231181', '2', '北安市', NULL, NULL, 48.24116800, 126.49098900, '231100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231182', '2', '五大连池市', NULL, NULL, 48.51734200, 126.20544600, '231100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231183', '2', '嫩江市', NULL, NULL, 49.18617300, 125.22076600, '231100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231200', '1', '绥化市', '绥化', 'sui,hua', 46.65414700, 126.96871400, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231202', '2', '北林区', NULL, NULL, 46.63811400, 126.98499500, '231200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231221', '2', '望奎县', NULL, NULL, 46.83218500, 126.48633300, '231200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231222', '2', '兰西县', NULL, NULL, 46.25241000, 126.28787800, '231200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231223', '2', '青冈县', NULL, NULL, 46.70398000, 126.09931400, '231200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231224', '2', '庆安县', NULL, NULL, 46.88062800, 127.50758600, '231200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231225', '2', '明水县', NULL, NULL, 47.17367200, 125.90629300, '231200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231226', '2', '绥棱县', NULL, NULL, 47.23581400, 127.11492800, '231200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231281', '2', '安达市', NULL, NULL, 46.45188200, 125.30762900, '231200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231282', '2', '肇东市', NULL, NULL, 46.05061600, 125.96237700, '231200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('231283', '2', '海伦市', NULL, NULL, 47.45066100, 126.93019100, '231200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('232700', '1', '大兴安岭地区', '大兴安岭', 'da,xing,an,ling', 50.41127500, 124.11785400, '230000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('232701', '2', '漠河市', NULL, NULL, 52.97297600, 122.54022000, '232700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('232718', '2', '加格达奇区', NULL, NULL, 50.40882200, 124.13974200, '232700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('232721', '2', '呼玛县', NULL, NULL, 51.72592400, 126.65185600, '232700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('232722', '2', '塔河县', NULL, NULL, 52.33451200, 124.70973300, '232700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310000', '0', '上海市', '上海', 'shang,hai', 31.23052500, 121.47366700, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101', '1', '黄浦区', '黄浦', 'huang,pu', 31.23166100, 121.48442000, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101002', '2', '南京东路街道', NULL, NULL, 31.22634100, 121.47182900, '310101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101013', '2', '外滩街道', NULL, NULL, 31.23496900, 121.48763400, '310101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101015', '2', '半淞园路街道', NULL, NULL, 31.20688600, 121.48740800, '310101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101017', '2', '小东门街道', NULL, NULL, 31.22003600, 121.50105100, '310101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101018', '2', '豫园街道', NULL, NULL, 31.22421600, 121.48823000, '310101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101019', '2', '老西门街道', NULL, NULL, 31.21525100, 121.48608300, '310101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101020', '2', '五里桥街道', NULL, NULL, 31.20089000, 121.48181900, '310101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101021', '2', '打浦桥街道', NULL, NULL, 31.20365600, 121.47350600, '310101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101022', '2', '淮海中路街道', NULL, NULL, 31.21494100, 121.47583200, '310101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310101023', '2', '瑞金二路街道', NULL, NULL, 31.21742600, 121.46679200, '310101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104', '1', '徐汇区', '徐汇', 'xu,hui', 31.18833400, 121.43630700, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104003', '2', '天平路街道', NULL, NULL, 31.20297800, 121.43879400, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104004', '2', '湖南路街道', NULL, NULL, 31.20832600, 121.43573300, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104007', '2', '斜土路街道', NULL, NULL, 31.20078300, 121.46383400, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104008', '2', '枫林路街道', NULL, NULL, 31.18528900, 121.45172500, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104010', '2', '长桥街道', NULL, NULL, 31.13197200, 121.43691700, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104011', '2', '田林街道', NULL, NULL, 31.17417700, 121.42301500, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104012', '2', '虹梅路街道', NULL, NULL, 31.16441100, 121.41122200, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104013', '2', '康健新村街道', NULL, NULL, 31.15587100, 121.42292600, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104014', '2', '徐家汇街道', NULL, NULL, 31.19000000, 121.43648100, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104015', '2', '凌云路街道', NULL, NULL, 31.13859000, 121.41436300, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104016', '2', '龙华街道', NULL, NULL, 31.16866000, 121.45061400, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104017', '2', '漕河泾街道', NULL, NULL, 31.16566700, 121.42984400, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310104103', '2', '华泾镇', NULL, NULL, 31.11742400, 121.45558600, '310104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105', '1', '长宁区', '长宁', 'chang,ning', 31.22055700, 121.42469600, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105001', '2', '华阳路街道', NULL, NULL, 31.21573500, 121.42222400, '310105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105002', '2', '江苏路街道', NULL, NULL, 31.21943500, 121.43181500, '310105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105004', '2', '新华路街道', NULL, NULL, 31.20503500, 121.42621600, '310105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105005', '2', '周家桥街道', NULL, NULL, 31.21751100, 121.40720300, '310105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105006', '2', '天山路街道', NULL, NULL, 31.20917000, 121.40692600, '310105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105008', '2', '仙霞新村街道', NULL, NULL, 31.20399900, 121.39470100, '310105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105009', '2', '虹桥街道', NULL, NULL, 31.19725500, 121.40910400, '310105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105010', '2', '程家桥街道', NULL, NULL, 31.19474400, 121.36851200, '310105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105011', '2', '北新泾街道', NULL, NULL, 31.21876200, 121.37459000, '310105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310105102', '2', '新泾镇', NULL, NULL, 31.21234300, 121.37283300, '310105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106', '1', '静安区', '静安', 'jing,an', 31.22771800, 121.44734800, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106006', '2', '江宁路街道', NULL, NULL, 31.24019500, 121.44783300, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106011', '2', '石门二路街道', NULL, NULL, 31.23569100, 121.45750000, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106012', '2', '南京西路街道', NULL, NULL, 31.22421000, 121.45783600, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106013', '2', '静安寺街道', NULL, NULL, 31.22472600, 121.44355300, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106014', '2', '曹家渡街道', NULL, NULL, 31.22953000, 121.43978100, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106015', '2', '天目西路街道', NULL, NULL, 31.24863800, 121.45570100, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106016', '2', '北站街道', NULL, NULL, 31.24069500, 121.47004500, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106017', '2', '宝山路街道', NULL, NULL, 31.26164600, 121.46899400, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106018', '2', '共和新路街道', NULL, NULL, 31.27329700, 121.46213000, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106019', '2', '大宁路街道', NULL, NULL, 31.28473100, 121.45685000, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106020', '2', '彭浦新村街道', NULL, NULL, 31.31297900, 121.44523700, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106021', '2', '临汾路街道', NULL, NULL, 31.31055200, 121.46052600, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106022', '2', '芷江西路街道', NULL, NULL, 31.25793100, 121.46461900, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310106100', '2', '彭浦镇', NULL, NULL, 31.28302700, 121.44035400, '310106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107', '1', '普陀区', '普陀', 'pu,tuo', 31.24961800, 121.39547000, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107005', '2', '曹杨新村街道', NULL, NULL, 31.24192200, 121.40991800, '310107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107014', '2', '长风新村街道', NULL, NULL, 31.23002400, 121.41082900, '310107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107015', '2', '长寿路街道', NULL, NULL, 31.23945500, 121.43430400, '310107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107016', '2', '甘泉路街道', NULL, NULL, 31.26164300, 121.43078600, '310107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107017', '2', '石泉路街道', NULL, NULL, 31.25540200, 121.42420600, '310107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107020', '2', '宜川路街道', NULL, NULL, 31.25863400, 121.44106500, '310107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107021', '2', '真如镇街道', NULL, NULL, 31.25696000, 121.40107500, '310107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107022', '2', '万里街道', NULL, NULL, 31.27203200, 121.40510800, '310107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107102', '2', '长征镇', NULL, NULL, 31.23792100, 121.37316800, '310107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310107103', '2', '桃浦镇', NULL, NULL, 31.27879200, 121.36348200, '310107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310109', '1', '虹口区', '虹口', 'hong,kou', 31.26491700, 121.50499400, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310109009', '2', '欧阳路街道', NULL, NULL, 31.26831100, 121.49249000, '310109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310109010', '2', '曲阳路街道', NULL, NULL, 31.28307000, 121.49523100, '310109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310109011', '2', '广中路街道', NULL, NULL, 31.26697200, 121.47764800, '310109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310109014', '2', '嘉兴路街道', NULL, NULL, 31.27130600, 121.50021600, '310109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310109016', '2', '凉城新村街道', NULL, NULL, 31.29459900, 121.47097600, '310109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310109017', '2', '四川北路街道', NULL, NULL, 31.26331000, 121.48593300, '310109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310109018', '2', '北外滩街道', NULL, NULL, 31.25208800, 121.49940200, '310109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310109019', '2', '江湾镇街道', NULL, NULL, 31.30483900, 121.47335200, '310109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110', '1', '杨浦区', '杨浦', 'yang,pu', 31.25958800, 121.52540900, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110001', '2', '定海路街道', NULL, NULL, 31.27888400, 121.54915400, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110006', '2', '平凉路街道', NULL, NULL, 31.26137300, 121.51921300, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110008', '2', '江浦路街道', NULL, NULL, 31.26669300, 121.51741100, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110009', '2', '四平路街道', NULL, NULL, 31.27672700, 121.51179200, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110012', '2', '控江路街道', NULL, NULL, 31.28423000, 121.52780000, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110013', '2', '长白新村街道', NULL, NULL, 31.29273900, 121.54325400, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110015', '2', '延吉新村街道', NULL, NULL, 31.28576900, 121.53676800, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110016', '2', '殷行街道', NULL, NULL, 31.32409400, 121.53830700, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110018', '2', '大桥街道', NULL, NULL, 31.26809100, 121.52998600, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110019', '2', '五角场街道', NULL, NULL, 31.30507000, 121.51972800, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110020', '2', '新江湾城街道', NULL, NULL, 31.32926600, 121.52202000, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310110021', '2', '长海路街道', NULL, NULL, 31.30842300, 121.52058600, '310110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112', '1', '闵行区', '闵行', 'min,hang', 31.11283400, 121.38085700, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112001', '2', '江川路街道', NULL, NULL, 31.00910100, 121.41812500, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112006', '2', '古美街道', NULL, NULL, 31.13293300, 121.39193700, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112008', '2', '新虹街道', NULL, NULL, 31.20560400, 121.30800700, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112009', '2', '浦锦街道', NULL, NULL, 31.08359200, 121.49511000, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112101', '2', '莘庄镇', NULL, NULL, 31.12174800, 121.37009000, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112102', '2', '七宝镇', NULL, NULL, 31.15832900, 121.35128600, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112103', '2', '颛桥镇', NULL, NULL, 31.06603800, 121.40052800, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112106', '2', '华漕镇', NULL, NULL, 31.20739500, 121.29298600, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112107', '2', '虹桥镇', NULL, NULL, 31.17740500, 121.38463700, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112108', '2', '梅陇镇', NULL, NULL, 31.10312600, 121.42643000, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112110', '2', '吴泾镇', NULL, NULL, 31.03834800, 121.45553000, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112112', '2', '马桥镇', NULL, NULL, 31.03071400, 121.36878600, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112114', '2', '浦江镇', NULL, NULL, 31.07580300, 121.51629200, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310112501', '2', '莘庄工业区', NULL, NULL, 31.08004000, 121.38530200, '310112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113', '1', '宝山区', '宝山', 'bao,shan', 31.40524200, 121.48943100, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113003', '2', '友谊路街道', NULL, NULL, 31.40584900, 121.48305300, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113007', '2', '吴淞街道', NULL, NULL, 31.37254200, 121.49400000, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113008', '2', '张庙街道', NULL, NULL, 31.33660800, 121.44182900, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113101', '2', '罗店镇', NULL, NULL, 31.39439100, 121.35618600, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113102', '2', '大场镇', NULL, NULL, 31.28693000, 121.41698300, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113103', '2', '杨行镇', NULL, NULL, 31.36464600, 121.43853300, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113104', '2', '月浦镇', NULL, NULL, 31.42022000, 121.42180300, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113106', '2', '罗泾镇', NULL, NULL, 31.47269200, 121.32745000, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113109', '2', '顾村镇', NULL, NULL, 31.34957200, 121.40683400, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113111', '2', '高境镇', NULL, NULL, 31.32117600, 121.48255300, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113112', '2', '庙行镇', NULL, NULL, 31.32920800, 121.42835600, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310113113', '2', '淞南镇', NULL, NULL, 31.34804200, 121.48975900, '310113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114', '1', '嘉定区', '嘉定', 'jia,ding', 31.37556600, 121.26527600, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114001', '2', '新成路街道', NULL, NULL, 31.38611000, 121.26967200, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114002', '2', '真新街道', NULL, NULL, 31.24442800, 121.36031600, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114003', '2', '菊园街道', NULL, NULL, 31.40244600, 121.25282500, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114004', '2', '嘉定镇街道', NULL, NULL, 31.37238700, 121.23968600, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114102', '2', '南翔镇', NULL, NULL, 31.29430200, 121.32066300, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114103', '2', '安亭镇', NULL, NULL, 31.29405000, 121.16440200, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114106', '2', '马陆镇', NULL, NULL, 31.33304800, 121.28379000, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114109', '2', '徐行镇', NULL, NULL, 31.41655700, 121.28022700, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114111', '2', '华亭镇', NULL, NULL, 31.46804100, 121.24224900, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114114', '2', '外冈镇', NULL, NULL, 31.36278900, 121.16194900, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310114118', '2', '江桥镇', NULL, NULL, 31.23903300, 121.33165300, '310114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115', '1', '浦东新区', '浦东', 'pu,dong', 31.22146100, 121.54434600, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115004', '2', '潍坊新村街道', NULL, NULL, 31.22874600, 121.52953200, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115005', '2', '陆家嘴街道', NULL, NULL, 31.23739100, 121.52550900, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115007', '2', '周家渡街道', NULL, NULL, 31.18165000, 121.50606300, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115008', '2', '塘桥街道', NULL, NULL, 31.21495000, 121.52485000, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115009', '2', '上钢新村街道', NULL, NULL, 31.17190300, 121.48287000, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115010', '2', '南码头路街道', NULL, NULL, 31.19645400, 121.51909100, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115011', '2', '沪东新村街道', NULL, NULL, 31.26708800, 121.58276700, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115012', '2', '金杨新村街道', NULL, NULL, 31.25624200, 121.57343400, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115013', '2', '洋泾街道', NULL, NULL, 31.24112400, 121.54577800, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115014', '2', '浦兴路街道', NULL, NULL, 31.26678500, 121.58796100, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115015', '2', '东明路街道', NULL, NULL, 31.14678200, 121.52761100, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115016', '2', '花木街道', NULL, NULL, 31.20639500, 121.54783000, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115103', '2', '川沙新镇', NULL, NULL, 31.19320200, 121.69567300, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115104', '2', '高桥镇', NULL, NULL, 31.33919500, 121.57954200, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115105', '2', '北蔡镇', NULL, NULL, 31.18180300, 121.55451300, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115110', '2', '合庆镇', NULL, NULL, 31.23744700, 121.72344100, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115114', '2', '唐镇', NULL, NULL, 31.20814100, 121.65510800, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115117', '2', '曹路镇', NULL, NULL, 31.27837800, 121.66703900, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115120', '2', '金桥镇', NULL, NULL, 31.26589900, 121.61138500, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115121', '2', '高行镇', NULL, NULL, 31.29294900, 121.60662500, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115123', '2', '高东镇', NULL, NULL, 31.32691500, 121.62275300, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115125', '2', '张江镇', NULL, NULL, 31.20529800, 121.61427100, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115130', '2', '三林镇', NULL, NULL, 31.14525700, 121.50251100, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115131', '2', '惠南镇', NULL, NULL, 31.04794000, 121.74953100, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115132', '2', '周浦镇', NULL, NULL, 31.11374800, 121.57503200, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115133', '2', '新场镇', NULL, NULL, 31.02595400, 121.65322600, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115134', '2', '大团镇', NULL, NULL, 30.96662900, 121.73726300, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115136', '2', '康桥镇', NULL, NULL, 31.13636900, 121.59708000, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115137', '2', '航头镇', NULL, NULL, 31.03339300, 121.58705100, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115139', '2', '祝桥镇', NULL, NULL, 31.10296600, 121.75963300, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115140', '2', '泥城镇', NULL, NULL, 30.90384100, 121.81665700, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115141', '2', '宣桥镇', NULL, NULL, 31.03569700, 121.69457600, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115142', '2', '书院镇', NULL, NULL, 30.98239600, 121.87124500, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115143', '2', '万祥镇', NULL, NULL, 30.97328900, 121.81565100, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115144', '2', '老港镇', NULL, NULL, 31.03944700, 121.83995000, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310115145', '2', '南汇新城镇', NULL, NULL, 30.89802100, 121.91966700, '310115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116', '1', '金山区', '金山', 'jin,shan', 30.74276900, 121.34177400, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116001', '2', '石化街道', NULL, NULL, 30.72566100, 121.33632900, '310116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116101', '2', '朱泾镇', NULL, NULL, 30.89875300, 121.16625200, '310116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116102', '2', '枫泾镇', NULL, NULL, 30.88862300, 121.00968300, '310116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116103', '2', '张堰镇', NULL, NULL, 30.80165400, 121.29814500, '310116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116104', '2', '亭林镇', NULL, NULL, 30.88244500, 121.31337200, '310116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116105', '2', '吕巷镇', NULL, NULL, 30.83191000, 121.18260700, '310116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116107', '2', '廊下镇', NULL, NULL, 30.79051500, 121.19247600, '310116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116109', '2', '金山卫镇', NULL, NULL, 30.72515200, 121.31771600, '310116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116112', '2', '漕泾镇', NULL, NULL, 30.79405400, 121.41091100, '310116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310116113', '2', '山阳镇', NULL, NULL, 30.76157300, 121.35621200, '310116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117', '1', '松江区', '松江', 'song,jiang', 31.03257000, 121.22767600, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117001', '2', '岳阳街道', NULL, NULL, 31.01610700, 121.23571800, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117002', '2', '永丰街道', NULL, NULL, 31.00386300, 121.21591400, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117003', '2', '方松街道', NULL, NULL, 31.02580800, 121.22262800, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117004', '2', '中山街道', NULL, NULL, 31.03631300, 121.24563900, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117005', '2', '广富林街道', NULL, NULL, 31.06660400, 121.22234000, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117006', '2', '九里亭街道', NULL, NULL, 31.14658100, 121.30327300, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117102', '2', '泗泾镇', NULL, NULL, 31.11834700, 121.27119100, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117103', '2', '佘山镇', NULL, NULL, 31.09535800, 121.17560700, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117104', '2', '车墩镇', NULL, NULL, 31.01549100, 121.31472600, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117105', '2', '新桥镇', NULL, NULL, 31.05947600, 121.31534400, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117106', '2', '洞泾镇', NULL, NULL, 31.08217500, 121.26923700, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117107', '2', '九亭镇', NULL, NULL, 31.13206500, 121.32905800, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117109', '2', '泖港镇', NULL, NULL, 30.93332900, 121.21347700, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117116', '2', '石湖荡镇', NULL, NULL, 30.98450900, 121.11935700, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117117', '2', '新浜镇', NULL, NULL, 30.93317000, 121.06798500, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117120', '2', '叶榭镇', NULL, NULL, 30.94368400, 121.32025200, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117121', '2', '小昆山镇', NULL, NULL, 31.02972400, 121.13203500, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310117501', '2', '松江工业区', NULL, NULL, 31.01124000, 121.26476000, '310117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118', '1', '青浦区', '青浦', 'qing,pu', 31.15098000, 121.12424900, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118001', '2', '夏阳街道', NULL, NULL, 31.14819900, 121.12610700, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118002', '2', '盈浦街道', NULL, NULL, 31.14581600, 121.11466200, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118003', '2', '香花桥街道', NULL, NULL, 31.21345200, 121.09971500, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118102', '2', '朱家角镇', NULL, NULL, 31.10392400, 121.04642700, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118103', '2', '练塘镇', NULL, NULL, 30.99996300, 121.05246400, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118104', '2', '金泽镇', NULL, NULL, 31.03601300, 120.92219000, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118105', '2', '赵巷镇', NULL, NULL, 31.14917100, 121.19611700, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118106', '2', '徐泾镇', NULL, NULL, 31.17323000, 121.27217100, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118107', '2', '华新镇', NULL, NULL, 31.24606000, 121.22723400, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118109', '2', '重固镇', NULL, NULL, 31.20066300, 121.17806200, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310118110', '2', '白鹤镇', NULL, NULL, 31.25921000, 121.14304200, '310118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310120', '1', '奉贤区', '奉贤', 'feng,xian', 30.91840600, 121.47394500, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310120101', '2', '南桥镇', NULL, NULL, 30.90366500, 121.45888800, '310120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310120102', '2', '奉城镇', NULL, NULL, 30.90945700, 121.65757800, '310120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310120104', '2', '庄行镇', NULL, NULL, 30.89554100, 121.39546500, '310120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310120106', '2', '金汇镇', NULL, NULL, 30.98914300, 121.50142100, '310120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310120109', '2', '四团镇', NULL, NULL, 30.93873700, 121.72318300, '310120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310120111', '2', '青村镇', NULL, NULL, 30.92304800, 121.58123700, '310120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310120118', '2', '柘林镇', NULL, NULL, 30.87128000, 121.46575300, '310120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310120123', '2', '海湾镇', NULL, NULL, 30.85719200, 121.56779400, '310120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151', '1', '崇明区', '崇明', 'chong,ming', 31.62386300, 121.39766200, '310000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151100', '2', '城桥镇', NULL, NULL, 31.62824800, 121.39799500, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151101', '2', '堡镇', NULL, NULL, 31.53666000, 121.61840600, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151102', '2', '新河镇', NULL, NULL, 31.58166500, 121.52457300, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151103', '2', '庙镇', NULL, NULL, 31.71247000, 121.34909800, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151104', '2', '竖新镇', NULL, NULL, 31.61493300, 121.60370700, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151105', '2', '向化镇', NULL, NULL, 31.52057100, 121.72337400, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151106', '2', '三星镇', NULL, NULL, 31.74332400, 121.28775900, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151107', '2', '港沿镇', NULL, NULL, 31.58806900, 121.65615800, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151108', '2', '中兴镇', NULL, NULL, 31.39001700, 121.69391800, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151109', '2', '陈家镇', NULL, NULL, 31.52654100, 121.83242400, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151110', '2', '绿华镇', NULL, NULL, 31.76321000, 121.22054700, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151111', '2', '港西镇', NULL, NULL, 31.68736200, 121.41585500, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151112', '2', '建设镇', NULL, NULL, 31.65461600, 121.45675100, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151113', '2', '新海镇', NULL, NULL, 31.81817500, 121.29306800, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151114', '2', '东平镇', NULL, NULL, 31.67536300, 121.54130500, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151115', '2', '长兴镇', NULL, NULL, 31.39005900, 121.69396700, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151200', '2', '新村乡', NULL, NULL, 31.82922100, 121.33205200, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151201', '2', '横沙乡', NULL, NULL, 31.34037200, 121.84164500, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('310151410', '2', '东平林场', NULL, NULL, 31.67881800, 121.47989000, '310151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320000', '0', '江苏省', '江苏', 'jiang,su', 32.06137700, 118.76356300, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320100', '1', '南京市', '南京', 'nan,jing', 32.05934400, 118.79662400, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320102', '2', '玄武区', NULL, NULL, 32.04864400, 118.79777900, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320104', '2', '秦淮区', NULL, NULL, 32.03906500, 118.79479200, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320105', '2', '建邺区', NULL, NULL, 32.00334300, 118.73164200, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320106', '2', '鼓楼区', NULL, NULL, 32.06681400, 118.76994300, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320111', '2', '浦口区', NULL, NULL, 32.05979600, 118.62716500, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320113', '2', '栖霞区', NULL, NULL, 32.09626900, 118.90913800, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320114', '2', '雨花台区', NULL, NULL, 31.99129100, 118.77908700, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320115', '2', '江宁区', NULL, NULL, 31.95319500, 118.83951000, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320116', '2', '六合区', NULL, NULL, 32.32323500, 118.82224100, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320117', '2', '溧水区', NULL, NULL, 31.65110800, 119.02841400, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320118', '2', '高淳区', NULL, NULL, 31.32867800, 118.89207400, '320100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320200', '1', '无锡市', '无锡', 'wu,xi', 31.49106400, 120.31188900, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320205', '2', '锡山区', NULL, NULL, 31.58948400, 120.35773200, '320200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320206', '2', '惠山区', NULL, NULL, 31.68028200, 120.29843000, '320200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320211', '2', '滨湖区', NULL, NULL, 31.52784600, 120.28438100, '320200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320213', '2', '梁溪区', NULL, NULL, 31.56622600, 120.30355100, '320200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320214', '2', '新吴区', NULL, NULL, 31.50803478, 120.43022637, '320200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320281', '2', '江阴市', NULL, NULL, 31.92164200, 120.28479400, '320200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320282', '2', '宜兴市', NULL, NULL, 31.33842900, 119.82187300, '320200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320300', '1', '徐州市', '徐州', 'xu,zhou', 34.20422400, 117.28375200, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320302', '2', '鼓楼区', NULL, NULL, 34.28873600, 117.18564300, '320300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320303', '2', '云龙区', NULL, NULL, 34.25363800, 117.25151500, '320300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320305', '2', '贾汪区', NULL, NULL, 34.43649200, 117.46513700, '320300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320311', '2', '泉山区', NULL, NULL, 34.22655000, 117.19440500, '320300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320312', '2', '铜山区', NULL, NULL, 34.18116200, 117.16969800, '320300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320321', '2', '丰县', NULL, NULL, 34.69651500, 116.65825000, '320300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320322', '2', '沛县', NULL, NULL, 34.76076100, 116.93635300, '320300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320324', '2', '睢宁县', NULL, NULL, 33.91372700, 117.94136400, '320300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320381', '2', '新沂市', NULL, NULL, 34.36869400, 118.35467100, '320300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320382', '2', '邳州市', NULL, NULL, 34.33920800, 118.01251100, '320300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320400', '1', '常州市', '常州', 'chang,zhou', 31.81131300, 119.97409200, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320402', '2', '天宁区', NULL, NULL, 31.79232000, 119.99943900, '320400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320404', '2', '钟楼区', NULL, NULL, 31.80260800, 119.90208100, '320400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320411', '2', '新北区', NULL, NULL, 31.83066500, 119.97224100, '320400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320412', '2', '武进区', NULL, NULL, 31.70125200, 119.94244100, '320400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320413', '2', '金坛区', NULL, NULL, 31.72238400, 119.58750300, '320400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320481', '2', '溧阳市', NULL, NULL, 31.41696700, 119.48416400, '320400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320500', '1', '苏州市', '苏州', 'su,zhou', 31.29975800, 120.58529400, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320505', '2', '虎丘区', NULL, NULL, 31.32960000, 120.43423800, '320500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320506', '2', '吴中区', NULL, NULL, 31.26360400, 120.63209400, '320500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320507', '2', '相城区', NULL, NULL, 31.36918900, 120.64239100, '320500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320508', '2', '姑苏区', NULL, NULL, 31.33674000, 120.61699900, '320500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320509', '2', '吴江区', NULL, NULL, 31.13852500, 120.64572800, '320500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320571', '2', '苏州工业园区', NULL, NULL, 31.31425200, 120.65954300, '320500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320581', '2', '常熟市', NULL, NULL, 31.65601600, 120.75251200, '320500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320582', '2', '张家港市', NULL, NULL, 31.87673900, 120.55597900, '320500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320583', '2', '昆山市', NULL, NULL, 31.38547600, 120.98079500, '320500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320585', '2', '太仓市', NULL, NULL, 31.45804300, 121.13034400, '320500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320600', '1', '南通市', '南通', 'nan,tong', 31.98126900, 120.89452200, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320612', '2', '通州区', NULL, NULL, 32.06597200, 121.07374200, '320600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320613', '2', '崇川区', NULL, NULL, 32.01027700, 120.85725300, '320600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320614', '2', '海门区', NULL, NULL, 31.86941800, 121.18201600, '320600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320623', '2', '如东县', NULL, NULL, 32.33158400, 121.18495000, '320600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320681', '2', '启东市', NULL, NULL, 31.79283100, 121.65523000, '320600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320682', '2', '如皋市', NULL, NULL, 32.37149300, 120.57402800, '320600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320685', '2', '海安市', NULL, NULL, 32.53285300, 120.46779000, '320600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320700', '1', '连云港市', '连云港', 'lian,yun,gang', 34.59663900, 119.22148700, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320703', '2', '连云区', NULL, NULL, 34.76031700, 119.33890100, '320700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320706', '2', '海州区', NULL, NULL, 34.57250600, 119.16349200, '320700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320707', '2', '赣榆区', NULL, NULL, 34.84133600, 119.17317300, '320700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320722', '2', '东海县', NULL, NULL, 34.54219400, 118.75286900, '320700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320723', '2', '灌云县', NULL, NULL, 34.28407400, 119.23942600, '320700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320724', '2', '灌南县', NULL, NULL, 34.08725100, 119.31558300, '320700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320800', '1', '淮安市', '淮安', 'huai,an', 33.55149500, 119.11316600, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320803', '2', '淮安区', NULL, NULL, 33.50270600, 119.14057000, '320800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320804', '2', '淮阴区', NULL, NULL, 33.63258800, 119.03489500, '320800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320812', '2', '清江浦区', NULL, NULL, 33.55257900, 119.02666200, '320800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320813', '2', '洪泽区', NULL, NULL, 33.29409500, 118.87313200, '320800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320826', '2', '涟水县', NULL, NULL, 33.78164800, 119.26058900, '320800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320830', '2', '盱眙县', NULL, NULL, 33.01190500, 118.54454500, '320800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320831', '2', '金湖县', NULL, NULL, 33.02466300, 119.02043200, '320800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320900', '1', '盐城市', '盐城', 'yan,cheng', 33.34817600, 120.16263000, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320902', '2', '亭湖区', NULL, NULL, 33.39141400, 120.19614800, '320900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320903', '2', '盐都区', NULL, NULL, 33.33853800, 120.15356700, '320900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320904', '2', '大丰区', NULL, NULL, 33.20004700, 120.50076100, '320900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320921', '2', '响水县', NULL, NULL, 34.19975300, 119.57785800, '320900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320922', '2', '滨海县', NULL, NULL, 33.99037200, 119.82071300, '320900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320923', '2', '阜宁县', NULL, NULL, 33.75885700, 119.80227100, '320900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320924', '2', '射阳县', NULL, NULL, 33.76661000, 120.32654400, '320900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320925', '2', '建湖县', NULL, NULL, 33.43893100, 119.78874300, '320900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('320981', '2', '东台市', NULL, NULL, 32.86784500, 120.32030800, '320900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321000', '1', '扬州市', '扬州', 'yang,zhou', 32.39440400, 119.41283400, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321002', '2', '广陵区', NULL, NULL, 32.39565400, 119.43178500, '321000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321003', '2', '邗江区', NULL, NULL, 32.37741000, 119.39793500, '321000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321012', '2', '江都区', NULL, NULL, 32.43571000, 119.56968400, '321000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321023', '2', '宝应县', NULL, NULL, 33.24112500, 119.35838900, '321000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321081', '2', '仪征市', NULL, NULL, 32.27283300, 119.18446800, '321000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321084', '2', '高邮市', NULL, NULL, 32.78160600, 119.45892000, '321000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321100', '1', '镇江市', '镇江', 'zhen,jiang', 32.18814100, 119.42444100, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321102', '2', '京口区', NULL, NULL, 32.19828500, 119.47018600, '321100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321111', '2', '润州区', NULL, NULL, 32.19592600, 119.41073700, '321100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321112', '2', '丹徒区', NULL, NULL, 32.13211800, 119.43385400, '321100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321181', '2', '丹阳市', NULL, NULL, 32.01003500, 119.60607100, '321100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321182', '2', '扬中市', NULL, NULL, 32.23647600, 119.79681600, '321100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321183', '2', '句容市', NULL, NULL, 31.94573200, 119.16869300, '321100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321200', '1', '泰州市', '泰州', 'tai,zhou', 32.45669200, 119.92288300, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321202', '2', '海陵区', NULL, NULL, 32.49248000, 119.92382500, '321200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321203', '2', '高港区', NULL, NULL, 32.31923000, 119.88154000, '321200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321204', '2', '姜堰区', NULL, NULL, 32.51029000, 120.12807000, '321200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321281', '2', '兴化市', NULL, NULL, 32.91195200, 119.85255000, '321200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321282', '2', '靖江市', NULL, NULL, 31.98325000, 120.27712400, '321200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321283', '2', '泰兴市', NULL, NULL, 32.17307200, 120.05147500, '321200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321300', '1', '宿迁市', '宿迁', 'su,qian', 33.96318600, 118.27522800, '320000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321302', '2', '宿城区', NULL, NULL, 33.96389100, 118.24204800, '321300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321311', '2', '宿豫区', NULL, NULL, 33.94813000, 118.33042300, '321300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321322', '2', '沭阳县', NULL, NULL, 34.11064200, 118.80432100, '321300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321323', '2', '泗阳县', NULL, NULL, 33.72357600, 118.70363600, '321300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('321324', '2', '泗洪县', NULL, NULL, 33.47657500, 118.22394100, '321300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330000', '0', '浙江省', '浙江', 'zhe,jiang', 30.26661900, 120.15257500, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330100', '1', '杭州市', '杭州', 'hang,zhou', 30.24602600, 120.21079200, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330102', '2', '上城区', NULL, NULL, 30.22654300, 120.19732000, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330105', '2', '拱墅区', NULL, NULL, 30.31912600, 120.14150300, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330106', '2', '西湖区', NULL, NULL, 30.25924200, 120.13039600, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330108', '2', '滨江区', NULL, NULL, 30.20833200, 120.21198100, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330109', '2', '萧山区', NULL, NULL, 30.18411900, 120.26426300, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330110', '2', '余杭区', NULL, NULL, 30.27370500, 119.97874200, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330111', '2', '富阳区', NULL, NULL, 30.04879000, 119.96025500, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330112', '2', '临安区', NULL, NULL, 30.23435500, 119.72444600, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330113', '2', '临平区', NULL, NULL, 30.41915400, 120.29922200, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330114', '2', '钱塘区', NULL, NULL, 30.32287000, 120.49387600, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330122', '2', '桐庐县', NULL, NULL, 29.79418000, 119.69175500, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330127', '2', '淳安县', NULL, NULL, 29.60967800, 119.04201500, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330182', '2', '建德市', NULL, NULL, 29.47496400, 119.28119500, '330100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330200', '1', '宁波市', '宁波', 'ning,bo', 29.86025800, 121.62454000, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330203', '2', '海曙区', NULL, NULL, 29.87489400, 121.55039200, '330200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330205', '2', '江北区', NULL, NULL, 29.88673000, 121.55506700, '330200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330206', '2', '北仑区', NULL, NULL, 29.89985400, 121.84400000, '330200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330211', '2', '镇海区', NULL, NULL, 29.96521200, 121.59668600, '330200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330212', '2', '鄞州区', NULL, NULL, 29.81730200, 121.54661700, '330200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330213', '2', '奉化区', NULL, NULL, 29.65529200, 121.40615100, '330200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330225', '2', '象山县', NULL, NULL, 29.47682600, 121.86925100, '330200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330226', '2', '宁海县', NULL, NULL, 29.28792900, 121.42972900, '330200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330281', '2', '余姚市', NULL, NULL, 30.03796700, 121.15457200, '330200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330282', '2', '慈溪市', NULL, NULL, 30.17069500, 121.26652500, '330200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330300', '1', '温州市', '温州', 'wen,zhou', 27.99384900, 120.69927900, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330302', '2', '鹿城区', NULL, NULL, 28.01577600, 120.65519900, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330303', '2', '龙湾区', NULL, NULL, 27.93326100, 120.81233300, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330304', '2', '瓯海区', NULL, NULL, 27.96744500, 120.61514900, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330305', '2', '洞头区', NULL, NULL, 27.83641200, 121.15740600, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330324', '2', '永嘉县', NULL, NULL, 28.15391400, 120.69136000, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330326', '2', '平阳县', NULL, NULL, 27.66239400, 120.56516100, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330327', '2', '苍南县', NULL, NULL, 27.51863600, 120.42595700, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330328', '2', '文成县', NULL, NULL, 27.78685600, 120.09092900, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330329', '2', '泰顺县', NULL, NULL, 27.55657800, 119.71764300, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330381', '2', '瑞安市', NULL, NULL, 27.77896700, 120.65524500, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330382', '2', '乐清市', NULL, NULL, 28.11251900, 120.98629700, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330383', '2', '龙港市', NULL, NULL, 27.57837900, 120.55295200, '330300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330400', '1', '嘉兴市', '嘉兴', 'jia,xing', 30.74681400, 120.75562300, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330402', '2', '南湖区', NULL, NULL, 30.74777700, 120.78288500, '330400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330411', '2', '秀洲区', NULL, NULL, 30.76481100, 120.70904700, '330400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330421', '2', '嘉善县', NULL, NULL, 30.83086600, 120.92608100, '330400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330424', '2', '海盐县', NULL, NULL, 30.52664000, 120.94628000, '330400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330481', '2', '海宁市', NULL, NULL, 30.51153600, 120.68022400, '330400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330482', '2', '平湖市', NULL, NULL, 30.67780400, 121.01561900, '330400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330483', '2', '桐乡市', NULL, NULL, 30.63037500, 120.56512700, '330400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330500', '1', '湖州市', '湖州', 'hu,zhou', 30.89417800, 120.08688100, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330502', '2', '吴兴区', NULL, NULL, 30.85718400, 120.18560800, '330500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330503', '2', '南浔区', NULL, NULL, 30.85107500, 120.41773100, '330500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330521', '2', '德清县', NULL, NULL, 30.54251000, 119.97740000, '330500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330522', '2', '长兴县', NULL, NULL, 31.02696200, 119.91121200, '330500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330523', '2', '安吉县', NULL, NULL, 30.63880300, 119.68026100, '330500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330600', '1', '绍兴市', '绍兴', 'shao,xing', 30.05154900, 120.58288600, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330602', '2', '越城区', NULL, NULL, 29.98909200, 120.58233800, '330600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330603', '2', '柯桥区', NULL, NULL, 30.08303900, 120.49553200, '330600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330604', '2', '上虞区', NULL, NULL, 30.03386200, 120.86857100, '330600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330624', '2', '新昌县', NULL, NULL, 29.50052500, 120.90391800, '330600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330681', '2', '诸暨市', NULL, NULL, 29.70939800, 120.24660200, '330600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330683', '2', '嵊州市', NULL, NULL, 29.56151900, 120.83050500, '330600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330700', '1', '金华市', '金华', 'jin,hua', 29.07919500, 119.64726500, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330702', '2', '婺城区', NULL, NULL, 29.08731100, 119.57157400, '330700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330703', '2', '金东区', NULL, NULL, 29.09982200, 119.69282100, '330700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330723', '2', '武义县', NULL, NULL, 28.89338700, 119.81653300, '330700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330726', '2', '浦江县', NULL, NULL, 29.45336300, 119.89259000, '330700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330727', '2', '磐安县', NULL, NULL, 29.05449100, 120.44993700, '330700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330781', '2', '兰溪市', NULL, NULL, 29.20905900, 119.46040400, '330700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330782', '2', '义乌市', NULL, NULL, 29.30629600, 120.07567900, '330700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330783', '2', '东阳市', NULL, NULL, 29.29015800, 120.24179000, '330700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330784', '2', '永康市', NULL, NULL, 28.88899000, 120.04735600, '330700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330800', '1', '衢州市', '衢州', 'qu,zhou', 28.97022900, 118.85930700, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330802', '2', '柯城区', NULL, NULL, 28.93693700, 118.87413800, '330800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330803', '2', '衢江区', NULL, NULL, 28.98035600, 118.95913900, '330800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330822', '2', '常山县', NULL, NULL, 28.90244600, 118.51122400, '330800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330824', '2', '开化县', NULL, NULL, 29.13672900, 118.41575600, '330800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330825', '2', '龙游县', NULL, NULL, 29.02903800, 119.17171600, '330800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330881', '2', '江山市', NULL, NULL, 28.73796000, 118.62722800, '330800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330900', '1', '舟山市', '舟山', 'zhou,shan', 29.98557800, 122.20739500, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330902', '2', '定海区', NULL, NULL, 30.02015300, 122.10651100, '330900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330903', '2', '普陀区', NULL, NULL, 29.97060100, 122.32355900, '330900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330921', '2', '岱山县', NULL, NULL, 30.26453300, 122.22571800, '330900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('330922', '2', '嵊泗县', NULL, NULL, 30.72569500, 122.45133500, '330900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331000', '1', '台州市', '台州', 'tai,zhou', 28.65571600, 121.42079000, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331002', '2', '椒江区', NULL, NULL, 28.67333400, 121.44285900, '331000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331003', '2', '黄岩区', NULL, NULL, 28.64943300, 121.26180400, '331000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331004', '2', '路桥区', NULL, NULL, 28.57722800, 121.33769000, '331000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331022', '2', '三门县', NULL, NULL, 29.10488800, 121.39561000, '331000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331023', '2', '天台县', NULL, NULL, 29.14459400, 121.00665700, '331000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331024', '2', '仙居县', NULL, NULL, 28.84685600, 120.72873300, '331000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331081', '2', '温岭市', NULL, NULL, 28.37280500, 121.38543500, '331000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331082', '2', '临海市', NULL, NULL, 28.85904200, 121.14462500, '331000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331083', '2', '玉环市', NULL, NULL, 28.13670300, 121.23191500, '331000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331100', '1', '丽水市', '丽水', 'li,shui', 28.46769400, 119.92324900, '330000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331102', '2', '莲都区', NULL, NULL, 28.44610000, 119.91226600, '331100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331121', '2', '青田县', NULL, NULL, 28.13960000, 120.28969300, '331100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331122', '2', '缙云县', NULL, NULL, 28.65929400, 120.09168500, '331100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331123', '2', '遂昌县', NULL, NULL, 28.59238800, 119.27586500, '331100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331124', '2', '松阳县', NULL, NULL, 28.44888300, 119.48140600, '331100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331125', '2', '云和县', NULL, NULL, 28.11602400, 119.57345400, '331100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331126', '2', '庆元县', NULL, NULL, 27.61859400, 119.06276300, '331100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331127', '2', '景宁畲族自治县', NULL, NULL, 27.97359400, 119.63568600, '331100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('331181', '2', '龙泉市', NULL, NULL, 28.07491600, 119.14126000, '331100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340000', '0', '安徽省', '安徽', 'an,hui', 31.73455900, 117.33013900, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340100', '1', '合肥市', '合肥', 'he,fei', 31.82056700, 117.22726700, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340102', '2', '瑶海区', NULL, NULL, 31.85811100, 117.30944000, '340100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340103', '2', '庐阳区', NULL, NULL, 31.87872200, 117.26508800, '340100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340104', '2', '蜀山区', NULL, NULL, 31.85121100, 117.26053000, '340100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340111', '2', '包河区', NULL, NULL, 31.79380100, 117.31013300, '340100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340121', '2', '长丰县', NULL, NULL, 32.47834600, 117.16762800, '340100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340122', '2', '肥东县', NULL, NULL, 31.87860100, 117.47790000, '340100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340123', '2', '肥西县', NULL, NULL, 31.70700600, 117.15841600, '340100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340124', '2', '庐江县', NULL, NULL, 31.25697800, 117.28816500, '340100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340181', '2', '巢湖市', NULL, NULL, 31.62446400, 117.89023600, '340100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340200', '1', '芜湖市', '芜湖', 'wu,hu', 31.35261400, 118.43306500, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340202', '2', '镜湖区', NULL, NULL, 31.34056000, 118.38513300, '340200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340207', '2', '鸠江区', NULL, NULL, 31.36975200, 118.39233700, '340200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340209', '2', '弋江区', NULL, NULL, 31.31142100, 118.37266400, '340200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340210', '2', '湾沚区', NULL, NULL, 31.13477700, 118.57602900, '340200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340212', '2', '繁昌区', NULL, NULL, 31.10176600, 118.19853600, '340200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340223', '2', '南陵县', NULL, NULL, 30.91462100, 118.33408300, '340200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340281', '2', '无为市', NULL, NULL, 31.30446200, 117.90226500, '340200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340300', '1', '蚌埠市', '蚌埠', 'beng,bu', 32.91682000, 117.38856600, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340302', '2', '龙子湖区', NULL, NULL, 32.95092000, 117.37993300, '340300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340303', '2', '蚌山区', NULL, NULL, 32.91639300, 117.37334700, '340300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340304', '2', '禹会区', NULL, NULL, 32.92971500, 117.34186000, '340300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340311', '2', '淮上区', NULL, NULL, 32.96557000, 117.35935200, '340300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340321', '2', '怀远县', NULL, NULL, 32.97154300, 117.20508300, '340300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340322', '2', '五河县', NULL, NULL, 33.12653200, 117.88131200, '340300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340323', '2', '固镇县', NULL, NULL, 33.31837100, 117.31658500, '340300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340400', '1', '淮南市', '淮南', 'huai,nan', 32.58538400, 117.01860300, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340402', '2', '大通区', NULL, NULL, 32.63151900, 117.05331400, '340400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340403', '2', '田家庵区', NULL, NULL, 32.64745600, 117.01726300, '340400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340404', '2', '谢家集区', NULL, NULL, 32.59917300, 116.86002600, '340400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340405', '2', '八公山区', NULL, NULL, 32.63078700, 116.83319200, '340400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340406', '2', '潘集区', NULL, NULL, 32.77162600, 116.83462100, '340400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340421', '2', '凤台县', NULL, NULL, 32.71053600, 116.71094700, '340400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340422', '2', '寿县', NULL, NULL, 32.54502700, 116.79820300, '340400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340500', '1', '马鞍山市', '马鞍山', 'ma,an,shan', 31.66876500, 118.50685000, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340503', '2', '花山区', NULL, NULL, 31.70012700, 118.51136600, '340500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340504', '2', '雨山区', NULL, NULL, 31.68237400, 118.49867500, '340500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340506', '2', '博望区', NULL, NULL, 31.55133600, 118.81840500, '340500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340521', '2', '当涂县', NULL, NULL, 31.57085700, 118.49787300, '340500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340522', '2', '含山县', NULL, NULL, 31.73541000, 118.10148200, '340500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340523', '2', '和县', NULL, NULL, 31.74248000, 118.35366800, '340500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340600', '1', '淮北市', '淮北', 'huai,bei', 33.95626400, 116.79836200, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340602', '2', '杜集区', NULL, NULL, 33.99217300, 116.82799100, '340600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340603', '2', '相山区', NULL, NULL, 33.95992700, 116.79523300, '340600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340604', '2', '烈山区', NULL, NULL, 33.89540700, 116.81322100, '340600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340621', '2', '濉溪县', NULL, NULL, 33.91561200, 116.76616000, '340600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340700', '1', '铜陵市', '铜陵', 'tong,ling', 30.94521400, 117.81129800, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340705', '2', '铜官区', NULL, NULL, 30.93677200, 117.85654100, '340700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340706', '2', '义安区', NULL, NULL, 30.95061900, 117.93740500, '340700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340711', '2', '郊区', NULL, NULL, 30.82169900, 117.76791900, '340700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340722', '2', '枞阳县', NULL, NULL, 30.70546600, 117.25019100, '340700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340800', '1', '安庆市', '安庆', 'an,qing', 30.53182800, 117.11534900, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340802', '2', '迎江区', NULL, NULL, 30.51276800, 117.09087800, '340800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340803', '2', '大观区', NULL, NULL, 30.55298200, 117.01375400, '340800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340811', '2', '宜秀区', NULL, NULL, 30.61318900, 116.98746900, '340800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340822', '2', '怀宁县', NULL, NULL, 30.73484000, 116.82961200, '340800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340825', '2', '太湖县', NULL, NULL, 30.45419800, 116.30881000, '340800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340826', '2', '宿松县', NULL, NULL, 30.17166300, 116.13448500, '340800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340827', '2', '望江县', NULL, NULL, 30.12840400, 116.70641000, '340800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340828', '2', '岳西县', NULL, NULL, 30.84971600, 116.35973200, '340800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340881', '2', '桐城市', NULL, NULL, 31.03547600, 116.93658800, '340800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('340882', '2', '潜山市', NULL, NULL, 30.63169800, 116.58151400, '340800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341000', '1', '黄山市', '黄山', 'huang,shan', 29.71488600, 118.33764300, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341002', '2', '屯溪区', NULL, NULL, 29.69655000, 118.31501200, '341000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341003', '2', '黄山区', NULL, NULL, 30.27299100, 118.14163200, '341000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341004', '2', '徽州区', NULL, NULL, 29.82729100, 118.33679900, '341000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341021', '2', '歙县', NULL, NULL, 29.86097700, 118.41533300, '341000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341022', '2', '休宁县', NULL, NULL, 29.78452200, 118.19363600, '341000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341023', '2', '黟县', NULL, NULL, 29.92507700, 117.93805800, '341000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341024', '2', '祁门县', NULL, NULL, 29.85417900, 117.71745200, '341000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341100', '1', '滁州市', '滁州', 'chu,zhou', 32.25590400, 118.33343900, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341102', '2', '琅琊区', NULL, NULL, 32.33447500, 118.32115000, '341100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341103', '2', '南谯区', NULL, NULL, 32.20005000, 118.41684100, '341100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341122', '2', '来安县', NULL, NULL, 32.41650400, 118.43242900, '341100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341124', '2', '全椒县', NULL, NULL, 32.08593000, 118.27414900, '341100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341125', '2', '定远县', NULL, NULL, 32.53072000, 117.69851900, '341100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341126', '2', '凤阳县', NULL, NULL, 32.87571400, 117.53179100, '341100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341181', '2', '天长市', NULL, NULL, 32.66740900, 119.00483800, '341100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341182', '2', '明光市', NULL, NULL, 32.78193000, 118.01819700, '341100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341200', '1', '阜阳市', '阜阳', 'fu,yang', 32.89103200, 115.81425200, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341202', '2', '颍州区', NULL, NULL, 32.88359100, 115.80710800, '341200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341203', '2', '颍东区', NULL, NULL, 32.91173000, 115.85672800, '341200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341204', '2', '颍泉区', NULL, NULL, 32.92546100, 115.80741500, '341200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341221', '2', '临泉县', NULL, NULL, 33.03888400, 115.26312000, '341200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341222', '2', '太和县', NULL, NULL, 33.16032700, 115.62194100, '341200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341225', '2', '阜南县', NULL, NULL, 32.65968100, 115.59600300, '341200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341226', '2', '颍上县', NULL, NULL, 32.65319500, 116.25677800, '341200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341282', '2', '界首市', NULL, NULL, 33.25779900, 115.37468800, '341200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341300', '1', '宿州市', '宿州', 'su,zhou', 33.64772600, 116.96419000, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341302', '2', '埇桥区', NULL, NULL, 33.64020500, 116.97703900, '341300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341321', '2', '砀山县', NULL, NULL, 34.44213900, 116.36625700, '341300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341322', '2', '萧县', NULL, NULL, 34.22164800, 116.93656900, '341300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341323', '2', '灵璧县', NULL, NULL, 33.55446400, 117.54932100, '341300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341324', '2', '泗县', NULL, NULL, 33.48368600, 117.91027700, '341300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341500', '1', '六安市', '六安', 'liu,an', 31.73589200, 116.51972900, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341502', '2', '金安区', NULL, NULL, 31.75014000, 116.53945800, '341500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341503', '2', '裕安区', NULL, NULL, 31.73878900, 116.47950500, '341500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341504', '2', '叶集区', NULL, NULL, 31.86369300, 115.92527100, '341500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341522', '2', '霍邱县', NULL, NULL, 32.35336200, 116.27796600, '341500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341523', '2', '舒城县', NULL, NULL, 31.46353200, 116.94882000, '341500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341524', '2', '金寨县', NULL, NULL, 31.72654800, 115.93444100, '341500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341525', '2', '霍山县', NULL, NULL, 31.40966800, 116.34827400, '341500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341600', '1', '亳州市', '亳州', 'bo,zhou', 33.84628500, 115.77858800, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341602', '2', '谯城区', NULL, NULL, 33.87568300, 115.77911000, '341600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341621', '2', '涡阳县', NULL, NULL, 33.49413400, 116.21665000, '341600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341622', '2', '蒙城县', NULL, NULL, 33.26567100, 116.56434000, '341600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341623', '2', '利辛县', NULL, NULL, 33.15847500, 116.20649500, '341600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341700', '1', '池州市', '池州', 'chi,zhou', 30.67426400, 117.49566300, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341702', '2', '贵池区', NULL, NULL, 30.68738900, 117.56843200, '341700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341721', '2', '东至县', NULL, NULL, 30.11104300, 117.02763400, '341700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341722', '2', '石台县', NULL, NULL, 30.21021800, 117.48621100, '341700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341723', '2', '青阳县', NULL, NULL, 30.63900600, 117.84736600, '341700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341800', '1', '宣城市', '宣城', 'xuan,cheng', 30.93927800, 118.75912700, '340000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341802', '2', '宣州区', NULL, NULL, 30.94435600, 118.78609800, '341800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341821', '2', '郎溪县', NULL, NULL, 31.14300200, 119.18414600, '341800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341823', '2', '泾县', NULL, NULL, 30.68879300, 118.41955200, '341800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341824', '2', '绩溪县', NULL, NULL, 30.06729700, 118.57880900, '341800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341825', '2', '旌德县', NULL, NULL, 30.29828700, 118.55004300, '341800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341881', '2', '宁国市', NULL, NULL, 30.63403200, 118.98308500, '341800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('341882', '2', '广德市', NULL, NULL, 30.87760800, 119.42079900, '341800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350000', '0', '福建省', '福建', 'fu,jian', 26.10108200, 119.29619400, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350100', '1', '福州市', '福州', 'fu,zhou', 26.07428600, 119.29641100, '350000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350102', '2', '鼓楼区', NULL, NULL, 26.08266600, 119.30450700, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350103', '2', '台江区', NULL, NULL, 26.05270000, 119.31412900, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350104', '2', '仓山区', NULL, NULL, 26.04702700, 119.27322000, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350105', '2', '马尾区', NULL, NULL, 25.99865700, 119.43925900, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350111', '2', '晋安区', NULL, NULL, 26.08196300, 119.32859100, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350112', '2', '长乐区', NULL, NULL, 25.88832300, 119.59401000, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350121', '2', '闽侯县', NULL, NULL, 26.15042800, 119.13136200, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350122', '2', '连江县', NULL, NULL, 26.19773700, 119.53954200, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350123', '2', '罗源县', NULL, NULL, 26.49027300, 119.54896600, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350124', '2', '闽清县', NULL, NULL, 26.22109900, 118.86333400, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350125', '2', '永泰县', NULL, NULL, 25.86719800, 118.93274600, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350128', '2', '平潭县', NULL, NULL, 25.49913900, 119.79071500, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350181', '2', '福清市', NULL, NULL, 25.72103500, 119.38413800, '350100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350200', '1', '厦门市', '厦门', 'xia,men', 24.47962700, 118.08891000, '350000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350203', '2', '思明区', NULL, NULL, 24.44567600, 118.08274500, '350200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350205', '2', '海沧区', NULL, NULL, 24.48468800, 118.03288300, '350200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350206', '2', '湖里区', NULL, NULL, 24.51285800, 118.14682500, '350200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350211', '2', '集美区', NULL, NULL, 24.57597600, 118.09740700, '350200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350212', '2', '同安区', NULL, NULL, 24.72329900, 118.15082300, '350200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350213', '2', '翔安区', NULL, NULL, 24.61950700, 118.24779100, '350200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350300', '1', '莆田市', '莆田', 'pu,tian', 25.45420200, 119.00766200, '350000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350302', '2', '城厢区', NULL, NULL, 25.41906200, 118.99426100, '350300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350303', '2', '涵江区', NULL, NULL, 25.45905700, 119.11617300, '350300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350304', '2', '荔城区', NULL, NULL, 25.43226800, 119.01482100, '350300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350305', '2', '秀屿区', NULL, NULL, 25.31864900, 119.10517700, '350300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350322', '2', '仙游县', NULL, NULL, 25.37337600, 118.68972200, '350300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350400', '1', '三明市', '三明', 'san,ming', 26.26345500, 117.63891900, '350000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350404', '2', '三元区', NULL, NULL, 26.27166000, 117.64614900, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350405', '2', '沙县区', NULL, NULL, 26.39684300, 117.79255100, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350421', '2', '明溪县', NULL, NULL, 26.35529700, 117.20226600, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350423', '2', '清流县', NULL, NULL, 26.17765800, 116.81677200, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350424', '2', '宁化县', NULL, NULL, 26.26229800, 116.65436900, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350425', '2', '大田县', NULL, NULL, 25.69311200, 117.84663200, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350426', '2', '尤溪县', NULL, NULL, 26.17013600, 118.19034600, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350428', '2', '将乐县', NULL, NULL, 26.72876000, 117.47141700, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350429', '2', '泰宁县', NULL, NULL, 26.90024400, 117.17544800, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350430', '2', '建宁县', NULL, NULL, 26.83341600, 116.84846300, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350481', '2', '永安市', NULL, NULL, 25.94167100, 117.36504600, '350400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350500', '1', '泉州市', '泉州', 'quan,zhou', 24.87445200, 118.67572400, '350000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350502', '2', '鲤城区', NULL, NULL, 24.90813300, 118.58652000, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350503', '2', '丰泽区', NULL, NULL, 24.89037300, 118.61300700, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350504', '2', '洛江区', NULL, NULL, 24.93931900, 118.67116800, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350505', '2', '泉港区', NULL, NULL, 25.12039900, 118.91580400, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350521', '2', '惠安县', NULL, NULL, 25.01247600, 118.78089700, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350524', '2', '安溪县', NULL, NULL, 25.05606500, 118.18629500, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350525', '2', '永春县', NULL, NULL, 25.32273700, 118.29422100, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350526', '2', '德化县', NULL, NULL, 25.49210200, 118.24110400, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350527', '2', '金门县', NULL, NULL, 24.43714700, 118.31917900, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350581', '2', '石狮市', NULL, NULL, 24.73196900, 118.64794500, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350582', '2', '晋江市', NULL, NULL, 24.78163500, 118.55165900, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350583', '2', '南安市', NULL, NULL, 24.96013900, 118.38565200, '350500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350600', '1', '漳州市', '漳州', 'zhang,zhou', 24.51529700, 117.64729800, '350000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350602', '2', '芗城区', NULL, NULL, 24.51093700, 117.65372700, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350603', '2', '龙文区', NULL, NULL, 24.50352300, 117.71118800, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350604', '2', '龙海区', NULL, NULL, 24.44683900, 117.81848500, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350605', '2', '长泰区', NULL, NULL, 24.62598900, 117.75911900, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350622', '2', '云霄县', NULL, NULL, 23.93592400, 117.33445600, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350623', '2', '漳浦县', NULL, NULL, 24.11741000, 117.61378300, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350624', '2', '诏安县', NULL, NULL, 23.71167400, 117.17531400, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350626', '2', '东山县', NULL, NULL, 23.70203400, 117.42950000, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350627', '2', '南靖县', NULL, NULL, 24.51510000, 117.35706100, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350628', '2', '平和县', NULL, NULL, 24.36383100, 117.31479800, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350629', '2', '华安县', NULL, NULL, 25.00445000, 117.53411000, '350600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350700', '1', '南平市', '南平', 'nan,ping', 27.38282900, 118.08132500, '350000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350702', '2', '延平区', NULL, NULL, 26.63750300, 118.18180600, '350700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350703', '2', '建阳区', NULL, NULL, 27.33199600, 118.12039200, '350700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350721', '2', '顺昌县', NULL, NULL, 26.79345500, 117.80943300, '350700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350722', '2', '浦城县', NULL, NULL, 27.91780400, 118.54107900, '350700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350723', '2', '光泽县', NULL, NULL, 27.54106100, 117.33381200, '350700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350724', '2', '松溪县', NULL, NULL, 27.52602800, 118.78542900, '350700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350725', '2', '政和县', NULL, NULL, 27.36612200, 118.85770300, '350700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350781', '2', '邵武市', NULL, NULL, 27.34067200, 117.49277800, '350700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350782', '2', '武夷山市', NULL, NULL, 27.75642200, 118.03532100, '350700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350783', '2', '建瓯市', NULL, NULL, 27.02323300, 118.30471200, '350700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350800', '1', '龙岩市', '龙岩', 'long,yan', 25.07588400, 117.01736200, '350000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350802', '2', '新罗区', NULL, NULL, 25.09894200, 117.03681600, '350800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350803', '2', '永定区', NULL, NULL, 24.72414800, 116.73221600, '350800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350821', '2', '长汀县', NULL, NULL, 25.83353100, 116.35758100, '350800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350823', '2', '上杭县', NULL, NULL, 25.04986700, 116.41944700, '350800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350824', '2', '武平县', NULL, NULL, 25.09613900, 116.10021600, '350800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350825', '2', '连城县', NULL, NULL, 25.71046800, 116.75426400, '350800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350881', '2', '漳平市', NULL, NULL, 25.29048100, 117.41982300, '350800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350900', '1', '宁德市', '宁德', 'ning,de', 26.66622200, 119.54772900, '350000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350902', '2', '蕉城区', NULL, NULL, 26.66065800, 119.52628400, '350900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350921', '2', '霞浦县', NULL, NULL, 26.88597100, 120.00526700, '350900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350922', '2', '古田县', NULL, NULL, 26.57813400, 118.74603000, '350900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350923', '2', '屏南县', NULL, NULL, 26.90825600, 118.98575900, '350900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350924', '2', '寿宁县', NULL, NULL, 27.45467000, 119.51458900, '350900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350925', '2', '周宁县', NULL, NULL, 27.10460000, 119.33898600, '350900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350926', '2', '柘荣县', NULL, NULL, 27.23421000, 119.90059700, '350900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350981', '2', '福安市', NULL, NULL, 27.08827400, 119.64787100, '350900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('350982', '2', '福鼎市', NULL, NULL, 27.32479600, 120.21655900, '350900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360000', '0', '江西省', '江西', 'jiang,xi', 28.63665200, 115.81630100, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360100', '1', '南昌市', '南昌', 'nan,chang', 28.68297600, 115.85797200, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360102', '2', '东湖区', NULL, NULL, 28.69878700, 115.90357600, '360100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360103', '2', '西湖区', NULL, NULL, 28.65700500, 115.87699800, '360100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360104', '2', '青云谱区', NULL, NULL, 28.62182000, 115.92570900, '360100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360111', '2', '青山湖区', NULL, NULL, 28.68286700, 115.96213800, '360100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360112', '2', '新建区', NULL, NULL, 28.69319200, 115.81524400, '360100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360113', '2', '红谷滩区', NULL, NULL, 28.56035454, 115.78950565, '360100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360121', '2', '南昌县', NULL, NULL, 28.55794900, 115.93346400, '360100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360123', '2', '安义县', NULL, NULL, 28.84558500, 115.54915800, '360100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360124', '2', '进贤县', NULL, NULL, 28.37762700, 116.24246800, '360100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360200', '1', '景德镇市', '景德镇', 'jing,de,zhen', 29.27440000, 117.18489200, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360202', '2', '昌江区', NULL, NULL, 29.27368300, 117.18264800, '360200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360203', '2', '珠山区', NULL, NULL, 29.30519100, 117.27136500, '360200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360222', '2', '浮梁县', NULL, NULL, 29.35249300, 117.21498400, '360200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360281', '2', '乐平市', NULL, NULL, 28.97852100, 117.15149900, '360200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360300', '1', '萍乡市', '萍乡', 'ping,xiang', 27.65872100, 113.88714700, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360302', '2', '安源区', NULL, NULL, 27.61500000, 113.87072000, '360300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360313', '2', '湘东区', NULL, NULL, 27.64055800, 113.73271100, '360300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360321', '2', '莲花县', NULL, NULL, 27.12849800, 113.96158900, '360300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360322', '2', '上栗县', NULL, NULL, 27.88022100, 113.79529400, '360300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360323', '2', '芦溪县', NULL, NULL, 27.63127300, 114.02935100, '360300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360400', '1', '九江市', '九江', 'jiu,jiang', 29.66116000, 115.95356000, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360402', '2', '濂溪区', NULL, NULL, 29.66800800, 115.99273500, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360403', '2', '浔阳区', NULL, NULL, 29.70547000, 116.00167700, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360404', '2', '柴桑区', NULL, NULL, 29.60877500, 115.91100500, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360423', '2', '武宁县', NULL, NULL, 29.24678500, 115.09264900, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360424', '2', '修水县', NULL, NULL, 29.02616600, 114.54653600, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360425', '2', '永修县', NULL, NULL, 29.01139200, 115.83207000, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360426', '2', '德安县', NULL, NULL, 29.29859900, 115.76711400, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360428', '2', '都昌县', NULL, NULL, 29.27380300, 116.20399900, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360429', '2', '湖口县', NULL, NULL, 29.73119400, 116.25220600, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360430', '2', '彭泽县', NULL, NULL, 29.87740400, 116.56385800, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360481', '2', '瑞昌市', NULL, NULL, 29.67602600, 115.68122100, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360482', '2', '共青城市', NULL, NULL, 29.23508200, 115.78426900, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360483', '2', '庐山市', NULL, NULL, 29.44800700, 116.04469600, '360400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360500', '1', '新余市', '新余', 'xin,yu', 27.81887800, 114.91714500, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360502', '2', '渝水区', NULL, NULL, 27.79952600, 114.94449900, '360500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360521', '2', '分宜县', NULL, NULL, 27.81472300, 114.69264000, '360500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360600', '1', '鹰潭市', '鹰潭', 'ying,tan', 28.27209200, 117.03953200, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360602', '2', '月湖区', NULL, NULL, 28.26699900, 117.10247000, '360600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360603', '2', '余江区', NULL, NULL, 28.19965700, 116.85457600, '360600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360681', '2', '贵溪市', NULL, NULL, 28.29239700, 117.24517800, '360600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360700', '1', '赣州市', '赣州', 'gan,zhou', 25.83113900, 114.93349400, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360702', '2', '章贡区', NULL, NULL, 25.81824700, 114.92042600, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360703', '2', '南康区', NULL, NULL, 25.66136900, 114.76504400, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360704', '2', '赣县区', NULL, NULL, 25.85449600, 115.02119600, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360722', '2', '信丰县', NULL, NULL, 25.38676000, 114.92248500, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360723', '2', '大余县', NULL, NULL, 25.40196800, 114.36230600, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360724', '2', '上犹县', NULL, NULL, 25.78475400, 114.55177000, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360725', '2', '崇义县', NULL, NULL, 25.68227800, 114.30813500, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360726', '2', '安远县', NULL, NULL, 25.13685500, 115.39399200, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360728', '2', '定南县', NULL, NULL, 24.78337200, 115.02790800, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360729', '2', '全南县', NULL, NULL, 24.74222300, 114.52941500, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360730', '2', '宁都县', NULL, NULL, 26.47086500, 116.00917100, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360731', '2', '于都县', NULL, NULL, 25.95256400, 115.41514500, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360732', '2', '兴国县', NULL, NULL, 26.33812900, 115.36347500, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360733', '2', '会昌县', NULL, NULL, 25.58734000, 115.80927100, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360734', '2', '寻乌县', NULL, NULL, 24.96951300, 115.63853400, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360735', '2', '石城县', NULL, NULL, 26.31491000, 116.34761100, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360781', '2', '瑞金市', NULL, NULL, 25.88623000, 116.02711400, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360783', '2', '龙南市', NULL, NULL, 24.90247300, 114.80486400, '360700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360800', '1', '吉安市', '吉安', 'ji,an', 27.09124300, 114.96681000, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360802', '2', '吉州区', NULL, NULL, 27.14420400, 114.99499100, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360803', '2', '青原区', NULL, NULL, 27.08201200, 115.01483600, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360821', '2', '吉安县', NULL, NULL, 27.03986600, 114.90833700, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360822', '2', '吉水县', NULL, NULL, 27.41887200, 115.15309600, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360823', '2', '峡江县', NULL, NULL, 27.58290000, 115.31656700, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360824', '2', '新干县', NULL, NULL, 27.74036800, 115.38685300, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360825', '2', '永丰县', NULL, NULL, 27.31730100, 115.42159900, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360826', '2', '泰和县', NULL, NULL, 26.80168700, 114.92298700, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360827', '2', '遂川县', NULL, NULL, 26.31341300, 114.52082500, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360828', '2', '万安县', NULL, NULL, 26.45682100, 114.75974600, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360829', '2', '安福县', NULL, NULL, 27.39328600, 114.61981800, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360830', '2', '永新县', NULL, NULL, 26.94518400, 114.24243500, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360881', '2', '井冈山市', NULL, NULL, 26.74813200, 114.28956300, '360800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360900', '1', '宜春市', '宜春', 'yi,chun', 27.81624500, 114.41682600, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360902', '2', '袁州区', NULL, NULL, 27.79634400, 114.42794000, '360900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360921', '2', '奉新县', NULL, NULL, 28.68825400, 115.40062400, '360900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360922', '2', '万载县', NULL, NULL, 28.10619500, 114.44546900, '360900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360923', '2', '上高县', NULL, NULL, 28.23859100, 114.94804500, '360900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360924', '2', '宜丰县', NULL, NULL, 28.39446600, 114.80303600, '360900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360925', '2', '靖安县', NULL, NULL, 28.86129600, 115.36263500, '360900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360926', '2', '铜鼓县', NULL, NULL, 28.51329100, 114.35462300, '360900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360981', '2', '丰城市', NULL, NULL, 28.16005300, 115.77113100, '360900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360982', '2', '樟树市', NULL, NULL, 28.05463200, 115.54617400, '360900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('360983', '2', '高安市', NULL, NULL, 28.44803900, 115.36690300, '360900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361000', '1', '抚州市', '抚州', 'fu,zhou', 27.94897900, 116.35805400, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361002', '2', '临川区', NULL, NULL, 27.93509800, 116.31193200, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361003', '2', '东乡区', NULL, NULL, 28.24905900, 116.60315900, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361021', '2', '南城县', NULL, NULL, 27.57003100, 116.63722800, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361022', '2', '黎川县', NULL, NULL, 27.28272900, 116.90744600, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361023', '2', '南丰县', NULL, NULL, 27.21845000, 116.52589800, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361024', '2', '崇仁县', NULL, NULL, 27.75441600, 116.07636300, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361025', '2', '乐安县', NULL, NULL, 27.42868200, 115.83099000, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361026', '2', '宜黄县', NULL, NULL, 27.55474400, 116.23617400, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361027', '2', '金溪县', NULL, NULL, 27.91973000, 116.75501800, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361028', '2', '资溪县', NULL, NULL, 27.70608800, 117.06033200, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361030', '2', '广昌县', NULL, NULL, 26.84397400, 116.33655600, '361000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361100', '1', '上饶市', '上饶', 'shang,rao', 28.45513000, 117.94306400, '360000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361102', '2', '信州区', NULL, NULL, 28.43069400, 117.96599700, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361103', '2', '广丰区', NULL, NULL, 28.46369700, 118.18972900, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361104', '2', '广信区', NULL, NULL, 28.44889300, 117.90745400, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361123', '2', '玉山县', NULL, NULL, 28.68223900, 118.24466800, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361124', '2', '铅山县', NULL, NULL, 28.29841500, 117.73474200, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361125', '2', '横峰县', NULL, NULL, 28.40711600, 117.59643300, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361126', '2', '弋阳县', NULL, NULL, 28.37803900, 117.44934600, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361127', '2', '余干县', NULL, NULL, 28.70283000, 116.69578700, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361128', '2', '鄱阳县', NULL, NULL, 29.00567500, 116.70373100, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361129', '2', '万年县', NULL, NULL, 28.69411200, 117.05862000, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361130', '2', '婺源县', NULL, NULL, 29.24849100, 117.86153200, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('361181', '2', '德兴市', NULL, NULL, 28.93055700, 117.59454900, '361100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370000', '0', '山东省', '山东', 'shan,dong', 36.67020100, 117.02072500, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370100', '1', '济南市', '济南', 'ji,nan', 36.65206900, 117.12012800, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370102', '2', '历下区', NULL, NULL, 36.66712300, 117.07624400, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370103', '2', '市中区', NULL, NULL, 36.65112100, 116.99747200, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370104', '2', '槐荫区', NULL, NULL, 36.65226400, 116.90105700, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370105', '2', '天桥区', NULL, NULL, 36.67866500, 116.98710600, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370112', '2', '历城区', NULL, NULL, 36.68073100, 117.06523300, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370113', '2', '长清区', NULL, NULL, 36.55425100, 116.75210100, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370114', '2', '章丘区', NULL, NULL, 36.68125800, 117.52622800, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370115', '2', '济阳区', NULL, NULL, 36.97829900, 117.17372200, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370116', '2', '莱芜区', NULL, NULL, 36.21489500, 117.67582800, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370117', '2', '钢城区', NULL, NULL, 36.05939300, 117.81160400, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370124', '2', '平阴县', NULL, NULL, 36.28976100, 116.45598300, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370126', '2', '商河县', NULL, NULL, 37.30969400, 117.15716500, '370100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370200', '1', '青岛市', '青岛', 'qing,dao', 36.06693800, 120.38266500, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370202', '2', '市南区', NULL, NULL, 36.07598800, 120.41185700, '370200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370203', '2', '市北区', NULL, NULL, 36.08765000, 120.37467500, '370200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370211', '2', '黄岛区', NULL, NULL, 35.96054000, 120.19799200, '370200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370212', '2', '崂山区', NULL, NULL, 36.10706900, 120.46928200, '370200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370213', '2', '李沧区', NULL, NULL, 36.14598700, 120.43265200, '370200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370214', '2', '城阳区', NULL, NULL, 36.30762400, 120.39625500, '370200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370215', '2', '即墨区', NULL, NULL, 36.39021700, 120.44769100, '370200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370281', '2', '胶州市', NULL, NULL, 36.26468700, 120.03333600, '370200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370283', '2', '平度市', NULL, NULL, 36.75390100, 119.96987300, '370200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370285', '2', '莱西市', NULL, NULL, 36.88916700, 120.51758100, '370200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370300', '1', '淄博市', '淄博', 'zi,bo', 36.81378700, 118.05499400, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370302', '2', '淄川区', NULL, NULL, 36.64421100, 117.96697800, '370300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370303', '2', '张店区', NULL, NULL, 36.80701100, 118.01787700, '370300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370304', '2', '博山区', NULL, NULL, 36.49501400, 117.86270000, '370300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370305', '2', '临淄区', NULL, NULL, 36.82688200, 118.30939800, '370300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370306', '2', '周村区', NULL, NULL, 36.80309000, 117.86968600, '370300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370321', '2', '桓台县', NULL, NULL, 36.95979400, 118.09792300, '370300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370322', '2', '高青县', NULL, NULL, 37.17104000, 117.82674300, '370300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370323', '2', '沂源县', NULL, NULL, 36.18540200, 118.17085600, '370300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370400', '1', '枣庄市', '枣庄', 'zao,zhuang', 34.81085800, 117.32375900, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370402', '2', '市中区', NULL, NULL, 34.86379100, 117.55612500, '370400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370403', '2', '薛城区', NULL, NULL, 34.79533900, 117.26352400, '370400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370404', '2', '峄城区', NULL, NULL, 34.77293100, 117.59073800, '370400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370405', '2', '台儿庄区', NULL, NULL, 34.56310300, 117.73428700, '370400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370406', '2', '山亭区', NULL, NULL, 35.09963800, 117.46186600, '370400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370481', '2', '滕州市', NULL, NULL, 35.11412000, 117.16588100, '370400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370500', '1', '东营市', '东营', 'dong,ying', 37.43383900, 118.67453400, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370502', '2', '东营区', NULL, NULL, 37.44903500, 118.58218200, '370500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370503', '2', '河口区', NULL, NULL, 37.88621700, 118.52551900, '370500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370505', '2', '垦利区', NULL, NULL, 37.57341200, 118.57523400, '370500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370522', '2', '利津县', NULL, NULL, 37.49083900, 118.25512800, '370500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370523', '2', '广饶县', NULL, NULL, 37.05391500, 118.41943700, '370500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370600', '1', '烟台市', '烟台', 'yan,tai', 37.46455100, 121.44775500, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370602', '2', '芝罘区', NULL, NULL, 37.54131200, 121.40030300, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370611', '2', '福山区', NULL, NULL, 37.49833000, 121.26763800, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370612', '2', '牟平区', NULL, NULL, 37.38745400, 121.60101500, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370613', '2', '莱山区', NULL, NULL, 37.51132200, 121.44494900, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370614', '2', '蓬莱区', NULL, NULL, 37.79569700, 120.82914100, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370681', '2', '龙口市', NULL, NULL, 37.64528100, 120.47614000, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370682', '2', '莱阳市', NULL, NULL, 36.97975700, 120.71155500, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370683', '2', '莱州市', NULL, NULL, 37.17818700, 119.94205700, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370685', '2', '招远市', NULL, NULL, 37.35451700, 120.43390400, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370686', '2', '栖霞市', NULL, NULL, 37.33599300, 120.84959500, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370687', '2', '海阳市', NULL, NULL, 36.68831600, 121.17350600, '370600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370700', '1', '潍坊市', '潍坊', 'wei,fang', 36.70766800, 119.16172100, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370702', '2', '潍城区', NULL, NULL, 36.72807700, 119.02491000, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370703', '2', '寒亭区', NULL, NULL, 36.75592500, 119.21125100, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370704', '2', '坊子区', NULL, NULL, 36.65367100, 119.16634300, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370705', '2', '奎文区', NULL, NULL, 36.70745900, 119.13228800, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370724', '2', '临朐县', NULL, NULL, 36.51246000, 118.54327400, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370725', '2', '昌乐县', NULL, NULL, 36.68803500, 118.84103500, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370781', '2', '青州市', NULL, NULL, 36.68517800, 118.47963700, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370782', '2', '诸城市', NULL, NULL, 36.00926100, 119.41290800, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370783', '2', '寿光市', NULL, NULL, 36.85713300, 118.79106200, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370784', '2', '安丘市', NULL, NULL, 36.47964200, 119.21892000, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370785', '2', '高密市', NULL, NULL, 36.38297300, 119.75527100, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370786', '2', '昌邑市', NULL, NULL, 36.84325600, 119.40318500, '370700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370800', '1', '济宁市', '济宁', 'ji,ning', 35.41511700, 116.58711600, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370811', '2', '任城区', NULL, NULL, 35.44422600, 116.60576300, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370812', '2', '兖州区', NULL, NULL, 35.55193800, 116.78365000, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370826', '2', '微山县', NULL, NULL, 34.80665700, 117.12918800, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370827', '2', '鱼台县', NULL, NULL, 35.01270600, 116.65052600, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370828', '2', '金乡县', NULL, NULL, 35.06709300, 116.31161900, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370829', '2', '嘉祥县', NULL, NULL, 35.40794000, 116.34230800, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370830', '2', '汶上县', NULL, NULL, 35.71189100, 116.49727700, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370831', '2', '泗水县', NULL, NULL, 35.66471900, 117.25082400, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370832', '2', '梁山县', NULL, NULL, 35.76595700, 116.13177400, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370881', '2', '曲阜市', NULL, NULL, 35.58193300, 116.98621200, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370883', '2', '邹城市', NULL, NULL, 35.40253600, 117.00740600, '370800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370900', '1', '泰安市', '泰安', 'tai,an', 36.20178400, 117.08696300, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370902', '2', '泰山区', NULL, NULL, 36.19283300, 117.13521500, '370900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370911', '2', '岱岳区', NULL, NULL, 36.18808800, 117.04165100, '370900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370921', '2', '宁阳县', NULL, NULL, 35.75910100, 116.80556300, '370900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370923', '2', '东平县', NULL, NULL, 35.93704900, 116.47021100, '370900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370982', '2', '新泰市', NULL, NULL, 35.90953000, 117.76806900, '370900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('370983', '2', '肥城市', NULL, NULL, 36.18197500, 116.76909800, '370900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371000', '1', '威海市', '威海', 'wei,hai', 37.51331500, 122.12051900, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371002', '2', '环翠区', NULL, NULL, 37.50173500, 122.12311500, '371000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371003', '2', '文登区', NULL, NULL, 37.19621600, 122.08835700, '371000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371082', '2', '荣成市', NULL, NULL, 37.16569800, 122.48703600, '371000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371083', '2', '乳山市', NULL, NULL, 36.92032900, 121.53955700, '371000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371100', '1', '日照市', '日照', 'ri,zhao', 35.41691200, 119.52685000, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371102', '2', '东港区', NULL, NULL, 35.42603700, 119.46228700, '371100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371103', '2', '岚山区', NULL, NULL, 35.12198500, 119.31881000, '371100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371121', '2', '五莲县', NULL, NULL, 35.76015400, 119.21367300, '371100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371122', '2', '莒县', NULL, NULL, 35.59125000, 118.86905900, '371100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371300', '1', '临沂市', '临沂', 'lin,yi', 35.10377100, 118.35646400, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371302', '2', '兰山区', NULL, NULL, 35.05279700, 118.34733200, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371311', '2', '罗庄区', NULL, NULL, 34.99706100, 118.28469300, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371312', '2', '河东区', NULL, NULL, 35.08893600, 118.40307300, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371321', '2', '沂南县', NULL, NULL, 35.55007800, 118.46525900, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371322', '2', '郯城县', NULL, NULL, 34.61407700, 118.36727000, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371323', '2', '沂水县', NULL, NULL, 35.79091900, 118.62814200, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371324', '2', '兰陵县', NULL, NULL, 34.85823500, 118.07091200, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371325', '2', '费县', NULL, NULL, 35.26585100, 117.97760000, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371326', '2', '平邑县', NULL, NULL, 35.51684900, 117.61520100, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371327', '2', '莒南县', NULL, NULL, 35.20625200, 118.83516600, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371328', '2', '蒙阴县', NULL, NULL, 35.72012800, 117.95336700, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371329', '2', '临沭县', NULL, NULL, 34.91996800, 118.65041100, '371300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371400', '1', '德州市', '德州', 'de,zhou', 37.43649200, 116.35924400, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371402', '2', '德城区', NULL, NULL, 37.45105300, 116.29950700, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371403', '2', '陵城区', NULL, NULL, 37.33644400, 116.57614800, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371422', '2', '宁津县', NULL, NULL, 37.65245600, 116.80027900, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371423', '2', '庆云县', NULL, NULL, 37.77437600, 117.38416300, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371424', '2', '临邑县', NULL, NULL, 37.19013900, 116.86656800, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371425', '2', '齐河县', NULL, NULL, 36.78416400, 116.76276700, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371426', '2', '平原县', NULL, NULL, 37.16545300, 116.43401600, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371427', '2', '夏津县', NULL, NULL, 36.94801300, 116.00179600, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371428', '2', '武城县', NULL, NULL, 37.21339800, 116.06931200, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371481', '2', '乐陵市', NULL, NULL, 37.72976900, 117.23208500, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371482', '2', '禹城市', NULL, NULL, 36.93419800, 116.63855800, '371400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371500', '1', '聊城市', '聊城', 'liao,cheng', 36.45585700, 115.98523800, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371502', '2', '东昌府区', NULL, NULL, 36.41273700, 116.00639900, '371500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371503', '2', '茌平区', NULL, NULL, 36.58081400, 116.25486500, '371500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371521', '2', '阳谷县', NULL, NULL, 36.11461800, 115.79154600, '371500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371522', '2', '莘县', NULL, NULL, 36.23352200, 115.67095800, '371500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371524', '2', '东阿县', NULL, NULL, 36.33519800, 116.24765500, '371500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371525', '2', '冠县', NULL, NULL, 36.48401100, 115.44168400, '371500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371526', '2', '高唐县', NULL, NULL, 36.84715000, 116.23012600, '371500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371581', '2', '临清市', NULL, NULL, 36.83779200, 115.70476900, '371500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371600', '1', '滨州市', '滨州', 'bin,zhou', 37.38268700, 117.97073100, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371602', '2', '滨城区', NULL, NULL, 37.43199700, 118.01956700, '371600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371603', '2', '沾化区', NULL, NULL, 37.69895200, 118.09896200, '371600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371621', '2', '惠民县', NULL, NULL, 37.47528000, 117.59374400, '371600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371622', '2', '阳信县', NULL, NULL, 37.63277300, 117.60340700, '371600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371623', '2', '无棣县', NULL, NULL, 37.77057900, 117.62584600, '371600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371625', '2', '博兴县', NULL, NULL, 37.15452900, 118.11071500, '371600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371681', '2', '邹平市', NULL, NULL, 36.86339300, 117.74313000, '371600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371700', '1', '菏泽市', '菏泽', 'he,ze', 35.23430900, 115.47964600, '370000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371702', '2', '牡丹区', NULL, NULL, 35.25167500, 115.41688300, '371700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371703', '2', '定陶区', NULL, NULL, 35.10574200, 115.58317200, '371700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371721', '2', '曹县', NULL, NULL, 34.85875000, 115.55639300, '371700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371722', '2', '单县', NULL, NULL, 34.77928200, 116.10639600, '371700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371723', '2', '成武县', NULL, NULL, 34.95278000, 115.88977500, '371700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371724', '2', '巨野县', NULL, NULL, 35.38854300, 116.06258500, '371700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371725', '2', '郓城县', NULL, NULL, 35.57527600, 115.93893900, '371700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371726', '2', '鄄城县', NULL, NULL, 35.53408800, 115.54450700, '371700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('371728', '2', '东明县', NULL, NULL, 35.27566400, 115.10740200, '371700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410000', '0', '河南省', '河南', 'he,nan', 34.76705200, 113.75309400, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410100', '1', '郑州市', '郑州', 'zheng,zhou', 34.74630300, 113.62535100, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410102', '2', '中原区', NULL, NULL, 34.74828000, 113.61296600, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410103', '2', '二七区', NULL, NULL, 34.72413800, 113.64017700, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410104', '2', '管城回族区', NULL, NULL, 34.75443600, 113.67744600, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410105', '2', '金水区', NULL, NULL, 34.80041500, 113.66030000, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410106', '2', '上街区', NULL, NULL, 34.80351400, 113.30918500, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410108', '2', '惠济区', NULL, NULL, 34.86799400, 113.61705500, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410122', '2', '中牟县', NULL, NULL, 34.72053500, 113.97579800, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410181', '2', '巩义市', NULL, NULL, 34.74820700, 113.02235400, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410182', '2', '荥阳市', NULL, NULL, 34.78660000, 113.38338500, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410183', '2', '新密市', NULL, NULL, 34.54021600, 113.39093200, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410184', '2', '新郑市', NULL, NULL, 34.39647900, 113.74024000, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410185', '2', '登封市', NULL, NULL, 34.45487700, 113.05056000, '410100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410200', '1', '开封市', '开封', 'kai,feng', 34.79808300, 114.31427800, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410202', '2', '龙亭区', NULL, NULL, 34.81551500, 114.35537800, '410200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410203', '2', '顺河回族区', NULL, NULL, 34.79749900, 114.37557800, '410200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410204', '2', '鼓楼区', NULL, NULL, 34.78847300, 114.34835600, '410200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410205', '2', '禹王台区', NULL, NULL, 34.77706400, 114.34809900, '410200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410212', '2', '祥符区', NULL, NULL, 34.75739600, 114.44121200, '410200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410221', '2', '杞县', NULL, NULL, 34.54973100, 114.78262900, '410200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410222', '2', '通许县', NULL, NULL, 34.50193600, 114.47322000, '410200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410223', '2', '尉氏县', NULL, NULL, 34.41247900, 114.19297500, '410200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410225', '2', '兰考县', NULL, NULL, 34.85637200, 114.81822800, '410200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410300', '1', '洛阳市', '洛阳', 'luo,yang', 34.61970200, 112.45389500, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410302', '2', '老城区', NULL, NULL, 34.69861700, 112.44671000, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410303', '2', '西工区', NULL, NULL, 34.65995900, 112.42818300, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410304', '2', '瀍河回族区', NULL, NULL, 34.67977300, 112.50013100, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410305', '2', '涧西区', NULL, NULL, 34.65817700, 112.39576600, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410307', '2', '偃师区', NULL, NULL, 34.72715000, 112.78937500, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410308', '2', '孟津区', NULL, NULL, 34.82558700, 112.44525000, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410311', '2', '洛龙区', NULL, NULL, 34.61969400, 112.46393300, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410323', '2', '新安县', NULL, NULL, 34.72890900, 112.13246000, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410324', '2', '栾川县', NULL, NULL, 33.78570000, 111.61572900, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410325', '2', '嵩县', NULL, NULL, 34.13463900, 112.08543200, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410326', '2', '汝阳县', NULL, NULL, 34.15428300, 112.47301300, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410327', '2', '宜阳县', NULL, NULL, 34.51462000, 112.17918700, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410328', '2', '洛宁县', NULL, NULL, 34.38937100, 111.65295800, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410329', '2', '伊川县', NULL, NULL, 34.42174100, 112.42575100, '410300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410400', '1', '平顶山市', '平顶山', 'ping,ding,shan', 33.76655400, 113.19259500, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410402', '2', '新华区', NULL, NULL, 33.73675800, 113.29440600, '410400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410403', '2', '卫东区', NULL, NULL, 33.73538800, 113.33531600, '410400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410404', '2', '石龙区', NULL, NULL, 33.89924700, 112.89884500, '410400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410411', '2', '湛河区', NULL, NULL, 33.71184695, 113.22794603, '410400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410421', '2', '宝丰县', NULL, NULL, 33.86915900, 113.05453800, '410400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410422', '2', '叶县', NULL, NULL, 33.62743700, 113.35747600, '410400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410423', '2', '鲁山县', NULL, NULL, 33.73843400, 112.90805200, '410400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410425', '2', '郏县', NULL, NULL, 33.97180300, 113.21257800, '410400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410481', '2', '舞钢市', NULL, NULL, 33.31414700, 113.51642700, '410400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410482', '2', '汝州市', NULL, NULL, 34.16717000, 112.84469600, '410400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410500', '1', '安阳市', '安阳', 'an,yang', 36.09877900, 114.39248000, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410502', '2', '文峰区', NULL, NULL, 36.09059300, 114.35696700, '410500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410503', '2', '北关区', NULL, NULL, 36.10766000, 114.35574200, '410500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410505', '2', '殷都区', NULL, NULL, 36.10999800, 114.30378900, '410500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410506', '2', '龙安区', NULL, NULL, 36.07693700, 114.30103700, '410500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410522', '2', '安阳县', NULL, NULL, 36.09211000, 114.46295300, '410500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410523', '2', '汤阴县', NULL, NULL, 35.92515500, 114.35768600, '410500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410526', '2', '滑县', NULL, NULL, 35.57612800, 114.51797700, '410500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410527', '2', '内黄县', NULL, NULL, 35.97201600, 114.90146000, '410500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410581', '2', '林州市', NULL, NULL, 36.08412700, 113.81927500, '410500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410600', '1', '鹤壁市', '鹤壁', 'he,bi', 35.74832900, 114.29730500, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410602', '2', '鹤山区', NULL, NULL, 35.95464700, 114.16313300, '410600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410603', '2', '山城区', NULL, NULL, 35.89819600, 114.18361500, '410600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410611', '2', '淇滨区', NULL, NULL, 35.74176300, 114.29874800, '410600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410621', '2', '浚县', NULL, NULL, 35.67724900, 114.55061100, '410600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410622', '2', '淇县', NULL, NULL, 35.62257100, 114.20885100, '410600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410700', '1', '新乡市', '新乡', 'xin,xiang', 35.30358900, 113.92679000, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410702', '2', '红旗区', NULL, NULL, 35.30295200, 113.87521100, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410703', '2', '卫滨区', NULL, NULL, 35.30179600, 113.86566600, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410704', '2', '凤泉区', NULL, NULL, 35.38442800, 113.91618300, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410711', '2', '牧野区', NULL, NULL, 35.31561400, 113.90856100, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410721', '2', '新乡县', NULL, NULL, 35.17006600, 113.81388400, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410724', '2', '获嘉县', NULL, NULL, 35.26015300, 113.65755100, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410725', '2', '原阳县', NULL, NULL, 35.06687300, 113.93982900, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410726', '2', '延津县', NULL, NULL, 35.16587600, 114.20562400, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410727', '2', '封丘县', NULL, NULL, 35.04123700, 114.41890700, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410781', '2', '卫辉市', NULL, NULL, 35.39835700, 114.06458400, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410782', '2', '辉县市', NULL, NULL, 35.46296400, 113.80572000, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410783', '2', '长垣市', NULL, NULL, 35.20162800, 114.66885000, '410700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410800', '1', '焦作市', '焦作', 'jiao,zuo', 35.21572600, 113.24190200, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410802', '2', '解放区', NULL, NULL, 35.24051700, 113.23064000, '410800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410803', '2', '中站区', NULL, NULL, 35.23704600, 113.18288000, '410800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410804', '2', '马村区', NULL, NULL, 35.25710500, 113.32212000, '410800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410811', '2', '山阳区', NULL, NULL, 35.21505400, 113.25458100, '410800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410821', '2', '修武县', NULL, NULL, 35.22286000, 113.44786200, '410800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410822', '2', '博爱县', NULL, NULL, 35.17033200, 113.06470100, '410800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410823', '2', '武陟县', NULL, NULL, 35.05080405, 113.39718431, '410800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410825', '2', '温县', NULL, NULL, 34.93961000, 113.08067000, '410800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410882', '2', '沁阳市', NULL, NULL, 35.08756900, 112.95087300, '410800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410883', '2', '孟州市', NULL, NULL, 34.90724800, 112.79158600, '410800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410900', '1', '濮阳市', '濮阳', 'pu,yang', 35.76273100, 115.02924600, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410902', '2', '华龙区', NULL, NULL, 35.77805800, 115.07384200, '410900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410922', '2', '清丰县', NULL, NULL, 35.88669400, 115.10460200, '410900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410923', '2', '南乐县', NULL, NULL, 36.07021900, 115.20587600, '410900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410926', '2', '范县', NULL, NULL, 35.85302000, 115.50408100, '410900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410927', '2', '台前县', NULL, NULL, 35.97028600, 115.87167100, '410900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('410928', '2', '濮阳县', NULL, NULL, 35.71311300, 115.02916500, '410900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411000', '1', '许昌市', '许昌', 'xu,chang', 34.03732000, 113.85200400, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411002', '2', '魏都区', NULL, NULL, 34.04718900, 113.83082600, '411000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411003', '2', '建安区', NULL, NULL, 34.12472900, 113.82286900, '411000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411024', '2', '鄢陵县', NULL, NULL, 34.10298500, 114.17732900, '411000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411025', '2', '襄城县', NULL, NULL, 33.85160900, 113.50690400, '411000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411081', '2', '禹州市', NULL, NULL, 34.14244200, 113.48871500, '411000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411082', '2', '长葛市', NULL, NULL, 34.19545800, 113.81397200, '411000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411100', '1', '漯河市', '漯河', 'luo,he', 33.58038000, 114.01660000, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411102', '2', '源汇区', NULL, NULL, 33.57231900, 113.98416400, '411100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411103', '2', '郾城区', NULL, NULL, 33.58769700, 114.00659600, '411100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411104', '2', '召陵区', NULL, NULL, 33.58650900, 114.09387900, '411100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411121', '2', '舞阳县', NULL, NULL, 33.43825900, 113.60932700, '411100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411122', '2', '临颍县', NULL, NULL, 33.82809600, 113.93112100, '411100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411200', '1', '三门峡市', '三门峡', 'san,men,xia', 34.77319600, 111.20048200, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411202', '2', '湖滨区', NULL, NULL, 34.77129600, 111.18855200, '411200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411203', '2', '陕州区', NULL, NULL, 34.72196400, 111.10305700, '411200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411221', '2', '渑池县', NULL, NULL, 34.76793700, 111.76175300, '411200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411224', '2', '卢氏县', NULL, NULL, 34.05438200, 111.04783000, '411200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411281', '2', '义马市', NULL, NULL, 34.74756300, 111.87472600, '411200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411282', '2', '灵宝市', NULL, NULL, 34.51773400, 110.89422500, '411200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411300', '1', '南阳市', '南阳', 'nan,yang', 32.99021800, 112.52854900, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411302', '2', '宛城区', NULL, NULL, 33.00356400, 112.53950600, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411303', '2', '卧龙区', NULL, NULL, 32.98636400, 112.53490700, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411321', '2', '南召县', NULL, NULL, 33.48980400, 112.42927700, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411322', '2', '方城县', NULL, NULL, 33.25538700, 113.01284900, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411323', '2', '西峡县', NULL, NULL, 33.30727200, 111.47364400, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411324', '2', '镇平县', NULL, NULL, 33.03382600, 112.23457100, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411325', '2', '内乡县', NULL, NULL, 33.04469800, 111.84935400, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411326', '2', '淅川县', NULL, NULL, 33.13830600, 111.49070900, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411327', '2', '社旗县', NULL, NULL, 33.05622900, 112.94818300, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411328', '2', '唐河县', NULL, NULL, 32.68246400, 112.80829000, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411329', '2', '新野县', NULL, NULL, 32.52128200, 112.36010000, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411330', '2', '桐柏县', NULL, NULL, 32.37920500, 113.42861000, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411381', '2', '邓州市', NULL, NULL, 32.68773200, 112.08745000, '411300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411400', '1', '商丘市', '商丘', 'shang,qiu', 34.41516500, 115.65635800, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411402', '2', '梁园区', NULL, NULL, 34.44451900, 115.61360900, '411400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411403', '2', '睢阳区', NULL, NULL, 34.38904800, 115.65325800, '411400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411421', '2', '民权县', NULL, NULL, 34.64838400, 115.17501900, '411400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411422', '2', '睢县', NULL, NULL, 34.44658700, 115.07189900, '411400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411423', '2', '宁陵县', NULL, NULL, 34.46122600, 115.31422100, '411400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411424', '2', '柘城县', NULL, NULL, 34.09201500, 115.30518200, '411400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411425', '2', '虞城县', NULL, NULL, 34.40086800, 115.82851900, '411400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411426', '2', '夏邑县', NULL, NULL, 34.23780100, 116.13142200, '411400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411481', '2', '永城市', NULL, NULL, 33.92992700, 116.44986400, '411400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411500', '1', '信阳市', '信阳', 'xin,yang', 32.14862400, 114.09105800, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411502', '2', '浉河区', NULL, NULL, 32.11688500, 114.05867000, '411500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411503', '2', '平桥区', NULL, NULL, 32.10114800, 114.12563000, '411500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411521', '2', '罗山县', NULL, NULL, 32.02533874, 114.43715714, '411500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411522', '2', '光山县', NULL, NULL, 32.01076200, 114.91910100, '411500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411523', '2', '新县', NULL, NULL, 31.64438000, 114.87943400, '411500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411524', '2', '商城县', NULL, NULL, 31.79858500, 115.40659500, '411500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411525', '2', '固始县', NULL, NULL, 32.16923900, 115.65406600, '411500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411526', '2', '潢川县', NULL, NULL, 32.13177800, 115.05167100, '411500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411527', '2', '淮滨县', NULL, NULL, 32.47477200, 115.42010100, '411500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411528', '2', '息县', NULL, NULL, 32.34312000, 114.74039200, '411500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411600', '1', '周口市', '周口', 'zhou,kou', 33.63465200, 114.70122200, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411602', '2', '川汇区', NULL, NULL, 33.64767900, 114.65055100, '411600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411603', '2', '淮阳区', NULL, NULL, 33.73154300, 114.85260400, '411600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411621', '2', '扶沟县', NULL, NULL, 34.06006200, 114.39466600, '411600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411622', '2', '西华县', NULL, NULL, 33.76827700, 114.52970900, '411600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411623', '2', '商水县', NULL, NULL, 33.56040900, 114.61943000, '411600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411624', '2', '沈丘县', NULL, NULL, 33.40980500, 115.09854100, '411600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411625', '2', '郸城县', NULL, NULL, 33.64601000, 115.17714100, '411600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411627', '2', '太康县', NULL, NULL, 34.06451300, 114.83794600, '411600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411628', '2', '鹿邑县', NULL, NULL, 33.86069800, 115.48452500, '411600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411681', '2', '项城市', NULL, NULL, 33.46560900, 114.87512800, '411600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411700', '1', '驻马店市', '驻马店', 'zhu,ma,dian', 33.01403800, 114.02198800, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411702', '2', '驿城区', NULL, NULL, 32.97455000, 113.99375300, '411700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411721', '2', '西平县', NULL, NULL, 33.38765800, 114.02149200, '411700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411722', '2', '上蔡县', NULL, NULL, 33.26243900, 114.26438100, '411700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411723', '2', '平舆县', NULL, NULL, 32.96344000, 114.61853700, '411700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411724', '2', '正阳县', NULL, NULL, 32.60569700, 114.39277400, '411700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411725', '2', '确山县', NULL, NULL, 32.82134000, 114.01681800, '411700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411726', '2', '泌阳县', NULL, NULL, 32.72439300, 113.32717800, '411700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411727', '2', '汝南县', NULL, NULL, 33.00508300, 114.32551000, '411700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411728', '2', '遂平县', NULL, NULL, 33.14631600, 114.01332300, '411700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('411729', '2', '新蔡县', NULL, NULL, 32.74488000, 114.96551900, '411700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001', '1', '济源市', '济源', 'ji,yuan', 35.06905700, 112.60234700, '410000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001001', '2', '沁园街道', NULL, NULL, 35.07039300, 112.57383300, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001002', '2', '济水街道', NULL, NULL, 35.09181800, 112.61109500, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001003', '2', '北海街道', NULL, NULL, 35.10292800, 112.57501800, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001004', '2', '天坛街道', NULL, NULL, 35.09451400, 112.56563600, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001005', '2', '玉泉街道', NULL, NULL, 35.09256100, 112.61578200, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001100', '2', '克井镇', NULL, NULL, 35.16024900, 112.54309400, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001101', '2', '五龙口镇', NULL, NULL, 35.13585300, 112.68916900, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001102', '2', '轵城镇', NULL, NULL, 35.04598900, 112.60128600, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001103', '2', '承留镇', NULL, NULL, 35.07706000, 112.49914200, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001104', '2', '邵原镇', NULL, NULL, 35.16103200, 112.13332200, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001105', '2', '坡头镇', NULL, NULL, 34.92885000, 112.52483300, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001106', '2', '梨林镇', NULL, NULL, 35.07802300, 112.71345500, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001107', '2', '大峪镇', NULL, NULL, 34.93763600, 112.39612100, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001108', '2', '思礼镇', NULL, NULL, 35.10140900, 112.50720300, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001109', '2', '王屋镇', NULL, NULL, 35.11388800, 112.27254500, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('419001110', '2', '下冶镇', NULL, NULL, 35.03280300, 112.19986000, '419001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420000', '0', '湖北省', '湖北', 'hu,bei', 30.54622200, 114.34155200, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420100', '1', '武汉市', '武汉', 'wu,han', 30.59335400, 114.30456900, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420102', '2', '江岸区', NULL, NULL, 30.63331200, 114.28302000, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420103', '2', '江汉区', NULL, NULL, 30.60112900, 114.27076300, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420104', '2', '硚口区', NULL, NULL, 30.58255900, 114.21474600, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420105', '2', '汉阳区', NULL, NULL, 30.55428700, 114.21859000, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420106', '2', '武昌区', NULL, NULL, 30.55418000, 114.31646400, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420107', '2', '青山区', NULL, NULL, 30.61418104, 114.45401920, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420111', '2', '洪山区', NULL, NULL, 30.50064200, 114.34266400, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420112', '2', '东西湖区', NULL, NULL, 30.62007900, 114.13629500, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420113', '2', '汉南区', NULL, NULL, 30.30877600, 114.08458200, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420114', '2', '蔡甸区', NULL, NULL, 30.53639500, 114.08727900, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420115', '2', '江夏区', NULL, NULL, 30.37558000, 114.32088400, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420116', '2', '黄陂区', NULL, NULL, 30.88230500, 114.37569800, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420117', '2', '新洲区', NULL, NULL, 30.84176100, 114.80101500, '420100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420200', '1', '黄石市', '黄石', 'huang,shi', 30.20108200, 115.03899900, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420202', '2', '黄石港区', NULL, NULL, 30.22319400, 115.06565300, '420200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420203', '2', '西塞山区', NULL, NULL, 30.20511400, 115.11006700, '420200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420204', '2', '下陆区', NULL, NULL, 30.17414800, 114.96091400, '420200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420205', '2', '铁山区', NULL, NULL, 30.20315200, 114.89160300, '420200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420222', '2', '阳新县', NULL, NULL, 29.83023600, 115.21521100, '420200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420281', '2', '大冶市', NULL, NULL, 30.09626300, 114.98046000, '420200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420300', '1', '十堰市', '十堰', 'shi,yan', 32.62905700, 110.79892100, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420302', '2', '茅箭区', NULL, NULL, 32.59184700, 110.81347800, '420300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420303', '2', '张湾区', NULL, NULL, 32.65232700, 110.76941600, '420300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420304', '2', '郧阳区', NULL, NULL, 32.83553200, 110.81326100, '420300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420322', '2', '郧西县', NULL, NULL, 32.99328700, 110.42589500, '420300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420323', '2', '竹山县', NULL, NULL, 32.22503900, 110.22969600, '420300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420324', '2', '竹溪县', NULL, NULL, 32.31825700, 109.71532200, '420300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420325', '2', '房县', NULL, NULL, 32.04017000, 110.72675400, '420300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420381', '2', '丹江口市', NULL, NULL, 32.54028700, 111.51331800, '420300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420500', '1', '宜昌市', '宜昌', 'yi,chang', 30.69217000, 111.28696200, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420502', '2', '西陵区', NULL, NULL, 30.71076500, 111.28569600, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420503', '2', '伍家岗区', NULL, NULL, 30.64404800, 111.36088200, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420504', '2', '点军区', NULL, NULL, 30.69343000, 111.26833800, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420505', '2', '猇亭区', NULL, NULL, 30.53113300, 111.43437800, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420506', '2', '夷陵区', NULL, NULL, 30.76987500, 111.32637100, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420525', '2', '远安县', NULL, NULL, 31.06141600, 111.64111600, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420526', '2', '兴山县', NULL, NULL, 31.34806500, 110.74683100, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420527', '2', '秭归县', NULL, NULL, 30.82585800, 110.97773100, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420528', '2', '长阳土家族自治县', NULL, NULL, 30.47303800, 111.20697000, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420529', '2', '五峰土家族自治县', NULL, NULL, 30.15674100, 111.07374000, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420581', '2', '宜都市', NULL, NULL, 30.37882600, 111.44983900, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420582', '2', '当阳市', NULL, NULL, 30.82089300, 111.78836000, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420583', '2', '枝江市', NULL, NULL, 30.42613000, 111.76043900, '420500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420600', '1', '襄阳市', '襄阳', 'xiang,yang', 32.01016100, 112.12174300, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420602', '2', '襄城区', NULL, NULL, 32.00993200, 112.13402500, '420600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420606', '2', '樊城区', NULL, NULL, 32.04506500, 112.13524100, '420600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420607', '2', '襄州区', NULL, NULL, 32.08865100, 112.21136500, '420600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420624', '2', '南漳县', NULL, NULL, 31.77464900, 111.83899700, '420600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420625', '2', '谷城县', NULL, NULL, 32.26416300, 111.65290600, '420600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420626', '2', '保康县', NULL, NULL, 31.87815400, 111.26146200, '420600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420682', '2', '老河口市', NULL, NULL, 32.35900800, 111.68435600, '420600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420683', '2', '枣阳市', NULL, NULL, 32.12896800, 112.77272300, '420600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420684', '2', '宜城市', NULL, NULL, 31.72027800, 112.25648600, '420600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420700', '1', '鄂州市', '鄂州', 'e,zhou', 30.39112000, 114.89495600, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420702', '2', '梁子湖区', NULL, NULL, 30.10022900, 114.68531400, '420700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420703', '2', '华容区', NULL, NULL, 30.53515000, 114.72994500, '420700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420704', '2', '鄂城区', NULL, NULL, 30.40053500, 114.89157000, '420700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420800', '1', '荆门市', '荆门', 'jing,men', 31.03544500, 112.19900900, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420802', '2', '东宝区', NULL, NULL, 31.05165000, 112.20099700, '420800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420804', '2', '掇刀区', NULL, NULL, 30.97339700, 112.20790000, '420800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420822', '2', '沙洋县', NULL, NULL, 30.70639400, 112.58749000, '420800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420881', '2', '钟祥市', NULL, NULL, 31.16714000, 112.58861700, '420800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420882', '2', '京山市', NULL, NULL, 31.01841400, 113.11956100, '420800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420900', '1', '孝感市', '孝感', 'xiao,gan', 30.91831100, 113.95696200, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420902', '2', '孝南区', NULL, NULL, 30.91695000, 113.91076900, '420900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420921', '2', '孝昌县', NULL, NULL, 31.25970900, 113.99728600, '420900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420922', '2', '大悟县', NULL, NULL, 31.56117900, 114.12712200, '420900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420923', '2', '云梦县', NULL, NULL, 31.02173600, 113.75295800, '420900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420981', '2', '应城市', NULL, NULL, 30.92859200, 113.57186400, '420900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420982', '2', '安陆市', NULL, NULL, 31.25501900, 113.68832000, '420900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('420984', '2', '汉川市', NULL, NULL, 30.67321900, 113.83806800, '420900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421000', '1', '荆州市', '荆州', 'jing,zhou', 30.33628200, 112.24143000, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421002', '2', '沙市区', NULL, NULL, 30.32669300, 112.25197500, '421000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421003', '2', '荆州区', NULL, NULL, 30.35298400, 112.19028200, '421000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421022', '2', '公安县', NULL, NULL, 30.05851900, 112.22974200, '421000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421024', '2', '江陵县', NULL, NULL, 30.04222700, 112.42458100, '421000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421081', '2', '石首市', NULL, NULL, 29.72094400, 112.42538000, '421000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421083', '2', '洪湖市', NULL, NULL, 29.82725600, 113.47598400, '421000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421087', '2', '松滋市', NULL, NULL, 30.17471700, 111.75645500, '421000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421088', '2', '监利市', NULL, NULL, 29.84022900, 112.90463400, '421000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421100', '1', '黄冈市', '黄冈', 'huang,gang', 30.45372200, 114.87242500, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421102', '2', '黄州区', NULL, NULL, 30.43435400, 114.88010400, '421100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421121', '2', '团风县', NULL, NULL, 30.64322500, 114.87236400, '421100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421122', '2', '红安县', NULL, NULL, 31.28846100, 114.61816400, '421100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421123', '2', '罗田县', NULL, NULL, 30.78304700, 115.39914900, '421100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421124', '2', '英山县', NULL, NULL, 30.73498900, 115.68095300, '421100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421125', '2', '浠水县', NULL, NULL, 30.45221200, 115.26515500, '421100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421126', '2', '蕲春县', NULL, NULL, 30.22614600, 115.43642300, '421100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421127', '2', '黄梅县', NULL, NULL, 30.07045300, 115.94421900, '421100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421181', '2', '麻城市', NULL, NULL, 31.17291700, 115.00801100, '421100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421182', '2', '武穴市', NULL, NULL, 29.86950900, 115.59550800, '421100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421200', '1', '咸宁市', '咸宁', 'xian,ning', 29.84135000, 114.32260100, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421202', '2', '咸安区', NULL, NULL, 29.85272600, 114.29900200, '421200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421221', '2', '嘉鱼县', NULL, NULL, 29.97057500, 113.93924900, '421200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421222', '2', '通城县', NULL, NULL, 29.24540000, 113.81681100, '421200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421223', '2', '崇阳县', NULL, NULL, 29.55686600, 114.03948400, '421200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421224', '2', '通山县', NULL, NULL, 29.60646800, 114.48283200, '421200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421281', '2', '赤壁市', NULL, NULL, 29.72512200, 113.90038500, '421200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421300', '1', '随州市', '随州', 'sui,zhou', 31.69027500, 113.38232400, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421303', '2', '曾都区', NULL, NULL, 31.71642300, 113.37105200, '421300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421321', '2', '随县', NULL, NULL, 31.88323300, 113.29097000, '421300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('421381', '2', '广水市', NULL, NULL, 31.61701500, 113.82597700, '421300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('422800', '1', '恩施土家族苗族自治州', '恩施', 'en,shi', 30.27210400, 109.48807600, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('422801', '2', '恩施市', NULL, NULL, 30.29514800, 109.47957200, '422800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('422802', '2', '利川市', NULL, NULL, 30.29097400, 108.93645600, '422800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('422822', '2', '建始县', NULL, NULL, 30.60219500, 109.72233300, '422800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('422823', '2', '巴东县', NULL, NULL, 31.04285400, 110.34092100, '422800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('422825', '2', '宣恩县', NULL, NULL, 29.98685600, 109.48991800, '422800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('422826', '2', '咸丰县', NULL, NULL, 29.66523700, 109.14018800, '422800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('422827', '2', '来凤县', NULL, NULL, 29.49347400, 109.40769700, '422800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('422828', '2', '鹤峰县', NULL, NULL, 29.89007300, 110.03401100, '422800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004', '1', '仙桃市', '仙桃', 'xian,tao', 30.32840700, 113.44297300, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004001', '2', '沙嘴街道', NULL, NULL, 30.35709600, 113.45174100, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004002', '2', '干河街道', NULL, NULL, 30.37336300, 113.42728100, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004003', '2', '龙华山街道', NULL, NULL, 30.36895300, 113.46117300, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004101', '2', '郑场镇', NULL, NULL, 30.48782500, 113.03365600, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004102', '2', '毛嘴镇', NULL, NULL, 30.41803900, 113.03542500, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004103', '2', '剅河镇', NULL, NULL, 30.33988400, 113.08607100, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004104', '2', '三伏潭镇', NULL, NULL, 30.37521900, 113.20155800, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004105', '2', '胡场镇', NULL, NULL, 30.37378600, 113.32952900, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004106', '2', '长埫口镇', NULL, NULL, 30.40083600, 113.56366300, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004107', '2', '西流河镇', NULL, NULL, 30.31495100, 113.67795000, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004108', '2', '沙湖镇', NULL, NULL, 30.16928000, 113.67485400, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004109', '2', '杨林尾镇', NULL, NULL, 30.13736700, 113.50941000, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004110', '2', '彭场镇', NULL, NULL, 30.26402000, 113.50680100, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004111', '2', '张沟镇', NULL, NULL, 30.25015500, 113.38059500, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004112', '2', '郭河镇', NULL, NULL, 30.24035900, 113.29361700, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004113', '2', '沔城回族镇', NULL, NULL, 30.19146300, 113.23203800, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004114', '2', '通海口镇', NULL, NULL, 30.19955500, 113.15330900, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004115', '2', '陈场镇', NULL, NULL, 30.23562600, 113.08810500, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004400', '2', '工业园区', NULL, NULL, 30.33043500, 113.41750900, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429004408', '2', '排湖风景区', NULL, NULL, 30.29416500, 113.29088700, '429004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005', '1', '潜江市', '潜江', 'qian,jiang', 30.40195400, 112.90027900, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005001', '2', '园林街道', NULL, NULL, 30.41582200, 112.89208300, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005002', '2', '泽口街道', NULL, NULL, 30.47532000, 112.86257100, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005003', '2', '广华街道', NULL, NULL, 30.45532000, 112.69867700, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005004', '2', '周矶街道', NULL, NULL, 30.41216000, 112.81063300, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005005', '2', '杨市街道', NULL, NULL, 30.36846200, 112.90684600, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005006', '2', '泰丰街道', NULL, NULL, 30.40158100, 112.91122400, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005007', '2', '高场街道', NULL, NULL, 30.40287700, 112.72321500, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005100', '2', '竹根滩镇', NULL, NULL, 30.49376900, 112.90657200, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005101', '2', '渔洋镇', NULL, NULL, 30.17239900, 112.90891200, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005102', '2', '老新镇', NULL, NULL, 30.18938200, 112.85722600, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005103', '2', '熊口镇', NULL, NULL, 30.30626100, 112.78101200, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005104', '2', '王场镇', NULL, NULL, 30.50472200, 112.77434600, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005105', '2', '高石碑镇', NULL, NULL, 30.54755600, 112.67322300, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005106', '2', '积玉口镇', NULL, NULL, 30.45238500, 112.59684300, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005107', '2', '浩口镇', NULL, NULL, 30.37921000, 112.65013500, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005108', '2', '张金镇', NULL, NULL, 30.19234300, 112.59638200, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005109', '2', '龙湾镇', NULL, NULL, 30.22938700, 112.71714800, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005400', '2', '江汉石油管理局', NULL, NULL, 30.44820300, 112.69615500, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005450', '2', '周矶管理区', NULL, NULL, 30.45330400, 112.79443400, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005451', '2', '后湖管理区', NULL, NULL, 30.33591900, 112.70350600, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005453', '2', '总口管理区', NULL, NULL, 30.28895500, 112.92076400, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005454', '2', '白鹭湖管理区', NULL, NULL, 30.13766000, 112.70910700, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429005455', '2', '运粮湖管理区', NULL, NULL, 30.28441000, 112.52781000, '429005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006', '1', '天门市', '天门', 'tian,men', 30.66370600, 113.16654500, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006001', '2', '竟陵街道', NULL, NULL, 30.66449500, 113.16241800, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006002', '2', '侨乡街道', NULL, NULL, 30.57964700, 113.13164500, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006003', '2', '杨林街道', NULL, NULL, 30.63968100, 113.19252300, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006100', '2', '多宝镇', NULL, NULL, 30.66814800, 112.69768200, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006101', '2', '拖市镇', NULL, NULL, 30.72695700, 112.83894900, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006102', '2', '张港镇', NULL, NULL, 30.56765700, 112.88148000, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006103', '2', '蒋场镇', NULL, NULL, 30.60539100, 112.94484200, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006104', '2', '汪场镇', NULL, NULL, 30.61405500, 113.04069800, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006105', '2', '渔薪镇', NULL, NULL, 30.67581400, 112.99068700, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006106', '2', '黄潭镇', NULL, NULL, 30.65975900, 113.09080100, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006107', '2', '岳口镇', NULL, NULL, 30.50739000, 113.09449200, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006108', '2', '横林镇', NULL, NULL, 30.53657000, 113.18841000, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006109', '2', '彭市镇', NULL, NULL, 30.45656000, 113.18775100, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006110', '2', '麻洋镇', NULL, NULL, 30.43524100, 113.26762900, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006111', '2', '多祥镇', NULL, NULL, 30.40222700, 113.44544000, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006112', '2', '干驿镇', NULL, NULL, 30.54371600, 113.38621200, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006113', '2', '马湾镇', NULL, NULL, 30.57891200, 113.33589700, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006114', '2', '卢市镇', NULL, NULL, 30.66836000, 113.33074000, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006115', '2', '小板镇', NULL, NULL, 30.60800000, 113.22485200, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006116', '2', '九真镇', NULL, NULL, 30.74215100, 113.22049600, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006118', '2', '皂市镇', NULL, NULL, 30.85644500, 113.34994100, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006119', '2', '胡市镇', NULL, NULL, 30.77968300, 113.38962200, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006120', '2', '石家河镇', NULL, NULL, 30.75783700, 113.08646700, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006121', '2', '佛子山镇', NULL, NULL, 30.75258500, 113.01085800, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006201', '2', '净潭乡', NULL, NULL, 30.65526700, 113.40076100, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429006452', '2', '沉湖管委会', NULL, NULL, 30.49125800, 113.40399600, '429006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429021', '1', '神农架林区', '神农架', 'shen,nong,jia', 31.74510300, 110.67587900, '420000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429021100', '2', '松柏镇', NULL, NULL, 31.74698900, 110.66166700, '429021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429021101', '2', '阳日镇', NULL, NULL, 31.73747900, 110.81958600, '429021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429021102', '2', '木鱼镇', NULL, NULL, 31.40149700, 110.48260300, '429021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429021103', '2', '红坪镇', NULL, NULL, 31.67296000, 110.42941100, '429021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429021104', '2', '新华镇', NULL, NULL, 31.59291900, 110.89152700, '429021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429021105', '2', '大九湖镇', NULL, NULL, 31.45633300, 110.13202400, '429021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429021201', '2', '宋洛乡', NULL, NULL, 31.66086100, 110.60796200, '429021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('429021203', '2', '下谷坪土家族乡', NULL, NULL, 31.36569700, 110.24527200, '429021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430000', '0', '湖南省', '湖南', 'hu,nan', 28.11600700, 112.98295100, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430100', '1', '长沙市', '长沙', 'chang,sha', 28.22830400, 112.93888200, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430102', '2', '芙蓉区', NULL, NULL, 28.18535100, 113.03260500, '430100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430103', '2', '天心区', NULL, NULL, 28.11454400, 112.98978000, '430100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430104', '2', '岳麓区', NULL, NULL, 28.23420200, 112.93011600, '430100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430105', '2', '开福区', NULL, NULL, 28.25728600, 112.98528400, '430100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430111', '2', '雨花区', NULL, NULL, 28.13579500, 113.03853000, '430100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430112', '2', '望城区', NULL, NULL, 28.35322100, 112.83125000, '430100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430121', '2', '长沙县', NULL, NULL, 28.24682100, 113.08055500, '430100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430181', '2', '浏阳市', NULL, NULL, 28.16386600, 113.64328000, '430100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430182', '2', '宁乡市', NULL, NULL, 28.27783800, 112.55194600, '430100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430200', '1', '株洲市', '株洲', 'zhu,zhou', 27.82886200, 113.13278300, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430202', '2', '荷塘区', NULL, NULL, 27.85631400, 113.17316900, '430200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430203', '2', '芦淞区', NULL, NULL, 27.78519800, 113.15345500, '430200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430204', '2', '石峰区', NULL, NULL, 27.87551300, 113.11776300, '430200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430211', '2', '天元区', NULL, NULL, 27.82673800, 113.08222700, '430200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430212', '2', '渌口区', NULL, NULL, 27.69940900, 113.14389700, '430200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430223', '2', '攸县', NULL, NULL, 27.01516000, 113.39715200, '430200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430224', '2', '茶陵县', NULL, NULL, 26.77795700, 113.53790700, '430200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430225', '2', '炎陵县', NULL, NULL, 26.49006900, 113.77207100, '430200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430281', '2', '醴陵市', NULL, NULL, 27.64570000, 113.49711900, '430200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430300', '1', '湘潭市', '湘潭', 'xiang,tan', 27.83136000, 112.94543900, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430302', '2', '雨湖区', NULL, NULL, 27.85635800, 112.90729200, '430300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430304', '2', '岳塘区', NULL, NULL, 27.87237900, 112.96871600, '430300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430321', '2', '湘潭县', NULL, NULL, 27.77966900, 112.95076700, '430300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430381', '2', '湘乡市', NULL, NULL, 27.71865500, 112.55026800, '430300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430382', '2', '韶山市', NULL, NULL, 27.91479600, 112.52536400, '430300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430400', '1', '衡阳市', '衡阳', 'heng,yang', 26.89421600, 112.57201600, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430405', '2', '珠晖区', NULL, NULL, 26.89479600, 112.62065300, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430406', '2', '雁峰区', NULL, NULL, 26.84033500, 112.61391400, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430407', '2', '石鼓区', NULL, NULL, 26.94425700, 112.59793700, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430408', '2', '蒸湘区', NULL, NULL, 26.91238800, 112.56733300, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430412', '2', '南岳区', NULL, NULL, 27.23184600, 112.73767800, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430421', '2', '衡阳县', NULL, NULL, 26.97025800, 112.37064900, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430422', '2', '衡南县', NULL, NULL, 26.73966500, 112.67757200, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430423', '2', '衡山县', NULL, NULL, 27.23045600, 112.86814300, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430424', '2', '衡东县', NULL, NULL, 27.08292700, 112.95399700, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430426', '2', '祁东县', NULL, NULL, 26.79928400, 112.09031900, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430481', '2', '耒阳市', NULL, NULL, 26.42214900, 112.85980600, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430482', '2', '常宁市', NULL, NULL, 26.42171700, 112.39989400, '430400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430500', '1', '邵阳市', '邵阳', 'shao,yang', 27.23952800, 111.46785500, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430502', '2', '双清区', NULL, NULL, 27.23247400, 111.49687500, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430503', '2', '大祥区', NULL, NULL, 27.22207800, 111.43889200, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430511', '2', '北塔区', NULL, NULL, 27.24624400, 111.45198800, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430522', '2', '新邵县', NULL, NULL, 27.32136300, 111.45843100, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430523', '2', '邵阳县', NULL, NULL, 26.99078500, 111.27387200, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430524', '2', '隆回县', NULL, NULL, 27.11397800, 111.03243700, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430525', '2', '洞口县', NULL, NULL, 27.06027400, 110.57596200, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430527', '2', '绥宁县', NULL, NULL, 26.58295600, 110.15612100, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430528', '2', '新宁县', NULL, NULL, 26.43291300, 110.85729400, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430529', '2', '城步苗族自治县', NULL, NULL, 26.39059800, 110.32223900, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430581', '2', '武冈市', NULL, NULL, 26.72741400, 110.63228600, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430582', '2', '邵东市', NULL, NULL, 27.25981200, 111.74426800, '430500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430600', '1', '岳阳市', '岳阳', 'yue,yang', 29.35648000, 113.12892200, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430602', '2', '岳阳楼区', NULL, NULL, 29.37135600, 113.12936200, '430600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430603', '2', '云溪区', NULL, NULL, 29.47235500, 113.27284700, '430600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430611', '2', '君山区', NULL, NULL, 29.46125900, 113.00649200, '430600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430621', '2', '岳阳县', NULL, NULL, 29.14468100, 113.11615200, '430600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430623', '2', '华容县', NULL, NULL, 29.53077500, 112.54044800, '430600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430624', '2', '湘阴县', NULL, NULL, 28.69012300, 112.90924800, '430600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430626', '2', '平江县', NULL, NULL, 28.70197600, 113.58083400, '430600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430681', '2', '汨罗市', NULL, NULL, 28.80693700, 113.06709700, '430600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430682', '2', '临湘市', NULL, NULL, 29.47668700, 113.45046100, '430600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430700', '1', '常德市', '常德', 'chang,de', 29.03144600, 111.69905000, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430702', '2', '武陵区', NULL, NULL, 29.05533200, 111.68304300, '430700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430703', '2', '鼎城区', NULL, NULL, 29.01759600, 111.67989600, '430700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430721', '2', '安乡县', NULL, NULL, 29.41216600, 112.17097300, '430700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430722', '2', '汉寿县', NULL, NULL, 28.90555900, 111.97058200, '430700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430723', '2', '澧县', NULL, NULL, 29.63338400, 111.75846300, '430700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430724', '2', '临澧县', NULL, NULL, 29.44157000, 111.64749400, '430700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430725', '2', '桃源县', NULL, NULL, 28.90327900, 111.48920600, '430700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430726', '2', '石门县', NULL, NULL, 29.58491200, 111.37952700, '430700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430781', '2', '津市市', NULL, NULL, 29.60651200, 111.87795700, '430700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430800', '1', '张家界市', '张家界', 'zhang,jia,jie', 29.11734300, 110.47888700, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430802', '2', '永定区', NULL, NULL, 29.11966200, 110.53737900, '430800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430811', '2', '武陵源区', NULL, NULL, 29.34685000, 110.55031300, '430800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430821', '2', '慈利县', NULL, NULL, 29.43042900, 111.13942400, '430800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430822', '2', '桑植县', NULL, NULL, 29.41411200, 110.20480400, '430800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430900', '1', '益阳市', '益阳', 'yi,yang', 28.55485300, 112.35599400, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430902', '2', '资阳区', NULL, NULL, 28.59149000, 112.32428600, '430900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430903', '2', '赫山区', NULL, NULL, 28.58011000, 112.37389500, '430900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430921', '2', '南县', NULL, NULL, 29.36239600, 112.39632300, '430900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430922', '2', '桃江县', NULL, NULL, 28.51821500, 112.15643200, '430900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430923', '2', '安化县', NULL, NULL, 28.37422300, 111.21329600, '430900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('430981', '2', '沅江市', NULL, NULL, 28.84575500, 112.35465700, '430900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431000', '1', '郴州市', '郴州', 'chen,zhou', 25.77011700, 113.01551700, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431002', '2', '北湖区', NULL, NULL, 25.78463200, 113.01060600, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431003', '2', '苏仙区', NULL, NULL, 25.79962400, 113.04236400, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431021', '2', '桂阳县', NULL, NULL, 25.75382000, 112.73380400, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431022', '2', '宜章县', NULL, NULL, 25.40059000, 112.94880600, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431023', '2', '永兴县', NULL, NULL, 26.12756600, 113.11709300, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431024', '2', '嘉禾县', NULL, NULL, 25.61602500, 112.37921600, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431025', '2', '临武县', NULL, NULL, 25.27645900, 112.56383300, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431026', '2', '汝城县', NULL, NULL, 25.53302400, 113.68519300, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431027', '2', '桂东县', NULL, NULL, 26.07782100, 113.94484700, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431028', '2', '安仁县', NULL, NULL, 26.72323600, 113.27314800, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431081', '2', '资兴市', NULL, NULL, 25.97722600, 113.23584100, '431000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431100', '1', '永州市', '永州', 'yong,zhou', 26.41986100, 111.61348200, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431102', '2', '零陵区', NULL, NULL, 26.22227800, 111.62980600, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431103', '2', '冷水滩区', NULL, NULL, 26.46137200, 111.59224100, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431122', '2', '东安县', NULL, NULL, 26.39217300, 111.31589300, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431123', '2', '双牌县', NULL, NULL, 25.96176000, 111.65971400, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431124', '2', '道县', NULL, NULL, 25.52739800, 111.60079500, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431125', '2', '江永县', NULL, NULL, 25.27446100, 111.34354300, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431126', '2', '宁远县', NULL, NULL, 25.57081700, 111.94592500, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431127', '2', '蓝山县', NULL, NULL, 25.36957500, 112.19584200, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431128', '2', '新田县', NULL, NULL, 25.90399200, 112.20340200, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431129', '2', '江华瑶族自治县', NULL, NULL, 25.18608200, 111.57892000, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431181', '2', '祁阳市', NULL, NULL, 26.58029200, 111.84025300, '431100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431200', '1', '怀化市', '怀化', 'huai,hua', 27.56981300, 110.00159800, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431202', '2', '鹤城区', NULL, NULL, 27.57858100, 110.04009900, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431221', '2', '中方县', NULL, NULL, 27.44055400, 109.94543600, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431222', '2', '沅陵县', NULL, NULL, 28.45210300, 110.39378200, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431223', '2', '辰溪县', NULL, NULL, 28.00623500, 110.18315900, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431224', '2', '溆浦县', NULL, NULL, 27.90886900, 110.59441900, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431225', '2', '会同县', NULL, NULL, 26.88715600, 109.73472400, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431226', '2', '麻阳苗族自治县', NULL, NULL, 27.85766600, 109.81770300, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431227', '2', '新晃侗族自治县', NULL, NULL, 27.35209400, 109.17480800, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431228', '2', '芷江侗族自治县', NULL, NULL, 27.44325700, 109.68478400, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431229', '2', '靖州苗族侗族自治县', NULL, NULL, 26.57584300, 109.69646800, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431230', '2', '通道侗族自治县', NULL, NULL, 26.15748800, 109.78466900, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431281', '2', '洪江市', NULL, NULL, 27.20938500, 109.83647500, '431200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431300', '1', '娄底市', '娄底', 'lou,di', 27.69983800, 111.99446800, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431302', '2', '娄星区', NULL, NULL, 27.73020800, 112.00192200, '431300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431321', '2', '双峰县', NULL, NULL, 27.45800200, 112.17426200, '431300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431322', '2', '新化县', NULL, NULL, 27.72541600, 111.32767400, '431300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431381', '2', '冷水江市', NULL, NULL, 27.65400000, 111.45951500, '431300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('431382', '2', '涟源市', NULL, NULL, 27.69340700, 111.66330500, '431300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('433100', '1', '湘西土家族苗族自治州', '湘西', 'xiang,xi', 28.31259200, 109.73742800, '430000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('433101', '2', '吉首市', NULL, NULL, 28.26194800, 109.69834800, '433100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('433122', '2', '泸溪县', NULL, NULL, 28.21610900, 110.21961900, '433100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('433123', '2', '凤凰县', NULL, NULL, 27.95744100, 109.58081500, '433100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('433124', '2', '花垣县', NULL, NULL, 28.57191000, 109.48237800, '433100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('433125', '2', '保靖县', NULL, NULL, 28.70004500, 109.66000800, '433100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('433126', '2', '古丈县', NULL, NULL, 28.61697100, 109.95072000, '433100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('433127', '2', '永顺县', NULL, NULL, 28.97981900, 109.85714200, '433100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('433130', '2', '龙山县', NULL, NULL, 29.45843600, 109.44387100, '433100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440000', '0', '广东省', '广东', 'guang,dong', 23.13330600, 113.26688700, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440100', '1', '广州市', '广州', 'guang,zhou', 23.13006100, 113.26449900, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440103', '2', '荔湾区', NULL, NULL, 23.10712300, 113.21899800, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440104', '2', '越秀区', NULL, NULL, 23.12867300, 113.26706500, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440105', '2', '海珠区', NULL, NULL, 23.08400300, 113.31741200, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440106', '2', '天河区', NULL, NULL, 23.12481700, 113.36159700, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440111', '2', '白云区', NULL, NULL, 23.15715900, 113.27320000, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440112', '2', '黄埔区', NULL, NULL, 23.18135500, 113.48061300, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440113', '2', '番禺区', NULL, NULL, 22.93756000, 113.38391700, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440114', '2', '花都区', NULL, NULL, 23.40432600, 113.22012500, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440115', '2', '南沙区', NULL, NULL, 22.80143500, 113.52517800, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440117', '2', '从化区', NULL, NULL, 23.54828700, 113.58698800, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440118', '2', '增城区', NULL, NULL, 23.26145200, 113.81073400, '440100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440200', '1', '韶关市', '韶关', 'shao,guan', 24.81097700, 113.59732400, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440203', '2', '武江区', NULL, NULL, 24.79316100, 113.58678600, '440200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440204', '2', '浈江区', NULL, NULL, 24.80489800, 113.61107700, '440200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440205', '2', '曲江区', NULL, NULL, 24.68282600, 113.60459100, '440200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440222', '2', '始兴县', NULL, NULL, 24.95390800, 114.06199800, '440200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440224', '2', '仁化县', NULL, NULL, 25.08576400, 113.74917500, '440200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440229', '2', '翁源县', NULL, NULL, 24.35058100, 114.12998600, '440200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440232', '2', '乳源瑶族自治县', NULL, NULL, 24.77585600, 113.27587500, '440200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440233', '2', '新丰县', NULL, NULL, 24.05990900, 114.20664100, '440200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440281', '2', '乐昌市', NULL, NULL, 25.13067500, 113.34736500, '440200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440282', '2', '南雄市', NULL, NULL, 25.11873000, 114.31204900, '440200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440300', '1', '深圳市', '深圳', 'shen,zhen', 22.54352700, 114.05793900, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440303', '2', '罗湖区', NULL, NULL, 22.54835700, 114.13166000, '440300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440304', '2', '福田区', NULL, NULL, 22.52092200, 114.05519800, '440300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440305', '2', '南山区', NULL, NULL, 22.53319100, 113.93047800, '440300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440306', '2', '宝安区', NULL, NULL, 22.55498600, 113.88383100, '440300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440307', '2', '龙岗区', NULL, NULL, 22.72088900, 114.24688400, '440300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440308', '2', '盐田区', NULL, NULL, 22.55700100, 114.23673900, '440300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440309', '2', '龙华区', NULL, NULL, 22.69673500, 114.04491000, '440300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440310', '2', '坪山区', NULL, NULL, 22.70878600, 114.35084400, '440300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440311', '2', '光明区', NULL, NULL, 22.74875000, 113.93605900, '440300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440400', '1', '珠海市', '珠海', 'zhu,hai', 22.27164400, 113.57689200, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440402', '2', '香洲区', NULL, NULL, 22.26563500, 113.54337200, '440400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440403', '2', '斗门区', NULL, NULL, 22.20913400, 113.29622800, '440400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440404', '2', '金湾区', NULL, NULL, 22.14785600, 113.36390700, '440400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440500', '1', '汕头市', '汕头', 'shan,tou', 23.35415200, 116.68195600, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440507', '2', '龙湖区', NULL, NULL, 23.37210100, 116.71652600, '440500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440511', '2', '金平区', NULL, NULL, 23.36571600, 116.70341000, '440500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440512', '2', '濠江区', NULL, NULL, 23.28660500, 116.72670100, '440500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440513', '2', '潮阳区', NULL, NULL, 23.26551200, 116.60140100, '440500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440514', '2', '潮南区', NULL, NULL, 23.23919600, 116.43910500, '440500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440515', '2', '澄海区', NULL, NULL, 23.46767800, 116.75670800, '440500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440523', '2', '南澳县', NULL, NULL, 23.42165800, 117.02348200, '440500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440600', '1', '佛山市', '佛山', 'fo,shan', 23.02135100, 113.12158600, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440604', '2', '禅城区', NULL, NULL, 23.00947500, 113.12253200, '440600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440605', '2', '南海区', NULL, NULL, 23.02887500, 113.14324600, '440600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440606', '2', '顺德区', NULL, NULL, 22.80541300, 113.29319700, '440600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440607', '2', '三水区', NULL, NULL, 23.15667500, 112.89727100, '440600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440608', '2', '高明区', NULL, NULL, 22.89984000, 112.89183900, '440600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440700', '1', '江门市', '江门', 'jiang,men', 22.57894800, 113.08154800, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440703', '2', '蓬江区', NULL, NULL, 22.59528500, 113.07891400, '440700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440704', '2', '江海区', NULL, NULL, 22.56130100, 113.11102900, '440700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440705', '2', '新会区', NULL, NULL, 22.45851900, 113.03445400, '440700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440781', '2', '台山市', NULL, NULL, 22.25194700, 112.79381200, '440700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440783', '2', '开平市', NULL, NULL, 22.37737800, 112.69811300, '440700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440784', '2', '鹤山市', NULL, NULL, 22.76591200, 112.96420300, '440700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440785', '2', '恩平市', NULL, NULL, 22.18374300, 112.30490400, '440700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440800', '1', '湛江市', '湛江', 'zhan,jiang', 21.27010800, 110.35753800, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440802', '2', '赤坎区', NULL, NULL, 21.26594800, 110.36559200, '440800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440803', '2', '霞山区', NULL, NULL, 21.19246300, 110.39772100, '440800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440804', '2', '坡头区', NULL, NULL, 21.24440500, 110.45519200, '440800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440811', '2', '麻章区', NULL, NULL, 21.26437000, 110.33383300, '440800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440823', '2', '遂溪县', NULL, NULL, 21.37837100, 110.25043000, '440800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440825', '2', '徐闻县', NULL, NULL, 20.32596900, 110.17595000, '440800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440881', '2', '廉江市', NULL, NULL, 21.60998800, 110.28610900, '440800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440882', '2', '雷州市', NULL, NULL, 20.91454800, 110.09701100, '440800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440883', '2', '吴川市', NULL, NULL, 21.44076300, 110.77936100, '440800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440900', '1', '茂名市', '茂名', 'mao,ming', 21.66272800, 110.92553300, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440902', '2', '茂南区', NULL, NULL, 21.64166100, 110.91856600, '440900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440904', '2', '电白区', NULL, NULL, 21.51394600, 111.01336800, '440900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440981', '2', '高州市', NULL, NULL, 21.91964700, 110.85405600, '440900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440982', '2', '化州市', NULL, NULL, 21.66448300, 110.63958100, '440900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('440983', '2', '信宜市', NULL, NULL, 22.35488700, 110.94686600, '440900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441200', '1', '肇庆市', '肇庆', 'zhao,qing', 23.04774700, 112.46524500, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441202', '2', '端州区', NULL, NULL, 23.05184700, 112.48557700, '441200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441203', '2', '鼎湖区', NULL, NULL, 23.15906200, 112.56738000, '441200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441204', '2', '高要区', NULL, NULL, 23.02474000, 112.45805500, '441200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441223', '2', '广宁县', NULL, NULL, 23.63540500, 112.44036000, '441200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441224', '2', '怀集县', NULL, NULL, 23.92080600, 112.16690800, '441200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441225', '2', '封开县', NULL, NULL, 23.42426700, 111.51246800, '441200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441226', '2', '德庆县', NULL, NULL, 23.14503500, 111.78554400, '441200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441284', '2', '四会市', NULL, NULL, 23.32699100, 112.73430900, '441200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441300', '1', '惠州市', '惠州', 'hui,zhou', 23.11236800, 114.41558700, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441302', '2', '惠城区', NULL, NULL, 23.08465700, 114.38252600, '441300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441303', '2', '惠阳区', NULL, NULL, 22.78943100, 114.45610700, '441300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441322', '2', '博罗县', NULL, NULL, 23.17258700, 114.28960200, '441300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441323', '2', '惠东县', NULL, NULL, 22.98483100, 114.72013600, '441300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441324', '2', '龙门县', NULL, NULL, 23.72787300, 114.25489800, '441300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441400', '1', '梅州市', '梅州', 'mei,zhou', 24.28883200, 116.12204600, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441402', '2', '梅江区', NULL, NULL, 24.31065000, 116.11668600, '441400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441403', '2', '梅县区', NULL, NULL, 24.26619100, 116.08139500, '441400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441422', '2', '大埔县', NULL, NULL, 24.34703700, 116.69482500, '441400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441423', '2', '丰顺县', NULL, NULL, 23.73936400, 116.18189500, '441400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441424', '2', '五华县', NULL, NULL, 23.93333700, 115.77616600, '441400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441426', '2', '平远县', NULL, NULL, 24.56692800, 115.89123500, '441400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441427', '2', '蕉岭县', NULL, NULL, 24.65896300, 116.17147700, '441400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441481', '2', '兴宁市', NULL, NULL, 24.13729600, 115.73113300, '441400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441500', '1', '汕尾市', '汕尾', 'shan,wei', 22.78720400, 115.37555700, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441502', '2', '城区', NULL, NULL, 22.77920400, 115.36522000, '441500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441521', '2', '海丰县', NULL, NULL, 22.96721200, 115.32297400, '441500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441523', '2', '陆河县', NULL, NULL, 23.30202800, 115.66005000, '441500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441581', '2', '陆丰市', NULL, NULL, 22.91874000, 115.65214200, '441500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441600', '1', '河源市', '河源', 'he,yuan', 23.74427600, 114.70021500, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441602', '2', '源城区', NULL, NULL, 23.73405500, 114.70330500, '441600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441621', '2', '紫金县', NULL, NULL, 23.63559700, 115.18381400, '441600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441622', '2', '龙川县', NULL, NULL, 24.10059900, 115.26002000, '441600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441623', '2', '连平县', NULL, NULL, 24.36955200, 114.48835800, '441600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441624', '2', '和平县', NULL, NULL, 24.46917700, 114.93563400, '441600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441625', '2', '东源县', NULL, NULL, 23.79007900, 114.74660000, '441600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441700', '1', '阳江市', '阳江', 'yang,jiang', 21.85685300, 111.98343000, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441702', '2', '江城区', NULL, NULL, 21.86256500, 111.95486700, '441700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441704', '2', '阳东区', NULL, NULL, 21.86908100, 112.00558600, '441700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441721', '2', '阳西县', NULL, NULL, 21.75393500, 111.61769600, '441700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441781', '2', '阳春市', NULL, NULL, 22.17120900, 111.79197400, '441700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441800', '1', '清远市', '清远', 'qing,yuan', 23.68206400, 113.05609800, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441802', '2', '清城区', NULL, NULL, 23.69805000, 113.06257700, '441800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441803', '2', '清新区', NULL, NULL, 23.73419200, 113.01768600, '441800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441821', '2', '佛冈县', NULL, NULL, 23.87946600, 113.53152500, '441800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441823', '2', '阳山县', NULL, NULL, 24.46523400, 112.64119900, '441800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441825', '2', '连山壮族瑶族自治县', NULL, NULL, 24.57055300, 112.09372600, '441800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441826', '2', '连南瑶族自治县', NULL, NULL, 24.72595300, 112.28721200, '441800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441881', '2', '英德市', NULL, NULL, 24.20716000, 113.40182700, '441800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441882', '2', '连州市', NULL, NULL, 24.78087300, 112.37725500, '441800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441900', '1', '东莞市', '东莞', 'dong,guan', 23.02101600, 113.75188400, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('441999', '2', '东莞市', NULL, NULL, 23.02101600, 113.75188400, '441900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('442000', '1', '中山市', '中山', 'zhong,shan', 22.51702400, 113.39251700, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('442099', '2', '中山市', NULL, NULL, 22.51702400, 113.39251700, '442000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445100', '1', '潮州市', '潮州', 'chao,zhou', 23.65766200, 116.62190100, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445102', '2', '湘桥区', NULL, NULL, 23.67510400, 116.62834300, '445100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445103', '2', '潮安区', NULL, NULL, 23.46359800, 116.67697100, '445100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445122', '2', '饶平县', NULL, NULL, 23.66329400, 117.00450000, '445100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445200', '1', '揭阳市', '揭阳', 'jie,yang', 23.55096800, 116.37273200, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445202', '2', '榕城区', NULL, NULL, 23.52591800, 116.36714000, '445200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445203', '2', '揭东区', NULL, NULL, 23.56725200, 116.41192800, '445200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445222', '2', '揭西县', NULL, NULL, 23.43140000, 115.84252100, '445200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445224', '2', '惠来县', NULL, NULL, 23.03381600, 116.29503300, '445200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445281', '2', '普宁市', NULL, NULL, 23.29774200, 116.16564600, '445200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445300', '1', '云浮市', '云浮', 'yun,fu', 22.91463900, 112.04478800, '440000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445302', '2', '云城区', NULL, NULL, 22.92858400, 112.04356200, '445300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445303', '2', '云安区', NULL, NULL, 23.07033400, 112.00294700, '445300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445321', '2', '新兴县', NULL, NULL, 22.69556400, 112.22431800, '445300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445322', '2', '郁南县', NULL, NULL, 23.23456100, 111.53538700, '445300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('445381', '2', '罗定市', NULL, NULL, 22.76922900, 111.56966000, '445300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450000', '0', '广西壮族自治区', '广西', 'guang,xi', 22.81665900, 108.32753700, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450100', '1', '南宁市', '南宁', 'nan,ning', 22.81770000, 108.36640700, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450102', '2', '兴宁区', NULL, NULL, 22.85354000, 108.36807100, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450103', '2', '青秀区', NULL, NULL, 22.78583300, 108.49520400, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450105', '2', '江南区', NULL, NULL, 22.78116600, 108.27320600, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450107', '2', '西乡塘区', NULL, NULL, 22.83385200, 108.31344000, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450108', '2', '良庆区', NULL, NULL, 22.75361300, 108.39388900, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450109', '2', '邕宁区', NULL, NULL, 22.75863300, 108.48743800, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450110', '2', '武鸣区', NULL, NULL, 23.15925700, 108.27486900, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450123', '2', '隆安县', NULL, NULL, 23.16635600, 107.69572100, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450124', '2', '马山县', NULL, NULL, 23.70844800, 108.17776400, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450125', '2', '上林县', NULL, NULL, 23.43245100, 108.60508900, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450126', '2', '宾阳县', NULL, NULL, 23.21777300, 108.81034000, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450181', '2', '横州市', NULL, NULL, 22.68125700, 109.26244800, '450100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450200', '1', '柳州市', '柳州', 'liu,zhou', 24.32644200, 109.42807100, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450202', '2', '城中区', NULL, NULL, 24.36696400, 109.42739800, '450200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450203', '2', '鱼峰区', NULL, NULL, 24.31827600, 109.45278100, '450200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450204', '2', '柳南区', NULL, NULL, 24.33622900, 109.38550400, '450200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450205', '2', '柳北区', NULL, NULL, 24.36261100, 109.40200900, '450200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450206', '2', '柳江区', NULL, NULL, 24.25564400, 109.32636500, '450200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450222', '2', '柳城县', NULL, NULL, 24.64991200, 109.24461300, '450200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450223', '2', '鹿寨县', NULL, NULL, 24.47289700, 109.75052700, '450200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450224', '2', '融安县', NULL, NULL, 25.22519800, 109.39680900, '450200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450225', '2', '融水苗族自治县', NULL, NULL, 25.06662400, 109.25660900, '450200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450226', '2', '三江侗族自治县', NULL, NULL, 25.78394100, 109.60788100, '450200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450300', '1', '桂林市', '桂林', 'gui,lin', 25.23561500, 110.17975200, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450302', '2', '秀峰区', NULL, NULL, 25.27395400, 110.26410200, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450303', '2', '叠彩区', NULL, NULL, 25.31415800, 110.30148900, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450304', '2', '象山区', NULL, NULL, 25.26158500, 110.28122300, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450305', '2', '七星区', NULL, NULL, 25.25309300, 110.31757600, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450311', '2', '雁山区', NULL, NULL, 25.10179800, 110.28661100, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450312', '2', '临桂区', NULL, NULL, 25.23898300, 110.21196700, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450321', '2', '阳朔县', NULL, NULL, 24.77878500, 110.49630500, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450323', '2', '灵川县', NULL, NULL, 25.39480000, 110.31983700, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450324', '2', '全州县', NULL, NULL, 25.94939000, 111.08708900, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450325', '2', '兴安县', NULL, NULL, 25.61257600, 110.67201300, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450326', '2', '永福县', NULL, NULL, 24.98044700, 109.98297400, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450327', '2', '灌阳县', NULL, NULL, 25.48962400, 111.16148200, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450328', '2', '龙胜各族自治县', NULL, NULL, 25.79803200, 110.01169100, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450329', '2', '资源县', NULL, NULL, 26.04257700, 110.65294100, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450330', '2', '平乐县', NULL, NULL, 24.62281000, 110.63272000, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450332', '2', '恭城瑶族自治县', NULL, NULL, 24.83158100, 110.82841000, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450381', '2', '荔浦市', NULL, NULL, 24.48843000, 110.39523200, '450300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450400', '1', '梧州市', '梧州', 'wu,zhou', 23.47673300, 111.27902200, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450403', '2', '万秀区', NULL, NULL, 23.47054300, 111.31806500, '450400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450405', '2', '长洲区', NULL, NULL, 23.48627900, 111.27427600, '450400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450406', '2', '龙圩区', NULL, NULL, 23.40458200, 111.24627400, '450400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450421', '2', '苍梧县', NULL, NULL, 23.86830200, 111.54773400, '450400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450422', '2', '藤县', NULL, NULL, 23.37553800, 110.91460600, '450400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450423', '2', '蒙山县', NULL, NULL, 24.19356700, 110.52500300, '450400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450481', '2', '岑溪市', NULL, NULL, 22.91860600, 110.99486700, '450400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450500', '1', '北海市', '北海', 'bei,hai', 21.48130500, 109.12024800, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450502', '2', '海城区', NULL, NULL, 21.47491400, 109.11725600, '450500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450503', '2', '银海区', NULL, NULL, 21.44972900, 109.13968900, '450500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450512', '2', '铁山港区', NULL, NULL, 21.52987800, 109.42209900, '450500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450521', '2', '合浦县', NULL, NULL, 21.66132000, 109.20723600, '450500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450600', '1', '防城港市', '防城港', 'fang,cheng,gang', 21.68673200, 108.35467000, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450602', '2', '港口区', NULL, NULL, 21.64388600, 108.37943500, '450600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450603', '2', '防城区', NULL, NULL, 21.76882600, 108.35397800, '450600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450621', '2', '上思县', NULL, NULL, 22.15367100, 107.98362700, '450600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450681', '2', '东兴市', NULL, NULL, 21.54782100, 107.97182800, '450600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450700', '1', '钦州市', '钦州', 'qin,zhou', 21.98089400, 108.65435500, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450702', '2', '钦南区', NULL, NULL, 21.94043800, 108.65742700, '450700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450703', '2', '钦北区', NULL, NULL, 22.00240000, 108.63873800, '450700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450721', '2', '灵山县', NULL, NULL, 22.41667100, 109.29069800, '450700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450722', '2', '浦北县', NULL, NULL, 22.27190200, 109.55623200, '450700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450800', '1', '贵港市', '贵港', 'gui,gang', 23.11182000, 109.59890300, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450802', '2', '港北区', NULL, NULL, 23.11136000, 109.57222700, '450800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450803', '2', '港南区', NULL, NULL, 23.07581600, 109.59935700, '450800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450804', '2', '覃塘区', NULL, NULL, 23.12740100, 109.45266100, '450800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450821', '2', '平南县', NULL, NULL, 23.54041300, 110.39248900, '450800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450881', '2', '桂平市', NULL, NULL, 23.39425200, 110.07879900, '450800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450900', '1', '玉林市', '玉林', 'yu,lin', 22.65400100, 110.18097000, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450902', '2', '玉州区', NULL, NULL, 22.62847600, 110.15071700, '450900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450903', '2', '福绵区', NULL, NULL, 22.58531600, 110.05956400, '450900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450921', '2', '容县', NULL, NULL, 22.85844000, 110.55809300, '450900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450922', '2', '陆川县', NULL, NULL, 22.32156300, 110.26412000, '450900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450923', '2', '博白县', NULL, NULL, 22.27353900, 109.97585600, '450900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450924', '2', '兴业县', NULL, NULL, 22.73639500, 109.87522300, '450900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('450981', '2', '北流市', NULL, NULL, 22.70841500, 110.35376500, '450900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451000', '1', '百色市', '百色', 'bai,se', 23.90307000, 106.61869000, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451002', '2', '右江区', NULL, NULL, 23.90080400, 106.61815100, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451003', '2', '田阳区', NULL, NULL, 23.73563100, 106.91542400, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451022', '2', '田东县', NULL, NULL, 23.59670600, 107.12560900, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451024', '2', '德保县', NULL, NULL, 23.32408400, 106.61508700, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451026', '2', '那坡县', NULL, NULL, 23.38799700, 105.83234000, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451027', '2', '凌云县', NULL, NULL, 24.34744400, 106.56114000, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451028', '2', '乐业县', NULL, NULL, 24.77650600, 106.55651700, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451029', '2', '田林县', NULL, NULL, 24.29462700, 106.22874000, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451030', '2', '西林县', NULL, NULL, 24.50718900, 105.09708700, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451031', '2', '隆林各族自治县', NULL, NULL, 24.77089800, 105.34416700, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451081', '2', '靖西市', NULL, NULL, 23.13437500, 106.41766600, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451082', '2', '平果市', NULL, NULL, 23.32981500, 107.58976800, '451000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451100', '1', '贺州市', '贺州', 'he,zhou', 24.40418200, 111.56721600, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451102', '2', '八步区', NULL, NULL, 24.41232400, 111.55134000, '451100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451103', '2', '平桂区', NULL, NULL, 24.45309400, 111.47983900, '451100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451121', '2', '昭平县', NULL, NULL, 24.10157194, 110.96965168, '451100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451122', '2', '钟山县', NULL, NULL, 24.52588000, 111.30288500, '451100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451123', '2', '富川瑶族自治县', NULL, NULL, 24.81160100, 111.29601200, '451100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451200', '1', '河池市', '河池', 'he,chi', 24.48503000, 108.63654000, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451202', '2', '金城江区', NULL, NULL, 24.68947500, 108.03738400, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451203', '2', '宜州区', NULL, NULL, 24.50098100, 108.61130300, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451221', '2', '南丹县', NULL, NULL, 24.97506600, 107.54057800, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451222', '2', '天峨县', NULL, NULL, 24.99918100, 107.17228700, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451223', '2', '凤山县', NULL, NULL, 24.54691900, 107.04236800, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451224', '2', '东兰县', NULL, NULL, 24.51069800, 107.37425900, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451225', '2', '罗城仫佬族自治县', NULL, NULL, 24.77750100, 108.90461300, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451226', '2', '环江毛南族自治县', NULL, NULL, 24.82592300, 108.25842600, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451227', '2', '巴马瑶族自治县', NULL, NULL, 24.14110400, 107.25946500, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451228', '2', '都安瑶族自治县', NULL, NULL, 23.93270400, 108.10522900, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451229', '2', '大化瑶族自治县', NULL, NULL, 23.73567300, 107.99821700, '451200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451300', '1', '来宾市', '来宾', 'lai,bin', 23.75010500, 109.22124300, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451302', '2', '兴宾区', NULL, NULL, 23.72764700, 109.18328400, '451300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451321', '2', '忻城县', NULL, NULL, 24.06683300, 108.66554500, '451300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451322', '2', '象州县', NULL, NULL, 23.97383200, 109.70485200, '451300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451323', '2', '武宣县', NULL, NULL, 23.59473500, 109.66325000, '451300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451324', '2', '金秀瑶族自治县', NULL, NULL, 24.13050900, 110.19035400, '451300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451381', '2', '合山市', NULL, NULL, 23.80703200, 108.88582900, '451300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451400', '1', '崇左市', '崇左', 'chong,zuo', 22.37713900, 107.36497300, '450000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451402', '2', '江州区', NULL, NULL, 22.40609000, 107.35369400, '451400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451421', '2', '扶绥县', NULL, NULL, 22.63554200, 107.90389000, '451400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451422', '2', '宁明县', NULL, NULL, 22.14024200, 107.07639400, '451400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451423', '2', '龙州县', NULL, NULL, 22.34359100, 106.85400100, '451400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451424', '2', '大新县', NULL, NULL, 22.82912400, 107.19997700, '451400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451425', '2', '天等县', NULL, NULL, 23.08081800, 107.14353900, '451400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('451481', '2', '凭祥市', NULL, NULL, 22.09442100, 106.76671500, '451400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460000', '0', '海南省', '海南', 'hai,nan', 20.01863900, 110.34878100, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460100', '1', '海口市', '海口', 'hai,kou', 20.04631600, 110.20016200, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460105', '2', '秀英区', NULL, NULL, 20.00796600, 110.29367700, '460100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460106', '2', '龙华区', NULL, NULL, 20.03084300, 110.32862800, '460100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460107', '2', '琼山区', NULL, NULL, 19.98429300, 110.38431800, '460100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460108', '2', '美兰区', NULL, NULL, 20.02898300, 110.36635900, '460100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460200', '1', '三亚市', '三亚', 'san,ya', 18.25286500, 109.51170900, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460202', '2', '海棠区', NULL, NULL, 18.38417700, 109.73567600, '460200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460203', '2', '吉阳区', NULL, NULL, 18.28146000, 109.57823800, '460200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460204', '2', '天涯区', NULL, NULL, 18.29897500, 109.45232500, '460200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460205', '2', '崖州区', NULL, NULL, 18.35771100, 109.17257000, '460200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460300', '1', '三沙市', '三沙', 'san,sha', 16.83100400, 112.33864900, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460321', '2', '西沙群岛', NULL, NULL, 16.83437200, 112.34696100, '460300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460322', '2', '南沙群岛', NULL, NULL, 9.54853100, 112.89622900, '460300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460323', '2', '中沙群岛', NULL, NULL, 15.16780300, 117.80603400, '460300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460400', '1', '儋州市', '儋州', 'dan,zhou', 19.52094800, 109.58081200, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('460499', '2', '儋州市', NULL, NULL, 19.52094800, 109.58081200, '460400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469001', '1', '五指山市', '五指山', 'wu,zhi,shan', 18.77482700, 109.51678400, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469001100', '2', '通什镇', NULL, NULL, 18.78069200, 109.51718800, '469001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469001101', '2', '南圣镇', NULL, NULL, 18.73861200, 109.59266000, '469001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469001102', '2', '毛阳镇', NULL, NULL, 18.93696400, 109.50804000, '469001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469001103', '2', '番阳镇', NULL, NULL, 18.87442100, 109.39785000, '469001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469001200', '2', '畅好乡', NULL, NULL, 18.73502000, 109.48231100, '469001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469001201', '2', '毛道乡', NULL, NULL, 18.79125500, 109.41069900, '469001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469001202', '2', '水满乡', NULL, NULL, 18.88326400, 109.66261000, '469001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002', '1', '琼海市', '琼海', 'qiong,hai', 19.25911200, 110.47452400, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002100', '2', '嘉积镇', NULL, NULL, 19.24333500, 110.48580700, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002101', '2', '万泉镇', NULL, NULL, 19.24307100, 110.40965700, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002102', '2', '石壁镇', NULL, NULL, 19.16333800, 110.30866600, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002103', '2', '中原镇', NULL, NULL, 19.15183900, 110.46772300, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002104', '2', '博鳌镇', NULL, NULL, 19.15950000, 110.58703500, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002105', '2', '阳江镇', NULL, NULL, 19.09957200, 110.34904400, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002106', '2', '龙江镇', NULL, NULL, 19.14684300, 110.32496400, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002107', '2', '潭门镇', NULL, NULL, 19.24178600, 110.61687300, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002108', '2', '塔洋镇', NULL, NULL, 19.28831100, 110.50801400, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002109', '2', '长坡镇', NULL, NULL, 19.33567000, 110.60686700, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002110', '2', '大路镇', NULL, NULL, 19.38102300, 110.47646800, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469002111', '2', '会山镇', NULL, NULL, 19.06957100, 110.26424600, '469002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005', '1', '文昌市', '文昌', 'wen,chang', 19.54423400, 110.79747300, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005100', '2', '文城镇', NULL, NULL, 19.61378100, 110.75386800, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005101', '2', '重兴镇', NULL, NULL, 19.41180000, 110.59663600, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005102', '2', '蓬莱镇', NULL, NULL, 19.53677300, 110.54113900, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005103', '2', '会文镇', NULL, NULL, 19.46213200, 110.73219200, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005104', '2', '东路镇', NULL, NULL, 19.79255500, 110.70703500, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005105', '2', '潭牛镇', NULL, NULL, 19.71024100, 110.73623600, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005106', '2', '东阁镇', NULL, NULL, 19.65601200, 110.84947200, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005107', '2', '文教镇', NULL, NULL, 19.66768000, 110.90782000, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005108', '2', '东郊镇', NULL, NULL, 19.57377100, 110.85138500, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005109', '2', '龙楼镇', NULL, NULL, 19.65331900, 110.96778900, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005110', '2', '昌洒镇', NULL, NULL, 19.76193800, 110.90063300, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005111', '2', '翁田镇', NULL, NULL, 19.93179500, 110.87980000, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005112', '2', '抱罗镇', NULL, NULL, 19.84368000, 110.74930500, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005113', '2', '冯坡镇', NULL, NULL, 19.96465100, 110.78395300, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005114', '2', '锦山镇', NULL, NULL, 19.99564100, 110.69756800, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005115', '2', '铺前镇', NULL, NULL, 20.02378000, 110.58024600, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005116', '2', '公坡镇', NULL, NULL, 19.78936400, 110.80871700, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469005402', '2', '国营罗豆农场', NULL, NULL, 19.97237900, 110.63980800, '469005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006', '1', '万宁市', '万宁', 'wan,ning', 18.79369700, 110.39260500, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006100', '2', '万城镇', NULL, NULL, 18.82405600, 110.40139100, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006101', '2', '龙滚镇', NULL, NULL, 19.05875000, 110.51910000, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006102', '2', '和乐镇', NULL, NULL, 18.90362600, 110.47761700, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006103', '2', '后安镇', NULL, NULL, 18.86868700, 110.44323100, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006104', '2', '大茂镇', NULL, NULL, 18.84900100, 110.39647000, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006105', '2', '东澳镇', NULL, NULL, 18.71559500, 110.40199100, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006106', '2', '礼纪镇', NULL, NULL, 18.75043000, 110.31765500, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006107', '2', '长丰镇', NULL, NULL, 18.80014600, 110.32757700, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006108', '2', '山根镇', NULL, NULL, 18.96782100, 110.48662700, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006109', '2', '北大镇', NULL, NULL, 18.92013800, 110.33587300, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006110', '2', '南桥镇', NULL, NULL, 18.68011600, 110.15269700, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469006111', '2', '三更罗镇', NULL, NULL, 18.86121900, 110.18672200, '469006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007', '1', '东方市', '东方', 'dong,fang', 19.09518700, 108.65182900, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007100', '2', '八所镇', NULL, NULL, 19.09197200, 108.67062100, '469007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007101', '2', '东河镇', NULL, NULL, 19.04806400, 108.93806600, '469007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007102', '2', '大田镇', NULL, NULL, 19.16475300, 108.87549000, '469007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007103', '2', '感城镇', NULL, NULL, 18.84639100, 108.65772600, '469007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007104', '2', '板桥镇', NULL, NULL, 18.79484100, 108.68915300, '469007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007105', '2', '三家镇', NULL, NULL, 19.24124700, 108.75845200, '469007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007106', '2', '四更镇', NULL, NULL, 19.22561600, 108.68211700, '469007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007107', '2', '新龙镇', NULL, NULL, 18.95202300, 108.68453800, '469007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007200', '2', '天安乡', NULL, NULL, 19.01773000, 108.91248600, '469007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469007201', '2', '江边乡', NULL, NULL, 18.89442800, 108.97683700, '469007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021', '1', '定安县', '定安', 'ding,an', 19.68121500, 110.35800100, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021100', '2', '定城镇', NULL, NULL, 19.68033400, 110.36841400, '469021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021101', '2', '新竹镇', NULL, NULL, 19.61819200, 110.20849800, '469021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021102', '2', '龙湖镇', NULL, NULL, 19.57341600, 110.40064200, '469021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021103', '2', '黄竹镇', NULL, NULL, 19.47265700, 110.44656900, '469021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021104', '2', '雷鸣镇', NULL, NULL, 19.55358300, 110.32652600, '469021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021105', '2', '龙门镇', NULL, NULL, 19.43900100, 110.32715200, '469021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021106', '2', '龙河镇', NULL, NULL, 19.38220300, 110.21891000, '469021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021107', '2', '岭口镇', NULL, NULL, 19.34264800, 110.30824300, '469021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021108', '2', '翰林镇', NULL, NULL, 19.33375800, 110.26473000, '469021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469021109', '2', '富文镇', NULL, NULL, 19.55162000, 110.26286300, '469021');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469022', '1', '屯昌县', '屯昌', 'tun,chang', 19.35166200, 110.10166700, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469022100', '2', '屯城镇', NULL, NULL, 19.37157700, 110.10506200, '469022');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469022101', '2', '新兴镇', NULL, NULL, 19.50649200, 110.18286800, '469022');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469022102', '2', '枫木镇', NULL, NULL, 19.21417300, 110.01947500, '469022');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469022103', '2', '乌坡镇', NULL, NULL, 19.18056400, 110.07588200, '469022');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469022104', '2', '南吕镇', NULL, NULL, 19.25070000, 110.08253000, '469022');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469022105', '2', '南坤镇', NULL, NULL, 19.31855500, 109.94870200, '469022');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469022106', '2', '坡心镇', NULL, NULL, 19.30703300, 110.08994200, '469022');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469022107', '2', '西昌镇', NULL, NULL, 19.43388900, 110.04541500, '469022');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023', '1', '澄迈县', '澄迈', 'cheng,mai', 19.73888500, 110.00749700, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023100', '2', '金江镇', NULL, NULL, 19.73893100, 110.01702500, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023101', '2', '老城镇', NULL, NULL, 19.95305400, 110.12662200, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023102', '2', '瑞溪镇', NULL, NULL, 19.73180400, 110.12913900, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023103', '2', '永发镇', NULL, NULL, 19.74722600, 110.19515600, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023104', '2', '加乐镇', NULL, NULL, 19.58493700, 110.00056400, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023105', '2', '文儒镇', NULL, NULL, 19.53752800, 110.05344800, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023106', '2', '中兴镇', NULL, NULL, 19.56724600, 109.85898700, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023107', '2', '仁兴镇', NULL, NULL, 19.49248900, 109.88195100, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023108', '2', '福山镇', NULL, NULL, 19.83006900, 109.92970700, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023109', '2', '桥头镇', NULL, NULL, 19.95376000, 109.93297900, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469023110', '2', '大丰镇', NULL, NULL, 19.85466700, 110.03796300, '469023');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024', '1', '临高县', '临高', 'lin,gao', 19.91332600, 109.69088400, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024100', '2', '临城镇', NULL, NULL, 19.89649000, 109.69654200, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024101', '2', '波莲镇', NULL, NULL, 19.86773300, 109.64853400, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024102', '2', '东英镇', NULL, NULL, 19.95901400, 109.64871800, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024103', '2', '博厚镇', NULL, NULL, 19.88520700, 109.74567800, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024104', '2', '皇桐镇', NULL, NULL, 19.83288000, 109.84957500, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024105', '2', '多文镇', NULL, NULL, 19.77442100, 109.77070500, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024106', '2', '和舍镇', NULL, NULL, 19.59609600, 109.72756300, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024107', '2', '南宝镇', NULL, NULL, 19.68120900, 109.59917900, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024108', '2', '新盈镇', NULL, NULL, 19.89513000, 109.53634900, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024109', '2', '调楼镇', NULL, NULL, 19.92919100, 109.54653500, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469024401', '2', '国营加来农场', NULL, NULL, 19.70698700, 109.69966000, '469024');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025', '1', '白沙黎族自治县', '白沙', 'bai,sha', 19.22164100, 109.44290000, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025100', '2', '牙叉镇', NULL, NULL, 19.21278500, 109.44542400, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025101', '2', '七坊镇', NULL, NULL, 19.29558000, 109.24007000, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025102', '2', '邦溪镇', NULL, NULL, 19.36941000, 109.10305100, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025103', '2', '打安镇', NULL, NULL, 19.28388700, 109.37366800, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025200', '2', '细水乡', NULL, NULL, 19.20974900, 109.56446600, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025201', '2', '元门乡', NULL, NULL, 19.15766600, 109.48611000, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025202', '2', '南开乡', NULL, NULL, 19.07781000, 109.41468000, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025203', '2', '阜龙乡', NULL, NULL, 19.32259000, 109.46078200, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025204', '2', '青松乡', NULL, NULL, 19.15518900, 109.27093900, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025205', '2', '金波乡', NULL, NULL, 19.23835700, 109.17373300, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469025206', '2', '荣邦乡', NULL, NULL, 19.41395000, 109.17072700, '469025');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469026', '1', '昌江黎族自治县', '昌江', 'chang,jiang', 19.29813900, 109.05578300, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469026100', '2', '石碌镇', NULL, NULL, 19.27760400, 109.05586000, '469026');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469026101', '2', '叉河镇', NULL, NULL, 19.23893400, 108.95734400, '469026');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469026102', '2', '十月田镇', NULL, NULL, 19.32878100, 108.95220400, '469026');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469026103', '2', '乌烈镇', NULL, NULL, 19.28904400, 108.79219100, '469026');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469026104', '2', '昌化镇', NULL, NULL, 19.32965000, 108.68528700, '469026');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469026105', '2', '海尾镇', NULL, NULL, 19.42222700, 108.81853900, '469026');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469026106', '2', '七叉镇', NULL, NULL, 19.11495200, 109.05095000, '469026');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469026200', '2', '王下乡', NULL, NULL, 19.00705200, 109.14692700, '469026');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027', '1', '乐东黎族自治县', '乐东', 'le,dong', 18.75006300, 109.17338400, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027100', '2', '抱由镇', NULL, NULL, 18.74496500, 109.17987200, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027101', '2', '万冲镇', NULL, NULL, 18.84301900, 109.32323800, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027102', '2', '大安镇', NULL, NULL, 18.69132900, 109.21475600, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027103', '2', '志仲镇', NULL, NULL, 18.62924100, 109.26511700, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027104', '2', '千家镇', NULL, NULL, 18.56570300, 109.08525100, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027105', '2', '九所镇', NULL, NULL, 18.45363600, 108.95394200, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027106', '2', '利国镇', NULL, NULL, 18.47207500, 108.89728100, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027107', '2', '黄流镇', NULL, NULL, 18.50668400, 108.79487200, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027108', '2', '佛罗镇', NULL, NULL, 18.57878400, 108.73678300, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027109', '2', '尖峰镇', NULL, NULL, 18.69051900, 108.79240600, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469027110', '2', '莺歌海镇', NULL, NULL, 18.51051600, 108.69766900, '469027');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028', '1', '陵水黎族自治县', '陵水', 'ling,shui', 18.50673100, 110.03749600, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028100', '2', '椰林镇', NULL, NULL, 18.50067000, 110.05291200, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028101', '2', '光坡镇', NULL, NULL, 18.54328500, 110.04881900, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028102', '2', '三才镇', NULL, NULL, 18.47457800, 110.00329900, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028103', '2', '英州镇', NULL, NULL, 18.42712700, 109.85888800, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028104', '2', '隆广镇', NULL, NULL, 18.50198000, 109.89942000, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028105', '2', '文罗镇', NULL, NULL, 18.51546800, 109.95690300, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028106', '2', '本号镇', NULL, NULL, 18.60874700, 109.96246000, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028107', '2', '新村镇', NULL, NULL, 18.41246400, 109.97137200, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028108', '2', '黎安镇', NULL, NULL, 18.43715400, 110.06914500, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028200', '2', '提蒙乡', NULL, NULL, 18.56490500, 110.01302300, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469028201', '2', '群英乡', NULL, NULL, 18.58315400, 109.87851900, '469028');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469029', '1', '保亭黎族苗族自治县', '保亭', 'bao,ting', 18.64033900, 109.70027900, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469029100', '2', '保城镇', NULL, NULL, 18.64159000, 109.70346600, '469029');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469029101', '2', '什玲镇', NULL, NULL, 18.66392100, 109.78174000, '469029');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469029102', '2', '加茂镇', NULL, NULL, 18.55461100, 109.70504400, '469029');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469029103', '2', '响水镇', NULL, NULL, 18.59207900, 109.61629000, '469029');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469029104', '2', '新政镇', NULL, NULL, 18.54164500, 109.62891400, '469029');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469029105', '2', '三道镇', NULL, NULL, 18.46457600, 109.66867200, '469029');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469029200', '2', '六弓乡', NULL, NULL, 18.53983300, 109.78505800, '469029');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469029201', '2', '南林乡', NULL, NULL, 18.40529000, 109.61681000, '469029');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469029202', '2', '毛感乡', NULL, NULL, 18.61299500, 109.50906100, '469029');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030', '1', '琼中黎族苗族自治县', '琼中', 'qiong,zhong', 19.03327000, 109.83842300, '460000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030100', '2', '营根镇', NULL, NULL, 19.03613400, 109.83175800, '469030');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030101', '2', '湾岭镇', NULL, NULL, 19.14110600, 109.90041400, '469030');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030102', '2', '黎母山镇', NULL, NULL, 19.26768300, 109.78685000, '469030');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030103', '2', '和平镇', NULL, NULL, 18.90050900, 110.02331300, '469030');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030104', '2', '长征镇', NULL, NULL, 18.95862800, 109.87803400, '469030');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030105', '2', '红毛镇', NULL, NULL, 19.03075800, 109.68977100, '469030');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030106', '2', '中平镇', NULL, NULL, 19.06086300, 110.06027100, '469030');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030200', '2', '吊罗山乡', NULL, NULL, 18.79223100, 109.87838000, '469030');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030201', '2', '上安乡', NULL, NULL, 18.87730900, 109.83808500, '469030');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('469030202', '2', '什运乡', NULL, NULL, 18.99210300, 109.60797900, '469030');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500000', '0', '重庆市', '重庆', 'chong,qing', 29.56370700, 106.55048300, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101', '1', '万州区', '万州', 'wan,zhou', 30.80769400, 108.40877000, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101001', '2', '高笋塘街道', NULL, NULL, 30.80076200, 108.37990500, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101002', '2', '太白街道', NULL, NULL, 30.81747800, 108.35664000, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101003', '2', '牌楼街道', NULL, NULL, 30.78339000, 108.39208500, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101004', '2', '双河口街道', NULL, NULL, 30.75608900, 108.37265500, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101005', '2', '龙都街道', NULL, NULL, 30.76313600, 108.41162800, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101006', '2', '周家坝街道', NULL, NULL, 30.84520900, 108.37237000, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101007', '2', '沙河街道', NULL, NULL, 30.84876400, 108.36532000, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101008', '2', '钟鼓楼街道', NULL, NULL, 30.82349200, 108.38859500, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101009', '2', '百安坝街道', NULL, NULL, 30.75972600, 108.44985800, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101010', '2', '五桥街道', NULL, NULL, 30.76846800, 108.45934100, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101011', '2', '陈家坝街道', NULL, NULL, 30.81138500, 108.41308600, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101012', '2', '高峰街道', NULL, NULL, 30.70990100, 108.34658900, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101013', '2', '天城街道', NULL, NULL, 30.86852300, 108.37325900, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101014', '2', '九池街道', NULL, NULL, 30.78865300, 108.37766700, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101102', '2', '龙沙镇', NULL, NULL, 30.63423400, 108.23759800, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101103', '2', '响水镇', NULL, NULL, 30.65347900, 108.19773000, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101104', '2', '武陵镇', NULL, NULL, 30.50055300, 108.25480100, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101105', '2', '瀼渡镇', NULL, NULL, 30.58959600, 108.31027200, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101106', '2', '甘宁镇', NULL, NULL, 30.66897600, 108.28246400, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101108', '2', '熊家镇', NULL, NULL, 30.90524100, 108.43360800, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101109', '2', '小周镇', NULL, NULL, 30.91976300, 108.52789400, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101110', '2', '大周镇', NULL, NULL, 30.88485000, 108.50244000, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101111', '2', '高梁镇', NULL, NULL, 30.82442900, 108.30546900, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101112', '2', '李河镇', NULL, NULL, 30.81567100, 108.26614700, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101113', '2', '分水镇', NULL, NULL, 30.71761700, 108.08700200, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101114', '2', '孙家镇', NULL, NULL, 30.72677100, 108.01995700, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101115', '2', '余家镇', NULL, NULL, 30.80094100, 107.96249200, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101116', '2', '后山镇', NULL, NULL, 30.82487000, 108.03628000, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101117', '2', '弹子镇', NULL, NULL, 30.85505000, 108.01054400, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101118', '2', '长岭镇', NULL, NULL, 30.76771700, 108.48990600, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101119', '2', '新田镇', NULL, NULL, 30.69660600, 108.40698500, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101120', '2', '新乡镇', NULL, NULL, 30.49775400, 108.27721300, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101121', '2', '走马镇', NULL, NULL, 30.56677100, 108.44425700, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101122', '2', '罗田镇', NULL, NULL, 30.51607400, 108.56941300, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101123', '2', '龙驹镇', NULL, NULL, 30.60866300, 108.64006700, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101124', '2', '白土镇', NULL, NULL, 30.59381600, 108.81476300, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101125', '2', '长滩镇', NULL, NULL, 30.73781200, 108.60929500, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101126', '2', '太安镇', NULL, NULL, 30.80091900, 108.65505100, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101127', '2', '白羊镇', NULL, NULL, 30.81339900, 108.61680700, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101128', '2', '太龙镇', NULL, NULL, 30.90215800, 108.53556600, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101129', '2', '郭村镇', NULL, NULL, 30.56397800, 108.17319600, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101201', '2', '柱山乡', NULL, NULL, 30.73013000, 108.27788500, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101203', '2', '铁峰乡', NULL, NULL, 30.96888700, 108.40356200, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101204', '2', '茨竹乡', NULL, NULL, 30.65761100, 108.51047900, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101205', '2', '溪口乡', NULL, NULL, 30.60744000, 108.34383400, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101206', '2', '长坪乡', NULL, NULL, 30.44239100, 108.25402000, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101207', '2', '燕山乡', NULL, NULL, 30.55174500, 108.31180800, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101208', '2', '梨树乡', NULL, NULL, 30.66205900, 108.75163000, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101209', '2', '恒合土家族乡', NULL, NULL, 30.52968500, 108.75962200, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101210', '2', '普子乡', NULL, NULL, 30.56909600, 108.82138000, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101211', '2', '地宝土家族乡', NULL, NULL, 30.65561000, 108.89967100, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500101212', '2', '黄柏乡', NULL, NULL, 30.91589800, 108.59762000, '500101');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102', '1', '涪陵区', '涪陵', 'fu,ling', 29.75229900, 107.24656400, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102001', '2', '敦仁街道', NULL, NULL, 29.70349400, 107.40261900, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102002', '2', '崇义街道', NULL, NULL, 29.71163200, 107.37584900, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102003', '2', '荔枝街道', NULL, NULL, 29.70312400, 107.38709700, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102004', '2', '江北街道', NULL, NULL, 29.73456900, 107.38496100, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102005', '2', '江东街道', NULL, NULL, 29.69632500, 107.42283200, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102006', '2', '李渡街道', NULL, NULL, 29.78951300, 107.27697800, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102007', '2', '龙桥街道', NULL, NULL, 29.70951600, 107.29900400, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102008', '2', '白涛街道', NULL, NULL, 29.54739100, 107.48386500, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102100', '2', '百胜镇', NULL, NULL, 29.81045700, 107.39850500, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102101', '2', '珍溪镇', NULL, NULL, 29.90001100, 107.47318300, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102102', '2', '清溪镇', NULL, NULL, 29.79863000, 107.47444700, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102103', '2', '南沱镇', NULL, NULL, 29.85057200, 107.53063000, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102104', '2', '焦石镇', NULL, NULL, 29.71689400, 107.60337700, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102106', '2', '马武镇', NULL, NULL, 29.59246000, 107.32086000, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102107', '2', '青羊镇', NULL, NULL, 29.52737900, 107.21229900, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102108', '2', '龙潭镇', NULL, NULL, 29.44447500, 107.10569000, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102111', '2', '蔺市镇', NULL, NULL, 29.66098400, 107.19940500, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102112', '2', '新妙镇', NULL, NULL, 29.65527400, 107.05290000, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102113', '2', '石沱镇', NULL, NULL, 29.70545400, 107.14510900, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102115', '2', '义和镇', NULL, NULL, 29.72763800, 107.22310400, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102204', '2', '罗云乡', NULL, NULL, 29.77637600, 107.60198100, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102206', '2', '大木乡', NULL, NULL, 29.61777800, 107.66733100, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102208', '2', '武陵山乡', NULL, NULL, 29.52841300, 107.56396000, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102213', '2', '同乐乡', NULL, NULL, 29.46141500, 107.19830500, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102216', '2', '大顺乡', NULL, NULL, 29.50063000, 107.06332000, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500102217', '2', '增福乡', NULL, NULL, 29.51014200, 106.99107900, '500102');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103', '1', '渝中区', '渝中', 'yu,zhong', 29.55263100, 106.56891400, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103001', '2', '七星岗街道', NULL, NULL, 29.55614900, 106.56358300, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103003', '2', '解放碑街道', NULL, NULL, 29.55725600, 106.57498500, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103004', '2', '两路口街道', NULL, NULL, 29.55214200, 106.54941000, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103005', '2', '上清寺街道', NULL, NULL, 29.55985600, 106.54800300, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103007', '2', '菜园坝街道', NULL, NULL, 29.53736700, 106.53044700, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103008', '2', '南纪门街道', NULL, NULL, 29.55195800, 106.56987000, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103009', '2', '望龙门街道', NULL, NULL, 29.55452000, 106.58344000, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103010', '2', '朝天门街道', NULL, NULL, 29.56405200, 106.58503100, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103011', '2', '大溪沟街道', NULL, NULL, 29.56223100, 106.56060900, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103012', '2', '大坪街道', NULL, NULL, 29.53869600, 106.51614400, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103013', '2', '化龙桥街道', NULL, NULL, 29.55110200, 106.50873800, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500103014', '2', '石油路街道', NULL, NULL, 29.53531100, 106.51015600, '500103');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500104', '1', '大渡口区', '大渡口', 'da,du,kou', 29.48446400, 106.48229900, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500104001', '2', '新山村街道', NULL, NULL, 29.48240600, 106.48615700, '500104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500104002', '2', '跃进村街道', NULL, NULL, 29.48762300, 106.49333300, '500104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500104003', '2', '九宫庙街道', NULL, NULL, 29.47653100, 106.48402900, '500104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500104004', '2', '茄子溪街道', NULL, NULL, 29.43137200, 106.49663400, '500104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500104005', '2', '春晖路街道', NULL, NULL, 29.45540300, 106.47257300, '500104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500104101', '2', '八桥镇', NULL, NULL, 29.47551500, 106.48266000, '500104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500104102', '2', '建胜镇', NULL, NULL, 29.42835700, 106.49693900, '500104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500104103', '2', '跳磴镇', NULL, NULL, 29.40235000, 106.43223300, '500104');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105', '1', '江北区', '江北', 'jiang,bei', 29.60622400, 106.57439500, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105004', '2', '华新街街道', NULL, NULL, 29.56436500, 106.52893400, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105005', '2', '寸滩街道', NULL, NULL, 29.60537000, 106.57272100, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105006', '2', '观音桥街道', NULL, NULL, 29.58186900, 106.54528600, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105007', '2', '五里店街道', NULL, NULL, 29.57892600, 106.55908300, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105008', '2', '郭家沱街道', NULL, NULL, 29.57423000, 106.68133000, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105009', '2', '铁山坪街道', NULL, NULL, 29.60777700, 106.66095900, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105010', '2', '江北城街道', NULL, NULL, 29.57750500, 106.57248300, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105011', '2', '石马河街道', NULL, NULL, 29.59537400, 106.48356300, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105012', '2', '大石坝街道', NULL, NULL, 29.55856100, 106.49590600, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105100', '2', '鱼嘴镇', NULL, NULL, 29.62265600, 106.76129000, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105101', '2', '复盛镇', NULL, NULL, 29.64676200, 106.79470700, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500105102', '2', '五宝镇', NULL, NULL, 29.62837400, 106.85609100, '500105');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106', '1', '沙坪坝区', '沙坪坝', 'sha,ping,ba', 29.54101700, 106.45693900, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106001', '2', '小龙坎街道', NULL, NULL, 29.55427200, 106.46792400, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106002', '2', '沙坪坝街道', NULL, NULL, 29.56563800, 106.46222800, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106003', '2', '渝碚路街道', NULL, NULL, 29.55801100, 106.45915900, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106004', '2', '磁器口街道', NULL, NULL, 29.57478000, 106.45631100, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106005', '2', '童家桥街道', NULL, NULL, 29.57257500, 106.44443600, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106006', '2', '石井坡街道', NULL, NULL, 29.59564100, 106.44516800, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106007', '2', '双碑街道', NULL, NULL, 29.60325800, 106.44739100, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106008', '2', '井口街道', NULL, NULL, 29.63725200, 106.44303500, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106009', '2', '歌乐山街道', NULL, NULL, 29.57465700, 106.41960200, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106010', '2', '山洞街道', NULL, NULL, 29.51284100, 106.42314500, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106011', '2', '新桥街道', NULL, NULL, 29.51761600, 106.44201400, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106012', '2', '天星桥街道', NULL, NULL, 29.54811700, 106.45795000, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106013', '2', '土湾街道', NULL, NULL, 29.55426800, 106.47241200, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106014', '2', '覃家岗街道', NULL, NULL, 29.54328100, 106.45543000, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106015', '2', '陈家桥街道', NULL, NULL, 29.61509600, 106.33698700, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106016', '2', '虎溪街道', NULL, NULL, 29.59913900, 106.33492600, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106017', '2', '西永街道', NULL, NULL, 29.59719000, 106.37724000, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106018', '2', '联芳街道', NULL, NULL, 29.54578900, 106.47377000, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106021', '2', '土主街道', NULL, NULL, 29.63149600, 106.37203100, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106102', '2', '井口镇', NULL, NULL, 29.63681300, 106.44307600, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106103', '2', '歌乐山镇', NULL, NULL, 29.55851500, 106.41536400, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106104', '2', '青木关镇', NULL, NULL, 29.67498100, 106.31161700, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106105', '2', '凤凰镇', NULL, NULL, 29.68544400, 106.31566200, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106106', '2', '回龙坝镇', NULL, NULL, 29.70479600, 106.38293500, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106108', '2', '曾家镇', NULL, NULL, 29.55182900, 106.30143300, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500106112', '2', '中梁镇', NULL, NULL, 29.64037500, 106.41318500, '500106');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107', '1', '九龙坡区', '九龙坡', 'jiu,long,po', 29.50232500, 106.51051500, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107001', '2', '杨家坪街道', NULL, NULL, 29.50675400, 106.52227200, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107002', '2', '黄桷坪街道', NULL, NULL, 29.48810800, 106.54381100, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107003', '2', '谢家湾街道', NULL, NULL, 29.51847200, 106.52079400, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107004', '2', '石坪桥街道', NULL, NULL, 29.51128100, 106.50021600, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107006', '2', '中梁山街道', NULL, NULL, 29.46071100, 106.44410000, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107007', '2', '渝州路街道', NULL, NULL, 29.53563400, 106.48897900, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107008', '2', '石桥铺街道', NULL, NULL, 29.51796500, 106.47052600, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107010', '2', '九龙街道', NULL, NULL, 29.50697300, 106.49283000, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107102', '2', '华岩镇', NULL, NULL, 29.42829600, 106.43758500, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107103', '2', '含谷镇', NULL, NULL, 29.51729400, 106.37754100, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107104', '2', '金凤镇', NULL, NULL, 29.51810800, 106.31306900, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107105', '2', '白市驿镇', NULL, NULL, 29.47944500, 106.37031600, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107106', '2', '走马镇', NULL, NULL, 29.45751800, 106.28863100, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107107', '2', '石板镇', NULL, NULL, 29.42459900, 106.36180100, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107108', '2', '巴福镇', NULL, NULL, 29.41247900, 106.33130500, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107109', '2', '陶家镇', NULL, NULL, 29.36101900, 106.34675300, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107110', '2', '西彭镇', NULL, NULL, 29.29814800, 106.33374900, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500107111', '2', '铜罐驿镇', NULL, NULL, 29.29568300, 106.38609300, '500107');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108', '1', '南岸区', '南岸', 'nan,an', 29.50109000, 106.64425400, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108001', '2', '铜元局街道', NULL, NULL, 29.52921600, 106.54526800, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108002', '2', '花园路街道', NULL, NULL, 29.50762600, 106.55353400, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108003', '2', '南坪街道', NULL, NULL, 29.53061600, 106.56976000, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108004', '2', '海棠溪街道', NULL, NULL, 29.54329100, 106.58814600, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108005', '2', '龙门浩街道', NULL, NULL, 29.55259200, 106.59435300, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108006', '2', '弹子石街道', NULL, NULL, 29.58219000, 106.59018800, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108007', '2', '南山街道', NULL, NULL, 29.54457200, 106.60792000, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108008', '2', '天文街道', NULL, NULL, 29.51585000, 106.65394100, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108101', '2', '南坪镇', NULL, NULL, 29.52590200, 106.57153900, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108102', '2', '涂山镇', NULL, NULL, 29.57466400, 106.60112500, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108103', '2', '鸡冠石镇', NULL, NULL, 29.59448300, 106.61299600, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108105', '2', '峡口镇', NULL, NULL, 29.56229500, 106.66898300, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108106', '2', '长生桥镇', NULL, NULL, 29.50451800, 106.66899800, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108107', '2', '迎龙镇', NULL, NULL, 29.52054000, 106.71123300, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500108108', '2', '广阳镇', NULL, NULL, 29.59555800, 106.77769200, '500108');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109', '1', '北碚区', '北碚', 'bei,bei', 29.80519700, 106.39559300, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109001', '2', '天生街道', NULL, NULL, 29.82640300, 106.43926800, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109002', '2', '朝阳街道', NULL, NULL, 29.83134700, 106.43447200, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109003', '2', '龙凤桥街道', NULL, NULL, 29.81475000, 106.43571400, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109004', '2', '北温泉街道', NULL, NULL, 29.83197400, 106.42187800, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109005', '2', '东阳街道', NULL, NULL, 29.83281700, 106.45080000, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109006', '2', '蔡家岗街道', NULL, NULL, 29.72745500, 106.49764800, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109007', '2', '歇马街道', NULL, NULL, 29.76301700, 106.36751900, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109008', '2', '水土街道', NULL, NULL, 29.78298500, 106.50181200, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109009', '2', '复兴街道', NULL, NULL, 29.81330600, 106.56158300, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109102', '2', '澄江镇', NULL, NULL, 29.87078200, 106.38812100, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109104', '2', '童家溪镇', NULL, NULL, 29.68301300, 106.44844900, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109105', '2', '天府镇', NULL, NULL, 29.87368200, 106.50134300, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109106', '2', '施家梁镇', NULL, NULL, 29.78496600, 106.47724300, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109108', '2', '静观镇', NULL, NULL, 29.89555700, 106.57017800, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109109', '2', '柳荫镇', NULL, NULL, 29.95612500, 106.60654800, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109111', '2', '三圣镇', NULL, NULL, 29.89304700, 106.62600000, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500109112', '2', '金刀峡镇', NULL, NULL, 29.99957700, 106.65655000, '500109');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110', '1', '綦江区', '綦江', 'qi,jiang', 29.02811700, 106.65121300, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110001', '2', '万盛街道', NULL, NULL, 28.95936700, 106.93022400, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110002', '2', '东林街道', NULL, NULL, 28.94264400, 106.93689800, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110003', '2', '古南街道', NULL, NULL, 29.01415300, 106.65963400, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110004', '2', '文龙街道', NULL, NULL, 29.03083400, 106.65851300, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110005', '2', '三江街道', NULL, NULL, 28.94315400, 106.70639800, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110006', '2', '新盛街道', NULL, NULL, 29.10226700, 106.63724300, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110100', '2', '万东镇', NULL, NULL, 28.95495300, 106.92634300, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110101', '2', '南桐镇', NULL, NULL, 28.94303300, 106.88204000, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110102', '2', '青年镇', NULL, NULL, 28.86204800, 106.84296300, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110103', '2', '关坝镇', NULL, NULL, 28.81635300, 106.81634800, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110104', '2', '丛林镇', NULL, NULL, 29.03099900, 106.96560900, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110105', '2', '石林镇', NULL, NULL, 28.86959900, 106.90838900, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110106', '2', '金桥镇', NULL, NULL, 29.07054500, 106.88016800, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110107', '2', '黑山镇', NULL, NULL, 28.91643500, 107.00138600, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110108', '2', '石角镇', NULL, NULL, 28.92339600, 106.76708900, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110109', '2', '东溪镇', NULL, NULL, 28.76445400, 106.65909900, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110110', '2', '赶水镇', NULL, NULL, 28.73980900, 106.72047700, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110111', '2', '打通镇', NULL, NULL, 28.60774800, 106.67709400, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110112', '2', '石壕镇', NULL, NULL, 28.53828000, 106.68460000, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110113', '2', '永新镇', NULL, NULL, 28.99604200, 106.50504500, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110114', '2', '三角镇', NULL, NULL, 29.04643100, 106.74131300, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110115', '2', '隆盛镇', NULL, NULL, 29.07849700, 106.81983400, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110116', '2', '郭扶镇', NULL, NULL, 28.84895800, 106.60253800, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110117', '2', '篆塘镇', NULL, NULL, 28.89240400, 106.66886700, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110118', '2', '丁山镇', NULL, NULL, 28.70963300, 106.58870000, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110119', '2', '安稳镇', NULL, NULL, 28.65432700, 106.75422000, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110120', '2', '扶欢镇', NULL, NULL, 28.83033400, 106.75940000, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110121', '2', '永城镇', NULL, NULL, 29.02258300, 106.82370800, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110123', '2', '中峰镇', NULL, NULL, 28.89624200, 106.44501500, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500110124', '2', '横山镇', NULL, NULL, 29.10548000, 106.69359000, '500110');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111', '1', '大足区', '大足', 'da,zu', 29.70755500, 105.72182500, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111001', '2', '龙滩子街道', NULL, NULL, 29.49282300, 105.79004500, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111002', '2', '龙岗街道', NULL, NULL, 29.70161200, 105.71147000, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111003', '2', '棠香街道', NULL, NULL, 29.70595700, 105.72863400, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111004', '2', '双路街道', NULL, NULL, 29.49114700, 105.76520600, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111005', '2', '通桥街道', NULL, NULL, 29.51055600, 105.79720400, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111006', '2', '智凤街道', NULL, NULL, 29.65082100, 105.78567300, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111102', '2', '龙水镇', NULL, NULL, 29.56173800, 105.77296200, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111104', '2', '宝顶镇', NULL, NULL, 29.74826200, 105.76494000, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111105', '2', '中敖镇', NULL, NULL, 29.76251900, 105.66981600, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111106', '2', '三驱镇', NULL, NULL, 29.63424300, 105.62423700, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111107', '2', '宝兴镇', NULL, NULL, 29.61883100, 105.69702300, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111108', '2', '玉龙镇', NULL, NULL, 29.54382100, 105.81934700, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111109', '2', '石马镇', NULL, NULL, 29.62831000, 105.83469200, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111110', '2', '拾万镇', NULL, NULL, 29.61228500, 105.89610600, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111111', '2', '回龙镇', NULL, NULL, 29.72749600, 105.86558800, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111112', '2', '金山镇', NULL, NULL, 29.66342700, 105.88554500, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111113', '2', '万古镇', NULL, NULL, 29.67871400, 105.93997300, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111114', '2', '国梁镇', NULL, NULL, 29.76316200, 105.92595400, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111115', '2', '雍溪镇', NULL, NULL, 29.73650600, 105.99334200, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111116', '2', '珠溪镇', NULL, NULL, 29.53508400, 105.66786700, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111117', '2', '龙石镇', NULL, NULL, 29.55926300, 105.62049800, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111118', '2', '邮亭镇', NULL, NULL, 29.42710100, 105.74107800, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111119', '2', '铁山镇', NULL, NULL, 29.68619500, 105.56708900, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111120', '2', '高升镇', NULL, NULL, 29.71605500, 105.58283300, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111121', '2', '季家镇', NULL, NULL, 29.62788800, 105.53624000, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111122', '2', '古龙镇', NULL, NULL, 29.70136300, 106.00789200, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500111123', '2', '高坪镇', NULL, NULL, 29.83506200, 105.66959100, '500111');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112', '1', '渝北区', '渝北', 'yu,bei', 29.71812000, 106.63112400, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112001', '2', '双凤桥街道', NULL, NULL, 29.73437000, 106.63199000, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112002', '2', '双龙湖街道', NULL, NULL, 29.71206200, 106.62644200, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112003', '2', '龙溪街道', NULL, NULL, 29.59052600, 106.51712600, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112004', '2', '回兴街道', NULL, NULL, 29.67088900, 106.61448100, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112005', '2', '龙山街道', NULL, NULL, 29.59048700, 106.49229000, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112006', '2', '龙塔街道', NULL, NULL, 29.60442900, 106.53190200, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112007', '2', '悦来街道', NULL, NULL, 29.72997800, 106.54439700, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112008', '2', '两路街道', NULL, NULL, 29.71977500, 106.65938200, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112009', '2', '王家街道', NULL, NULL, 29.76895100, 106.69816400, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112010', '2', '宝圣湖街道', NULL, NULL, 29.64988600, 106.59029100, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112011', '2', '仙桃街道', NULL, NULL, 29.71161300, 106.60656100, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112012', '2', '大竹林街道', NULL, NULL, 29.62333400, 106.47686700, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112013', '2', '天宫殿街道', NULL, NULL, 29.60384400, 106.55675300, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112014', '2', '鸳鸯街道', NULL, NULL, 29.66603000, 106.55962000, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112015', '2', '翠云街道', NULL, NULL, 29.68258600, 106.58268400, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112016', '2', '礼嘉街道', NULL, NULL, 29.67817600, 106.49644900, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112017', '2', '金山街道', NULL, NULL, 29.63237300, 106.57391100, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112018', '2', '康美街道', NULL, NULL, 29.63167100, 106.48523900, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112019', '2', '人和街道', NULL, NULL, 29.62713400, 106.53721100, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112111', '2', '木耳镇', NULL, NULL, 29.80181500, 106.64593100, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112113', '2', '兴隆镇', NULL, NULL, 29.88723600, 106.70786700, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112115', '2', '茨竹镇', NULL, NULL, 29.98299200, 106.74239400, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112117', '2', '大湾镇', NULL, NULL, 30.01687000, 106.82443900, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112119', '2', '龙兴镇', NULL, NULL, 29.69625900, 106.79538600, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112120', '2', '石船镇', NULL, NULL, 29.76371500, 106.82761800, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112121', '2', '统景镇', NULL, NULL, 29.84953400, 106.84448600, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112123', '2', '大盛镇', NULL, NULL, 29.88684600, 106.90042100, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112125', '2', '洛碛镇', NULL, NULL, 29.73449700, 106.93442100, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112126', '2', '古路镇', NULL, NULL, 29.85011900, 106.76672300, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500112130', '2', '玉峰山镇', NULL, NULL, 29.65540800, 106.66566400, '500112');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113', '1', '巴南区', '巴南', 'ba,nan', 29.40214500, 106.54051700, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113001', '2', '鱼洞街道', NULL, NULL, 29.33528400, 106.50227600, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113002', '2', '李家沱街道', NULL, NULL, 29.45971700, 106.55665900, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113003', '2', '龙洲湾街道', NULL, NULL, 29.40138100, 106.54292900, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113004', '2', '花溪街道', NULL, NULL, 29.43937700, 106.54792200, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113005', '2', '南泉街道', NULL, NULL, 29.44686500, 106.61250500, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113006', '2', '南彭街道', NULL, NULL, 29.34347900, 106.65472300, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113007', '2', '一品街道', NULL, NULL, 29.28521400, 106.56587400, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113008', '2', '惠民街道', NULL, NULL, 29.45825300, 106.70770200, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113009', '2', '莲花街道', NULL, NULL, 29.36101600, 106.49420800, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113103', '2', '界石镇', NULL, NULL, 29.38233800, 106.61216700, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113107', '2', '安澜镇', NULL, NULL, 29.25105000, 106.58292900, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113108', '2', '圣灯山镇', NULL, NULL, 29.27275000, 106.65056200, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113109', '2', '木洞镇', NULL, NULL, 29.57345900, 106.83843700, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113110', '2', '双河口镇', NULL, NULL, 29.61543500, 106.91913100, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113111', '2', '麻柳嘴镇', NULL, NULL, 29.69462700, 106.94183000, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113112', '2', '丰盛镇', NULL, NULL, 29.52190100, 106.93475200, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113113', '2', '二圣镇', NULL, NULL, 29.46563300, 106.77828600, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113114', '2', '东温泉镇', NULL, NULL, 29.45635500, 106.85769200, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113115', '2', '姜家镇', NULL, NULL, 29.39706200, 106.82286200, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113116', '2', '天星寺镇', NULL, NULL, 29.34848300, 106.76556100, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113117', '2', '接龙镇', NULL, NULL, 29.24361400, 106.79136200, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113118', '2', '石滩镇', NULL, NULL, 29.18594600, 106.88092700, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500113119', '2', '石龙镇', NULL, NULL, 29.28137000, 106.89195000, '500113');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114', '1', '黔江区', '黔江', 'qian,jiang', 29.53381900, 108.77055600, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114001', '2', '城东街道', NULL, NULL, 29.52164900, 108.79204200, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114002', '2', '城南街道', NULL, NULL, 29.46888500, 108.74257400, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114003', '2', '城西街道', NULL, NULL, 29.53127300, 108.77585500, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114004', '2', '正阳街道', NULL, NULL, 29.45745100, 108.79239500, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114005', '2', '舟白街道', NULL, NULL, 29.53398700, 108.83207000, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114006', '2', '冯家街道', NULL, NULL, 29.39172000, 108.79004200, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114102', '2', '小南海镇', NULL, NULL, 29.65891500, 108.76640800, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114104', '2', '邻鄂镇', NULL, NULL, 29.43177600, 108.91710500, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114105', '2', '阿蓬江镇', NULL, NULL, 29.15574300, 108.75236700, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114106', '2', '石会镇', NULL, NULL, 29.56985400, 108.62196400, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114107', '2', '黑溪镇', NULL, NULL, 29.61840000, 108.54522000, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114108', '2', '黄溪镇', NULL, NULL, 29.76596000, 108.60528000, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114109', '2', '黎水镇', NULL, NULL, 29.82507400, 108.64764600, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114110', '2', '金溪镇', NULL, NULL, 29.38883000, 108.69157000, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114111', '2', '马喇镇', NULL, NULL, 29.28102100, 108.85616600, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114112', '2', '濯水镇', NULL, NULL, 29.29789200, 108.77338900, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114113', '2', '石家镇', NULL, NULL, 29.23431600, 108.61970700, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114114', '2', '鹅池镇', NULL, NULL, 29.13622700, 108.59336200, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114115', '2', '中塘镇', NULL, NULL, 29.60756200, 108.82942200, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114116', '2', '沙坝镇', NULL, NULL, 29.49329400, 108.57731800, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114117', '2', '白石镇', NULL, NULL, 29.68446800, 108.56669600, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114201', '2', '蓬东乡', NULL, NULL, 29.38571500, 108.82822700, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114204', '2', '杉岭乡', NULL, NULL, 29.73329900, 108.62405100, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114205', '2', '太极乡', NULL, NULL, 29.32620300, 108.66678000, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114206', '2', '水田乡', NULL, NULL, 29.39839700, 108.74081000, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114207', '2', '白土乡', NULL, NULL, 29.37590800, 108.64660400, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114208', '2', '金洞乡', NULL, NULL, 29.20002000, 108.85161200, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114209', '2', '五里乡', NULL, NULL, 29.35560600, 108.87841000, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114210', '2', '水市乡', NULL, NULL, 29.24057300, 108.70224100, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500114211', '2', '新华乡', NULL, NULL, 29.31959400, 108.60788000, '500114');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115', '1', '长寿区', '长寿', 'chang,shou', 29.85791600, 107.08094500, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115001', '2', '凤城街道', NULL, NULL, 29.82456900, 107.06619600, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115002', '2', '晏家街道', NULL, NULL, 29.82917300, 107.01549900, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115003', '2', '江南街道', NULL, NULL, 29.80720300, 107.06543500, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115004', '2', '渡舟街道', NULL, NULL, 29.87608200, 107.08211000, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115005', '2', '八颗街道', NULL, NULL, 29.89843100, 107.02793500, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115006', '2', '新市街道', NULL, NULL, 29.95323000, 107.10277000, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115101', '2', '邻封镇', NULL, NULL, 29.89118100, 107.21892000, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115102', '2', '但渡镇', NULL, NULL, 29.82817800, 107.14014600, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115103', '2', '云集镇', NULL, NULL, 29.91528000, 107.34705200, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115104', '2', '长寿湖镇', NULL, NULL, 29.90597500, 107.23964100, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115105', '2', '双龙镇', NULL, NULL, 29.95685500, 107.20996800, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115106', '2', '龙河镇', NULL, NULL, 30.00806400, 107.18813200, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115107', '2', '石堰镇', NULL, NULL, 30.08070900, 107.17857700, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115108', '2', '云台镇', NULL, NULL, 30.13452900, 107.21000600, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115109', '2', '海棠镇', NULL, NULL, 30.16951300, 107.23555000, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115110', '2', '葛兰镇', NULL, NULL, 30.03495100, 107.12228800, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115113', '2', '洪湖镇', NULL, NULL, 29.99776200, 106.95644600, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500115114', '2', '万顺镇', NULL, NULL, 30.03339600, 106.97226800, '500115');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116', '1', '江津区', '江津', 'jiang,jin', 29.31998400, 106.26443500, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116001', '2', '几江街道', NULL, NULL, 29.28951600, 106.25966500, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116002', '2', '德感街道', NULL, NULL, 29.27313700, 106.23577900, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116004', '2', '双福街道', NULL, NULL, 29.41306000, 106.27189000, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116005', '2', '鼎山街道', NULL, NULL, 29.27786000, 106.26678100, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116100', '2', '油溪镇', NULL, NULL, 29.20435400, 106.14712600, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116101', '2', '吴滩镇', NULL, NULL, 29.25433700, 106.06880200, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116102', '2', '石门镇', NULL, NULL, 29.10132100, 106.03261400, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116103', '2', '朱杨镇', NULL, NULL, 29.06273400, 105.94066600, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116104', '2', '石蟆镇', NULL, NULL, 28.98348000, 105.93423900, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116105', '2', '永兴镇', NULL, NULL, 28.99155100, 106.17868000, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116106', '2', '塘河镇', NULL, NULL, 28.95667800, 106.05076300, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116107', '2', '白沙镇', NULL, NULL, 29.06026200, 106.11671300, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116108', '2', '龙华镇', NULL, NULL, 29.20735100, 106.21262600, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116109', '2', '李市镇', NULL, NULL, 29.07531900, 106.26702000, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116110', '2', '慈云镇', NULL, NULL, 29.07297800, 106.20936300, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116111', '2', '蔡家镇', NULL, NULL, 28.90274200, 106.34300200, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116112', '2', '中山镇', NULL, NULL, 28.85532300, 106.33667000, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116113', '2', '嘉平镇', NULL, NULL, 28.98528700, 106.35140700, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116114', '2', '柏林镇', NULL, NULL, 28.73382600, 106.46294600, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116115', '2', '先锋镇', NULL, NULL, 29.21123100, 106.30242300, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116116', '2', '珞璜镇', NULL, NULL, 29.34310400, 106.42773400, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116117', '2', '贾嗣镇', NULL, NULL, 29.11471400, 106.45403900, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116118', '2', '夏坝镇', NULL, NULL, 29.10987200, 106.51249100, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116119', '2', '西湖镇', NULL, NULL, 29.09770000, 106.39765100, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116120', '2', '杜市镇', NULL, NULL, 29.14711700, 106.53544100, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116121', '2', '广兴镇', NULL, NULL, 29.05571600, 106.55537600, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116122', '2', '四面山镇', NULL, NULL, 28.65832800, 106.41523100, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500116123', '2', '支坪镇', NULL, NULL, 29.24045200, 106.38988900, '500116');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117', '1', '合川区', '合川', 'he,chuan', 29.97196800, 106.27617000, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117001', '2', '合阳城街道', NULL, NULL, 29.99004600, 106.26512100, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117002', '2', '钓鱼城街道', NULL, NULL, 29.99396100, 106.27038200, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117003', '2', '南津街街道', NULL, NULL, 29.97580500, 106.26825300, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117004', '2', '云门街道', NULL, NULL, 30.08067100, 106.32525900, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117005', '2', '大石街道', NULL, NULL, 30.08893400, 106.22907400, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117006', '2', '盐井街道', NULL, NULL, 29.94243700, 106.35483600, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117007', '2', '草街街道', NULL, NULL, 29.99801700, 106.39066700, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117101', '2', '钱塘镇', NULL, NULL, 30.18225000, 106.31960900, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117102', '2', '沙鱼镇', NULL, NULL, 30.23648500, 106.37074500, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117103', '2', '官渡镇', NULL, NULL, 30.07894100, 106.43325800, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117104', '2', '涞滩镇', NULL, NULL, 30.17343300, 106.48787900, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117105', '2', '龙市镇', NULL, NULL, 30.21063800, 106.46316900, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117106', '2', '肖家镇', NULL, NULL, 30.28622600, 106.47379600, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117108', '2', '古楼镇', NULL, NULL, 30.17424600, 106.17665700, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117109', '2', '三庙镇', NULL, NULL, 30.23273100, 106.13148000, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117110', '2', '燕窝镇', NULL, NULL, 30.32914300, 106.07708100, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117111', '2', '二郎镇', NULL, NULL, 30.36124000, 105.99711900, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117112', '2', '龙凤镇', NULL, NULL, 30.26894900, 106.02686500, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117113', '2', '太和镇', NULL, NULL, 30.10205800, 106.04977000, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117114', '2', '隆兴镇', NULL, NULL, 30.19053300, 106.06212200, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117115', '2', '铜溪镇', NULL, NULL, 29.99789000, 106.14086300, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117116', '2', '渭沱镇', NULL, NULL, 30.04051200, 106.15113400, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117119', '2', '双凤镇', NULL, NULL, 30.01881600, 106.43154100, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117120', '2', '狮滩镇', NULL, NULL, 30.06604400, 106.50651300, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117121', '2', '清平镇', NULL, NULL, 29.97202000, 106.52400700, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117122', '2', '土场镇', NULL, NULL, 29.92286500, 106.49157000, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117123', '2', '小沔镇', NULL, NULL, 30.11975200, 106.53805100, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117124', '2', '双槐镇', NULL, NULL, 30.16627600, 106.56170400, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117125', '2', '三汇镇', NULL, NULL, 30.07847300, 106.59115300, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500117126', '2', '香龙镇', NULL, NULL, 30.25604500, 106.58010800, '500117');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118', '1', '永川区', '永川', 'yong,chuan', 29.35638400, 105.92695100, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118001', '2', '中山路街道', NULL, NULL, 29.36403700, 105.93343900, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118002', '2', '胜利路街道', NULL, NULL, 29.35357600, 105.88400500, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118003', '2', '南大街街道', NULL, NULL, 29.33769500, 105.89673400, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118004', '2', '茶山竹海街道', NULL, NULL, 29.36962700, 105.88343400, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118005', '2', '卫星湖街道', NULL, NULL, 29.24471500, 105.88029000, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118006', '2', '大安街道', NULL, NULL, 29.37574900, 106.00720100, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118007', '2', '陈食街道', NULL, NULL, 29.30867900, 106.00000600, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118102', '2', '临江镇', NULL, NULL, 29.25315800, 105.95963000, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118104', '2', '何埂镇', NULL, NULL, 29.13241400, 105.87333100, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118105', '2', '松溉镇', NULL, NULL, 29.05356200, 105.89314600, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118106', '2', '朱沱镇', NULL, NULL, 29.00416900, 105.84957500, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118107', '2', '仙龙镇', NULL, NULL, 29.14839400, 105.78776900, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118108', '2', '五间镇', NULL, NULL, 29.17970800, 105.83730200, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118109', '2', '来苏镇', NULL, NULL, 29.27119100, 105.78754600, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118110', '2', '宝峰镇', NULL, NULL, 29.27545600, 105.71268600, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118111', '2', '红炉镇', NULL, NULL, 29.34512900, 105.72536900, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118112', '2', '永荣镇', NULL, NULL, 29.33597400, 105.66114900, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118113', '2', '双石镇', NULL, NULL, 29.39904500, 105.84693100, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118114', '2', '三教镇', NULL, NULL, 29.48407400, 105.88006600, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118115', '2', '板桥镇', NULL, NULL, 29.50753100, 105.95589500, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118116', '2', '青峰镇', NULL, NULL, 29.33515900, 105.82934300, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118117', '2', '金龙镇', NULL, NULL, 29.50726100, 106.06538000, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500118118', '2', '吉安镇', NULL, NULL, 29.15292100, 105.75765400, '500118');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119', '1', '南川区', '南川', 'nan,chuan', 29.15787900, 107.09914700, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119001', '2', '东城街道', NULL, NULL, 29.15194400, 107.10888000, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119002', '2', '南城街道', NULL, NULL, 29.15414000, 107.09875100, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119003', '2', '西城街道', NULL, NULL, 29.15344400, 107.09332600, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119100', '2', '三泉镇', NULL, NULL, 29.12887500, 107.20922900, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119101', '2', '南平镇', NULL, NULL, 29.08183900, 106.98857100, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119102', '2', '神童镇', NULL, NULL, 29.18072300, 106.92676200, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119103', '2', '鸣玉镇', NULL, NULL, 29.30458800, 107.11482500, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119104', '2', '大观镇', NULL, NULL, 29.25459100, 106.97951300, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119105', '2', '兴隆镇', NULL, NULL, 29.16815900, 107.00712600, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119106', '2', '太平场镇', NULL, NULL, 29.44360000, 106.97986000, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119107', '2', '白沙镇', NULL, NULL, 29.37174800, 106.92629200, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119108', '2', '水江镇', NULL, NULL, 29.25254200, 107.29670200, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119109', '2', '石墙镇', NULL, NULL, 29.27096700, 107.20807300, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119110', '2', '金山镇', NULL, NULL, 28.92924000, 107.10948000, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119111', '2', '头渡镇', NULL, NULL, 28.93219600, 107.17880500, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119112', '2', '大有镇', NULL, NULL, 28.98695100, 107.33472100, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119113', '2', '合溪镇', NULL, NULL, 28.82714700, 107.31735400, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119114', '2', '黎香湖镇', NULL, NULL, 29.35957800, 106.97429800, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119115', '2', '山王坪镇', NULL, NULL, 29.14799600, 107.31093500, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119116', '2', '木凉镇', NULL, NULL, 29.21461700, 107.02494200, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119117', '2', '楠竹山镇', NULL, NULL, 29.22923500, 107.18614700, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119118', '2', '石溪镇', NULL, NULL, 29.33434000, 107.04399400, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119119', '2', '民主镇', NULL, NULL, 29.35970200, 107.17178000, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119120', '2', '德隆镇', NULL, NULL, 28.91453800, 107.25334000, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119121', '2', '福寿镇', NULL, NULL, 29.27658900, 107.08140500, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119122', '2', '河图镇', NULL, NULL, 29.30676200, 107.03303700, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119123', '2', '古花镇', NULL, NULL, 28.88609800, 107.34433400, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119124', '2', '庆元镇', NULL, NULL, 28.94763600, 107.35911100, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119125', '2', '乾丰镇', NULL, NULL, 29.41391000, 107.01014000, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119126', '2', '石莲镇', NULL, NULL, 29.06894100, 106.92469900, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119127', '2', '冷水关镇', NULL, NULL, 29.37876700, 107.14661300, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119128', '2', '骑龙镇', NULL, NULL, 29.35150500, 107.22541100, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119207', '2', '中桥乡', NULL, NULL, 29.32374000, 107.28266000, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500119212', '2', '峰岩乡', NULL, NULL, 29.29639200, 107.15764700, '500119');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120', '1', '璧山区', '璧山', 'bi,shan', 29.57774100, 106.20559600, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120001', '2', '璧城街道', NULL, NULL, 29.62997200, 106.25158200, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120002', '2', '青杠街道', NULL, NULL, 29.46952300, 106.23510200, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120003', '2', '璧泉街道', NULL, NULL, 29.58512100, 106.23203300, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120004', '2', '来凤街道', NULL, NULL, 29.43526800, 106.21815900, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120005', '2', '丁家街道', NULL, NULL, 29.40627400, 106.15075400, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120006', '2', '大路街道', NULL, NULL, 29.72417900, 106.22369600, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120100', '2', '河边镇', NULL, NULL, 29.65264000, 106.19925700, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120101', '2', '福禄镇', NULL, NULL, 29.60548100, 106.13970700, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120102', '2', '大兴镇', NULL, NULL, 29.55348500, 106.16215900, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120103', '2', '广普镇', NULL, NULL, 29.33083300, 106.14888200, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120104', '2', '三合镇', NULL, NULL, 29.34506900, 106.10187000, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120105', '2', '正兴镇', NULL, NULL, 29.45398700, 106.13626400, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120106', '2', '八塘镇', NULL, NULL, 29.83513400, 106.29525400, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120107', '2', '七塘镇', NULL, NULL, 29.77848700, 106.28592200, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500120108', '2', '健龙镇', NULL, NULL, 29.35797600, 106.18895600, '500120');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151', '1', '铜梁区', '铜梁', 'tong,liang', 29.84524800, 106.05626500, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151001', '2', '东城街道', NULL, NULL, 29.83084600, 106.07723800, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151002', '2', '南城街道', NULL, NULL, 29.82691200, 106.04761700, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151003', '2', '巴川街道', NULL, NULL, 29.83641300, 106.05620000, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151004', '2', '蒲吕街道', NULL, NULL, 29.80624900, 106.16540000, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151005', '2', '旧县街道', NULL, NULL, 29.86192500, 106.20891100, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151100', '2', '土桥镇', NULL, NULL, 29.76921100, 106.01287600, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151102', '2', '二坪镇', NULL, NULL, 29.89579100, 106.16260500, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151103', '2', '水口镇', NULL, NULL, 29.92704600, 106.11420000, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151104', '2', '安居镇', NULL, NULL, 29.97914200, 106.02614500, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151105', '2', '白羊镇', NULL, NULL, 29.96142300, 106.08527100, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151106', '2', '平滩镇', NULL, NULL, 29.84037800, 105.87775600, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151107', '2', '虎峰镇', NULL, NULL, 29.71054500, 106.12259100, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151108', '2', '石鱼镇', NULL, NULL, 29.77088700, 106.09334100, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151109', '2', '福果镇', NULL, NULL, 29.69875900, 106.04471300, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151110', '2', '少云镇', NULL, NULL, 29.98603300, 105.98445100, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151111', '2', '维新镇', NULL, NULL, 30.04454900, 105.89619400, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151112', '2', '高楼镇', NULL, NULL, 30.04034000, 105.98273500, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151113', '2', '大庙镇', NULL, NULL, 29.63835300, 106.07349800, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151114', '2', '围龙镇', NULL, NULL, 29.62185100, 106.01168600, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151115', '2', '华兴镇', NULL, NULL, 29.59737800, 106.07331800, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151117', '2', '永嘉镇', NULL, NULL, 29.56891800, 106.00538200, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151118', '2', '安溪镇', NULL, NULL, 29.56157000, 106.04646600, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151119', '2', '西河镇', NULL, NULL, 29.57208400, 105.93119300, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151120', '2', '侣俸镇', NULL, NULL, 29.85607200, 105.97602900, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151121', '2', '太平镇', NULL, NULL, 29.90074900, 106.04073600, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151122', '2', '小林镇', NULL, NULL, 29.78481500, 105.85608900, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151123', '2', '双山镇', NULL, NULL, 29.81835400, 105.83268300, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500151124', '2', '庆隆镇', NULL, NULL, 29.77485300, 106.14098300, '500151');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152', '1', '潼南区', '潼南', 'tong,nan', 30.19107700, 105.84048700, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152001', '2', '梓潼街道', NULL, NULL, 30.16812900, 105.83704700, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152002', '2', '桂林街道', NULL, NULL, 30.19633300, 105.84176900, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152100', '2', '上和镇', NULL, NULL, 30.15826200, 105.93557400, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152101', '2', '龙形镇', NULL, NULL, 30.24585700, 105.91096200, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152102', '2', '古溪镇', NULL, NULL, 30.32714000, 105.87495000, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152103', '2', '宝龙镇', NULL, NULL, 30.35262500, 105.92518700, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152104', '2', '玉溪镇', NULL, NULL, 30.32190700, 105.77915600, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152105', '2', '米心镇', NULL, NULL, 30.37906600, 105.77325000, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152106', '2', '群力镇', NULL, NULL, 30.29789700, 105.84150800, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152107', '2', '双江镇', NULL, NULL, 30.20765600, 105.75531200, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152108', '2', '花岩镇', NULL, NULL, 30.25495800, 105.64494500, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152109', '2', '柏梓镇', NULL, NULL, 30.09629500, 105.71733300, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152110', '2', '崇龛镇', NULL, NULL, 30.15370700, 105.61814000, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152111', '2', '塘坝镇', NULL, NULL, 30.01081800, 105.81238200, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152112', '2', '新胜镇', NULL, NULL, 29.95339100, 105.75549600, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152113', '2', '太安镇', NULL, NULL, 30.06758300, 105.81433900, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152114', '2', '小渡镇', NULL, NULL, 29.95627300, 105.90072600, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152115', '2', '卧佛镇', NULL, NULL, 29.90494300, 105.78968200, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152116', '2', '五桂镇', NULL, NULL, 29.81743100, 105.76019300, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152117', '2', '田家镇', NULL, NULL, 30.08721600, 105.86182700, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152118', '2', '别口镇', NULL, NULL, 30.11395600, 105.96238400, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500152119', '2', '寿桥镇', NULL, NULL, 29.89666400, 105.89834500, '500152');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153', '1', '荣昌区', '荣昌', 'rong,chang', 29.41689200, 105.61180000, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153001', '2', '昌元街道', NULL, NULL, 29.40170500, 105.59907000, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153002', '2', '广顺街道', NULL, NULL, 29.36956800, 105.52346800, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153003', '2', '昌州街道', NULL, NULL, 29.41283000, 105.60408700, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153004', '2', '峰高街道', NULL, NULL, 29.42548800, 105.68017600, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153005', '2', '安富街道', NULL, NULL, 29.35648200, 105.46995200, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153006', '2', '双河街道', NULL, NULL, 29.31693300, 105.57405900, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153100', '2', '直升镇', NULL, NULL, 29.37003400, 105.65676700, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153101', '2', '万灵镇', NULL, NULL, 29.48832300, 105.64910400, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153102', '2', '清江镇', NULL, NULL, 29.28487900, 105.47816300, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153103', '2', '仁义镇', NULL, NULL, 29.50687000, 105.48455900, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153104', '2', '河包镇', NULL, NULL, 29.56289900, 105.54751800, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153105', '2', '古昌镇', NULL, NULL, 29.48412500, 105.59472000, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153106', '2', '吴家镇', NULL, NULL, 29.63308800, 105.39612200, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153107', '2', '观胜镇', NULL, NULL, 29.57494700, 105.44233400, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153108', '2', '铜鼓镇', NULL, NULL, 29.60149200, 105.46582000, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153109', '2', '清流镇', NULL, NULL, 29.59279000, 105.33879500, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153110', '2', '盘龙镇', NULL, NULL, 29.49749200, 105.37260400, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153111', '2', '远觉镇', NULL, NULL, 29.55743700, 105.32145200, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153112', '2', '清升镇', NULL, NULL, 29.31573900, 105.51522300, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153113', '2', '荣隆镇', NULL, NULL, 29.43267100, 105.45087300, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500153114', '2', '龙集镇', NULL, NULL, 29.45756700, 105.41224200, '500153');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154', '1', '开州区', '开州', 'kai,zhou', 31.16041600, 108.39336000, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154001', '2', '汉丰街道', NULL, NULL, 31.16500300, 108.39466400, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154002', '2', '丰乐街道', NULL, NULL, 31.20542300, 108.43113300, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154003', '2', '镇东街道', NULL, NULL, 31.20533800, 108.43096100, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154004', '2', '白鹤街道', NULL, NULL, 31.26302500, 108.46775800, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154005', '2', '文峰街道', NULL, NULL, 31.17390200, 108.41321200, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154006', '2', '云枫街道', NULL, NULL, 31.15971100, 108.37185100, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154007', '2', '赵家街道', NULL, NULL, 31.08566500, 108.42799900, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154008', '2', '正安街道', NULL, NULL, 31.14872700, 108.31925100, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154100', '2', '大进镇', NULL, NULL, 31.50764000, 108.45206000, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154101', '2', '厚坝镇', NULL, NULL, 31.19900300, 108.48709000, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154102', '2', '长沙镇', NULL, NULL, 30.99522200, 108.30869500, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154103', '2', '郭家镇', NULL, NULL, 31.29455900, 108.48528200, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154104', '2', '临江镇', NULL, NULL, 31.10062000, 108.22605000, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154105', '2', '天和镇', NULL, NULL, 31.28502400, 108.19177400, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154106', '2', '温泉镇', NULL, NULL, 31.36412000, 108.52093500, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154107', '2', '铁桥镇', NULL, NULL, 31.03611700, 108.12668300, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154108', '2', '义和镇', NULL, NULL, 31.15557000, 108.08928000, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154109', '2', '中和镇', NULL, NULL, 31.17635400, 108.13490700, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154110', '2', '岳溪镇', NULL, NULL, 30.91059000, 108.17223300, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154111', '2', '南门镇', NULL, NULL, 30.95905900, 108.24817400, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154112', '2', '南雅镇', NULL, NULL, 31.07868200, 108.09202300, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154113', '2', '河堰镇', NULL, NULL, 31.35420200, 108.67597500, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154114', '2', '和谦镇', NULL, NULL, 31.41183100, 108.47293000, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154115', '2', '九龙山镇', NULL, NULL, 31.19307100, 108.25606600, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154117', '2', '敦好镇', NULL, NULL, 31.33635400, 108.38035000, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154118', '2', '竹溪镇', NULL, NULL, 31.12035400, 108.29120100, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154119', '2', '渠口镇', NULL, NULL, 31.13761500, 108.48259000, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154120', '2', '高桥镇', NULL, NULL, 31.36710700, 108.24439900, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154121', '2', '金峰镇', NULL, NULL, 31.19054300, 108.56548200, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154122', '2', '大德镇', NULL, NULL, 31.20974600, 108.34649000, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154123', '2', '白桥镇', NULL, NULL, 31.27928000, 108.59689000, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154124', '2', '巫山镇', NULL, NULL, 30.93345000, 107.95024700, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154125', '2', '谭家镇', NULL, NULL, 31.46084800, 108.49011400, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154126', '2', '满月镇', NULL, NULL, 31.61672900, 108.56957700, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154127', '2', '雪宝山镇', NULL, NULL, 31.59290200, 108.78791100, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154200', '2', '三汇口乡', NULL, NULL, 31.24045900, 108.07779300, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154201', '2', '五通乡', NULL, NULL, 30.88837800, 108.06157100, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154203', '2', '关面乡', NULL, NULL, 31.54990200, 108.67697000, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154205', '2', '麻柳乡', NULL, NULL, 31.43194000, 108.24882100, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500154206', '2', '紫水乡', NULL, NULL, 31.40963400, 108.31945800, '500154');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155', '1', '梁平区', '梁平', 'liang,ping', 30.65423300, 107.76956800, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155001', '2', '梁山街道', NULL, NULL, 30.69622100, 107.87249200, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155002', '2', '双桂街道', NULL, NULL, 30.64966300, 107.76368900, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155003', '2', '合兴街道', NULL, NULL, 30.73938000, 107.82112000, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155004', '2', '仁贤街道', NULL, NULL, 30.65702100, 107.68263900, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155005', '2', '金带街道', NULL, NULL, 30.60455400, 107.71145500, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155102', '2', '礼让镇', NULL, NULL, 30.68281300, 107.63474600, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155103', '2', '云龙镇', NULL, NULL, 30.52723800, 107.65220400, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155104', '2', '屏锦镇', NULL, NULL, 30.61002400, 107.55155700, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155106', '2', '袁驿镇', NULL, NULL, 30.73764600, 107.51653100, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155107', '2', '新盛镇', NULL, NULL, 30.84113000, 107.72777000, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155108', '2', '福禄镇', NULL, NULL, 30.65533000, 107.97343200, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155110', '2', '聚奎镇', NULL, NULL, 30.63535000, 107.59874100, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155111', '2', '明达镇', NULL, NULL, 30.72247600, 107.66287200, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155112', '2', '荫平镇', NULL, NULL, 30.54081900, 107.58070800, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155113', '2', '和林镇', NULL, NULL, 30.57867400, 107.68526700, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155114', '2', '回龙镇', NULL, NULL, 30.53073000, 107.48795000, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155115', '2', '碧山镇', NULL, NULL, 30.76670300, 107.46278500, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155116', '2', '虎城镇', NULL, NULL, 30.81030500, 107.54341400, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155117', '2', '七星镇', NULL, NULL, 30.67828300, 107.48752900, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155118', '2', '龙门镇', NULL, NULL, 30.79625600, 107.69186500, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155119', '2', '文化镇', NULL, NULL, 30.81356400, 107.77947500, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155121', '2', '石安镇', NULL, NULL, 30.59121800, 107.97875600, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155122', '2', '柏家镇', NULL, NULL, 30.59133800, 107.90798400, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155123', '2', '大观镇', NULL, NULL, 30.55200700, 107.81075100, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155124', '2', '竹山镇', NULL, NULL, 30.71545000, 107.58005000, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155125', '2', '蟠龙镇', NULL, NULL, 30.63247400, 107.85324300, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155126', '2', '星桥镇', NULL, NULL, 30.71902800, 107.78956000, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155127', '2', '曲水镇', NULL, NULL, 30.69552200, 108.05313400, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155128', '2', '安胜镇', NULL, NULL, 30.68786600, 107.72454900, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155129', '2', '复平镇', NULL, NULL, 30.76896400, 107.88455400, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155130', '2', '紫照镇', NULL, NULL, 30.53389000, 107.94106600, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155201', '2', '铁门乡', NULL, NULL, 30.49901200, 107.71472100, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500155202', '2', '龙胜乡', NULL, NULL, 30.77140100, 107.55742000, '500155');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156', '1', '武隆区', '武隆', 'wu,long', 29.32570700, 107.75995500, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156100', '2', '巷口镇', NULL, NULL, 29.30076200, 107.76400300, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156101', '2', '桐梓镇', NULL, NULL, 29.55735500, 107.95611300, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156102', '2', '火炉镇', NULL, NULL, 29.39099700, 107.87542100, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156103', '2', '江口镇', NULL, NULL, 29.23790000, 107.87919000, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156104', '2', '羊角镇', NULL, NULL, 29.37200900, 107.69002500, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156105', '2', '土坎镇', NULL, NULL, 29.40626700, 107.67647400, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156106', '2', '长坝镇', NULL, NULL, 29.33170500, 107.47986900, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156107', '2', '白马镇', NULL, NULL, 29.39360300, 107.54449200, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156108', '2', '鸭江镇', NULL, NULL, 29.45240400, 107.37796800, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156109', '2', '平桥镇', NULL, NULL, 29.37035100, 107.34291300, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156110', '2', '仙女山镇', NULL, NULL, 29.41803700, 107.76147600, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156111', '2', '和顺镇', NULL, NULL, 29.40868700, 107.42776200, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156112', '2', '双河镇', NULL, NULL, 29.54732700, 107.72388100, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156201', '2', '黄莺乡', NULL, NULL, 29.21624500, 107.69007900, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156207', '2', '后坪苗族土家族乡', NULL, NULL, 29.59934500, 108.03336000, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156209', '2', '接龙乡', NULL, NULL, 29.59158800, 107.89936000, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156210', '2', '土地乡', NULL, NULL, 29.50242900, 107.90402000, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156213', '2', '沧沟乡', NULL, NULL, 29.44221900, 107.97412700, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156216', '2', '石桥苗族土家族乡', NULL, NULL, 29.18472600, 107.82994900, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156218', '2', '浩口苗族仡佬族乡', NULL, NULL, 29.08972000, 107.83597100, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156219', '2', '文复苗族土家族乡', NULL, NULL, 29.27565900, 107.95610000, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156225', '2', '赵家乡', NULL, NULL, 29.26581400, 107.55655000, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156226', '2', '白云乡', NULL, NULL, 29.30939400, 107.42263400, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156227', '2', '大洞河乡', NULL, NULL, 29.25193400, 107.43281300, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156231', '2', '庙垭乡', NULL, NULL, 29.44219200, 107.32400900, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500156234', '2', '凤来乡', NULL, NULL, 29.39757100, 107.30087300, '500156');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229', '1', '城口县', '城口', 'cheng,kou', 31.94761400, 108.66411300, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229001', '2', '葛城街道', NULL, NULL, 31.94460400, 108.66106200, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229002', '2', '复兴街道', NULL, NULL, 31.93872000, 108.66339600, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229102', '2', '巴山镇', NULL, NULL, 32.10931000, 108.47174900, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229104', '2', '坪坝镇', NULL, NULL, 31.99600300, 108.52143200, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229105', '2', '庙坝镇', NULL, NULL, 31.93351300, 108.52271400, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229106', '2', '明通镇', NULL, NULL, 31.76977000, 108.54559200, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229107', '2', '修齐镇', NULL, NULL, 31.88060600, 108.78023300, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229108', '2', '高观镇', NULL, NULL, 31.84279400, 108.91983100, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229109', '2', '高燕镇', NULL, NULL, 31.93918800, 108.61757100, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229110', '2', '东安镇', NULL, NULL, 31.77401600, 109.09969800, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229111', '2', '咸宜镇', NULL, NULL, 31.68645000, 108.65976300, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229112', '2', '高楠镇', NULL, NULL, 32.13030800, 108.53578800, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229201', '2', '龙田乡', NULL, NULL, 31.97177700, 108.63972400, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229202', '2', '北屏乡', NULL, NULL, 31.97185700, 108.78368600, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229205', '2', '左岚乡', NULL, NULL, 32.14600100, 108.45611000, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229208', '2', '沿河乡', NULL, NULL, 32.05579300, 108.40097200, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229210', '2', '双河乡', NULL, NULL, 31.93947600, 108.35399200, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229211', '2', '蓼子乡', NULL, NULL, 31.81648900, 108.65257800, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229212', '2', '鸡鸣乡', NULL, NULL, 31.71048200, 108.60371100, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229214', '2', '周溪乡', NULL, NULL, 31.81489300, 108.48199100, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229216', '2', '明中乡', NULL, NULL, 31.73209300, 108.81420700, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229217', '2', '治平乡', NULL, NULL, 31.80139700, 108.80774800, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229219', '2', '岚天乡', NULL, NULL, 31.92188000, 108.89257800, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229220', '2', '厚坪乡', NULL, NULL, 31.73839700, 108.94055200, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500229221', '2', '河鱼乡', NULL, NULL, 31.90520400, 109.00694200, '500229');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230', '1', '丰都县', '丰都', 'feng,du', 29.86378500, 107.73105600, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230001', '2', '三合街道', NULL, NULL, 29.86683600, 107.73091700, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230002', '2', '名山街道', NULL, NULL, 29.87732100, 107.70503000, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230101', '2', '虎威镇', NULL, NULL, 29.90347500, 107.64437100, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230102', '2', '社坛镇', NULL, NULL, 29.99087200, 107.62144500, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230103', '2', '三元镇', NULL, NULL, 30.10235400, 107.65619500, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230104', '2', '许明寺镇', NULL, NULL, 30.15768000, 107.58561200, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230105', '2', '董家镇', NULL, NULL, 30.22177700, 107.70773400, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230106', '2', '树人镇', NULL, NULL, 29.98162200, 107.74284900, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230107', '2', '十直镇', NULL, NULL, 30.04427000, 107.79733300, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230109', '2', '高家镇', NULL, NULL, 30.01772200, 107.86454000, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230110', '2', '兴义镇', NULL, NULL, 29.94814000, 107.81903600, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230111', '2', '双路镇', NULL, NULL, 29.86013200, 107.77691100, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230112', '2', '江池镇', NULL, NULL, 29.91038100, 108.03250000, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230113', '2', '龙河镇', NULL, NULL, 29.83358600, 107.99025200, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230114', '2', '武平镇', NULL, NULL, 29.77990500, 108.09852800, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230115', '2', '包鸾镇', NULL, NULL, 29.76134100, 107.68442000, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230116', '2', '湛普镇', NULL, NULL, 29.83966500, 107.64532900, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230118', '2', '保合镇', NULL, NULL, 30.05671200, 107.70567100, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230119', '2', '南天湖镇', NULL, NULL, 29.69837400, 107.92393500, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230120', '2', '仁沙镇', NULL, NULL, 30.04920900, 107.59834000, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230121', '2', '兴龙镇', NULL, NULL, 29.99138000, 107.51266900, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230122', '2', '龙孔镇', NULL, NULL, 30.04125300, 107.91955600, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230123', '2', '暨龙镇', NULL, NULL, 29.74140900, 108.01341700, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230124', '2', '双龙镇', NULL, NULL, 30.12752000, 107.72480600, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230125', '2', '仙女湖镇', NULL, NULL, 29.66863000, 107.76232400, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230202', '2', '青龙乡', NULL, NULL, 30.16650700, 107.79076300, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230206', '2', '太平坝乡', NULL, NULL, 29.72383700, 108.15692800, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230207', '2', '都督乡', NULL, NULL, 29.62987000, 108.11884000, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230209', '2', '栗子乡', NULL, NULL, 29.80629200, 107.93133000, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500230210', '2', '三建乡', NULL, NULL, 29.79465400, 107.87255800, '500230');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231', '1', '垫江县', '垫江', 'dian,jiang', 30.32754800, 107.33251100, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231001', '2', '桂溪街道', NULL, NULL, 30.32406000, 107.35974900, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231002', '2', '桂阳街道', NULL, NULL, 30.31287700, 107.33412800, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231101', '2', '新民镇', NULL, NULL, 30.39486400, 107.39104800, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231102', '2', '沙坪镇', NULL, NULL, 30.47317800, 107.44265500, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231103', '2', '周嘉镇', NULL, NULL, 30.41471500, 107.54412000, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231104', '2', '普顺镇', NULL, NULL, 30.46936900, 107.60812000, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231105', '2', '永安镇', NULL, NULL, 30.35387200, 107.51708000, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231106', '2', '高安镇', NULL, NULL, 30.29200200, 107.46055800, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231107', '2', '高峰镇', NULL, NULL, 30.22405600, 107.41224800, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231108', '2', '五洞镇', NULL, NULL, 30.20759300, 107.34540000, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231109', '2', '太平镇', NULL, NULL, 30.26313300, 107.29772600, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231110', '2', '澄溪镇', NULL, NULL, 30.20241100, 107.26482900, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231111', '2', '砚台镇', NULL, NULL, 30.13828200, 107.32437800, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231112', '2', '鹤游镇', NULL, NULL, 30.07888700, 107.35631700, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231113', '2', '坪山镇', NULL, NULL, 30.09398000, 107.42790700, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231114', '2', '曹回镇', NULL, NULL, 30.39588000, 107.47761000, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231115', '2', '杠家镇', NULL, NULL, 30.21858800, 107.50821400, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231116', '2', '包家镇', NULL, NULL, 30.07459200, 107.28760500, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231117', '2', '白家镇', NULL, NULL, 30.01466200, 107.32952600, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231118', '2', '裴兴镇', NULL, NULL, 30.12161500, 107.51872200, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231119', '2', '三溪镇', NULL, NULL, 30.05960900, 107.45914000, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231120', '2', '永平镇', NULL, NULL, 30.14901600, 107.43917600, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231121', '2', '黄沙镇', NULL, NULL, 30.26704400, 107.38109000, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231122', '2', '长龙镇', NULL, NULL, 30.30642300, 107.41586900, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231202', '2', '沙河乡', NULL, NULL, 30.27760300, 107.56593900, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500231204', '2', '大石乡', NULL, NULL, 30.20592900, 107.54440600, '500231');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233', '1', '忠县', '忠县', 'zhong,xian', 30.29981700, 108.03807300, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233001', '2', '忠州街道', NULL, NULL, 30.31988900, 108.05003500, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233003', '2', '新生街道', NULL, NULL, 30.21163700, 107.95149400, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233004', '2', '乌杨街道', NULL, NULL, 30.20253600, 108.01252100, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233102', '2', '任家镇', NULL, NULL, 30.13912000, 107.87823000, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233104', '2', '洋渡镇', NULL, NULL, 30.12744200, 107.93334900, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233105', '2', '东溪镇', NULL, NULL, 30.27566700, 108.03968300, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233106', '2', '复兴镇', NULL, NULL, 30.29030600, 108.12637400, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233107', '2', '石宝镇', NULL, NULL, 30.42127500, 108.19720700, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233108', '2', '汝溪镇', NULL, NULL, 30.49610300, 108.07598100, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233109', '2', '野鹤镇', NULL, NULL, 30.52162700, 108.12757500, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233110', '2', '官坝镇', NULL, NULL, 30.48793000, 107.87949000, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233111', '2', '石黄镇', NULL, NULL, 30.50469800, 107.85350300, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233112', '2', '马灌镇', NULL, NULL, 30.38775000, 107.74190900, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233113', '2', '金鸡镇', NULL, NULL, 30.47466200, 107.73341200, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233114', '2', '新立镇', NULL, NULL, 30.27367600, 107.64870700, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233115', '2', '双桂镇', NULL, NULL, 30.23900600, 107.59078000, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233116', '2', '拔山镇', NULL, NULL, 30.30714900, 107.73021500, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233117', '2', '花桥镇', NULL, NULL, 30.35464600, 107.69801800, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233118', '2', '永丰镇', NULL, NULL, 30.31648500, 107.83000800, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233119', '2', '三汇镇', NULL, NULL, 30.36962500, 107.87365500, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233120', '2', '白石镇', NULL, NULL, 30.31303000, 107.88418000, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233122', '2', '黄金镇', NULL, NULL, 30.36856300, 108.00685600, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233201', '2', '善广乡', NULL, NULL, 30.20576200, 107.84477300, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233203', '2', '石子乡', NULL, NULL, 30.11067300, 108.05344000, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233204', '2', '磨子土家族乡', NULL, NULL, 30.19136000, 108.06868400, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233206', '2', '涂井乡', NULL, NULL, 30.41546300, 108.12482500, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233208', '2', '金声乡', NULL, NULL, 30.52260500, 107.99400400, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500233210', '2', '兴峰乡', NULL, NULL, 30.46545600, 107.96511900, '500233');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235', '1', '云阳县', '云阳', 'yun,yang', 30.93062800, 108.69750000, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235001', '2', '青龙街道', NULL, NULL, 30.92489100, 108.71077500, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235002', '2', '双江街道', NULL, NULL, 30.93598100, 108.70470900, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235003', '2', '人和街道', NULL, NULL, 30.95151800, 108.69221700, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235004', '2', '盘龙街道', NULL, NULL, 30.90506000, 108.71321000, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235100', '2', '云阳镇', NULL, NULL, 30.95522300, 108.90675500, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235101', '2', '云安镇', NULL, NULL, 31.04190700, 108.85641800, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235103', '2', '凤鸣镇', NULL, NULL, 30.86862600, 108.75091300, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235105', '2', '龙角镇', NULL, NULL, 30.80360700, 108.87140100, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235106', '2', '宝坪镇', NULL, NULL, 30.88516100, 108.85359600, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235107', '2', '故陵镇', NULL, NULL, 30.93460700, 109.07409600, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235108', '2', '红狮镇', NULL, NULL, 30.98356100, 109.02599500, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235109', '2', '南溪镇', NULL, NULL, 31.11481900, 108.82049300, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235111', '2', '双土镇', NULL, NULL, 31.15649700, 108.93714000, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235112', '2', '桑坪镇', NULL, NULL, 31.21724900, 109.04666800, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235113', '2', '江口镇', NULL, NULL, 31.22178000, 108.79675000, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235115', '2', '路阳镇', NULL, NULL, 31.23376000, 108.69441100, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235116', '2', '农坝镇', NULL, NULL, 31.37267500, 108.74098600, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235117', '2', '高阳镇', NULL, NULL, 31.09578200, 108.68131400, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235118', '2', '渠马镇', NULL, NULL, 31.13218100, 108.61548900, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235121', '2', '黄石镇', NULL, NULL, 30.99813700, 108.72210200, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235122', '2', '巴阳镇', NULL, NULL, 30.95465500, 108.58072300, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235124', '2', '鱼泉镇', NULL, NULL, 31.28500300, 108.85131800, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235126', '2', '平安镇', NULL, NULL, 31.03356800, 108.50852200, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235127', '2', '沙市镇', NULL, NULL, 31.33367600, 108.88745200, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235128', '2', '双龙镇', NULL, NULL, 31.17100900, 108.62272400, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235129', '2', '栖霞镇', NULL, NULL, 31.00258900, 108.85235400, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235130', '2', '水口镇', NULL, NULL, 31.00500500, 108.77036900, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235131', '2', '蔈草镇', NULL, NULL, 30.78917000, 108.95687400, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235132', '2', '泥溪镇', NULL, NULL, 30.73881300, 108.88208800, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235133', '2', '养鹿镇', NULL, NULL, 31.08618700, 108.55494800, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235134', '2', '后叶镇', NULL, NULL, 31.28775000, 108.68276300, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235135', '2', '龙洞镇', NULL, NULL, 30.96363800, 109.16101600, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235136', '2', '堰坪镇', NULL, NULL, 30.82333600, 109.04820600, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235137', '2', '大阳镇', NULL, NULL, 31.15617400, 109.01005200, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235138', '2', '耀灵镇', NULL, NULL, 30.65188200, 108.90121600, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235208', '2', '外郎乡', NULL, NULL, 30.77862700, 108.77739000, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235215', '2', '新津乡', NULL, NULL, 30.92568100, 108.96276600, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235216', '2', '普安乡', NULL, NULL, 30.86646100, 108.93001700, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235218', '2', '洞鹿乡', NULL, NULL, 31.07055500, 109.04275100, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235219', '2', '石门乡', NULL, NULL, 31.12975700, 109.04177700, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235239', '2', '上坝乡', NULL, NULL, 31.37185400, 108.91555900, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500235241', '2', '清水土家族乡', NULL, NULL, 30.70267000, 108.97288600, '500235');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236', '1', '奉节县', '奉节', 'feng,jie', 31.01850500, 109.40105600, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236100', '2', '永安镇', NULL, NULL, 31.01629900, 109.46453500, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236101', '2', '白帝镇', NULL, NULL, 31.05546800, 109.59459200, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236102', '2', '草堂镇', NULL, NULL, 31.09255600, 109.64573900, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236103', '2', '汾河镇', NULL, NULL, 31.12870100, 109.51190300, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236104', '2', '康乐镇', NULL, NULL, 31.10621700, 109.43864400, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236105', '2', '大树镇', NULL, NULL, 31.20611100, 109.32572500, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236106', '2', '竹园镇', NULL, NULL, 31.29667800, 109.26501500, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236107', '2', '公平镇', NULL, NULL, 31.12465600, 109.20310300, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236108', '2', '朱衣镇', NULL, NULL, 31.01898800, 109.39021500, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236109', '2', '甲高镇', NULL, NULL, 30.88802200, 109.17985100, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236110', '2', '羊市镇', NULL, NULL, 30.81865000, 109.04887600, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236111', '2', '吐祥镇', NULL, NULL, 30.71196400, 109.16200100, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236112', '2', '青龙镇', NULL, NULL, 30.77689400, 109.28216800, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236113', '2', '兴隆镇', NULL, NULL, 30.65615400, 109.44991100, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236114', '2', '新民镇', NULL, NULL, 30.90228400, 109.47428200, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236115', '2', '永乐镇', NULL, NULL, 31.02636800, 109.52094000, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236116', '2', '青莲镇', NULL, NULL, 31.23060400, 109.12234400, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236117', '2', '五马镇', NULL, NULL, 30.85290700, 109.38004700, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236118', '2', '安坪镇', NULL, NULL, 30.90893000, 109.30086200, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236200', '2', '红土乡', NULL, NULL, 31.12262700, 109.10291900, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236201', '2', '平安乡', NULL, NULL, 31.34496100, 109.17484400, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236203', '2', '岩湾乡', NULL, NULL, 31.18673500, 109.53413000, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236204', '2', '石岗乡', NULL, NULL, 31.12105600, 109.34282800, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236205', '2', '康坪乡', NULL, NULL, 30.97911900, 109.24898700, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236207', '2', '云雾土家族乡', NULL, NULL, 30.59902400, 109.13108000, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236208', '2', '太和土家族乡', NULL, NULL, 30.63973700, 109.26424500, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236209', '2', '龙桥土家族乡', NULL, NULL, 30.57324500, 109.38561400, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236210', '2', '长安土家族乡', NULL, NULL, 30.82799100, 109.56310100, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236211', '2', '冯坪乡', NULL, NULL, 30.82831300, 109.49915300, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500236213', '2', '鹤峰乡', NULL, NULL, 30.92650400, 109.54574100, '500236');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237', '1', '巫山县', '巫山', 'wu,shan', 31.07478000, 109.87899500, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237001', '2', '高唐街道', NULL, NULL, 31.07990300, 109.88326700, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237002', '2', '龙门街道', NULL, NULL, 31.08959000, 109.89631200, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237100', '2', '巫峡镇', NULL, NULL, 31.10510000, 109.86679600, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237101', '2', '庙宇镇', NULL, NULL, 30.86299900, 109.65469100, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237102', '2', '大昌镇', NULL, NULL, 31.25371300, 109.82050700, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237103', '2', '福田镇', NULL, NULL, 31.21782200, 109.71252100, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237104', '2', '龙溪镇', NULL, NULL, 31.30214700, 109.64269000, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237105', '2', '双龙镇', NULL, NULL, 31.18850700, 109.87381000, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237106', '2', '官阳镇', NULL, NULL, 31.33794700, 109.90833100, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237107', '2', '骡坪镇', NULL, NULL, 31.20648400, 110.08846500, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237108', '2', '抱龙镇', NULL, NULL, 30.94208300, 110.01106100, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237109', '2', '官渡镇', NULL, NULL, 30.95343200, 109.85249000, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237110', '2', '铜鼓镇', NULL, NULL, 30.92972500, 109.73483400, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237200', '2', '红椿土家族乡', NULL, NULL, 30.84946900, 109.71658900, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237207', '2', '两坪乡', NULL, NULL, 31.11881200, 109.97224000, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237208', '2', '曲尺乡', NULL, NULL, 31.03308800, 109.75058000, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237210', '2', '建平乡', NULL, NULL, 31.04255900, 109.92819300, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237211', '2', '大溪乡', NULL, NULL, 30.99945900, 109.64770100, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237214', '2', '金坪乡', NULL, NULL, 31.20585200, 109.94036900, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237216', '2', '平河乡', NULL, NULL, 31.25862700, 109.95374600, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237219', '2', '当阳乡', NULL, NULL, 31.40157200, 109.97939800, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237222', '2', '竹贤乡', NULL, NULL, 31.28158200, 110.07486900, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237225', '2', '三溪乡', NULL, NULL, 31.12981000, 110.09974300, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237227', '2', '培石乡', NULL, NULL, 31.00579100, 110.09817000, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237229', '2', '笃坪乡', NULL, NULL, 30.92628400, 110.10504000, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500237231', '2', '邓家土家族乡', NULL, NULL, 30.84603700, 110.05821800, '500237');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238', '1', '巫溪县', '巫溪', 'wu,xi', 31.39861900, 109.57003800, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238001', '2', '宁河街道', NULL, NULL, 31.39772900, 109.63035000, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238002', '2', '柏杨街道', NULL, NULL, 31.40194900, 109.57206000, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238100', '2', '城厢镇', NULL, NULL, 31.39277400, 109.61907000, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238101', '2', '凤凰镇', NULL, NULL, 31.39988300, 109.51777200, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238102', '2', '宁厂镇', NULL, NULL, 31.48933300, 109.64185800, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238103', '2', '上磺镇', NULL, NULL, 31.31701600, 109.48784800, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238104', '2', '古路镇', NULL, NULL, 31.32728900, 109.44655000, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238105', '2', '文峰镇', NULL, NULL, 31.40243100, 109.23386500, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238106', '2', '徐家镇', NULL, NULL, 31.64117600, 109.67664700, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238107', '2', '白鹿镇', NULL, NULL, 31.61031500, 109.69121100, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238108', '2', '尖山镇', NULL, NULL, 31.43266100, 108.89976800, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238109', '2', '下堡镇', NULL, NULL, 31.57490700, 109.52124000, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238110', '2', '峰灵镇', NULL, NULL, 31.31794000, 109.56319600, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238111', '2', '塘坊镇', NULL, NULL, 31.39028000, 109.31572300, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238112', '2', '朝阳镇', NULL, NULL, 31.40504900, 109.05146100, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238113', '2', '田坝镇', NULL, NULL, 31.39733600, 108.86841100, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238114', '2', '通城镇', NULL, NULL, 31.39280200, 109.74039200, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238115', '2', '土城镇', NULL, NULL, 31.63493600, 109.22736400, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238116', '2', '菱角镇', NULL, NULL, 31.39986400, 109.38822900, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238117', '2', '蒲莲镇', NULL, NULL, 31.29874000, 109.56455300, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238118', '2', '红池坝镇', NULL, NULL, 31.52172700, 108.87174000, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238200', '2', '胜利乡', NULL, NULL, 31.43160400, 109.45772400, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238202', '2', '大河乡', NULL, NULL, 31.50095800, 109.62285200, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238203', '2', '天星乡', NULL, NULL, 31.46777200, 109.54433500, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238204', '2', '长桂乡', NULL, NULL, 31.47190600, 109.36850400, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238209', '2', '鱼鳞乡', NULL, NULL, 31.67261600, 109.49268400, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238210', '2', '乌龙乡', NULL, NULL, 31.65274700, 109.43998600, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238214', '2', '花台乡', NULL, NULL, 31.30338900, 109.65651100, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238215', '2', '兰英乡', NULL, NULL, 29.05056700, 108.45857000, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238216', '2', '双阳乡', NULL, NULL, 31.47445900, 109.82610500, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238217', '2', '中梁乡', NULL, NULL, 31.58722300, 109.38343100, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238218', '2', '天元乡', NULL, NULL, 31.58643000, 109.20556000, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500238400', '2', '红池坝经济开发区', NULL, NULL, 31.58393300, 109.00065300, '500238');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240', '1', '石柱土家族自治县', '石柱', 'shi,zhu', 29.99906600, 108.11425100, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240001', '2', '南宾街道', NULL, NULL, 29.99682500, 108.11764900, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240003', '2', '下路街道', NULL, NULL, 29.94009900, 108.09122400, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240101', '2', '西沱镇', NULL, NULL, 30.39916500, 108.21436500, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240103', '2', '悦崃镇', NULL, NULL, 30.20173900, 108.27036700, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240104', '2', '临溪镇', NULL, NULL, 30.40368600, 108.35249000, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240105', '2', '黄水镇', NULL, NULL, 30.24009800, 108.39520600, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240106', '2', '马武镇', NULL, NULL, 29.78124100, 108.34930200, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240107', '2', '沙子镇', NULL, NULL, 30.02699600, 108.41224700, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240108', '2', '王场镇', NULL, NULL, 30.32321800, 108.18535900, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240109', '2', '沿溪镇', NULL, NULL, 30.29536100, 108.13247600, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240110', '2', '龙沙镇', NULL, NULL, 30.13266900, 108.18862600, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240111', '2', '鱼池镇', NULL, NULL, 30.26263000, 108.22783600, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240112', '2', '大歇镇', NULL, NULL, 30.06747000, 108.11139500, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240113', '2', '三河镇', NULL, NULL, 30.03452500, 108.19100100, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240114', '2', '万朝镇', NULL, NULL, 30.18582700, 108.14735400, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240115', '2', '桥头镇', NULL, NULL, 30.10284300, 108.24958000, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240116', '2', '冷水镇', NULL, NULL, 30.14074500, 108.55738900, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240117', '2', '黄鹤镇', NULL, NULL, 29.83880200, 108.36850600, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240118', '2', '枫木镇', NULL, NULL, 30.24290900, 108.45289300, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240203', '2', '黎场乡', NULL, NULL, 30.34875000, 108.14659000, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240204', '2', '三星乡', NULL, NULL, 29.89439600, 108.11275000, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240205', '2', '六塘乡', NULL, NULL, 29.93427300, 108.27260300, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240207', '2', '三益乡', NULL, NULL, 30.14479600, 108.28007100, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240208', '2', '王家乡', NULL, NULL, 30.34347900, 108.31642100, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240209', '2', '河嘴乡', NULL, NULL, 30.51194200, 108.40676100, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240210', '2', '石家乡', NULL, NULL, 30.28345000, 108.33018000, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240213', '2', '中益乡', NULL, NULL, 30.09524200, 108.33757000, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240214', '2', '洗新乡', NULL, NULL, 29.91414300, 108.39504000, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240216', '2', '龙潭乡', NULL, NULL, 29.83552500, 108.26985300, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240217', '2', '新乐乡', NULL, NULL, 29.92470000, 108.47220000, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240218', '2', '金铃乡', NULL, NULL, 29.99106800, 108.49955000, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500240219', '2', '金竹乡', NULL, NULL, 29.96065300, 108.45975000, '500240');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241', '1', '秀山土家族苗族自治县', '秀山', 'xiu,shan', 28.44824800, 109.00709600, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241001', '2', '乌杨街道', NULL, NULL, 28.45276300, 108.97504700, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241002', '2', '中和街道', NULL, NULL, 28.45162300, 108.99553400, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241003', '2', '平凯街道', NULL, NULL, 28.42966800, 109.00520000, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241004', '2', '官庄街道', NULL, NULL, 28.50416000, 109.01875000, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241102', '2', '清溪场镇', NULL, NULL, 28.40604100, 108.91539700, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241103', '2', '隘口镇', NULL, NULL, 28.32915500, 108.80932500, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241104', '2', '溶溪镇', NULL, NULL, 28.52440100, 108.88534400, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241106', '2', '龙池镇', NULL, NULL, 28.60638900, 109.05396200, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241107', '2', '石堤镇', NULL, NULL, 28.73769400, 109.18773200, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241108', '2', '峨溶镇', NULL, NULL, 28.56831700, 109.29408600, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241109', '2', '洪安镇', NULL, NULL, 28.49585900, 109.26905400, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241110', '2', '雅江镇', NULL, NULL, 28.45564000, 109.18242500, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241111', '2', '石耶镇', NULL, NULL, 28.38013300, 109.06109300, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241112', '2', '梅江镇', NULL, NULL, 28.26194400, 109.03569100, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241113', '2', '兰桥镇', NULL, NULL, 28.18559700, 108.99871800, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241114', '2', '膏田镇', NULL, NULL, 28.48698200, 108.84598700, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241115', '2', '溪口镇', NULL, NULL, 28.59776600, 108.92138600, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241116', '2', '妙泉镇', NULL, NULL, 28.64123500, 109.00893100, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241117', '2', '宋农镇', NULL, NULL, 28.67297000, 109.11019600, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241118', '2', '钟灵镇', NULL, NULL, 28.29458100, 108.96468200, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241119', '2', '里仁镇', NULL, NULL, 28.67965900, 109.18437500, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241201', '2', '孝溪乡', NULL, NULL, 28.37574700, 108.91423400, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241207', '2', '海洋乡', NULL, NULL, 28.73678600, 109.14185300, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241208', '2', '大溪乡', NULL, NULL, 28.79766700, 109.17385900, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241211', '2', '涌洞乡', NULL, NULL, 28.60725000, 109.12701200, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241214', '2', '中平乡', NULL, NULL, 28.41341600, 109.13282500, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500241215', '2', '岑溪乡', NULL, NULL, 28.34208600, 109.11296600, '500241');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242', '1', '酉阳土家族苗族自治县', '酉阳', 'you,yang', 28.84140900, 108.76726000, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242002', '2', '桃花源街道', NULL, NULL, 28.84841100, 108.77147900, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242101', '2', '龙潭镇', NULL, NULL, 28.76095100, 108.97348100, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242102', '2', '麻旺镇', NULL, NULL, 28.90359800, 108.95658900, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242103', '2', '酉酬镇', NULL, NULL, 28.97102900, 109.13041200, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242104', '2', '大溪镇', NULL, NULL, 29.09098000, 109.16011400, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242105', '2', '兴隆镇', NULL, NULL, 29.25707700, 109.04484400, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242106', '2', '黑水镇', NULL, NULL, 29.05240300, 108.80057400, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242107', '2', '丁市镇', NULL, NULL, 28.77680500, 108.54373100, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242108', '2', '龚滩镇', NULL, NULL, 28.92851600, 108.35570300, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242109', '2', '李溪镇', NULL, NULL, 28.52906500, 108.62091500, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242110', '2', '泔溪镇', NULL, NULL, 28.97640200, 108.96275200, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242111', '2', '酉水河镇', NULL, NULL, 28.88915800, 109.13044600, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242112', '2', '苍岭镇', NULL, NULL, 28.99806700, 108.60424300, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242113', '2', '小河镇', NULL, NULL, 28.65616100, 108.64129000, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242114', '2', '板溪镇', NULL, NULL, 28.74163100, 108.82045000, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242115', '2', '涂市镇', NULL, NULL, 28.90360700, 108.86499600, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242116', '2', '铜鼓镇', NULL, NULL, 28.77968700, 108.68878900, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242117', '2', '五福镇', NULL, NULL, 29.11753400, 109.11779100, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242118', '2', '万木镇', NULL, NULL, 28.62995500, 108.50098900, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242119', '2', '南腰界镇', NULL, NULL, 28.39739900, 108.64394100, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242204', '2', '可大乡', NULL, NULL, 29.02931800, 109.24334100, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242205', '2', '偏柏乡', NULL, NULL, 29.02859700, 109.09946000, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242207', '2', '木叶乡', NULL, NULL, 29.25348600, 108.99211400, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242208', '2', '毛坝乡', NULL, NULL, 29.10266700, 108.90371700, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242209', '2', '花田乡', NULL, NULL, 28.95084100, 108.70857900, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242210', '2', '后坪乡', NULL, NULL, 28.69282700, 108.40282900, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242211', '2', '天馆乡', NULL, NULL, 28.84446500, 108.46776600, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242212', '2', '宜居乡', NULL, NULL, 28.87232400, 108.57926900, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242214', '2', '两罾乡', NULL, NULL, 28.88054600, 108.39447400, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242215', '2', '板桥乡', NULL, NULL, 28.70130700, 108.72515900, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242216', '2', '官清乡', NULL, NULL, 28.62614500, 108.67596800, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242218', '2', '车田乡', NULL, NULL, 29.13071500, 109.04211800, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242219', '2', '腴地乡', NULL, NULL, 29.00568900, 108.91323800, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242220', '2', '清泉乡', NULL, NULL, 28.79537300, 108.39075000, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242221', '2', '庙溪乡', NULL, NULL, 29.05056700, 108.45857000, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242222', '2', '浪坪乡', NULL, NULL, 29.07932700, 108.54705000, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242223', '2', '双泉乡', NULL, NULL, 29.02934900, 108.65587500, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500242224', '2', '楠木乡', NULL, NULL, 28.60037000, 108.76582000, '500242');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243', '1', '彭水苗族土家族自治县', '彭水', 'peng,shui', 29.29425200, 108.16571900, '500000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243001', '2', '汉葭街道', NULL, NULL, 29.29026800, 108.16412400, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243002', '2', '绍庆街道', NULL, NULL, 29.28523000, 108.16103800, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243003', '2', '靛水街道', NULL, NULL, 29.28510900, 108.08698700, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243101', '2', '保家镇', NULL, NULL, 29.43117100, 108.31416600, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243102', '2', '郁山镇', NULL, NULL, 29.52562000, 108.40949800, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243103', '2', '高谷镇', NULL, NULL, 29.38991900, 108.08038000, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243104', '2', '桑柘镇', NULL, NULL, 29.27591600, 108.40171700, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243105', '2', '鹿角镇', NULL, NULL, 29.13198500, 108.28921200, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243106', '2', '黄家镇', NULL, NULL, 29.12436500, 108.05923000, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243107', '2', '普子镇', NULL, NULL, 29.62868900, 108.32906600, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243108', '2', '龙射镇', NULL, NULL, 29.52922500, 108.21621500, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243109', '2', '连湖镇', NULL, NULL, 29.69622600, 108.44035600, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243110', '2', '万足镇', NULL, NULL, 29.21013000, 108.21711200, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243111', '2', '新田镇', NULL, NULL, 29.19529600, 108.27621400, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243112', '2', '鞍子镇', NULL, NULL, 29.12661900, 108.47135000, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243113', '2', '平安镇', NULL, NULL, 29.46593800, 108.14813100, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243114', '2', '长生镇', NULL, NULL, 29.35465900, 108.32389400, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243115', '2', '梅子垭镇', NULL, NULL, 29.15729100, 108.52175600, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243116', '2', '太原镇', NULL, NULL, 29.69405400, 108.28104000, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243117', '2', '龙溪镇', NULL, NULL, 29.46675400, 108.51986400, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243118', '2', '大同镇', NULL, NULL, 29.33969700, 108.51810800, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243201', '2', '岩东乡', NULL, NULL, 29.28392700, 108.24268500, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243202', '2', '鹿鸣乡', NULL, NULL, 29.44403600, 108.09060000, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243204', '2', '棣棠乡', NULL, NULL, 29.60275200, 108.22210200, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243206', '2', '三义乡', NULL, NULL, 29.72444100, 108.38373400, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243207', '2', '联合乡', NULL, NULL, 29.59134900, 108.43192000, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243208', '2', '石柳乡', NULL, NULL, 29.60977200, 108.46201000, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243210', '2', '走马乡', NULL, NULL, 29.42431900, 108.46409200, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243211', '2', '芦塘乡', NULL, NULL, 29.51546600, 108.33523100, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243213', '2', '乔梓乡', NULL, NULL, 29.41028700, 108.39403300, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243217', '2', '诸佛乡', NULL, NULL, 29.21863600, 108.50090000, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243219', '2', '桐楼乡', NULL, NULL, 29.28618200, 108.55610800, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243222', '2', '善感乡', NULL, NULL, 29.08156900, 108.35496500, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243223', '2', '双龙乡', NULL, NULL, 29.07470900, 108.23930900, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243224', '2', '石盘乡', NULL, NULL, 29.13650700, 108.20832400, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243225', '2', '大垭乡', NULL, NULL, 29.02271700, 107.88838400, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243226', '2', '润溪乡', NULL, NULL, 29.07360800, 107.92153900, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243227', '2', '朗溪乡', NULL, NULL, 29.07494800, 108.14018300, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('500243228', '2', '龙塘乡', NULL, NULL, 29.06575800, 107.99120700, '500243');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510000', '0', '四川省', '四川', 'si,chuan', 30.65169600, 104.07645200, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510100', '1', '成都市', '成都', 'cheng,du', 30.57296100, 104.06630100, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510104', '2', '锦江区', NULL, NULL, 30.59872600, 104.11726200, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510105', '2', '青羊区', NULL, NULL, 30.67458300, 104.06241500, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510106', '2', '金牛区', NULL, NULL, 30.69129900, 104.05172800, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510107', '2', '武侯区', NULL, NULL, 30.64184900, 104.04324600, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510108', '2', '成华区', NULL, NULL, 30.65996600, 104.10145200, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510112', '2', '龙泉驿区', NULL, NULL, 30.55680800, 104.27536000, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510113', '2', '青白江区', NULL, NULL, 30.87860000, 104.25134200, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510114', '2', '新都区', NULL, NULL, 30.82350700, 104.15858200, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510115', '2', '温江区', NULL, NULL, 30.68195600, 103.85642300, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510116', '2', '双流区', NULL, NULL, 30.57488400, 103.92342000, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510117', '2', '郫都区', NULL, NULL, 30.79511300, 103.90048600, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510118', '2', '新津区', NULL, NULL, 30.41040400, 103.81090600, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510121', '2', '金堂县', NULL, NULL, 30.86203000, 104.41187100, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510129', '2', '大邑县', NULL, NULL, 30.57300400, 103.51226000, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510131', '2', '蒲江县', NULL, NULL, 30.19755800, 103.50647800, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510181', '2', '都江堰市', NULL, NULL, 30.98876300, 103.64719300, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510182', '2', '彭州市', NULL, NULL, 30.99046300, 103.95770600, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510183', '2', '邛崃市', NULL, NULL, 30.41029000, 103.46417600, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510184', '2', '崇州市', NULL, NULL, 30.63018300, 103.67302500, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510185', '2', '简阳市', NULL, NULL, 30.41093700, 104.54764400, '510100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510300', '1', '自贡市', '自贡', 'zi,gong', 29.33924000, 104.77930700, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510302', '2', '自流井区', NULL, NULL, 29.33736100, 104.77714900, '510300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510303', '2', '贡井区', NULL, NULL, 29.34548100, 104.71529400, '510300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510304', '2', '大安区', NULL, NULL, 29.36371000, 104.77398200, '510300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510311', '2', '沿滩区', NULL, NULL, 29.27208000, 104.87382600, '510300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510321', '2', '荣县', NULL, NULL, 29.44546100, 104.41743800, '510300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510322', '2', '富顺县', NULL, NULL, 29.18177900, 104.97519300, '510300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510400', '1', '攀枝花市', '攀枝花', 'pan,zhi,hua', 26.58241700, 101.71846000, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510402', '2', '东区', NULL, NULL, 26.54648400, 101.70412900, '510400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510403', '2', '西区', NULL, NULL, 26.59770000, 101.63055700, '510400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510411', '2', '仁和区', NULL, NULL, 26.49779600, 101.73861500, '510400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510421', '2', '米易县', NULL, NULL, 26.89627100, 102.11115700, '510400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510422', '2', '盐边县', NULL, NULL, 26.68261100, 101.85402700, '510400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510500', '1', '泸州市', '泸州', 'lu,zhou', 28.87098000, 105.44186600, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510502', '2', '江阳区', NULL, NULL, 28.87875300, 105.43499200, '510500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510503', '2', '纳溪区', NULL, NULL, 28.77288800, 105.37132400, '510500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510504', '2', '龙马潭区', NULL, NULL, 28.91307500, 105.43802000, '510500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510521', '2', '泸县', NULL, NULL, 29.15160000, 105.38187900, '510500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510522', '2', '合江县', NULL, NULL, 28.81127800, 105.83101100, '510500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510524', '2', '叙永县', NULL, NULL, 28.15561400, 105.44499000, '510500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510525', '2', '古蔺县', NULL, NULL, 28.03851400, 105.81296500, '510500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510600', '1', '德阳市', '德阳', 'de,yang', 31.12744900, 104.39779500, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510603', '2', '旌阳区', NULL, NULL, 31.14333500, 104.41706100, '510600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510604', '2', '罗江区', NULL, NULL, 31.31738800, 104.51045700, '510600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510623', '2', '中江县', NULL, NULL, 31.03327000, 104.67860100, '510600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510681', '2', '广汉市', NULL, NULL, 30.97726400, 104.28220400, '510600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510682', '2', '什邡市', NULL, NULL, 31.12731100, 104.16700400, '510600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510683', '2', '绵竹市', NULL, NULL, 31.33925100, 104.22067900, '510600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510700', '1', '绵阳市', '绵阳', 'mian,yang', 31.46767300, 104.67912700, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510703', '2', '涪城区', NULL, NULL, 31.45519200, 104.75691700, '510700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510704', '2', '游仙区', NULL, NULL, 31.47378800, 104.76613600, '510700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510705', '2', '安州区', NULL, NULL, 31.53431900, 104.56754300, '510700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510722', '2', '三台县', NULL, NULL, 31.09582600, 105.09372200, '510700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510723', '2', '盐亭县', NULL, NULL, 31.20836200, 105.38945300, '510700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510725', '2', '梓潼县', NULL, NULL, 31.64263500, 105.17074600, '510700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510726', '2', '北川羌族自治县', NULL, NULL, 31.61717000, 104.46804700, '510700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510727', '2', '平武县', NULL, NULL, 32.40968400, 104.55548100, '510700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510781', '2', '江油市', NULL, NULL, 31.77857200, 104.74564000, '510700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510800', '1', '广元市', '广元', 'guang,yuan', 32.43577400, 105.84400400, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510802', '2', '利州区', NULL, NULL, 32.43361200, 105.84558100, '510800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510811', '2', '昭化区', NULL, NULL, 32.33305800, 105.95748000, '510800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510812', '2', '朝天区', NULL, NULL, 32.65135200, 105.88284800, '510800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510821', '2', '旺苍县', NULL, NULL, 32.22853500, 106.28995500, '510800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510822', '2', '青川县', NULL, NULL, 32.57582100, 105.23849800, '510800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510823', '2', '剑阁县', NULL, NULL, 32.28828000, 105.52476400, '510800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510824', '2', '苍溪县', NULL, NULL, 31.73182300, 105.93478700, '510800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510900', '1', '遂宁市', '遂宁', 'sui,ning', 30.53268000, 105.59260200, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510903', '2', '船山区', NULL, NULL, 30.52620100, 105.56835900, '510900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510904', '2', '安居区', NULL, NULL, 30.35509100, 105.45636000, '510900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510921', '2', '蓬溪县', NULL, NULL, 30.75763000, 105.70749800, '510900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510923', '2', '大英县', NULL, NULL, 30.59447200, 105.23685200, '510900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('510981', '2', '射洪市', NULL, NULL, 30.87187700, 105.38840600, '510900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511000', '1', '内江市', '内江', 'nei,jiang', 29.58021000, 105.05799200, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511002', '2', '市中区', NULL, NULL, 29.58759000, 105.06759600, '511000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511011', '2', '东兴区', NULL, NULL, 29.59352800, 105.07610700, '511000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511024', '2', '威远县', NULL, NULL, 29.52744800, 104.66911300, '511000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511025', '2', '资中县', NULL, NULL, 29.76341900, 104.85187400, '511000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511083', '2', '隆昌市', NULL, NULL, 29.33973100, 105.28734000, '511000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511100', '1', '乐山市', '乐山', 'le,shan', 29.55227500, 103.76608500, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511102', '2', '市中区', NULL, NULL, 29.55570500, 103.76130000, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511111', '2', '沙湾区', NULL, NULL, 29.41240400, 103.55011800, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511112', '2', '五通桥区', NULL, NULL, 29.40683700, 103.81802400, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511113', '2', '金口河区', NULL, NULL, 29.24435100, 103.07863500, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511123', '2', '犍为县', NULL, NULL, 29.20884300, 103.94869400, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511124', '2', '井研县', NULL, NULL, 29.65177400, 104.06920300, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511126', '2', '夹江县', NULL, NULL, 29.73814300, 103.57131300, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511129', '2', '沐川县', NULL, NULL, 28.95644200, 103.90281200, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511132', '2', '峨边彝族自治县', NULL, NULL, 29.23042600, 103.26204800, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511133', '2', '马边彝族自治县', NULL, NULL, 28.83560600, 103.54616000, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511181', '2', '峨眉山市', NULL, NULL, 29.60172900, 103.48472700, '511100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511300', '1', '南充市', '南充', 'nan,chong', 30.83723500, 106.11056500, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511302', '2', '顺庆区', NULL, NULL, 30.79736600, 106.09232700, '511300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511303', '2', '高坪区', NULL, NULL, 30.78128400, 106.11893100, '511300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511304', '2', '嘉陵区', NULL, NULL, 30.75883100, 106.07208000, '511300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511321', '2', '南部县', NULL, NULL, 31.34825500, 106.03634900, '511300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511322', '2', '营山县', NULL, NULL, 31.07705700, 106.56552400, '511300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511323', '2', '蓬安县', NULL, NULL, 31.02896200, 106.41242900, '511300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511324', '2', '仪陇县', NULL, NULL, 31.27169300, 106.30308200, '511300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511325', '2', '西充县', NULL, NULL, 30.99554600, 105.90089400, '511300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511381', '2', '阆中市', NULL, NULL, 31.55835600, 106.00504600, '511300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511400', '1', '眉山市', '眉山', 'mei,shan', 30.07711300, 103.84841700, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511402', '2', '东坡区', NULL, NULL, 30.04195600, 103.83186800, '511400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511403', '2', '彭山区', NULL, NULL, 30.19327800, 103.87285200, '511400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511421', '2', '仁寿县', NULL, NULL, 29.99563800, 104.13393100, '511400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511423', '2', '洪雅县', NULL, NULL, 29.91582800, 103.36503500, '511400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511424', '2', '丹棱县', NULL, NULL, 30.01527300, 103.51281800, '511400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511425', '2', '青神县', NULL, NULL, 29.83208300, 103.84659000, '511400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511500', '1', '宜宾市', '宜宾', 'yi,bin', 28.75235400, 104.64282600, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511502', '2', '翠屏区', NULL, NULL, 28.76653700, 104.61985300, '511500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511503', '2', '南溪区', NULL, NULL, 28.84636600, 104.96914700, '511500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511504', '2', '叙州区', NULL, NULL, 28.69006800, 104.53324400, '511500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511523', '2', '江安县', NULL, NULL, 28.72379700, 105.06698200, '511500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511524', '2', '长宁县', NULL, NULL, 28.58286600, 104.92064300, '511500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511525', '2', '高县', NULL, NULL, 28.43616600, 104.51774800, '511500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511526', '2', '珙县', NULL, NULL, 28.43951400, 104.70898600, '511500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511527', '2', '筠连县', NULL, NULL, 28.16785700, 104.51173200, '511500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511528', '2', '兴文县', NULL, NULL, 28.30377800, 105.23634600, '511500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511529', '2', '屏山县', NULL, NULL, 28.82848900, 104.34608300, '511500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511600', '1', '广安市', '广安', 'guang,an', 30.45635400, 106.63264700, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511602', '2', '广安区', NULL, NULL, 30.47394800, 106.64161200, '511600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511603', '2', '前锋区', NULL, NULL, 30.49605900, 106.88603900, '511600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511621', '2', '岳池县', NULL, NULL, 30.53891800, 106.43991500, '511600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511622', '2', '武胜县', NULL, NULL, 30.34949300, 106.29594500, '511600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511623', '2', '邻水县', NULL, NULL, 30.33491100, 106.93024200, '511600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511681', '2', '华蓥市', NULL, NULL, 30.39043900, 106.78315100, '511600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511700', '1', '达州市', '达州', 'da,zhou', 31.20927800, 107.46778000, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511702', '2', '通川区', NULL, NULL, 31.21466500, 107.50505300, '511700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511703', '2', '达川区', NULL, NULL, 31.19657300, 107.51173600, '511700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511722', '2', '宣汉县', NULL, NULL, 31.35384500, 107.72719800, '511700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511723', '2', '开江县', NULL, NULL, 31.08294500, 107.86860900, '511700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511724', '2', '大竹县', NULL, NULL, 30.73694900, 107.20472400, '511700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511725', '2', '渠县', NULL, NULL, 30.83700100, 106.97337200, '511700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511781', '2', '万源市', NULL, NULL, 32.08169800, 108.03439300, '511700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511800', '1', '雅安市', '雅安', 'ya,an', 30.00999800, 103.04153800, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511802', '2', '雨城区', NULL, NULL, 30.00571800, 103.03286800, '511800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511803', '2', '名山区', NULL, NULL, 30.07001600, 103.10903400, '511800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511822', '2', '荥经县', NULL, NULL, 29.79325400, 102.84653700, '511800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511823', '2', '汉源县', NULL, NULL, 29.34427500, 102.65041700, '511800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511824', '2', '石棉县', NULL, NULL, 29.23096300, 102.35836400, '511800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511825', '2', '天全县', NULL, NULL, 30.05728000, 102.77174500, '511800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511826', '2', '芦山县', NULL, NULL, 30.14473100, 102.93390900, '511800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511827', '2', '宝兴县', NULL, NULL, 30.38239000, 102.81406000, '511800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511900', '1', '巴中市', '巴中', 'ba,zhong', 31.86785300, 106.74754800, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511902', '2', '巴州区', NULL, NULL, 31.85144500, 106.76876500, '511900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511903', '2', '恩阳区', NULL, NULL, 31.78718600, 106.65438600, '511900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511921', '2', '通江县', NULL, NULL, 31.91170500, 107.24503300, '511900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511922', '2', '南江县', NULL, NULL, 32.34658900, 106.82869700, '511900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('511923', '2', '平昌县', NULL, NULL, 31.56043600, 107.10361300, '511900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('512000', '1', '资阳市', '资阳', 'zi,yang', 30.12923600, 104.62726500, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('512002', '2', '雁江区', NULL, NULL, 30.10777800, 104.67681400, '512000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('512021', '2', '安岳县', NULL, NULL, 30.10362300, 105.35551000, '512000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('512022', '2', '乐至县', NULL, NULL, 30.27541800, 105.01982300, '512000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513200', '1', '阿坝藏族羌族自治州', '阿坝', 'a,ba', 31.89942700, 102.22450400, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513201', '2', '马尔康市', NULL, NULL, 31.90585600, 102.20633500, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513221', '2', '汶川县', NULL, NULL, 31.47687500, 103.59018500, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513222', '2', '理县', NULL, NULL, 31.43585300, 103.16366000, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513223', '2', '茂县', NULL, NULL, 31.68172700, 103.85332000, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513224', '2', '松潘县', NULL, NULL, 32.65568500, 103.60428000, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513225', '2', '九寨沟县', NULL, NULL, 33.25200800, 104.24260000, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513226', '2', '金川县', NULL, NULL, 31.47625000, 102.06382100, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513227', '2', '小金县', NULL, NULL, 30.99582300, 102.36298400, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513228', '2', '黑水县', NULL, NULL, 32.06919600, 102.98740800, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513230', '2', '壤塘县', NULL, NULL, 32.26555300, 100.97854400, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513231', '2', '阿坝县', NULL, NULL, 32.90238700, 101.70654800, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513232', '2', '若尔盖县', NULL, NULL, 33.57850300, 102.96738000, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513233', '2', '红原县', NULL, NULL, 32.79017000, 102.54392800, '513200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513300', '1', '甘孜藏族自治州', '甘孜', 'gan,zi', 30.04952000, 101.96231000, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513301', '2', '康定市', NULL, NULL, 29.99854400, 101.95687000, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513322', '2', '泸定县', NULL, NULL, 29.91410300, 102.23481400, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513323', '2', '丹巴县', NULL, NULL, 30.87861800, 101.89054000, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513324', '2', '九龙县', NULL, NULL, 28.99982200, 101.50706800, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513325', '2', '雅江县', NULL, NULL, 30.03149800, 101.01436600, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513326', '2', '道孚县', NULL, NULL, 30.97948600, 101.12515700, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513327', '2', '炉霍县', NULL, NULL, 31.39065700, 100.67601400, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513328', '2', '甘孜县', NULL, NULL, 31.62273100, 99.99168300, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513329', '2', '新龙县', NULL, NULL, 30.93917000, 100.31156900, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513330', '2', '德格县', NULL, NULL, 31.80600100, 98.58098400, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513331', '2', '白玉县', NULL, NULL, 31.20966900, 98.82402500, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513332', '2', '石渠县', NULL, NULL, 32.97872800, 98.10293800, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513333', '2', '色达县', NULL, NULL, 32.26854100, 100.33301100, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513334', '2', '理塘县', NULL, NULL, 29.99422800, 100.26914500, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513335', '2', '巴塘县', NULL, NULL, 30.00533000, 99.11055500, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513336', '2', '乡城县', NULL, NULL, 28.93108100, 99.79811600, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513337', '2', '稻城县', NULL, NULL, 29.03774700, 100.29687300, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513338', '2', '得荣县', NULL, NULL, 28.71303700, 99.28630000, '513300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513400', '1', '凉山彝族自治州', '凉山', 'liang,shan', 27.88139600, 102.26771300, '510000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513401', '2', '西昌市', NULL, NULL, 27.89441000, 102.26416600, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513402', '2', '会理市', NULL, NULL, 26.65505900, 102.24476700, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513422', '2', '木里藏族自治县', NULL, NULL, 27.92842800, 101.27997800, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513423', '2', '盐源县', NULL, NULL, 27.42259300, 101.50903800, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513424', '2', '德昌县', NULL, NULL, 27.40289100, 102.17534200, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513426', '2', '会东县', NULL, NULL, 26.63474400, 102.57797900, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513427', '2', '宁南县', NULL, NULL, 27.06143100, 102.75158700, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513428', '2', '普格县', NULL, NULL, 27.37641300, 102.54090100, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513429', '2', '布拖县', NULL, NULL, 27.71210000, 102.80915700, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513430', '2', '金阳县', NULL, NULL, 27.69673500, 103.24878600, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513431', '2', '昭觉县', NULL, NULL, 28.01520800, 102.83971000, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513432', '2', '喜德县', NULL, NULL, 28.30642900, 102.41245100, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513433', '2', '冕宁县', NULL, NULL, 28.55023200, 102.17672700, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513434', '2', '越西县', NULL, NULL, 28.63972100, 102.50739600, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513435', '2', '甘洛县', NULL, NULL, 28.95913100, 102.77144100, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513436', '2', '美姑县', NULL, NULL, 28.32833300, 103.13189300, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('513437', '2', '雷波县', NULL, NULL, 28.26320200, 103.57170500, '513400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520000', '0', '贵州省', '贵州', 'gui,zhou', 26.60032800, 106.70525100, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520100', '1', '贵阳市', '贵阳', 'gui,yang', 26.64669400, 106.62820100, '520000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520102', '2', '南明区', NULL, NULL, 26.56805500, 106.71430500, '520100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520103', '2', '云岩区', NULL, NULL, 26.60460400, 106.72439400, '520100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520111', '2', '花溪区', NULL, NULL, 26.40981700, 106.67026000, '520100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520112', '2', '乌当区', NULL, NULL, 26.63091100, 106.75069000, '520100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520113', '2', '白云区', NULL, NULL, 26.67793200, 106.62306900, '520100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520115', '2', '观山湖区', NULL, NULL, 26.61620100, 106.59827500, '520100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520121', '2', '开阳县', NULL, NULL, 27.05782300, 106.96471600, '520100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520122', '2', '息烽县', NULL, NULL, 27.09057000, 106.74075200, '520100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520123', '2', '修文县', NULL, NULL, 26.83604800, 106.59195800, '520100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520181', '2', '清镇市', NULL, NULL, 26.57043500, 106.46868600, '520100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520200', '1', '六盘水市', '六盘水', 'liu,pan,shui', 26.59253800, 104.83035700, '520000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520201', '2', '钟山区', NULL, NULL, 26.57469900, 104.84372300, '520200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520203', '2', '六枝特区', NULL, NULL, 26.20048100, 105.47487500, '520200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520204', '2', '水城区', NULL, NULL, 26.54760400, 104.95787100, '520200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520281', '2', '盘州市', NULL, NULL, 25.70987800, 104.47155400, '520200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520300', '1', '遵义市', '遵义', 'zun,yi', 27.72193100, 107.03192200, '520000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520302', '2', '红花岗区', NULL, NULL, 27.64479300, 106.89359800, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520303', '2', '汇川区', NULL, NULL, 27.74971600, 106.93372700, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520304', '2', '播州区', NULL, NULL, 27.53573500, 106.82908100, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520322', '2', '桐梓县', NULL, NULL, 28.13299100, 106.82466100, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520323', '2', '绥阳县', NULL, NULL, 27.94604900, 107.19132600, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520324', '2', '正安县', NULL, NULL, 28.55350700, 107.45446300, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520325', '2', '道真仡佬族苗族自治县', NULL, NULL, 28.86254800, 107.61307600, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520326', '2', '务川仡佬族苗族自治县', NULL, NULL, 28.56292100, 107.89935300, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520327', '2', '凤冈县', NULL, NULL, 27.95442400, 107.71646000, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520328', '2', '湄潭县', NULL, NULL, 27.74894200, 107.46549200, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520329', '2', '余庆县', NULL, NULL, 27.21479800, 107.90603500, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520330', '2', '习水县', NULL, NULL, 28.33292300, 106.19715000, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520381', '2', '赤水市', NULL, NULL, 28.59076100, 105.69755700, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520382', '2', '仁怀市', NULL, NULL, 27.79188300, 106.40132200, '520300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520400', '1', '安顺市', '安顺', 'an,shun', 26.25310300, 105.94760000, '520000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520402', '2', '西秀区', NULL, NULL, 26.24532900, 105.96522500, '520400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520403', '2', '平坝区', NULL, NULL, 26.40586600, 106.25557200, '520400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520422', '2', '普定县', NULL, NULL, 26.30187600, 105.74315600, '520400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520423', '2', '镇宁布依族苗族自治县', NULL, NULL, 26.05725300, 105.77055100, '520400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520424', '2', '关岭布依族苗族自治县', NULL, NULL, 25.95370600, 105.53822700, '520400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520425', '2', '紫云苗族布依族自治县', NULL, NULL, 25.75067800, 106.08421000, '520400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520500', '1', '毕节市', '毕节', 'bi,jie', 27.28361500, 105.29154400, '520000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520502', '2', '七星关区', NULL, NULL, 27.29830400, 105.30521900, '520500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520521', '2', '大方县', NULL, NULL, 27.14446100, 105.60193200, '520500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520523', '2', '金沙县', NULL, NULL, 27.45860100, 106.22011200, '520500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520524', '2', '织金县', NULL, NULL, 26.66363000, 105.77052400, '520500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520525', '2', '纳雍县', NULL, NULL, 26.77931500, 105.41446700, '520500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520526', '2', '威宁彝族回族苗族自治县', NULL, NULL, 26.87387200, 104.25278700, '520500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520527', '2', '赫章县', NULL, NULL, 27.11790100, 104.72779400, '520500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520581', '2', '黔西市', NULL, NULL, 27.00868100, 106.03227700, '520500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520600', '1', '铜仁市', '铜仁', 'tong,ren', 27.73155500, 109.18952800, '520000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520602', '2', '碧江区', NULL, NULL, 27.81524400, 109.26427100, '520600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520603', '2', '万山区', NULL, NULL, 27.67137400, 109.15337800, '520600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520621', '2', '江口县', NULL, NULL, 27.70488300, 108.84399300, '520600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520622', '2', '玉屏侗族自治县', NULL, NULL, 27.23550200, 108.90666100, '520600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520623', '2', '石阡县', NULL, NULL, 27.51349900, 108.22368600, '520600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520624', '2', '思南县', NULL, NULL, 27.93833400, 108.25324200, '520600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520625', '2', '印江土家族苗族自治县', NULL, NULL, 27.99444200, 108.40963800, '520600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520626', '2', '德江县', NULL, NULL, 28.26402800, 108.12077300, '520600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520627', '2', '沿河土家族自治县', NULL, NULL, 28.56408300, 108.50315200, '520600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('520628', '2', '松桃苗族自治县', NULL, NULL, 28.15427000, 109.20287700, '520600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522300', '1', '黔西南布依族苗族自治州', '黔西南', 'qian,xi,nan', 25.08773300, 104.90641900, '520000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522301', '2', '兴义市', NULL, NULL, 25.10469700, 104.91909100, '522300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522302', '2', '兴仁市', NULL, NULL, 25.43489400, 105.18641700, '522300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522323', '2', '普安县', NULL, NULL, 25.78418900, 104.95305100, '522300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522324', '2', '晴隆县', NULL, NULL, 25.83494300, 105.21888600, '522300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522325', '2', '贞丰县', NULL, NULL, 25.38677400, 105.65014700, '522300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522326', '2', '望谟县', NULL, NULL, 25.17420400, 106.09486400, '522300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522327', '2', '册亨县', NULL, NULL, 24.98371300, 105.81145000, '522300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522328', '2', '安龙县', NULL, NULL, 25.09901400, 105.44270200, '522300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522600', '1', '黔东南苗族侗族自治州', '黔东南', 'qian,dong,nan', 26.58375900, 107.98283800, '520000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522601', '2', '凯里市', NULL, NULL, 26.56620000, 107.98140900, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522622', '2', '黄平县', NULL, NULL, 26.90528000, 107.91665900, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522623', '2', '施秉县', NULL, NULL, 27.03310700, 108.12453100, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522624', '2', '三穗县', NULL, NULL, 26.95335900, 108.67526500, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522625', '2', '镇远县', NULL, NULL, 27.04903300, 108.42953600, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522626', '2', '岑巩县', NULL, NULL, 27.17402400, 108.81585000, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522627', '2', '天柱县', NULL, NULL, 26.90954800, 109.20782600, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522628', '2', '锦屏县', NULL, NULL, 26.67603500, 109.20079500, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522629', '2', '剑河县', NULL, NULL, 26.72841500, 108.44144900, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522630', '2', '台江县', NULL, NULL, 26.66761700, 108.32153400, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522631', '2', '黎平县', NULL, NULL, 26.21298500, 109.12607700, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522632', '2', '榕江县', NULL, NULL, 25.93187300, 108.52164000, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522633', '2', '从江县', NULL, NULL, 25.75463800, 108.90499800, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522634', '2', '雷山县', NULL, NULL, 26.37883000, 108.07798100, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522635', '2', '麻江县', NULL, NULL, 26.49129000, 107.58945500, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522636', '2', '丹寨县', NULL, NULL, 26.19857000, 107.78930100, '522600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522700', '1', '黔南布依族苗族自治州', '黔南', 'qian,nan', 26.25313600, 107.52230300, '520000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522701', '2', '都匀市', NULL, NULL, 26.25945600, 107.51862800, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522702', '2', '福泉市', NULL, NULL, 26.68677300, 107.52037100, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522722', '2', '荔波县', NULL, NULL, 25.42379000, 107.89880900, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522723', '2', '贵定县', NULL, NULL, 26.55709100, 107.23207700, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522725', '2', '瓮安县', NULL, NULL, 27.07838000, 107.47130700, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522726', '2', '独山县', NULL, NULL, 25.86541800, 107.55759100, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522727', '2', '平塘县', NULL, NULL, 25.82239500, 107.32263500, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522728', '2', '罗甸县', NULL, NULL, 25.42550700, 106.75177100, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522729', '2', '长顺县', NULL, NULL, 26.00318700, 106.44057000, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522730', '2', '龙里县', NULL, NULL, 26.45354600, 106.97917700, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522731', '2', '惠水县', NULL, NULL, 26.13243100, 106.65629300, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('522732', '2', '三都水族自治县', NULL, NULL, 25.98357200, 107.86948900, '522700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530000', '0', '云南省', '云南', 'yun,nan', 25.04643200, 102.70937200, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530100', '1', '昆明市', '昆明', 'kun,ming', 24.88149000, 102.83366900, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530102', '2', '五华区', NULL, NULL, 25.04347500, 102.70706300, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530103', '2', '盘龙区', NULL, NULL, 25.11648700, 102.75175600, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530111', '2', '官渡区', NULL, NULL, 24.95028500, 102.74888800, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530112', '2', '西山区', NULL, NULL, 25.03803900, 102.66442600, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530113', '2', '东川区', NULL, NULL, 26.08318900, 103.18830900, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530114', '2', '呈贡区', NULL, NULL, 24.88573800, 102.82210400, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530115', '2', '晋宁区', NULL, NULL, 24.66907700, 102.59532500, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530124', '2', '富民县', NULL, NULL, 25.22183700, 102.49727000, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530125', '2', '宜良县', NULL, NULL, 24.91983000, 103.14167400, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530126', '2', '石林彝族自治县', NULL, NULL, 24.77176100, 103.29053600, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530127', '2', '嵩明县', NULL, NULL, 25.32727300, 103.04338400, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530128', '2', '禄劝彝族苗族自治县', NULL, NULL, 25.55176800, 102.47199300, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530129', '2', '寻甸回族彝族自治县', NULL, NULL, 25.55851200, 103.25621900, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530181', '2', '安宁市', NULL, NULL, 24.91983100, 102.47865000, '530100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530300', '1', '曲靖市', '曲靖', 'qu,jing', 25.49086600, 103.79628800, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530302', '2', '麒麟区', NULL, NULL, 25.49647200, 103.80440600, '530300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530303', '2', '沾益区', NULL, NULL, 25.60135200, 103.82214900, '530300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530304', '2', '马龙区', NULL, NULL, 25.42810200, 103.57845900, '530300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530322', '2', '陆良县', NULL, NULL, 25.03006900, 103.66673200, '530300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530323', '2', '师宗县', NULL, NULL, 24.82247100, 103.98522400, '530300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530324', '2', '罗平县', NULL, NULL, 24.86528300, 104.29705000, '530300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530325', '2', '富源县', NULL, NULL, 25.67421700, 104.25508200, '530300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530326', '2', '会泽县', NULL, NULL, 26.41711600, 103.29715500, '530300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530381', '2', '宣威市', NULL, NULL, 26.21895600, 104.10425500, '530300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530400', '1', '玉溪市', '玉溪', 'yu,xi', 24.34678600, 102.52667300, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530402', '2', '红塔区', NULL, NULL, 24.34131800, 102.54008200, '530400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530403', '2', '江川区', NULL, NULL, 24.29984800, 102.74804800, '530400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530423', '2', '通海县', NULL, NULL, 24.11114000, 102.72553800, '530400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530424', '2', '华宁县', NULL, NULL, 24.19322000, 102.92891400, '530400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530425', '2', '易门县', NULL, NULL, 24.67215600, 102.16194700, '530400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530426', '2', '峨山彝族自治县', NULL, NULL, 24.16892100, 102.40614400, '530400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530427', '2', '新平彝族傣族自治县', NULL, NULL, 24.07039300, 101.99052000, '530400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530428', '2', '元江哈尼族彝族傣族自治县', NULL, NULL, 23.59606800, 101.99813800, '530400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530481', '2', '澄江市', NULL, NULL, 24.67553600, 102.90418100, '530400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530500', '1', '保山市', '保山', 'bao,shan', 25.11201800, 99.16148900, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530502', '2', '隆阳区', NULL, NULL, 25.12113700, 99.16563800, '530500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530521', '2', '施甸县', NULL, NULL, 24.72308400, 99.18919000, '530500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530523', '2', '龙陵县', NULL, NULL, 24.58670300, 98.68941000, '530500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530524', '2', '昌宁县', NULL, NULL, 24.82782400, 99.60450200, '530500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530581', '2', '腾冲市', NULL, NULL, 25.02028300, 98.49027600, '530500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530600', '1', '昭通市', '昭通', 'zhao,tong', 27.33818500, 103.71707800, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530602', '2', '昭阳区', NULL, NULL, 27.32003500, 103.70632300, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530621', '2', '鲁甸县', NULL, NULL, 27.18666800, 103.55796900, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530622', '2', '巧家县', NULL, NULL, 26.89690400, 102.93534300, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530623', '2', '盐津县', NULL, NULL, 28.10831100, 104.23428600, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530624', '2', '大关县', NULL, NULL, 27.74805400, 103.89116400, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530625', '2', '永善县', NULL, NULL, 28.22901800, 103.63756000, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530626', '2', '绥江县', NULL, NULL, 28.59211900, 103.96899500, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530627', '2', '镇雄县', NULL, NULL, 27.44188400, 104.87421900, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530628', '2', '彝良县', NULL, NULL, 27.62427700, 104.05599100, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530629', '2', '威信县', NULL, NULL, 27.84684900, 105.04904600, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530681', '2', '水富市', NULL, NULL, 28.62995100, 104.41596400, '530600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530700', '1', '丽江市', '丽江', 'li,jiang', 26.85516500, 100.22593600, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530702', '2', '古城区', NULL, NULL, 26.87646800, 100.22583000, '530700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530721', '2', '玉龙纳西族自治县', NULL, NULL, 26.82154300, 100.23696100, '530700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530722', '2', '永胜县', NULL, NULL, 26.68421900, 100.75019300, '530700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530723', '2', '华坪县', NULL, NULL, 26.62959800, 101.26537300, '530700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530724', '2', '宁蒗彝族自治县', NULL, NULL, 27.28220700, 100.85108300, '530700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530800', '1', '普洱市', '普洱', 'pu,er', 22.82522900, 100.96601100, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530802', '2', '思茅区', NULL, NULL, 22.78676900, 100.97706900, '530800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530821', '2', '宁洱哈尼族彝族自治县', NULL, NULL, 23.04880900, 101.04574300, '530800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530822', '2', '墨江哈尼族自治县', NULL, NULL, 23.43193600, 101.69250000, '530800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530823', '2', '景东彝族自治县', NULL, NULL, 24.44673100, 100.83387700, '530800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530824', '2', '景谷傣族彝族自治县', NULL, NULL, 23.49698700, 100.70280700, '530800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530825', '2', '镇沅彝族哈尼族拉祜族自治县', NULL, NULL, 24.00412800, 101.10804900, '530800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530826', '2', '江城哈尼族彝族自治县', NULL, NULL, 22.58585800, 101.86234400, '530800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530827', '2', '孟连傣族拉祜族佤族自治县', NULL, NULL, 22.32965500, 99.58407100, '530800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530828', '2', '澜沧拉祜族自治县', NULL, NULL, 22.55656800, 99.93267400, '530800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530829', '2', '西盟佤族自治县', NULL, NULL, 22.64411300, 99.58987600, '530800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530900', '1', '临沧市', '临沧', 'lin,cang', 23.88417500, 100.08883700, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530902', '2', '临翔区', NULL, NULL, 23.89529800, 100.08207300, '530900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530921', '2', '凤庆县', NULL, NULL, 24.58055900, 99.92873000, '530900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530922', '2', '云县', NULL, NULL, 24.44446100, 100.13030000, '530900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530923', '2', '永德县', NULL, NULL, 24.01846300, 99.25870200, '530900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530924', '2', '镇康县', NULL, NULL, 23.76288600, 98.82538900, '530900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530925', '2', '双江拉祜族佤族布朗族傣族自治县', NULL, NULL, 23.47315800, 99.82812100, '530900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530926', '2', '耿马傣族佤族自治县', NULL, NULL, 23.53792300, 99.39729300, '530900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('530927', '2', '沧源佤族自治县', NULL, NULL, 23.14675800, 99.24589400, '530900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532300', '1', '楚雄彝族自治州', '楚雄', 'chu,xiong', 25.04567800, 101.52830400, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532301', '2', '楚雄市', NULL, NULL, 25.03294500, 101.54624200, '532300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532302', '2', '禄丰市', NULL, NULL, 25.15277800, 102.07228100, '532300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532322', '2', '双柏县', NULL, NULL, 24.68881400, 101.64236900, '532300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532323', '2', '牟定县', NULL, NULL, 25.31293900, 101.54689800, '532300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532324', '2', '南华县', NULL, NULL, 25.20018200, 101.28326400, '532300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532325', '2', '姚安县', NULL, NULL, 25.50428700, 101.24163200, '532300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532326', '2', '大姚县', NULL, NULL, 25.72946200, 101.33668300, '532300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532327', '2', '永仁县', NULL, NULL, 26.04952200, 101.66679500, '532300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532328', '2', '元谋县', NULL, NULL, 25.70493900, 101.87457100, '532300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532329', '2', '武定县', NULL, NULL, 25.53073100, 102.40394900, '532300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532500', '1', '红河哈尼族彝族自治州', '红河', 'hong,he', 23.36312900, 103.37487300, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532501', '2', '个旧市', NULL, NULL, 23.38993500, 103.15266300, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532502', '2', '开远市', NULL, NULL, 23.71451800, 103.26690800, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532503', '2', '蒙自市', NULL, NULL, 23.39611100, 103.36493600, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532504', '2', '弥勒市', NULL, NULL, 24.41177400, 103.41481700, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532523', '2', '屏边苗族自治县', NULL, NULL, 22.98673300, 103.67545800, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532524', '2', '建水县', NULL, NULL, 23.63582400, 102.82617800, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532525', '2', '石屏县', NULL, NULL, 23.70570700, 102.49613800, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532527', '2', '泸西县', NULL, NULL, 24.53198100, 103.76615000, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532528', '2', '元阳县', NULL, NULL, 23.21967100, 102.83535800, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532529', '2', '红河县', NULL, NULL, 23.36894600, 102.42056600, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532530', '2', '金平苗族瑶族傣族自治县', NULL, NULL, 22.76977300, 103.22773300, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532531', '2', '绿春县', NULL, NULL, 22.99365400, 102.39265500, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532532', '2', '河口瑶族自治县', NULL, NULL, 22.52943800, 103.93926500, '532500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532600', '1', '文山壮族苗族自治州', '文山', 'wen,shan', 23.40098300, 104.21567000, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532601', '2', '文山市', NULL, NULL, 23.38683000, 104.23323700, '532600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532622', '2', '砚山县', NULL, NULL, 23.60507500, 104.33690500, '532600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532623', '2', '西畴县', NULL, NULL, 23.43770700, 104.67180200, '532600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532624', '2', '麻栗坡县', NULL, NULL, 23.12583700, 104.70273200, '532600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532625', '2', '马关县', NULL, NULL, 23.01310800, 104.39452400, '532600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532626', '2', '丘北县', NULL, NULL, 24.05064000, 104.16671300, '532600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532627', '2', '广南县', NULL, NULL, 24.04637800, 105.05507500, '532600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532628', '2', '富宁县', NULL, NULL, 23.62507200, 105.63092100, '532600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532800', '1', '西双版纳傣族自治州', '西双版纳', 'xi,shuang,ban,na', 22.00903700, 100.79700200, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532801', '2', '景洪市', NULL, NULL, 22.01179200, 100.79959500, '532800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532822', '2', '勐海县', NULL, NULL, 21.95732300, 100.45244400, '532800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532823', '2', '勐腊县', NULL, NULL, 21.46058100, 101.56503300, '532800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532900', '1', '大理白族自治州', '大理', 'da,li', 25.60654800, 100.26760800, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532901', '2', '大理市', NULL, NULL, 25.67846600, 100.30161400, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532922', '2', '漾濞彝族自治县', NULL, NULL, 25.67005900, 99.95796500, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532923', '2', '祥云县', NULL, NULL, 25.48372700, 100.54996100, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532924', '2', '宾川县', NULL, NULL, 25.83049100, 100.59027400, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532925', '2', '弥渡县', NULL, NULL, 25.34377800, 100.49103800, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532926', '2', '南涧彝族自治县', NULL, NULL, 25.03266300, 100.51076700, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532927', '2', '巍山彝族回族自治县', NULL, NULL, 25.22706500, 100.30697700, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532928', '2', '永平县', NULL, NULL, 25.46413400, 99.54063000, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532929', '2', '云龙县', NULL, NULL, 25.88527800, 99.37021600, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532930', '2', '洱源县', NULL, NULL, 26.11337000, 99.96229400, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532931', '2', '剑川县', NULL, NULL, 26.53688900, 99.90504100, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('532932', '2', '鹤庆县', NULL, NULL, 26.56070500, 100.17646900, '532900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533100', '1', '德宏傣族景颇族自治州', '德宏', 'de,hong', 24.43314600, 98.58562100, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533102', '2', '瑞丽市', NULL, NULL, 24.01837700, 97.85542300, '533100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533103', '2', '芒市', NULL, NULL, 24.43372700, 98.58823700, '533100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533122', '2', '梁河县', NULL, NULL, 24.80427500, 98.29658400, '533100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533123', '2', '盈江县', NULL, NULL, 24.69132500, 97.94347400, '533100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533124', '2', '陇川县', NULL, NULL, 24.18253900, 97.79291800, '533100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533300', '1', '怒江傈僳族自治州', '怒江', 'nu,jiang', 25.81755500, 98.85660000, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533301', '2', '泸水市', NULL, NULL, 25.82257900, 98.85772300, '533300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533323', '2', '福贡县', NULL, NULL, 26.90183100, 98.86913200, '533300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533324', '2', '贡山独龙族怒族自治县', NULL, NULL, 27.74083900, 98.66627900, '533300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533325', '2', '兰坪白族普米族自治县', NULL, NULL, 26.45373500, 99.41645800, '533300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533400', '1', '迪庆藏族自治州', '迪庆', 'di,qing', 27.81914900, 99.70211000, '530000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533401', '2', '香格里拉市', NULL, NULL, 27.84218500, 99.74358200, '533400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533422', '2', '德钦县', NULL, NULL, 28.46421300, 98.91785100, '533400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('533423', '2', '维西傈僳族自治县', NULL, NULL, 27.16380800, 99.30093700, '533400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540000', '0', '西藏自治区', '西藏', 'xi,zang', 29.64869400, 91.11744900, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540100', '1', '拉萨市', '拉萨', 'la,sa', 29.65349100, 91.17192400, '540000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540102', '2', '城关区', NULL, NULL, 29.65514600, 91.14095900, '540100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540103', '2', '堆龙德庆区', NULL, NULL, 29.64681500, 91.00286600, '540100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540104', '2', '达孜区', NULL, NULL, 29.67017300, 91.34950300, '540100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540121', '2', '林周县', NULL, NULL, 29.89329200, 91.26510500, '540100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540122', '2', '当雄县', NULL, NULL, 30.47173000, 91.10087900, '540100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540123', '2', '尼木县', NULL, NULL, 29.43240700, 90.16472100, '540100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540124', '2', '曲水县', NULL, NULL, 29.35429300, 90.74335500, '540100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540127', '2', '墨竹工卡县', NULL, NULL, 29.76213000, 91.91617400, '540100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540200', '1', '日喀则市', '日喀则', 'ri,ka,ze', 29.26683800, 88.88042300, '540000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540202', '2', '桑珠孜区', NULL, NULL, 29.24772600, 88.89850300, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540221', '2', '南木林县', NULL, NULL, 29.68233100, 89.09924300, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540222', '2', '江孜县', NULL, NULL, 28.91186000, 89.60565400, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540223', '2', '定日县', NULL, NULL, 28.65874300, 87.12612000, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540224', '2', '萨迦县', NULL, NULL, 28.89966400, 88.02167400, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540225', '2', '拉孜县', NULL, NULL, 29.08209400, 87.63674100, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540226', '2', '昂仁县', NULL, NULL, 29.29940800, 87.22759800, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540227', '2', '谢通门县', NULL, NULL, 29.42529500, 88.25585500, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540228', '2', '白朗县', NULL, NULL, 29.10768800, 89.26197700, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540229', '2', '仁布县', NULL, NULL, 29.23140900, 89.84145400, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540230', '2', '康马县', NULL, NULL, 28.55601600, 89.68176900, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540231', '2', '定结县', NULL, NULL, 28.36430200, 87.76584000, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540232', '2', '仲巴县', NULL, NULL, 29.77006800, 84.03152100, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540233', '2', '亚东县', NULL, NULL, 27.48621000, 88.90715000, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540234', '2', '吉隆县', NULL, NULL, 28.85186000, 85.29742800, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540235', '2', '聂拉木县', NULL, NULL, 28.15527800, 85.98198700, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540236', '2', '萨嘎县', NULL, NULL, 29.32881800, 85.23294100, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540237', '2', '岗巴县', NULL, NULL, 28.27180500, 88.51556600, '540200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540300', '1', '昌都市', '昌都', 'chang,du', 31.14287900, 97.17042500, '540000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540302', '2', '卡若区', NULL, NULL, 31.11208700, 97.19602100, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540321', '2', '江达县', NULL, NULL, 31.49917600, 98.21833600, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540322', '2', '贡觉县', NULL, NULL, 30.86011700, 98.27143500, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540323', '2', '类乌齐县', NULL, NULL, 31.21137800, 96.59938600, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540324', '2', '丁青县', NULL, NULL, 31.40989000, 95.61854000, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540325', '2', '察雅县', NULL, NULL, 30.65399200, 97.56843300, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540326', '2', '八宿县', NULL, NULL, 30.05320900, 96.91783600, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540327', '2', '左贡县', NULL, NULL, 29.67148800, 97.84117600, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540328', '2', '芒康县', NULL, NULL, 29.67995700, 98.59349300, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540329', '2', '洛隆县', NULL, NULL, 30.74206300, 95.82507200, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540330', '2', '边坝县', NULL, NULL, 30.93402600, 94.70780300, '540300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540400', '1', '林芝市', '林芝', 'lin,zhi', 29.64875000, 94.36143600, '540000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540402', '2', '巴宜区', NULL, NULL, 29.63646700, 94.36110800, '540400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540421', '2', '工布江达县', NULL, NULL, 29.88591100, 93.24636900, '540400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540422', '2', '米林县', NULL, NULL, 29.42506400, 94.50006600, '540400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540423', '2', '墨脱县', NULL, NULL, 29.32542500, 95.33210800, '540400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540424', '2', '波密县', NULL, NULL, 29.85975100, 95.76843900, '540400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540425', '2', '察隅县', NULL, NULL, 28.66128000, 97.46691900, '540400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540426', '2', '朗县', NULL, NULL, 29.04633700, 93.07470200, '540400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540500', '1', '山南市', '山南', 'shan,nan', 29.23772200, 91.77142600, '540000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540502', '2', '乃东区', NULL, NULL, 29.22542700, 91.76104600, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540521', '2', '扎囊县', NULL, NULL, 29.24484500, 91.33788900, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540522', '2', '贡嘎县', NULL, NULL, 29.29016900, 90.97842500, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540523', '2', '桑日县', NULL, NULL, 29.26019500, 92.01787200, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540524', '2', '琼结县', NULL, NULL, 29.02449200, 91.68430700, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540525', '2', '曲松县', NULL, NULL, 29.06282600, 92.20373800, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540526', '2', '措美县', NULL, NULL, 28.43835900, 91.43308900, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540527', '2', '洛扎县', NULL, NULL, 28.38612300, 90.85990300, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540528', '2', '加查县', NULL, NULL, 29.14035500, 92.59270100, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540529', '2', '隆子县', NULL, NULL, 28.40683500, 92.46156900, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540530', '2', '错那县', NULL, NULL, 27.99112100, 91.95715500, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540531', '2', '浪卡子县', NULL, NULL, 28.96707200, 90.40002400, '540500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540600', '1', '那曲市', '那曲', 'na,qu', 31.47790500, 92.05151000, '540000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540602', '2', '色尼区', NULL, NULL, 31.46964500, 92.05349800, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540621', '2', '嘉黎县', NULL, NULL, 30.64157700, 93.23238500, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540622', '2', '比如县', NULL, NULL, 31.47791400, 93.68130200, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540623', '2', '聂荣县', NULL, NULL, 32.10775000, 92.30337700, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540624', '2', '安多县', NULL, NULL, 32.26501600, 91.68195000, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540625', '2', '申扎县', NULL, NULL, 30.93045000, 88.70993600, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540626', '2', '索县', NULL, NULL, 31.88804500, 93.78506800, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540627', '2', '班戈县', NULL, NULL, 31.39215700, 90.00982200, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540628', '2', '巴青县', NULL, NULL, 31.91847000, 94.05343800, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540629', '2', '尼玛县', NULL, NULL, 31.78460500, 87.23649400, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('540630', '2', '双湖县', NULL, NULL, 33.18835500, 88.83801700, '540600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('542500', '1', '阿里地区', '阿里', 'a,li', 32.50098700, 80.10578600, '540000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('542521', '2', '普兰县', NULL, NULL, 30.29021000, 81.17718500, '542500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('542522', '2', '札达县', NULL, NULL, 31.48016400, 79.80713600, '542500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('542523', '2', '噶尔县', NULL, NULL, 32.49207800, 80.09659100, '542500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('542524', '2', '日土县', NULL, NULL, 33.38201700, 79.73355200, '542500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('542525', '2', '革吉县', NULL, NULL, 32.38679200, 81.14547000, '542500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('542526', '2', '改则县', NULL, NULL, 32.30314800, 84.06261200, '542500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('542527', '2', '措勤县', NULL, NULL, 31.01705100, 85.15219000, '542500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610000', '0', '陕西省', '陕西', 'shan,xi', 34.26661100, 108.95393900, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610100', '1', '西安市', '西安', 'xi,an', 34.34320700, 108.93964500, '610000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610102', '2', '新城区', NULL, NULL, 34.26659800, 108.96070700, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610103', '2', '碑林区', NULL, NULL, 34.25672700, 108.94068100, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610104', '2', '莲湖区', NULL, NULL, 34.26535000, 108.94416100, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610111', '2', '灞桥区', NULL, NULL, 34.27311100, 109.06467500, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610112', '2', '未央区', NULL, NULL, 34.29310900, 108.94666500, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610113', '2', '雁塔区', NULL, NULL, 34.21432800, 108.94466900, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610114', '2', '阎良区', NULL, NULL, 34.66205100, 109.22539400, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610115', '2', '临潼区', NULL, NULL, 34.36718100, 109.21424900, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610116', '2', '长安区', NULL, NULL, 34.15866800, 108.90694400, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610117', '2', '高陵区', NULL, NULL, 34.53502000, 109.08826900, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610118', '2', '鄠邑区', NULL, NULL, 34.10870700, 108.60477200, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610122', '2', '蓝田县', NULL, NULL, 34.15198300, 109.32329400, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610124', '2', '周至县', NULL, NULL, 34.16359200, 108.22221900, '610100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610200', '1', '铜川市', '铜川', 'tong,chuan', 34.89713300, 108.94511600, '610000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610202', '2', '王益区', NULL, NULL, 35.06942300, 109.07560500, '610200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610203', '2', '印台区', NULL, NULL, 35.11454000, 109.09984800, '610200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610204', '2', '耀州区', NULL, NULL, 34.91005700, 108.97991200, '610200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610222', '2', '宜君县', NULL, NULL, 35.39862400, 109.11706300, '610200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610300', '1', '宝鸡市', '宝鸡', 'bao,ji', 34.36286200, 107.23768200, '610000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610302', '2', '渭滨区', NULL, NULL, 34.35485300, 107.15524200, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610303', '2', '金台区', NULL, NULL, 34.39709600, 107.23277600, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610304', '2', '陈仓区', NULL, NULL, 34.35073000, 107.36899300, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610305', '2', '凤翔区', NULL, NULL, 34.52216700, 107.40102900, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610323', '2', '岐山县', NULL, NULL, 34.44373000, 107.62139700, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610324', '2', '扶风县', NULL, NULL, 34.37563600, 107.90015700, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610326', '2', '眉县', NULL, NULL, 34.27477400, 107.75003900, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610327', '2', '陇县', NULL, NULL, 34.89405400, 106.86419200, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610328', '2', '千阳县', NULL, NULL, 34.64237400, 107.13242100, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610329', '2', '麟游县', NULL, NULL, 34.67811900, 107.79330400, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610330', '2', '凤县', NULL, NULL, 33.91079700, 106.51584100, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610331', '2', '太白县', NULL, NULL, 34.05902700, 107.31927300, '610300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610400', '1', '咸阳市', '咸阳', 'xian,yang', 34.32989600, 108.70883700, '610000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610402', '2', '秦都区', NULL, NULL, 34.32947800, 108.70634700, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610403', '2', '杨陵区', NULL, NULL, 34.27264300, 108.08464700, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610404', '2', '渭城区', NULL, NULL, 34.36202000, 108.73706200, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610422', '2', '三原县', NULL, NULL, 34.61728200, 108.94075400, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610423', '2', '泾阳县', NULL, NULL, 34.52655700, 108.84302900, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610424', '2', '乾县', NULL, NULL, 34.52826200, 108.23931600, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610425', '2', '礼泉县', NULL, NULL, 34.48187500, 108.42468200, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610426', '2', '永寿县', NULL, NULL, 34.69239700, 108.14158800, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610428', '2', '长武县', NULL, NULL, 35.20627300, 107.79906000, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610429', '2', '旬邑县', NULL, NULL, 35.11255500, 108.33342700, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610430', '2', '淳化县', NULL, NULL, 34.79891900, 108.58020800, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610431', '2', '武功县', NULL, NULL, 34.26102600, 108.20027500, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610481', '2', '兴平市', NULL, NULL, 34.30004400, 108.49026200, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610482', '2', '彬州市', NULL, NULL, 35.03570200, 108.08189200, '610400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610500', '1', '渭南市', '渭南', 'wei,nan', 34.52063200, 109.47096200, '610000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610502', '2', '临渭区', NULL, NULL, 34.49890200, 109.51005100, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610503', '2', '华州区', NULL, NULL, 34.49701900, 109.77576500, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610522', '2', '潼关县', NULL, NULL, 34.54506400, 110.24612600, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610523', '2', '大荔县', NULL, NULL, 34.79707300, 109.94178400, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610524', '2', '合阳县', NULL, NULL, 35.23788100, 110.14941200, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610525', '2', '澄城县', NULL, NULL, 35.19025600, 109.93243900, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610526', '2', '蒲城县', NULL, NULL, 34.95575500, 109.58626300, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610527', '2', '白水县', NULL, NULL, 35.17749700, 109.59050100, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610528', '2', '富平县', NULL, NULL, 34.75159900, 109.17990300, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610581', '2', '韩城市', NULL, NULL, 35.47714500, 110.44295000, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610582', '2', '华阴市', NULL, NULL, 34.56655200, 110.09228600, '610500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610600', '1', '延安市', '延安', 'yan,an', 36.65010900, 109.49468000, '610000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610602', '2', '宝塔区', NULL, NULL, 36.58538800, 109.48933000, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610603', '2', '安塞区', NULL, NULL, 36.86457100, 109.32923600, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610621', '2', '延长县', NULL, NULL, 36.57975800, 110.01215000, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610622', '2', '延川县', NULL, NULL, 36.87804800, 110.19334100, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610625', '2', '志丹县', NULL, NULL, 36.82223200, 108.76781600, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610626', '2', '吴起县', NULL, NULL, 36.92746000, 108.17650100, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610627', '2', '甘泉县', NULL, NULL, 36.27664500, 109.35104600, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610628', '2', '富县', NULL, NULL, 35.98811100, 109.37884000, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610629', '2', '洛川县', NULL, NULL, 35.76262600, 109.43249000, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610630', '2', '宜川县', NULL, NULL, 36.05049400, 110.16843200, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610631', '2', '黄龙县', NULL, NULL, 35.58465500, 109.84029000, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610632', '2', '黄陵县', NULL, NULL, 35.57942100, 109.26291900, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610681', '2', '子长市', NULL, NULL, 37.14246200, 109.67528400, '610600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610700', '1', '汉中市', '汉中', 'han,zhong', 33.06637300, 107.02319000, '610000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610702', '2', '汉台区', NULL, NULL, 33.06752300, 107.03201000, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610703', '2', '南郑区', NULL, NULL, 33.00003400, 106.93623500, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610722', '2', '城固县', NULL, NULL, 33.15693700, 107.33378700, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610723', '2', '洋县', NULL, NULL, 33.22335700, 107.54587200, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610724', '2', '西乡县', NULL, NULL, 32.98328200, 107.76647700, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610725', '2', '勉县', NULL, NULL, 33.15285400, 106.67332000, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610726', '2', '宁强县', NULL, NULL, 32.83003200, 106.25763600, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610727', '2', '略阳县', NULL, NULL, 33.32744400, 106.15703600, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610728', '2', '镇巴县', NULL, NULL, 32.53718600, 107.89460600, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610729', '2', '留坝县', NULL, NULL, 33.61763700, 106.92078100, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610730', '2', '佛坪县', NULL, NULL, 33.52431300, 107.99086800, '610700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610800', '1', '榆林市', '榆林', 'yu,lin', 38.28576000, 109.73410400, '610000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610802', '2', '榆阳区', NULL, NULL, 38.27707800, 109.72054000, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610803', '2', '横山区', NULL, NULL, 37.96248900, 109.29392900, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610822', '2', '府谷县', NULL, NULL, 39.01565800, 111.01643100, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610824', '2', '靖边县', NULL, NULL, 37.60035100, 108.79415300, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610825', '2', '定边县', NULL, NULL, 37.59497600, 107.60104800, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610826', '2', '绥德县', NULL, NULL, 37.50298400, 110.26322600, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610827', '2', '米脂县', NULL, NULL, 37.75513400, 110.18398400, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610828', '2', '佳县', NULL, NULL, 38.01956200, 110.49138700, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610829', '2', '吴堡县', NULL, NULL, 37.45212100, 110.73964500, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610830', '2', '清涧县', NULL, NULL, 37.08901100, 110.12109600, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610831', '2', '子洲县', NULL, NULL, 37.61055400, 110.03512400, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610881', '2', '神木市', NULL, NULL, 38.89974200, 110.46686700, '610800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610900', '1', '安康市', '安康', 'an,kang', 32.68543500, 109.02901700, '610000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610902', '2', '汉滨区', NULL, NULL, 32.69608300, 109.02711100, '610900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610921', '2', '汉阴县', NULL, NULL, 32.89260700, 108.50814800, '610900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610922', '2', '石泉县', NULL, NULL, 33.03805000, 108.24806100, '610900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610923', '2', '宁陕县', NULL, NULL, 33.31028400, 108.31429900, '610900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610924', '2', '紫阳县', NULL, NULL, 32.52020900, 108.53429100, '610900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610925', '2', '岚皋县', NULL, NULL, 32.30671900, 108.90229000, '610900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610926', '2', '平利县', NULL, NULL, 32.38906100, 109.36191900, '610900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610927', '2', '镇坪县', NULL, NULL, 31.88367200, 109.52687300, '610900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610929', '2', '白河县', NULL, NULL, 32.80901000, 110.11260800, '610900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('610981', '2', '旬阳市', NULL, NULL, 32.83191300, 109.36186200, '610900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('611000', '1', '商洛市', '商洛', 'shang,luo', 33.87335800, 109.91864600, '610000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('611002', '2', '商州区', NULL, NULL, 33.86297900, 109.94145200, '611000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('611021', '2', '洛南县', NULL, NULL, 34.09091900, 110.14831900, '611000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('611022', '2', '丹凤县', NULL, NULL, 33.69625400, 110.32754200, '611000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('611023', '2', '商南县', NULL, NULL, 33.53184400, 110.88127100, '611000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('611024', '2', '山阳县', NULL, NULL, 33.53277100, 109.88160400, '611000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('611025', '2', '镇安县', NULL, NULL, 33.42376400, 109.15283300, '611000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('611026', '2', '柞水县', NULL, NULL, 33.68604800, 109.11400600, '611000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620000', '0', '甘肃省', '甘肃', 'gan,su', 36.06063400, 103.82677700, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620100', '1', '兰州市', '兰州', 'lan,zhou', 36.06079800, 103.83422800, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620102', '2', '城关区', NULL, NULL, 36.05735100, 103.82529700, '620100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620103', '2', '七里河区', NULL, NULL, 36.06624900, 103.78626100, '620100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620104', '2', '西固区', NULL, NULL, 36.08867700, 103.62763800, '620100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620105', '2', '安宁区', NULL, NULL, 36.10449300, 103.71895300, '620100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620111', '2', '红古区', NULL, NULL, 36.34576800, 102.85933800, '620100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620121', '2', '永登县', NULL, NULL, 36.73645700, 103.26027300, '620100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620122', '2', '皋兰县', NULL, NULL, 36.33243400, 103.94734500, '620100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620123', '2', '榆中县', NULL, NULL, 35.84335400, 104.11254100, '620100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620200', '1', '嘉峪关市', '嘉峪关', 'jia,yu,guan', 39.77325000, 98.28820000, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620299', '2', '嘉峪关市', NULL, NULL, 39.77325000, 98.28820000, '620200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620300', '1', '金昌市', '金昌', 'jin,chang', 38.52146800, 102.18797200, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620302', '2', '金川区', NULL, NULL, 38.52058300, 102.19415100, '620300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620321', '2', '永昌县', NULL, NULL, 38.24353400, 101.98464200, '620300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620400', '1', '白银市', '白银', 'bai,yin', 36.54512300, 104.13887200, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620402', '2', '白银区', NULL, NULL, 36.53469000, 104.14956000, '620400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620403', '2', '平川区', NULL, NULL, 36.72849400, 104.82527500, '620400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620421', '2', '靖远县', NULL, NULL, 36.57173600, 104.67620200, '620400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620422', '2', '会宁县', NULL, NULL, 35.69324100, 105.05288300, '620400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620423', '2', '景泰县', NULL, NULL, 37.18351000, 104.06312500, '620400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620500', '1', '天水市', '天水', 'tian,shui', 34.58151400, 105.72482800, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620502', '2', '秦州区', NULL, NULL, 34.58082600, 105.72408400, '620500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620503', '2', '麦积区', NULL, NULL, 34.57114300, 105.88945200, '620500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620521', '2', '清水县', NULL, NULL, 34.74990600, 106.13731800, '620500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620522', '2', '秦安县', NULL, NULL, 34.85919100, 105.67566000, '620500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620523', '2', '甘谷县', NULL, NULL, 34.74544700, 105.34078900, '620500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620524', '2', '武山县', NULL, NULL, 34.72116800, 104.89058000, '620500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620525', '2', '张家川回族自治县', NULL, NULL, 34.98867600, 106.20513000, '620500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620600', '1', '武威市', '武威', 'wu,wei', 37.92898000, 102.63782100, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620602', '2', '凉州区', NULL, NULL, 37.92874800, 102.64186400, '620600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620621', '2', '民勤县', NULL, NULL, 38.62429300, 103.09367100, '620600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620622', '2', '古浪县', NULL, NULL, 37.47088200, 102.89754200, '620600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620623', '2', '天祝藏族自治县', NULL, NULL, 36.97197800, 103.14241600, '620600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620700', '1', '张掖市', '张掖', 'zhang,ye', 38.92476600, 100.44985800, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620702', '2', '甘州区', NULL, NULL, 38.94431500, 100.41532400, '620700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620721', '2', '肃南裕固族自治县', NULL, NULL, 38.83693100, 99.61560100, '620700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620722', '2', '民乐县', NULL, NULL, 38.43031800, 100.81204700, '620700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620723', '2', '临泽县', NULL, NULL, 39.15224000, 100.16433300, '620700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620724', '2', '高台县', NULL, NULL, 39.37829400, 99.81926500, '620700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620725', '2', '山丹县', NULL, NULL, 38.78913700, 101.07419500, '620700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620800', '1', '平凉市', '平凉', 'ping,liang', 35.54241700, 106.66491300, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620802', '2', '崆峒区', NULL, NULL, 35.54288100, 106.67457700, '620800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620821', '2', '泾川县', NULL, NULL, 35.33299200, 107.36760800, '620800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620822', '2', '灵台县', NULL, NULL, 35.06995700, 107.59553500, '620800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620823', '2', '崇信县', NULL, NULL, 35.30572600, 107.02579500, '620800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620825', '2', '庄浪县', NULL, NULL, 35.20266000, 106.03620100, '620800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620826', '2', '静宁县', NULL, NULL, 35.52203500, 105.73216500, '620800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620881', '2', '华亭市', NULL, NULL, 35.20769500, 106.62889900, '620800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620900', '1', '酒泉市', '酒泉', 'jiu,quan', 39.73341600, 98.49432000, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620902', '2', '肃州区', NULL, NULL, 39.74516600, 98.50781500, '620900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620921', '2', '金塔县', NULL, NULL, 39.98396900, 98.90153400, '620900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620922', '2', '瓜州县', NULL, NULL, 40.52045700, 95.78225500, '620900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620923', '2', '肃北蒙古族自治县', NULL, NULL, 39.51215800, 94.87653300, '620900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620924', '2', '阿克塞哈萨克族自治县', NULL, NULL, 39.63394400, 94.34020200, '620900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620981', '2', '玉门市', NULL, NULL, 40.29234400, 97.04561700, '620900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('620982', '2', '敦煌市', NULL, NULL, 40.14206600, 94.66232800, '620900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621000', '1', '庆阳市', '庆阳', 'qing,yang', 35.70945900, 107.64343300, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621002', '2', '西峰区', NULL, NULL, 35.73031800, 107.65056300, '621000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621021', '2', '庆城县', NULL, NULL, 36.01612500, 107.88170600, '621000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621022', '2', '环县', NULL, NULL, 36.56856600, 107.30878800, '621000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621023', '2', '华池县', NULL, NULL, 36.46147400, 107.98972000, '621000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621024', '2', '合水县', NULL, NULL, 35.83421600, 108.02190500, '621000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621025', '2', '正宁县', NULL, NULL, 35.49215800, 108.35996400, '621000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621026', '2', '宁县', NULL, NULL, 35.50925200, 107.91346300, '621000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621027', '2', '镇原县', NULL, NULL, 35.67770500, 107.20088800, '621000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621100', '1', '定西市', '定西', 'ding,xi', 35.60794700, 104.59234200, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621102', '2', '安定区', NULL, NULL, 35.58065000, 104.61058700, '621100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621121', '2', '通渭县', NULL, NULL, 35.21131100, 105.24231200, '621100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621122', '2', '陇西县', NULL, NULL, 35.00449500, 104.63409500, '621100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621123', '2', '渭源县', NULL, NULL, 35.13702800, 104.21509200, '621100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621124', '2', '临洮县', NULL, NULL, 35.39499300, 103.85944600, '621100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621125', '2', '漳县', NULL, NULL, 34.84854000, 104.47172200, '621100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621126', '2', '岷县', NULL, NULL, 34.43833000, 104.03673100, '621100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621200', '1', '陇南市', '陇南', 'long,nan', 33.37017400, 104.96029600, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621202', '2', '武都区', NULL, NULL, 33.40068500, 104.92186100, '621200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621221', '2', '成县', NULL, NULL, 33.75072200, 105.74250800, '621200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621222', '2', '文县', NULL, NULL, 32.94403100, 104.68350000, '621200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621223', '2', '宕昌县', NULL, NULL, 34.04741200, 104.39335500, '621200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621224', '2', '康县', NULL, NULL, 33.32921200, 105.60860900, '621200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621225', '2', '西和县', NULL, NULL, 34.01421500, 105.29875600, '621200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621226', '2', '礼县', NULL, NULL, 34.18958600, 105.17855600, '621200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621227', '2', '徽县', NULL, NULL, 33.76992700, 106.08715600, '621200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('621228', '2', '两当县', NULL, NULL, 33.90895200, 106.30497300, '621200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('622900', '1', '临夏回族自治州', '临夏', 'lin,xia', 35.60179200, 103.21038600, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('622901', '2', '临夏市', NULL, NULL, 35.60468200, 103.24222000, '622900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('622921', '2', '临夏县', NULL, NULL, 35.47872600, 103.04068000, '622900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('622922', '2', '康乐县', NULL, NULL, 35.37029600, 103.70850700, '622900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('622923', '2', '永靖县', NULL, NULL, 35.95830600, 103.28585300, '622900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('622924', '2', '广河县', NULL, NULL, 35.48824800, 103.57558200, '622900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('622925', '2', '和政县', NULL, NULL, 35.42473600, 103.35044900, '622900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('622926', '2', '东乡族自治县', NULL, NULL, 35.66440900, 103.38812200, '622900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('622927', '2', '积石山保安族东乡族撒拉族自治县', NULL, NULL, 35.71766300, 102.87592800, '622900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('623000', '1', '甘南藏族自治州', '甘南', 'gan,nan', 34.98326600, 102.91173600, '620000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('623001', '2', '合作市', NULL, NULL, 35.00022800, 102.91030500, '623000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('623021', '2', '临潭县', NULL, NULL, 34.69300900, 103.35366500, '623000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('623022', '2', '卓尼县', NULL, NULL, 34.58947600, 103.50684900, '623000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('623023', '2', '舟曲县', NULL, NULL, 33.79369500, 104.25154300, '623000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('623024', '2', '迭部县', NULL, NULL, 34.05588800, 103.22173500, '623000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('623025', '2', '玛曲县', NULL, NULL, 33.99814500, 102.07260800, '623000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('623026', '2', '碌曲县', NULL, NULL, 34.59108400, 102.48751200, '623000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('623027', '2', '夏河县', NULL, NULL, 35.20439200, 102.54876100, '623000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630000', '0', '青海省', '青海', 'qing,hai', 36.62253800, 101.78048200, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630100', '1', '西宁市', '西宁', 'xi,ning', 36.61662100, 101.77779500, '630000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630102', '2', '城东区', NULL, NULL, 36.59983200, 101.80380800, '630100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630103', '2', '城中区', NULL, NULL, 36.54554500, 101.70535700, '630100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630104', '2', '城西区', NULL, NULL, 36.62828800, 101.76591500, '630100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630105', '2', '城北区', NULL, NULL, 36.65006400, 101.76630800, '630100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630106', '2', '湟中区', NULL, NULL, 36.50129100, 101.57168300, '630100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630121', '2', '大通回族土族自治县', NULL, NULL, 36.92687200, 101.68550300, '630100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630123', '2', '湟源县', NULL, NULL, 36.68242600, 101.25646400, '630100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630200', '1', '海东市', '海东', 'hai,dong', 36.47386400, 102.41029000, '630000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630202', '2', '乐都区', NULL, NULL, 36.48224200, 102.40161400, '630200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630203', '2', '平安区', NULL, NULL, 36.50013600, 102.10841400, '630200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630222', '2', '民和回族土族自治县', NULL, NULL, 36.32003800, 102.83077500, '630200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630223', '2', '互助土族自治县', NULL, NULL, 36.84460600, 101.95916700, '630200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630224', '2', '化隆回族自治县', NULL, NULL, 36.09612400, 102.26600700, '630200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('630225', '2', '循化撒拉族自治县', NULL, NULL, 35.85107900, 102.48895800, '630200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632200', '1', '海北藏族自治州', '海北', 'hai,bei', 36.95461200, 100.90094400, '630000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632221', '2', '门源回族自治县', NULL, NULL, 37.38875900, 101.61165800, '632200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632222', '2', '祁连县', NULL, NULL, 38.17711200, 100.25321100, '632200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632223', '2', '海晏县', NULL, NULL, 36.89666700, 100.99452100, '632200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632224', '2', '刚察县', NULL, NULL, 37.32509600, 100.14566200, '632200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632300', '1', '黄南藏族自治州', '黄南', 'huang,nan', 35.51931700, 102.01539700, '630000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632301', '2', '同仁市', NULL, NULL, 35.51576900, 102.01866300, '632300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632322', '2', '尖扎县', NULL, NULL, 35.94393300, 102.04043000, '632300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632323', '2', '泽库县', NULL, NULL, 35.03532200, 101.46656500, '632300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632324', '2', '河南蒙古族自治县', NULL, NULL, 34.73477700, 101.61771900, '632300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632500', '1', '海南藏族自治州', '海南', 'hai,nan', 36.29639900, 100.62264700, '630000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632521', '2', '共和县', NULL, NULL, 36.28415800, 100.61940500, '632500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632522', '2', '同德县', NULL, NULL, 35.25429700, 100.57785900, '632500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632523', '2', '贵德县', NULL, NULL, 36.03946900, 101.43378600, '632500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632524', '2', '兴海县', NULL, NULL, 35.58908600, 99.98779900, '632500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632525', '2', '贵南县', NULL, NULL, 35.58723900, 100.74773100, '632500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632600', '1', '果洛藏族自治州', '果洛', 'guo,luo', 34.47217900, 100.24516100, '630000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632621', '2', '玛沁县', NULL, NULL, 34.47751300, 100.23748800, '632600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632622', '2', '班玛县', NULL, NULL, 32.93196500, 100.73616000, '632600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632623', '2', '甘德县', NULL, NULL, 33.96977000, 99.90179600, '632600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632624', '2', '达日县', NULL, NULL, 33.74907200, 99.65196400, '632600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632625', '2', '久治县', NULL, NULL, 33.42947100, 101.48283100, '632600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632626', '2', '玛多县', NULL, NULL, 34.91564500, 98.20921700, '632600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632700', '1', '玉树藏族自治州', '玉树', 'yu,shu', 32.99293400, 97.00918400, '630000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632701', '2', '玉树市', NULL, NULL, 32.99293400, 97.00918400, '632700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632722', '2', '杂多县', NULL, NULL, 32.89356900, 95.30072900, '632700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632723', '2', '称多县', NULL, NULL, 33.37750400, 97.10948700, '632700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632724', '2', '治多县', NULL, NULL, 33.84463100, 95.61904500, '632700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632725', '2', '囊谦县', NULL, NULL, 32.20319300, 96.48953800, '632700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632726', '2', '曲麻莱县', NULL, NULL, 34.13700300, 95.80520900, '632700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632800', '1', '海西蒙古族藏族自治州', '海西', 'hai,xi', 37.34811000, 97.33192000, '630000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632801', '2', '格尔木市', NULL, NULL, 36.40727200, 94.92829300, '632800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632802', '2', '德令哈市', NULL, NULL, 37.36986500, 97.36152800, '632800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632803', '2', '茫崖市', NULL, NULL, 38.24751300, 90.85642900, '632800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632821', '2', '乌兰县', NULL, NULL, 36.94127900, 98.47988000, '632800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632822', '2', '都兰县', NULL, NULL, 36.30358300, 98.10320000, '632800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632823', '2', '天峻县', NULL, NULL, 37.30177000, 99.02391000, '632800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('632825', '2', '大柴旦行政委员会', NULL, NULL, 37.85265500, 95.36544900, '632800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640000', '0', '宁夏回族自治区', '宁夏', 'ning,xia', 38.47227300, 106.25888900, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640100', '1', '银川市', '银川', 'yin,chuan', 38.48778300, 106.23097700, '640000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640104', '2', '兴庆区', NULL, NULL, 38.47397200, 106.28845200, '640100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640105', '2', '西夏区', NULL, NULL, 38.50232500, 106.16120800, '640100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640106', '2', '金凤区', NULL, NULL, 38.47427700, 106.23933900, '640100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640121', '2', '永宁县', NULL, NULL, 38.27742200, 106.25393700, '640100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640122', '2', '贺兰县', NULL, NULL, 38.57994800, 106.36392700, '640100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640181', '2', '灵武市', NULL, NULL, 38.10245600, 106.33997800, '640100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640200', '1', '石嘴山市', '石嘴山', 'shi,zui,shan', 38.98463200, 106.38279200, '640000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640202', '2', '大武口区', NULL, NULL, 39.01937500, 106.36812800, '640200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640205', '2', '惠农区', NULL, NULL, 39.23929200, 106.78101300, '640200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640221', '2', '平罗县', NULL, NULL, 38.91392300, 106.52341100, '640200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640300', '1', '吴忠市', '吴忠', 'wu,zhong', 37.99775500, 106.19861300, '640000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640302', '2', '利通区', NULL, NULL, 37.98458600, 106.21247900, '640300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640303', '2', '红寺堡区', NULL, NULL, 37.42549400, 106.06216000, '640300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640323', '2', '盐池县', NULL, NULL, 37.78327600, 107.40718400, '640300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640324', '2', '同心县', NULL, NULL, 36.95463500, 105.89541200, '640300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640381', '2', '青铜峡市', NULL, NULL, 38.02157900, 106.07906000, '640300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640400', '1', '固原市', '固原', 'gu,yuan', 36.01628000, 106.24267000, '640000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640402', '2', '原州区', NULL, NULL, 36.00377700, 106.28784000, '640400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640422', '2', '西吉县', NULL, NULL, 35.96388500, 105.72918900, '640400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640423', '2', '隆德县', NULL, NULL, 35.62592000, 106.11132100, '640400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640424', '2', '泾源县', NULL, NULL, 35.49788700, 106.33056900, '640400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640425', '2', '彭阳县', NULL, NULL, 35.86006700, 106.63215100, '640400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640500', '1', '中卫市', '中卫', 'zhong,wei', 37.50018500, 105.19677000, '640000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640502', '2', '沙坡头区', NULL, NULL, 37.51698000, 105.17371500, '640500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640521', '2', '中宁县', NULL, NULL, 37.49209200, 105.68472900, '640500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('640522', '2', '海原县', NULL, NULL, 36.56518900, 105.64344900, '640500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650000', '0', '新疆维吾尔自治区', '新疆', 'xin,jiang', 43.79330100, 87.62857900, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650100', '1', '乌鲁木齐市', '乌鲁木齐', 'wu,lu,mu,qi', 43.82537700, 87.61682400, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650102', '2', '天山区', NULL, NULL, 43.79431200, 87.63198600, '650100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650103', '2', '沙依巴克区', NULL, NULL, 43.80103800, 87.59790000, '650100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650104', '2', '新市区', NULL, NULL, 43.89302300, 87.59268400, '650100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650105', '2', '水磨沟区', NULL, NULL, 43.83271400, 87.64208000, '650100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650106', '2', '头屯河区', NULL, NULL, 43.89869078, 87.37261808, '650100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650107', '2', '达坂城区', NULL, NULL, 43.36407800, 88.31127500, '650100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650109', '2', '米东区', NULL, NULL, 43.97444000, 87.65512200, '650100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650121', '2', '乌鲁木齐县', NULL, NULL, 43.50901600, 87.46425700, '650100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650200', '1', '克拉玛依市', '克拉玛依', 'ke,la,ma,yi', 45.57771200, 84.88923900, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650202', '2', '独山子区', NULL, NULL, 44.32825900, 84.88697500, '650200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650203', '2', '克拉玛依区', NULL, NULL, 45.60268600, 84.86772500, '650200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650204', '2', '白碱滩区', NULL, NULL, 45.68552300, 85.11912300, '650200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650205', '2', '乌尔禾区', NULL, NULL, 46.09278400, 85.68770400, '650200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650400', '1', '吐鲁番市', '吐鲁番', 'tu,lu,fan', 42.95073600, 89.19037400, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650402', '2', '高昌区', NULL, NULL, 42.94272800, 89.18589100, '650400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650421', '2', '鄯善县', NULL, NULL, 42.90067600, 90.24236900, '650400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650422', '2', '托克逊县', NULL, NULL, 42.80245100, 88.64285300, '650400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650500', '1', '哈密市', '哈密', 'ha,mi', 42.81934600, 93.51505300, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650502', '2', '伊州区', NULL, NULL, 42.82737600, 93.51508500, '650500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650521', '2', '巴里坤哈萨克自治县', NULL, NULL, 43.59847200, 93.01677300, '650500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('650522', '2', '伊吾县', NULL, NULL, 43.25497800, 94.69707400, '650500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652300', '1', '昌吉回族自治州', '昌吉', 'chang,ji', 44.01104400, 87.30899500, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652301', '2', '昌吉市', NULL, NULL, 44.01446800, 87.26743200, '652300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652302', '2', '阜康市', NULL, NULL, 44.16452500, 87.95382600, '652300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652323', '2', '呼图壁县', NULL, NULL, 44.17965700, 86.87127800, '652300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652324', '2', '玛纳斯县', NULL, NULL, 44.28460100, 86.20488000, '652300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652325', '2', '奇台县', NULL, NULL, 43.99790500, 89.58565200, '652300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652327', '2', '吉木萨尔县', NULL, NULL, 44.00040400, 89.17969800, '652300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652328', '2', '木垒哈萨克自治县', NULL, NULL, 43.83463100, 90.28601300, '652300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652700', '1', '博尔塔拉蒙古自治州', '博州', 'bo,zhou', 44.90603900, 82.06636300, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652701', '2', '博乐市', NULL, NULL, 44.85388200, 82.05143300, '652700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652702', '2', '阿拉山口市', NULL, NULL, 45.17327400, 82.55460900, '652700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652722', '2', '精河县', NULL, NULL, 44.59920200, 82.89070900, '652700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652723', '2', '温泉县', NULL, NULL, 44.96885700, 81.02482700, '652700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652800', '1', '巴音郭楞蒙古自治州', '巴州', 'ba,zhou', 41.76411500, 86.14529800, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652801', '2', '库尔勒市', NULL, NULL, 41.72607800, 86.17429300, '652800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652822', '2', '轮台县', NULL, NULL, 41.77804300, 84.25150800, '652800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652823', '2', '尉犁县', NULL, NULL, 41.34387100, 86.26161300, '652800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652824', '2', '若羌县', NULL, NULL, 39.02262600, 88.16722600, '652800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652825', '2', '且末县', NULL, NULL, 38.14574900, 85.52961900, '652800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652826', '2', '焉耆回族自治县', NULL, NULL, 42.05950900, 86.57434000, '652800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652827', '2', '和静县', NULL, NULL, 42.32359000, 86.38409200, '652800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652828', '2', '和硕县', NULL, NULL, 42.28361000, 86.87768800, '652800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652829', '2', '博湖县', NULL, NULL, 41.98074500, 86.63211600, '652800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652900', '1', '阿克苏地区', '阿克苏', 'a,ke,su', 41.17440100, 80.25666700, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652901', '2', '阿克苏市', NULL, NULL, 41.17213700, 80.23851700, '652900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652902', '2', '库车市', NULL, NULL, 41.71910400, 82.99876100, '652900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652922', '2', '温宿县', NULL, NULL, 41.27483300, 80.23057700, '652900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652924', '2', '沙雅县', NULL, NULL, 41.22141300, 82.78177400, '652900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652925', '2', '新和县', NULL, NULL, 41.55209700, 82.62037100, '652900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652926', '2', '拜城县', NULL, NULL, 41.79528900, 81.85128900, '652900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652927', '2', '乌什县', NULL, NULL, 41.22291800, 79.22121800, '652900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652928', '2', '阿瓦提县', NULL, NULL, 40.64364700, 80.37505300, '652900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('652929', '2', '柯坪县', NULL, NULL, 40.50164500, 79.05401900, '652900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653000', '1', '克孜勒苏柯尔克孜自治州', '克州', 'ke,zhou', 39.71473400, 76.16732700, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653001', '2', '阿图什市', NULL, NULL, 39.71658600, 76.16753800, '653000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653022', '2', '阿克陶县', NULL, NULL, 39.14778500, 75.94739600, '653000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653023', '2', '阿合奇县', NULL, NULL, 40.93707500, 78.40250800, '653000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653024', '2', '乌恰县', NULL, NULL, 39.72050000, 75.25922800, '653000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653100', '1', '喀什地区', '喀什', 'ka,shi', 39.46823000, 75.99393600, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653101', '2', '喀什市', NULL, NULL, 39.46823000, 75.99393600, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653121', '2', '疏附县', NULL, NULL, 39.37474700, 75.86259400, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653122', '2', '疏勒县', NULL, NULL, 39.40117300, 76.04716900, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653123', '2', '英吉沙县', NULL, NULL, 38.93004900, 76.17551500, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653124', '2', '泽普县', NULL, NULL, 38.18488200, 77.26005800, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653125', '2', '莎车县', NULL, NULL, 38.39090800, 77.22277600, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653126', '2', '叶城县', NULL, NULL, 37.88299400, 77.41366900, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653127', '2', '麦盖提县', NULL, NULL, 38.89898600, 77.60909900, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653128', '2', '岳普湖县', NULL, NULL, 39.22005600, 76.82144600, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653129', '2', '伽师县', NULL, NULL, 39.48876800, 76.72324000, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653130', '2', '巴楚县', NULL, NULL, 39.79923000, 78.54799000, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653131', '2', '塔什库尔干塔吉克自治县', NULL, NULL, 37.77209400, 75.22988900, '653100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653200', '1', '和田地区', '和田', 'he,tian', 37.11224600, 79.91288100, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653201', '2', '和田市', NULL, NULL, 37.11224600, 79.91288100, '653200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653221', '2', '和田县', NULL, NULL, 35.65725429, 79.34043134, '653200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653222', '2', '墨玉县', NULL, NULL, 37.27751800, 79.72843400, '653200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653223', '2', '皮山县', NULL, NULL, 37.57826400, 78.28548000, '653200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653224', '2', '洛浦县', NULL, NULL, 37.06649200, 80.18078900, '653200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653225', '2', '策勒县', NULL, NULL, 36.99785000, 80.80143300, '653200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653226', '2', '于田县', NULL, NULL, 36.85704500, 81.67741100, '653200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('653227', '2', '民丰县', NULL, NULL, 37.06442800, 82.69594600, '653200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654000', '1', '伊犁哈萨克自治州', '伊犁', 'yi,li', 43.91710600, 81.32369100, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654002', '2', '伊宁市', NULL, NULL, 43.90802100, 81.27771500, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654003', '2', '奎屯市', NULL, NULL, 44.42645200, 84.90321600, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654004', '2', '霍尔果斯市', NULL, NULL, 44.21838100, 80.41461400, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654021', '2', '伊宁县', NULL, NULL, 43.97711900, 81.52745000, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654022', '2', '察布查尔锡伯自治县', NULL, NULL, 43.84072600, 81.15133700, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654023', '2', '霍城县', NULL, NULL, 44.05632900, 80.87884500, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654024', '2', '巩留县', NULL, NULL, 43.48313000, 82.23121900, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654025', '2', '新源县', NULL, NULL, 43.43480300, 83.23300200, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654026', '2', '昭苏县', NULL, NULL, 43.15729300, 81.13097400, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654027', '2', '特克斯县', NULL, NULL, 43.21843500, 81.83573200, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654028', '2', '尼勒克县', NULL, NULL, 43.79862700, 82.51188400, '654000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654200', '1', '塔城地区', '塔城', 'ta,cheng', 46.75161900, 82.98694300, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654201', '2', '塔城市', NULL, NULL, 46.75161900, 82.98694300, '654200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654202', '2', '乌苏市', NULL, NULL, 44.41869300, 84.71376200, '654200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654203', '2', '沙湾市', NULL, NULL, 44.32665800, 85.61862800, '654200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654221', '2', '额敏县', NULL, NULL, 46.52554400, 83.62754200, '654200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654224', '2', '托里县', NULL, NULL, 45.94892300, 83.60644800, '654200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654225', '2', '裕民县', NULL, NULL, 46.20104900, 82.98225200, '654200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654226', '2', '和布克赛尔蒙古自治县', NULL, NULL, 46.79356900, 85.72811500, '654200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654300', '1', '阿勒泰地区', '阿勒泰', 'a,le,tai', 47.84523700, 88.14091900, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654301', '2', '阿勒泰市', NULL, NULL, 47.82706400, 88.13194600, '654300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654321', '2', '布尔津县', NULL, NULL, 47.70189200, 86.87504300, '654300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654322', '2', '富蕴县', NULL, NULL, 46.99404600, 89.52546300, '654300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654323', '2', '福海县', NULL, NULL, 47.11216500, 87.48664200, '654300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654324', '2', '哈巴河县', NULL, NULL, 48.06086500, 86.41811700, '654300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654325', '2', '青河县', NULL, NULL, 46.67853200, 90.37515900, '654300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('654326', '2', '吉木乃县', NULL, NULL, 47.44310600, 85.87416300, '654300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659001', '1', '石河子市', '石河子', 'shi,he,zi', 44.30536800, 86.08039700, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659001001', '2', '新城街道', NULL, NULL, 44.29313000, 86.02764200, '659001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659001002', '2', '向阳街道', NULL, NULL, 44.30708500, 86.05324700, '659001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659001003', '2', '红山街道', NULL, NULL, 44.29616900, 86.05202500, '659001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659001004', '2', '老街街道', NULL, NULL, 44.31184200, 86.03155000, '659001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659001005', '2', '东城街道', NULL, NULL, 44.30983500, 86.09181900, '659001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659001100', '2', '北泉镇', NULL, NULL, 44.33384100, 86.01673100, '659001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659001101', '2', '石河子镇', NULL, NULL, 44.28654000, 86.03568900, '659001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659001500', '2', '兵团一五二团', NULL, NULL, 44.21660100, 86.08355900, '659001');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002', '1', '阿拉尔市', '阿拉尔', 'a,la,er', 40.54720500, 81.28053200, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002001', '2', '幸福路街道', NULL, NULL, 40.56686900, 81.29820500, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002002', '2', '金银川路街道', NULL, NULL, 40.54929500, 81.27335600, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002003', '2', '青松路街道', NULL, NULL, 40.54585500, 81.26674500, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002004', '2', '南口街道', NULL, NULL, 40.52317500, 81.27906900, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002201', '2', '托喀依乡', NULL, NULL, 40.53756000, 81.11799500, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002402', '2', '工业园区', NULL, NULL, 40.54746100, 81.25539800, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002500', '2', '兵团七团', NULL, NULL, 40.59403900, 80.68643400, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002501', '2', '兵团八团', NULL, NULL, 40.59190800, 80.85422500, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002503', '2', '兵团十团', NULL, NULL, 40.61146800, 81.33161800, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002504', '2', '兵团十一团', NULL, NULL, 40.62424400, 81.56146500, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002505', '2', '兵团十二团', NULL, NULL, 40.50668300, 81.30129700, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002506', '2', '兵团十三团', NULL, NULL, 40.62708300, 81.50466500, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002507', '2', '兵团十四团', NULL, NULL, 40.55673700, 81.95796600, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002509', '2', '兵团十六团', NULL, NULL, 40.49625600, 80.84657000, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002511', '2', '兵团第一师水利水电工程处', NULL, NULL, 40.54967200, 81.28643000, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002513', '2', '阿拉尔农场', NULL, NULL, 40.53930700, 81.10894800, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659002514', '2', '兵团第一师幸福农场', NULL, NULL, 40.65676400, 81.02699100, '659002');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659003', '1', '图木舒克市', '图木舒克', 'tu,mu,shu,ke', 39.86777600, 79.07496500, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659003001', '2', '齐干却勒街道', NULL, NULL, 39.87446100, 79.09416900, '659003');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659003002', '2', '前海街道', NULL, NULL, 39.85766700, 79.05480300, '659003');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659003003', '2', '永安坝街道', NULL, NULL, 39.84630400, 79.02103600, '659003');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659003504', '2', '兵团四十四团', NULL, NULL, 39.87479100, 79.09933100, '659003');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659003509', '2', '兵团四十九团', NULL, NULL, 39.70238300, 78.91799300, '659003');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659003510', '2', '兵团五十团', NULL, NULL, 39.93325500, 79.50737700, '659003');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659003511', '2', '兵团五十一团', NULL, NULL, 39.97684100, 79.14394400, '659003');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659003513', '2', '兵团五十三团', NULL, NULL, 40.02720100, 79.40853200, '659003');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659003514', '2', '兵团图木舒克市喀拉拜勒镇', NULL, NULL, 39.68624100, 78.87341800, '659003');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659004', '1', '五家渠市', '五家渠', 'wu,jia,qu', 44.16648900, 87.54285200, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659004001', '2', '军垦路街道', NULL, NULL, 44.16647000, 87.51790700, '659004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659004002', '2', '青湖路街道', NULL, NULL, 44.16898900, 87.52665900, '659004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659004003', '2', '人民路街道', NULL, NULL, 44.17594900, 87.55540100, '659004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659004100', '2', '梧桐镇', NULL, NULL, 44.26264700, 87.65114100, '659004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659004101', '2', '蔡家湖镇', NULL, NULL, 44.40731600, 87.53967400, '659004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659004500', '2', '兵团一零一团', NULL, NULL, 44.35108700, 87.51732400, '659004');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659005', '1', '北屯市', '北屯', 'bei,tun', 47.32673300, 87.83441900, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659005100', '2', '北屯镇', NULL, NULL, 47.36356000, 87.80038100, '659005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659005501', '2', '兵团一八八团', NULL, NULL, 47.35464500, 87.79983100, '659005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659005502', '2', '兵团一八七团', NULL, NULL, 47.27454400, 87.99130200, '659005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659005503', '2', '兵团一八三团', NULL, NULL, 47.26371800, 88.09169800, '659005');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659006', '1', '铁门关市', '铁门关', 'tie,men,guan', 41.86299700, 85.67029100, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659006100', '2', '博古其镇', NULL, NULL, 41.79052200, 86.00762900, '659006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659006101', '2', '双丰镇', NULL, NULL, 41.82815400, 85.60860100, '659006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659006501', '2', '兵团二十九团', NULL, NULL, 41.81993000, 85.65961900, '659006');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659007', '1', '双河市', '双河', 'shuang,he', 44.84590600, 82.36790700, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659007501', '2', '兵团八十一团', NULL, NULL, 44.77233700, 82.48533600, '659007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659007502', '2', '兵团八十四团', NULL, NULL, 44.99524700, 82.07360900, '659007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659007504', '2', '兵团八十六团', NULL, NULL, 44.89220800, 82.15110800, '659007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659007505', '2', '兵团八十九团', NULL, NULL, 44.84018600, 82.35610100, '659007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659007506', '2', '兵团九十团', NULL, NULL, 44.81881100, 82.59351700, '659007');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659008', '1', '可克达拉市', '可克达拉', 'ke,ke,da,la', 43.94038100, 80.99415300, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659008408', '2', '都拉塔口岸', NULL, NULL, 43.68107400, 80.63010400, '659008');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659008502', '2', '兵团六十七团', NULL, NULL, 43.79733894, 80.75839107, '659008');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659008503', '2', '兵团六十八团', NULL, NULL, 43.87629400, 81.05199000, '659008');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659008507', '2', '兵团六十三团', NULL, NULL, 43.96614587, 80.54835472, '659008');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659008508', '2', '兵团六十四团', NULL, NULL, 44.12473100, 80.62763600, '659008');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659008509', '2', '兵团六十六团', NULL, NULL, 43.94446100, 81.03959400, '659008');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659009', '1', '昆玉市', '昆玉', 'kun,yu', 37.21537200, 79.27019300, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659009501', '2', '兵团二二四团', NULL, NULL, 37.21061400, 79.29160700, '659009');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659009502', '2', '兵团四十七团', NULL, NULL, 37.51184800, 79.64955400, '659009');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659009503', '2', '兵团皮山农场', NULL, NULL, 37.68643500, 78.45788200, '659009');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659009504', '2', '兵团一牧场', NULL, NULL, 36.26455600, 81.03976000, '659009');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659010', '1', '胡杨河市', '胡杨河', 'hu,yang,he', 44.69289400, 84.82759200, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659010100', '2', '兵团一三零团', NULL, NULL, 44.71310229, 84.82561869, '659010');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659010101', '2', '兵团一二九团', NULL, NULL, 44.89359400, 84.73736900, '659010');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659010102', '2', '兵团一二八团', NULL, NULL, 45.02472000, 84.60467000, '659010');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659011', '1', '新星市', '新星', 'xin,xing', 42.79704300, 93.74831000, '650000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659011500', '2', '红星一场二道湖镇', NULL, NULL, 42.77110400, 93.59225100, '659011');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659011502', '2', '红星四场骆驿镇', NULL, NULL, 42.66600300, 93.95569400, '659011');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('659011503', '2', '黄田农场黄田镇', NULL, NULL, 42.83997400, 93.91900900, '659011');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710000', '0', '台湾省', '台湾', 'tai,wan', 25.03752500, 121.56378200, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710100', '1', '台北市', '台北', 'tai,bei', 25.08290774, 121.55332261, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710101', '2', '中正区', NULL, NULL, 25.03072400, 121.52007600, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710102', '2', '大同区', NULL, NULL, 25.06272900, 121.51392900, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710103', '2', '中山区', NULL, NULL, 25.07470800, 121.54176600, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710104', '2', '松山区', NULL, NULL, 25.05894700, 121.55666800, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710105', '2', '大安区', NULL, NULL, 25.02342000, 121.54648800, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710106', '2', '万华区', NULL, NULL, 25.02993400, 121.49906500, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710107', '2', '信义区', NULL, NULL, 25.02972200, 121.57615000, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710108', '2', '士林区', NULL, NULL, 25.12759300, 121.54446300, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710109', '2', '北投区', NULL, NULL, 25.14910800, 121.52782300, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710110', '2', '内湖区', NULL, NULL, 25.08603600, 121.58651300, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710111', '2', '南港区', NULL, NULL, 25.03250500, 121.61815900, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710112', '2', '文山区', NULL, NULL, 24.98988600, 121.57289500, '710100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710200', '1', '高雄市', '高雄', 'gao,xiong', 22.62043100, 120.31201600, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710201', '2', '新兴区', NULL, NULL, 22.63057600, 120.30683900, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710202', '2', '前金区', NULL, NULL, 22.62641900, 120.29352000, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710203', '2', '苓雅区', NULL, NULL, 22.62401800, 120.32305500, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710204', '2', '盐埕区', NULL, NULL, 22.62560800, 120.28401900, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710205', '2', '鼓山区', NULL, NULL, 22.65180200, 120.27530800, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710206', '2', '旗津区', NULL, NULL, 22.59055100, 120.28319000, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710207', '2', '前镇区', NULL, NULL, 22.59047700, 120.30908000, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710208', '2', '三民区', NULL, NULL, 22.65946100, 120.32088600, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710209', '2', '左营区', NULL, NULL, 22.67906400, 120.29276200, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710210', '2', '楠梓区', NULL, NULL, 22.72573300, 120.31022900, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710211', '2', '小港区', NULL, NULL, 22.55723600, 120.37258400, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710242', '2', '仁武区', NULL, NULL, 22.70354300, 120.36257700, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710243', '2', '大社区', NULL, NULL, 22.74086700, 120.37275700, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710244', '2', '冈山区', NULL, NULL, 22.80618200, 120.30362900, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710245', '2', '路竹区', NULL, NULL, 22.86043600, 120.26761900, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710246', '2', '阿莲区', NULL, NULL, 22.86883000, 120.32213100, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710247', '2', '田寮区', NULL, NULL, 22.86688200, 120.39378600, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710248', '2', '燕巢区', NULL, NULL, 22.78982900, 120.37064900, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710249', '2', '桥头区', NULL, NULL, 22.75213700, 120.30245700, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710250', '2', '梓官区', NULL, NULL, 22.75090500, 120.25881600, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710251', '2', '弥陀区', NULL, NULL, 22.77488900, 120.24153700, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710252', '2', '永安区', NULL, NULL, 22.81883100, 120.23625000, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710253', '2', '湖内区', NULL, NULL, 22.89079400, 120.22796500, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710254', '2', '凤山区', NULL, NULL, 22.61232900, 120.35467800, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710255', '2', '大寮区', NULL, NULL, 22.58793800, 120.39525600, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710256', '2', '林园区', NULL, NULL, 22.51287800, 120.38912800, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710257', '2', '鸟松区', NULL, NULL, 22.66530300, 120.37333100, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710258', '2', '大树区', NULL, NULL, 22.71072300, 120.41331700, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710259', '2', '旗山区', NULL, NULL, 22.89424000, 120.48090300, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710260', '2', '美浓区', NULL, NULL, 22.92820600, 120.56745600, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710261', '2', '六龟区', NULL, NULL, 23.04511200, 120.68185100, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710262', '2', '内门区', NULL, NULL, 22.94310200, 120.47196800, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710263', '2', '杉林区', NULL, NULL, 22.98105300, 120.55994600, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710264', '2', '甲仙区', NULL, NULL, 23.11201300, 120.62032000, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710265', '2', '桃源区', NULL, NULL, 23.16742000, 120.79543800, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710266', '2', '那玛夏区', NULL, NULL, 23.27386100, 120.71957500, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710267', '2', '茂林区', NULL, NULL, 22.91125200, 120.76276700, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710268', '2', '茄萣区', NULL, NULL, 22.88774900, 120.19689400, '710200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710300', '1', '台南市', '台南', 'tai,nan', 23.31168900, 120.31489600, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710301', '2', '中西区', NULL, NULL, 22.99860100, 120.18781700, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710302', '2', '东区', NULL, NULL, 22.98143200, 120.23365400, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710303', '2', '南区', NULL, NULL, 22.94699400, 120.18819400, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710304', '2', '北区', NULL, NULL, 23.00941700, 120.20967900, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710305', '2', '安平区', NULL, NULL, 22.98785700, 120.16196000, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710306', '2', '安南区', NULL, NULL, 23.04967600, 120.17146200, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710339', '2', '永康区', NULL, NULL, 23.02649500, 120.25300700, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710340', '2', '归仁区', NULL, NULL, 22.94841300, 120.29525100, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710341', '2', '新化区', NULL, NULL, 23.03642500, 120.34361100, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710342', '2', '左镇区', NULL, NULL, 23.03317200, 120.40826200, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710343', '2', '玉井区', NULL, NULL, 23.12205100, 120.45423000, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710344', '2', '楠西区', NULL, NULL, 23.17215700, 120.50146500, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710345', '2', '南化区', NULL, NULL, 23.10982700, 120.53257500, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710346', '2', '仁德区', NULL, NULL, 22.94204500, 120.24830900, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710347', '2', '关庙区', NULL, NULL, 22.94903200, 120.33968800, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710348', '2', '龙崎区', NULL, NULL, 22.95622500, 120.38246800, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710349', '2', '官田区', NULL, NULL, 23.19334200, 120.35862000, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710350', '2', '麻豆区', NULL, NULL, 23.18654300, 120.23956200, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710351', '2', '佳里区', NULL, NULL, 23.16780000, 120.17345400, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710352', '2', '西港区', NULL, NULL, 23.12515000, 120.20159900, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710353', '2', '七股区', NULL, NULL, 23.14511700, 120.12461200, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710354', '2', '将军区', NULL, NULL, 23.20457600, 120.12794900, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710355', '2', '学甲区', NULL, NULL, 23.25763600, 120.18466200, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710356', '2', '北门区', NULL, NULL, 23.27984600, 120.13272700, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710357', '2', '新营区', NULL, NULL, 23.31466600, 120.29266100, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710358', '2', '后壁区', NULL, NULL, 23.36247600, 120.34541700, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710359', '2', '白河区', NULL, NULL, 23.34960700, 120.46730700, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710360', '2', '东山区', NULL, NULL, 23.27846100, 120.44630200, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710361', '2', '六甲区', NULL, NULL, 23.22852500, 120.37626600, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710362', '2', '下营区', NULL, NULL, 23.23306900, 120.27606200, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710363', '2', '柳营区', NULL, NULL, 23.25822600, 120.37018200, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710364', '2', '盐水区', NULL, NULL, 23.30485800, 120.25491000, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710365', '2', '善化区', NULL, NULL, 23.12655700, 120.29296700, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710366', '2', '大内区', NULL, NULL, 23.13664900, 120.41223600, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710367', '2', '山上区', NULL, NULL, 23.09402400, 120.37463600, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710368', '2', '新市区', NULL, NULL, 23.08298900, 120.29517100, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710369', '2', '安定区', NULL, NULL, 23.09568400, 120.23485500, '710300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710400', '1', '台中市', '台中', 'tai,zhong', 24.15564900, 120.64844800, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710401', '2', '中区', NULL, NULL, 24.14317100, 120.67988200, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710402', '2', '东区', NULL, NULL, 24.13875300, 120.69765000, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710403', '2', '南区', NULL, NULL, 24.11605400, 120.66544600, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710404', '2', '西区', NULL, NULL, 24.14955900, 120.66703100, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710405', '2', '北区', NULL, NULL, 24.15608500, 120.68176700, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710406', '2', '北屯区', NULL, NULL, 24.18823600, 120.72541500, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710407', '2', '西屯区', NULL, NULL, 24.19092900, 120.63625400, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710408', '2', '南屯区', NULL, NULL, 24.14025900, 120.61600200, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710431', '2', '太平区', NULL, NULL, 24.10642800, 120.77720300, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710432', '2', '大里区', NULL, NULL, 24.09987000, 120.69365700, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710433', '2', '雾峰区', NULL, NULL, 24.04708300, 120.72379100, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710434', '2', '乌日区', NULL, NULL, 24.08097300, 120.64169900, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710435', '2', '丰原区', NULL, NULL, 24.24381900, 120.73431400, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710436', '2', '后里区', NULL, NULL, 24.31981000, 120.72620600, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710437', '2', '石冈区', NULL, NULL, 24.25862300, 120.78941300, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710438', '2', '东势区', NULL, NULL, 24.25932200, 120.83667100, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710439', '2', '和平区', NULL, NULL, 24.24937900, 121.09565600, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710440', '2', '新社区', NULL, NULL, 24.18437200, 120.82726700, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710441', '2', '潭子区', NULL, NULL, 24.21178400, 120.70928800, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710442', '2', '大雅区', NULL, NULL, 24.22515300, 120.65007800, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710443', '2', '神冈区', NULL, NULL, 24.25425100, 120.67999200, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710444', '2', '大肚区', NULL, NULL, 24.14792600, 120.56181900, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710445', '2', '沙鹿区', NULL, NULL, 24.22981800, 120.58434600, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710446', '2', '龙井区', NULL, NULL, 24.20067200, 120.53002200, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710447', '2', '梧栖区', NULL, NULL, 24.24657100, 120.52433100, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710448', '2', '清水区', NULL, NULL, 24.30097800, 120.57491100, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710449', '2', '大甲区', NULL, NULL, 24.37451900, 120.62810200, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710450', '2', '外埔区', NULL, NULL, 24.33458600, 120.68415800, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710451', '2', '大安区', NULL, NULL, 24.35885500, 120.59128700, '710400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710600', '1', '南投县', '南投', 'nan,tou', 23.90267400, 120.69050700, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710614', '2', '南投市', NULL, NULL, 23.91961900, 120.67000800, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710615', '2', '中寮乡', NULL, NULL, 23.92817600, 120.74218900, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710616', '2', '草屯镇', NULL, NULL, 23.98340200, 120.74493200, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710617', '2', '国姓乡', NULL, NULL, 24.06378900, 120.84824200, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710618', '2', '埔里镇', NULL, NULL, 23.96992000, 120.96266900, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710619', '2', '仁爱乡', NULL, NULL, 24.10421500, 121.14536600, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710620', '2', '名间乡', NULL, NULL, 23.84793300, 120.64852300, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710621', '2', '集集镇', NULL, NULL, 23.83760700, 120.74978000, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710622', '2', '水里乡', NULL, NULL, 23.79965700, 120.87962800, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710623', '2', '鱼池乡', NULL, NULL, 23.89565600, 120.93536100, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710624', '2', '信义乡', NULL, NULL, 23.60279700, 121.03622400, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710625', '2', '竹山镇', NULL, NULL, 23.71679800, 120.71768700, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710626', '2', '鹿谷乡', NULL, NULL, 23.72753200, 120.74994500, '710600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710700', '1', '基隆市', '基隆', 'ji,long', 25.12861200, 121.75278900, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710701', '2', '仁爱区', NULL, NULL, 25.12210500, 121.74152600, '710700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710702', '2', '信义区', NULL, NULL, 25.12248100, 121.77229200, '710700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710703', '2', '中正区', NULL, NULL, 25.14090300, 121.78382500, '710700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710704', '2', '中山区', NULL, NULL, 25.14860800, 121.72943000, '710700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710705', '2', '安乐区', NULL, NULL, 25.14401000, 121.71007800, '710700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710706', '2', '暖暖区', NULL, NULL, 25.08110300, 121.74579300, '710700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710707', '2', '七堵区', NULL, NULL, 25.11439800, 121.68191700, '710700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710800', '1', '新竹市', '新竹', 'xin,zhu', 24.80688300, 120.96910000, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710801', '2', '东区', NULL, NULL, 24.78492400, 120.99074500, '710800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710802', '2', '北区', NULL, NULL, 24.81327000, 120.95276700, '710800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710803', '2', '香山区', NULL, NULL, 24.76446500, 120.92949000, '710800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710900', '1', '嘉义市', '嘉义', 'jia,yi', 23.48050151, 120.44805816, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710901', '2', '东区', NULL, NULL, 23.48507900, 120.47246200, '710900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('710902', '2', '西区', NULL, NULL, 23.47703000, 120.42007500, '710900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711000', '1', '台北市', '台北', 'tai,bei', 25.08290774, 121.55332260, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711001', '2', '松山区', NULL, NULL, 25.05894700, 121.55666800, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711002', '2', '大安区', NULL, NULL, 25.02342000, 121.54648800, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711003', '2', '中正区', NULL, NULL, 25.03072400, 121.52007600, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711005', '2', '万华区', NULL, NULL, 25.02993400, 121.49906500, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711009', '2', '大同区', NULL, NULL, 25.06272900, 121.51392900, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711010', '2', '中山区', NULL, NULL, 25.07470800, 121.54176600, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711011', '2', '文山区', NULL, NULL, 24.98988600, 121.57289500, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711013', '2', '南港区', NULL, NULL, 25.03250500, 121.61815900, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711014', '2', '内湖区', NULL, NULL, 25.08603600, 121.58651300, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711015', '2', '士林区', NULL, NULL, 25.12759300, 121.54446300, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711016', '2', '北投区', NULL, NULL, 25.14910800, 121.52782300, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711017', '2', '信义区', NULL, NULL, 25.02972200, 121.57615000, '711000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711100', '1', '台中市', '台中', 'tai,zhong', 24.15564900, 120.64844800, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711101', '2', '中区', NULL, NULL, 24.14317100, 120.67988200, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711102', '2', '东区', NULL, NULL, 24.13875300, 120.69765000, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711103', '2', '西区', NULL, NULL, 24.14955900, 120.66703100, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711104', '2', '南区', NULL, NULL, 24.11605400, 120.66544600, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711105', '2', '北区', NULL, NULL, 24.15608500, 120.68176700, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711106', '2', '西屯区', NULL, NULL, 24.19092900, 120.63625400, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711107', '2', '南屯区', NULL, NULL, 24.14025900, 120.61600200, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711108', '2', '北屯区', NULL, NULL, 24.18823600, 120.72541500, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711130', '2', '万里区', NULL, NULL, 25.18530000, 121.66367500, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711131', '2', '金山区', NULL, NULL, 25.22371700, 121.61428900, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711132', '2', '板桥区', NULL, NULL, 24.99960700, 121.45505200, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711133', '2', '汐止区', NULL, NULL, 25.06850500, 121.65666500, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711134', '2', '深坑区', NULL, NULL, 25.00095000, 121.62531800, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711135', '2', '石碇区', NULL, NULL, 24.96272900, 121.65365500, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711136', '2', '瑞芳区', NULL, NULL, 25.10211000, 121.83440100, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711137', '2', '平溪区', NULL, NULL, 25.01605100, 121.75553900, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711138', '2', '双溪区', NULL, NULL, 24.99623600, 121.83318200, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711139', '2', '贡寮区', NULL, NULL, 25.03419900, 121.92195000, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711140', '2', '新店区', NULL, NULL, 24.93733200, 121.53035000, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711141', '2', '丰原区', NULL, NULL, 24.24381900, 120.73431400, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711142', '2', '东势区', NULL, NULL, 24.25932200, 120.83667100, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711143', '2', '大甲区', NULL, NULL, 24.37451900, 120.62810200, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711144', '2', '清水区', NULL, NULL, 24.30097800, 120.57491100, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711145', '2', '沙鹿区', NULL, NULL, 24.22981800, 120.58434600, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711146', '2', '梧栖区', NULL, NULL, 24.24657100, 120.52433100, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711147', '2', '神冈区', NULL, NULL, 24.25425100, 120.67999200, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711148', '2', '后里区', NULL, NULL, 24.31981000, 120.72620600, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711149', '2', '大雅区', NULL, NULL, 24.22515300, 120.65007800, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711150', '2', '潭子区', NULL, NULL, 24.21178400, 120.70928800, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711151', '2', '新社区', NULL, NULL, 24.18437200, 120.82726700, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711152', '2', '石冈区', NULL, NULL, 24.25862300, 120.78941300, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711153', '2', '外埔区', NULL, NULL, 24.33458600, 120.68415800, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711154', '2', '大安区', NULL, NULL, 24.35885500, 120.59128700, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711155', '2', '乌日区', NULL, NULL, 24.08097300, 120.64169900, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711156', '2', '大肚区', NULL, NULL, 24.14792600, 120.56181900, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711157', '2', '龙井区', NULL, NULL, 24.20067200, 120.53002200, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711158', '2', '雾峰区', NULL, NULL, 24.04708300, 120.72379100, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711159', '2', '太平区', NULL, NULL, 24.10642800, 120.77720300, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711160', '2', '大里区', NULL, NULL, 24.09987000, 120.69365700, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711161', '2', '和平区', NULL, NULL, 24.24937900, 121.09565600, '711100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711200', '1', '基隆市', '基隆', 'ji,long', 25.12861200, 121.75278900, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711201', '2', '中正区', NULL, NULL, 25.14090300, 121.78382500, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711202', '2', '七堵区', NULL, NULL, 25.11439800, 121.68191700, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711203', '2', '暖暖区', NULL, NULL, 25.08110300, 121.74579300, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711204', '2', '仁爱区', NULL, NULL, 25.12210500, 121.74152600, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711205', '2', '中山区', NULL, NULL, 25.14860800, 121.72943000, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711206', '2', '安乐区', NULL, NULL, 25.14401000, 121.71007800, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711207', '2', '信义区', NULL, NULL, 25.12248100, 121.77229200, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711214', '2', '宜兰市', NULL, NULL, 24.75970700, 121.75444200, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711215', '2', '头城镇', NULL, NULL, 24.91128300, 121.85085000, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711216', '2', '礁溪乡', NULL, NULL, 24.80807300, 121.73569300, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711217', '2', '壮围乡', NULL, NULL, 24.76283300, 121.79949500, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711218', '2', '员山乡', NULL, NULL, 24.74132400, 121.66273600, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711219', '2', '罗东镇', NULL, NULL, 24.67835700, 121.77153900, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711220', '2', '三星乡', NULL, NULL, 24.66396400, 121.67005400, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711221', '2', '大同乡', NULL, NULL, 24.56318800, 121.53563700, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711222', '2', '五结乡', NULL, NULL, 24.68218000, 121.79443200, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711223', '2', '冬山乡', NULL, NULL, 24.64404900, 121.75337200, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711224', '2', '苏澳镇', NULL, NULL, 24.55064800, 121.83587700, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711225', '2', '南澳乡', NULL, NULL, 24.46172700, 121.66814800, '711200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711300', '1', '台南市', '台南', 'tai,nan', 23.31168900, 120.31489600, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711301', '2', '东区', NULL, NULL, 22.98143200, 120.23365400, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711302', '2', '南区', NULL, NULL, 22.94699400, 120.18819400, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711304', '2', '北区', NULL, NULL, 23.00941700, 120.20967900, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711306', '2', '安南区', NULL, NULL, 23.04967600, 120.17146200, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711307', '2', '安平区', NULL, NULL, 22.98785700, 120.16196000, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711308', '2', '中西区', NULL, NULL, 22.99860100, 120.18781700, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711314', '2', '竹北市', NULL, NULL, 24.83923300, 121.00201200, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711315', '2', '湖口乡', NULL, NULL, 24.88866000, 121.06023000, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711316', '2', '新丰乡', NULL, NULL, 24.90470600, 120.99771000, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711317', '2', '新埔镇', NULL, NULL, 24.84722200, 121.10569900, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711318', '2', '关西镇', NULL, NULL, 24.78733800, 121.17854400, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711319', '2', '芎林乡', NULL, NULL, 24.76821000, 121.11030100, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711320', '2', '宝山乡', NULL, NULL, 24.73090800, 120.99830300, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711321', '2', '竹东镇', NULL, NULL, 24.73634700, 121.08671400, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711322', '2', '五峰乡', NULL, NULL, 24.58911400, 121.14555200, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711323', '2', '横山乡', NULL, NULL, 24.72127800, 121.15731700, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711324', '2', '尖石乡', NULL, NULL, 24.58162600, 121.28933100, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711325', '2', '北埔乡', NULL, NULL, 24.68932600, 121.06209500, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711326', '2', '峨眉乡', NULL, NULL, 24.68488300, 121.00120300, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711341', '2', '新营区', NULL, NULL, 23.31466600, 120.29266100, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711342', '2', '盐水区', NULL, NULL, 23.30485800, 120.25491000, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711343', '2', '白河区', NULL, NULL, 23.34960700, 120.46730700, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711344', '2', '柳营区', NULL, NULL, 23.25822600, 120.37018200, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711345', '2', '后壁区', NULL, NULL, 23.36247600, 120.34541700, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711346', '2', '东山区', NULL, NULL, 23.27846100, 120.44630200, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711347', '2', '麻豆区', NULL, NULL, 23.18654300, 120.23956200, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711348', '2', '下营区', NULL, NULL, 23.23306900, 120.27606200, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711349', '2', '六甲区', NULL, NULL, 23.22852500, 120.37626600, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711350', '2', '官田区', NULL, NULL, 23.19334200, 120.35862000, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711351', '2', '大内区', NULL, NULL, 23.13664900, 120.41223600, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711352', '2', '佳里区', NULL, NULL, 23.16780000, 120.17345400, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711353', '2', '西港区', NULL, NULL, 23.12515000, 120.20159900, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711354', '2', '七股区', NULL, NULL, 23.14511700, 120.12461200, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711355', '2', '将军区', NULL, NULL, 23.20457600, 120.12794900, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711356', '2', '北门区', NULL, NULL, 23.27984600, 120.13272700, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711357', '2', '学甲区', NULL, NULL, 23.25763600, 120.18466200, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711358', '2', '新化区', NULL, NULL, 23.03642500, 120.34361100, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711359', '2', '善化区', NULL, NULL, 23.12655700, 120.29296700, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711360', '2', '新市区', NULL, NULL, 23.08298900, 120.29517100, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711361', '2', '安定区', NULL, NULL, 23.09568400, 120.23485500, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711362', '2', '山上区', NULL, NULL, 23.09402400, 120.37463600, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711363', '2', '玉井区', NULL, NULL, 23.12205100, 120.45423000, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711364', '2', '楠西区', NULL, NULL, 23.17215700, 120.50146500, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711365', '2', '南化区', NULL, NULL, 23.10982700, 120.53257500, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711366', '2', '左镇区', NULL, NULL, 23.03317200, 120.40826200, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711367', '2', '仁德区', NULL, NULL, 22.94204500, 120.24830900, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711368', '2', '归仁区', NULL, NULL, 22.94841300, 120.29525100, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711369', '2', '关庙区', NULL, NULL, 22.94903200, 120.33968800, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711370', '2', '龙崎区', NULL, NULL, 22.95622500, 120.38246800, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711371', '2', '永康区', NULL, NULL, 23.02649500, 120.25300700, '711300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711400', '1', '高雄市', '高雄', 'gao,xiong', 22.62043100, 120.31201600, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711401', '2', '盐埕区', NULL, NULL, 22.62560800, 120.28401900, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711402', '2', '鼓山区', NULL, NULL, 22.65180200, 120.27530800, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711403', '2', '左营区', NULL, NULL, 22.67906400, 120.29276200, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711404', '2', '楠梓区', NULL, NULL, 22.72573300, 120.31022900, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711405', '2', '三民区', NULL, NULL, 22.65946100, 120.32088600, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711406', '2', '新兴区', NULL, NULL, 22.63057600, 120.30683900, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711407', '2', '前金区', NULL, NULL, 22.62641900, 120.29352000, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711408', '2', '苓雅区', NULL, NULL, 22.62401800, 120.32305500, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711409', '2', '前镇区', NULL, NULL, 22.59047700, 120.30908000, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711410', '2', '旗津区', NULL, NULL, 22.59055100, 120.28319000, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711411', '2', '小港区', NULL, NULL, 22.55723600, 120.37258400, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711414', '2', '中坜区', NULL, NULL, 24.98275700, 121.21360800, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711415', '2', '平镇区', NULL, NULL, 24.91069900, 121.21784100, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711416', '2', '龙潭区', NULL, NULL, 24.86420700, 121.21269100, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711417', '2', '杨梅区', NULL, NULL, 24.90936600, 121.13089200, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711418', '2', '新屋区', NULL, NULL, 24.96608600, 121.06154500, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711419', '2', '观音区', NULL, NULL, 25.01914500, 121.10404800, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711420', '2', '桃园区', NULL, NULL, 24.99705800, 121.29771100, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711421', '2', '龟山区', NULL, NULL, 25.02794200, 121.36117500, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711422', '2', '八德区', NULL, NULL, 24.95089000, 121.28661600, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711423', '2', '大溪区', NULL, NULL, 24.87141600, 121.29795700, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711424', '2', '复兴区', NULL, NULL, 24.73552100, 121.37334700, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711425', '2', '大园区', NULL, NULL, 25.05050200, 121.21119000, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711426', '2', '芦竹区', NULL, NULL, 25.04865300, 121.28868000, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711441', '2', '凤山区', NULL, NULL, 22.61232900, 120.35467800, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711442', '2', '鸟松区', NULL, NULL, 22.66530300, 120.37333100, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711443', '2', '仁武区', NULL, NULL, 22.70354300, 120.36257700, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711444', '2', '大社区', NULL, NULL, 22.74086700, 120.37275700, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711445', '2', '大树区', NULL, NULL, 22.71072300, 120.41331700, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711446', '2', '大寮区', NULL, NULL, 22.58793800, 120.39525600, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711448', '2', '林园区', NULL, NULL, 22.51287800, 120.38912800, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711449', '2', '冈山区', NULL, NULL, 22.80618200, 120.30362900, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711450', '2', '茄萣区', NULL, NULL, 22.88774900, 120.19689400, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711451', '2', '永安区', NULL, NULL, 22.81883100, 120.23625000, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711452', '2', '桥头区', NULL, NULL, 22.75213700, 120.30245700, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711453', '2', '梓官区', NULL, NULL, 22.75090500, 120.25881600, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711454', '2', '田寮区', NULL, NULL, 22.86688200, 120.39378600, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711455', '2', '阿莲区', NULL, NULL, 22.86883000, 120.32213100, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711456', '2', '路竹区', NULL, NULL, 22.86043600, 120.26761900, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711457', '2', '燕巢区', NULL, NULL, 22.78982900, 120.37064900, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711458', '2', '弥陀区', NULL, NULL, 22.77488900, 120.24153700, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711459', '2', '湖内区', NULL, NULL, 22.89079400, 120.22796500, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711460', '2', '旗山区', NULL, NULL, 22.89424000, 120.48090300, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711461', '2', '六龟区', NULL, NULL, 23.04511200, 120.68185100, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711462', '2', '内门区', NULL, NULL, 22.94310200, 120.47196800, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711463', '2', '美浓区', NULL, NULL, 22.92820600, 120.56745600, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711464', '2', '杉林区', NULL, NULL, 22.98105300, 120.55994600, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711465', '2', '甲仙区', NULL, NULL, 23.11201300, 120.62032000, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711466', '2', '茂林区', NULL, NULL, 22.91125200, 120.76276700, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711467', '2', '桃源区', NULL, NULL, 23.16742000, 120.79543800, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711468', '2', '那玛夏区', NULL, NULL, 23.27386100, 120.71957500, '711400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711500', '1', '新北市', '新北', 'xin,bei', 25.01193000, 121.46562000, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711501', '2', '新庄区', NULL, NULL, 25.03383900, 121.42690200, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711502', '2', '林口区', NULL, NULL, 25.08914300, 121.38267900, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711503', '2', '五股区', NULL, NULL, 25.09221600, 121.42529900, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711504', '2', '芦洲区', NULL, NULL, 25.08552900, 121.47063400, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711505', '2', '三重区', NULL, NULL, 25.06458900, 121.48033700, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711506', '2', '泰山区', NULL, NULL, 25.05936500, 121.40782000, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711507', '2', '新店区', NULL, NULL, 24.93733200, 121.53035000, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711508', '2', '石碇区', NULL, NULL, 24.96272900, 121.65365500, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711509', '2', '深坑区', NULL, NULL, 25.00095000, 121.62531800, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711510', '2', '坪林区', NULL, NULL, 24.92701500, 121.73270800, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711511', '2', '乌来区', NULL, NULL, 24.78385500, 121.56111500, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711514', '2', '板桥区', NULL, NULL, 24.99960700, 121.45505200, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711515', '2', '三峡区', NULL, NULL, 24.87901700, 121.40793500, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711516', '2', '莺歌区', NULL, NULL, 24.96151100, 121.34128300, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711517', '2', '树林区', NULL, NULL, 24.98801600, 121.40368800, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711518', '2', '中和区', NULL, NULL, 24.98785700, 121.49308000, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711519', '2', '土城区', NULL, NULL, 24.97076400, 121.45429400, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711520', '2', '头份市', NULL, NULL, 24.67869200, 120.92583500, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711521', '2', '瑞芳区', NULL, NULL, 25.10211000, 121.83440100, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711522', '2', '平溪区', NULL, NULL, 25.01605100, 121.75553900, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711523', '2', '双溪区', NULL, NULL, 24.99623600, 121.83318200, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711524', '2', '贡寮区', NULL, NULL, 25.03419900, 121.92195000, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711525', '2', '金山区', NULL, NULL, 25.22371700, 121.61428900, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711526', '2', '万里区', NULL, NULL, 25.18530000, 121.66367500, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711527', '2', '淡水区', NULL, NULL, 25.19804600, 121.47366600, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711528', '2', '汐止区', NULL, NULL, 25.06850500, 121.65666500, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711529', '2', '头屋乡', NULL, NULL, 24.57517400, 120.88231900, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711530', '2', '三芝区', NULL, NULL, 25.23751100, 121.51303600, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711531', '2', '石门区', NULL, NULL, 25.26521800, 121.55519700, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711532', '2', '八里区', NULL, NULL, 25.11222700, 121.39973900, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711533', '2', '永和区', NULL, NULL, 25.00464200, 121.51336600, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711534', '2', '三义乡', NULL, NULL, 24.37576300, 120.77013300, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711535', '2', '西湖乡', NULL, NULL, 24.53772400, 120.76089300, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711536', '2', '卓兰镇', NULL, NULL, 24.32722400, 120.83551500, '711500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711600', '1', '宜兰县', '宜兰', 'yi,lan', 24.73142500, 121.76313700, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711601', '2', '宜兰市', NULL, NULL, 24.75970700, 121.75444200, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711602', '2', '头城镇', NULL, NULL, 24.91128300, 121.85085000, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711603', '2', '礁溪乡', NULL, NULL, 24.80807300, 121.73569300, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711604', '2', '壮围乡', NULL, NULL, 24.76283300, 121.79949500, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711605', '2', '员山乡', NULL, NULL, 24.74132400, 121.66273600, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711606', '2', '罗东镇', NULL, NULL, 24.67835700, 121.77153900, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711607', '2', '五结乡', NULL, NULL, 24.68218000, 121.79443200, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711608', '2', '冬山乡', NULL, NULL, 24.64404900, 121.75337200, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711609', '2', '苏澳镇', NULL, NULL, 24.55064800, 121.83587700, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711610', '2', '三星乡', NULL, NULL, 24.66396400, 121.67005400, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711611', '2', '大同乡', NULL, NULL, 24.56318800, 121.53563700, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711612', '2', '南澳乡', NULL, NULL, 24.46172700, 121.66814800, '711600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711700', '1', '桃园市', '桃园', 'tao,yuan', 24.99305100, 121.30101100, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711701', '2', '桃园区', NULL, NULL, 24.99705800, 121.29771100, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711702', '2', '大溪区', NULL, NULL, 24.87141600, 121.29795700, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711703', '2', '中坜区', NULL, NULL, 24.98275700, 121.21360800, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711704', '2', '杨梅区', NULL, NULL, 24.90936600, 121.13089200, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711705', '2', '芦竹区', NULL, NULL, 25.04865300, 121.28868000, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711706', '2', '大园区', NULL, NULL, 25.05050200, 121.21119000, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711707', '2', '龟山区', NULL, NULL, 25.02794200, 121.36117500, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711708', '2', '八德区', NULL, NULL, 24.95089000, 121.28661600, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711709', '2', '龙潭区', NULL, NULL, 24.86420700, 121.21269100, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711710', '2', '平镇区', NULL, NULL, 24.91069900, 121.21784100, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711711', '2', '新屋区', NULL, NULL, 24.96608600, 121.06154500, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711712', '2', '观音区', NULL, NULL, 25.01914500, 121.10404800, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711713', '2', '复兴区', NULL, NULL, 24.73552100, 121.37334700, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711727', '2', '彰化市', NULL, NULL, 24.06852300, 120.55747900, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711728', '2', '芬园乡', NULL, NULL, 23.99800800, 120.62741000, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711729', '2', '花坛乡', NULL, NULL, 24.03304500, 120.56236100, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711730', '2', '秀水乡', NULL, NULL, 24.02826200, 120.50449500, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711731', '2', '鹿港镇', NULL, NULL, 24.08473400, 120.43759600, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711732', '2', '福兴乡', NULL, NULL, 24.02875500, 120.44278600, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711733', '2', '线西乡', NULL, NULL, 24.12308000, 120.45956000, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711734', '2', '和美镇', NULL, NULL, 24.10936900, 120.50469000, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711735', '2', '伸港乡', NULL, NULL, 24.15639000, 120.48277000, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711736', '2', '员林市', NULL, NULL, 23.95691500, 120.61026000, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711737', '2', '社头乡', NULL, NULL, 23.90855200, 120.62080600, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711738', '2', '永靖乡', NULL, NULL, 23.92475800, 120.53107800, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711739', '2', '埔心乡', NULL, NULL, 23.95441100, 120.52898100, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711740', '2', '溪湖镇', NULL, NULL, 23.95219000, 120.48755500, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711741', '2', '大村乡', NULL, NULL, 23.99308500, 120.56345600, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711742', '2', '埔盐乡', NULL, NULL, 23.99303100, 120.46546300, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711743', '2', '田中镇', NULL, NULL, 23.85855000, 120.60918100, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711744', '2', '北斗镇', NULL, NULL, 23.86816500, 120.53191800, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711745', '2', '田尾乡', NULL, NULL, 23.89976800, 120.52409300, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711746', '2', '埤头乡', NULL, NULL, 23.87357000, 120.46852700, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711747', '2', '溪州乡', NULL, NULL, 23.83511100, 120.51942000, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711748', '2', '竹塘乡', NULL, NULL, 23.85740700, 120.41151600, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711749', '2', '二林镇', NULL, NULL, 23.90624700, 120.39439000, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711750', '2', '大城乡', NULL, NULL, 23.86675700, 120.31805900, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711751', '2', '芳苑乡', NULL, NULL, 23.94306900, 120.35568700, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711752', '2', '二水乡', NULL, NULL, 23.81319900, 120.62823800, '711700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711800', '1', '嘉义市', '嘉义', 'jia,yi', 23.48050151, 120.44805820, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711801', '2', '东区', NULL, NULL, 23.48507900, 120.47246200, '711800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711802', '2', '西区', NULL, NULL, 23.47703000, 120.42007500, '711800');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711900', '1', '新竹县', '新竹', 'xin,zhu', 24.82687500, 121.01290700, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711902', '2', '竹东镇', NULL, NULL, 24.73634700, 121.08671400, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711903', '2', '关西镇', NULL, NULL, 24.78733800, 121.17854400, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711904', '2', '新埔镇', NULL, NULL, 24.84722200, 121.10569900, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711905', '2', '竹北市', NULL, NULL, 24.83923300, 121.00201200, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711906', '2', '湖口乡', NULL, NULL, 24.88866000, 121.06023000, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711908', '2', '横山乡', NULL, NULL, 24.72127800, 121.15731700, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711909', '2', '新丰乡', NULL, NULL, 24.90470600, 120.99771000, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711910', '2', '芎林乡', NULL, NULL, 24.76821000, 121.11030100, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711911', '2', '宝山乡', NULL, NULL, 24.73090800, 120.99830300, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711912', '2', '北埔乡', NULL, NULL, 24.68932600, 121.06209500, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711913', '2', '峨眉乡', NULL, NULL, 24.68488300, 121.00120300, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711914', '2', '尖石乡', NULL, NULL, 24.58162600, 121.28933100, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711915', '2', '五峰乡', NULL, NULL, 24.58911400, 121.14555200, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711919', '2', '番路乡', NULL, NULL, 23.43447300, 120.62425500, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711920', '2', '梅山乡', NULL, NULL, 23.55749100, 120.61201600, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711921', '2', '竹崎乡', NULL, NULL, 23.50518600, 120.58434100, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711922', '2', '阿里山乡', NULL, NULL, 23.43654900, 120.77420300, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711923', '2', '中埔乡', NULL, NULL, 23.39845000, 120.51944100, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711924', '2', '大埔乡', NULL, NULL, 23.28744400, 120.59547500, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711925', '2', '水上乡', NULL, NULL, 23.42140600, 120.43926600, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711926', '2', '鹿草乡', NULL, NULL, 23.41572000, 120.30087700, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711927', '2', '太保市', NULL, NULL, 23.47393300, 120.35193000, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711928', '2', '朴子市', NULL, NULL, 23.43805300, 120.25252000, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711929', '2', '东石乡', NULL, NULL, 23.46008300, 120.19903500, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711930', '2', '六脚乡', NULL, NULL, 23.50897800, 120.26777600, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711931', '2', '新港乡', NULL, NULL, 23.54050100, 120.35400500, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711932', '2', '民雄乡', NULL, NULL, 23.54041800, 120.46053700, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711933', '2', '大林镇', NULL, NULL, 23.59354900, 120.48166400, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711934', '2', '溪口乡', NULL, NULL, 23.59480000, 120.40386100, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711935', '2', '义竹乡', NULL, NULL, 23.34963600, 120.22860900, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('711936', '2', '布袋镇', NULL, NULL, 23.39627500, 120.20091700, '711900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712000', '1', '苗栗县', '苗栗', 'miao,li', 24.56438500, 120.82059000, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712001', '2', '苗栗市', NULL, NULL, 24.55739600, 120.80196600, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712002', '2', '苑里镇', NULL, NULL, 24.41299700, 120.69240700, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712003', '2', '通霄镇', NULL, NULL, 24.48094900, 120.72330300, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712004', '2', '公馆乡', NULL, NULL, 24.50355300, 120.85677100, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712005', '2', '铜锣乡', NULL, NULL, 24.45605900, 120.79846000, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712006', '2', '三义乡', NULL, NULL, 24.37576300, 120.77013300, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712007', '2', '西湖乡', NULL, NULL, 24.53772400, 120.76089300, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712008', '2', '头屋乡', NULL, NULL, 24.57517400, 120.88231900, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712009', '2', '竹南镇', NULL, NULL, 24.69676200, 120.88433700, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712010', '2', '头份市', NULL, NULL, 24.67869200, 120.92583500, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712011', '2', '造桥乡', NULL, NULL, 24.61758000, 120.88350900, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712012', '2', '后龙镇', NULL, NULL, 24.60302100, 120.78012700, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712013', '2', '三湾乡', NULL, NULL, 24.63278500, 120.95096200, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712014', '2', '南庄乡', NULL, NULL, 24.57505300, 120.99591500, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712015', '2', '大湖乡', NULL, NULL, 24.38378900, 120.84662500, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712016', '2', '卓兰镇', NULL, NULL, 24.32722400, 120.83551500, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712017', '2', '狮潭乡', NULL, NULL, 24.52645100, 120.92478700, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712018', '2', '泰安乡', NULL, NULL, 24.39307900, 121.04939000, '712000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712100', '1', '云林县', '云林', 'yun,lin', 23.69638700, 120.53005300, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712121', '2', '斗南镇', NULL, NULL, 23.66494300, 120.48073800, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712122', '2', '大埤乡', NULL, NULL, 23.64588000, 120.43107400, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712123', '2', '虎尾镇', NULL, NULL, 23.71453500, 120.42285400, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712124', '2', '土库镇', NULL, NULL, 23.69974100, 120.36593200, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712125', '2', '褒忠乡', NULL, NULL, 23.71633700, 120.30900300, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712126', '2', '东势乡', NULL, NULL, 23.69840200, 120.25817200, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712127', '2', '台西乡', NULL, NULL, 23.70255600, 120.21318000, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712128', '2', '仑背乡', NULL, NULL, 23.77289400, 120.33501500, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712129', '2', '麦寮乡', NULL, NULL, 23.77592900, 120.25593100, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712130', '2', '斗六市', NULL, NULL, 23.69752900, 120.58650100, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712131', '2', '林内乡', NULL, NULL, 23.74312400, 120.61696000, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712132', '2', '古坑乡', NULL, NULL, 23.62812100, 120.61467500, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712133', '2', '莿桐乡', NULL, NULL, 23.77119000, 120.54166000, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712134', '2', '西螺镇', NULL, NULL, 23.78474900, 120.45785400, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712135', '2', '二仑乡', NULL, NULL, 23.79031600, 120.39394400, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712136', '2', '北港镇', NULL, NULL, 23.58489400, 120.28885500, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712137', '2', '水林乡', NULL, NULL, 23.56802800, 120.23913000, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712138', '2', '口湖乡', NULL, NULL, 23.57919000, 120.17822700, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712139', '2', '四湖乡', NULL, NULL, 23.64652500, 120.21056100, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712140', '2', '元长乡', NULL, NULL, 23.64537600, 120.32565200, '712100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712200', '1', '南投县', '南投', 'nan,tou', 23.90267400, 120.69050700, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712201', '2', '南投市', NULL, NULL, 23.91961900, 120.67000800, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712202', '2', '埔里镇', NULL, NULL, 23.96992000, 120.96266900, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712203', '2', '草屯镇', NULL, NULL, 23.98340200, 120.74493200, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712204', '2', '竹山镇', NULL, NULL, 23.71679800, 120.71768700, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712205', '2', '集集镇', NULL, NULL, 23.83760700, 120.74978000, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712206', '2', '名间乡', NULL, NULL, 23.84793300, 120.64852300, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712207', '2', '鹿谷乡', NULL, NULL, 23.72753200, 120.74994500, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712208', '2', '中寮乡', NULL, NULL, 23.92817600, 120.74218900, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712209', '2', '鱼池乡', NULL, NULL, 23.89565600, 120.93536100, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712210', '2', '国姓乡', NULL, NULL, 24.06378900, 120.84824200, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712211', '2', '水里乡', NULL, NULL, 23.79965700, 120.87962800, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712212', '2', '信义乡', NULL, NULL, 23.60279700, 121.03622400, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712213', '2', '仁爱乡', NULL, NULL, 24.10421500, 121.14536600, '712200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712300', '1', '彰化县', '彰化', 'zhang,hua', 24.07565800, 120.54463300, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712301', '2', '彰化市', NULL, NULL, 24.06852300, 120.55747900, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712302', '2', '鹿港镇', NULL, NULL, 24.08473400, 120.43759600, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712303', '2', '和美镇', NULL, NULL, 24.10936900, 120.50469000, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712304', '2', '北斗镇', NULL, NULL, 23.86816500, 120.53191800, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712305', '2', '员林市', NULL, NULL, 23.95691500, 120.61026000, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712306', '2', '溪湖镇', NULL, NULL, 23.95219000, 120.48755500, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712307', '2', '田中镇', NULL, NULL, 23.85855000, 120.60918100, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712308', '2', '二林镇', NULL, NULL, 23.90624700, 120.39439000, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712309', '2', '线西乡', NULL, NULL, 24.12308000, 120.45956000, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712310', '2', '伸港乡', NULL, NULL, 24.15639000, 120.48277000, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712311', '2', '福兴乡', NULL, NULL, 24.02875500, 120.44278600, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712312', '2', '秀水乡', NULL, NULL, 24.02826200, 120.50449500, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712313', '2', '花坛乡', NULL, NULL, 24.03304500, 120.56236100, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712314', '2', '芬园乡', NULL, NULL, 23.99800800, 120.62741000, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712315', '2', '大村乡', NULL, NULL, 23.99308500, 120.56345600, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712316', '2', '埔盐乡', NULL, NULL, 23.99303100, 120.46546300, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712317', '2', '埔心乡', NULL, NULL, 23.95441100, 120.52898100, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712318', '2', '永靖乡', NULL, NULL, 23.92475800, 120.53107800, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712319', '2', '社头乡', NULL, NULL, 23.90855200, 120.62080600, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712320', '2', '二水乡', NULL, NULL, 23.81319900, 120.62823800, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712321', '2', '田尾乡', NULL, NULL, 23.89976800, 120.52409300, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712322', '2', '埤头乡', NULL, NULL, 23.87357000, 120.46852700, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712323', '2', '芳苑乡', NULL, NULL, 23.94306900, 120.35568700, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712324', '2', '大城乡', NULL, NULL, 23.86675700, 120.31805900, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712325', '2', '竹塘乡', NULL, NULL, 23.85740700, 120.41151600, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712326', '2', '溪州乡', NULL, NULL, 23.83511100, 120.51942000, '712300');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712400', '1', '新竹市', '新竹', 'xin,zhu', 24.80688300, 120.96910000, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712401', '2', '东区', NULL, NULL, 24.78492400, 120.99074500, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712402', '2', '香山区', NULL, NULL, 24.76446500, 120.92949000, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712403', '2', '北区', NULL, NULL, 24.81327000, 120.95276700, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712434', '2', '屏东市', NULL, NULL, 22.66671600, 120.49200500, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712435', '2', '三地门乡', NULL, NULL, 22.78942300, 120.67811100, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712436', '2', '雾台乡', NULL, NULL, 22.75620900, 120.79304600, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712437', '2', '玛家乡', NULL, NULL, 22.66511800, 120.67249700, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712438', '2', '九如乡', NULL, NULL, 22.72919800, 120.48969300, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712439', '2', '里港乡', NULL, NULL, 22.80035300, 120.50941900, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712440', '2', '高树乡', NULL, NULL, 22.79863300, 120.61430100, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712441', '2', '盐埔乡', NULL, NULL, 22.74091000, 120.56046300, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712442', '2', '长治乡', NULL, NULL, 22.68574000, 120.54265700, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712443', '2', '麟洛乡', NULL, NULL, 22.65031000, 120.52547000, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712444', '2', '竹田乡', NULL, NULL, 22.58493900, 120.52156600, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712445', '2', '内埔乡', NULL, NULL, 22.64180200, 120.59611600, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712446', '2', '万丹乡', NULL, NULL, 22.57836100, 120.48366400, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712447', '2', '潮州镇', NULL, NULL, 22.54354000, 120.54435900, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712448', '2', '泰武乡', NULL, NULL, 22.59264300, 120.65825900, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712449', '2', '来义乡', NULL, NULL, 22.49380200, 120.65483600, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712450', '2', '万峦乡', NULL, NULL, 22.58091000, 120.61230500, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712451', '2', '崁顶乡', NULL, NULL, 22.51403200, 120.50557400, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712452', '2', '新埤乡', NULL, NULL, 22.47546100, 120.59999600, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712453', '2', '南州乡', NULL, NULL, 22.48154600, 120.51721400, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712454', '2', '林边乡', NULL, NULL, 22.44496300, 120.51188800, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712455', '2', '东港镇', NULL, NULL, 22.46741800, 120.48854100, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712456', '2', '琉球乡', NULL, NULL, 22.33990200, 120.37129100, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712457', '2', '佳冬乡', NULL, NULL, 22.42704300, 120.54861400, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712458', '2', '新园乡', NULL, NULL, 22.53403200, 120.46474100, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712459', '2', '枋寮乡', NULL, NULL, 22.39450600, 120.60646500, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712460', '2', '枋山乡', NULL, NULL, 22.25544300, 120.65700400, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712461', '2', '春日乡', NULL, NULL, 22.39660800, 120.67532900, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712462', '2', '狮子乡', NULL, NULL, 22.24614100, 120.73595500, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712463', '2', '车城乡', NULL, NULL, 22.07920500, 120.72788500, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712464', '2', '牡丹乡', NULL, NULL, 22.15295000, 120.81706700, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712465', '2', '恒春镇', NULL, NULL, 21.98980300, 120.73920000, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712466', '2', '满州乡', NULL, NULL, 22.05046200, 120.83515200, '712400');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712500', '1', '云林县', '云林', 'yun,lin', 23.69638700, 120.53005300, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712501', '2', '斗六市', NULL, NULL, 23.69752900, 120.58650100, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712502', '2', '斗南镇', NULL, NULL, 23.66494300, 120.48073800, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712503', '2', '虎尾镇', NULL, NULL, 23.71453500, 120.42285400, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712504', '2', '西螺镇', NULL, NULL, 23.78474900, 120.45785400, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712505', '2', '土库镇', NULL, NULL, 23.69974100, 120.36593200, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712506', '2', '北港镇', NULL, NULL, 23.58489400, 120.28885500, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712507', '2', '古坑乡', NULL, NULL, 23.62812100, 120.61467500, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712508', '2', '大埤乡', NULL, NULL, 23.64588000, 120.43107400, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712509', '2', '莿桐乡', NULL, NULL, 23.77119000, 120.54166000, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712510', '2', '林内乡', NULL, NULL, 23.74312400, 120.61696000, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712511', '2', '二仑乡', NULL, NULL, 23.79031600, 120.39394400, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712512', '2', '仑背乡', NULL, NULL, 23.77289400, 120.33501500, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712513', '2', '麦寮乡', NULL, NULL, 23.77592900, 120.25593100, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712514', '2', '东势乡', NULL, NULL, 23.69840200, 120.25817200, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712515', '2', '褒忠乡', NULL, NULL, 23.71633700, 120.30900300, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712516', '2', '台西乡', NULL, NULL, 23.70255600, 120.21318000, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712517', '2', '元长乡', NULL, NULL, 23.64537600, 120.32565200, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712518', '2', '四湖乡', NULL, NULL, 23.64652500, 120.21056100, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712519', '2', '口湖乡', NULL, NULL, 23.57919000, 120.17822700, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712520', '2', '水林乡', NULL, NULL, 23.56802800, 120.23913000, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712521', '2', '卑南乡', NULL, NULL, 22.75862200, 121.01173800, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712522', '2', '鹿野乡', NULL, NULL, 22.94935600, 121.15235100, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712523', '2', '关山镇', NULL, NULL, 23.03725300, 121.17544400, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712524', '2', '海端乡', NULL, NULL, 23.10411500, 121.03131600, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712525', '2', '池上乡', NULL, NULL, 23.08867300, 121.21697700, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712526', '2', '东河乡', NULL, NULL, 22.97374200, 121.24939600, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712527', '2', '成功镇', NULL, NULL, 23.11728900, 121.34597500, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712528', '2', '长滨乡', NULL, NULL, 23.32792500, 121.41998100, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712529', '2', '金峰乡', NULL, NULL, 22.60231600, 120.90571300, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712530', '2', '大武乡', NULL, NULL, 22.38183200, 120.89347200, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712531', '2', '达仁乡', NULL, NULL, 22.37340200, 120.84579100, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712532', '2', '太麻里乡', NULL, NULL, 22.58747200, 120.97209900, '712500');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712600', '1', '嘉义县', '嘉义', 'jia,yi', 23.45861700, 120.29289100, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712602', '2', '朴子市', NULL, NULL, 23.43805300, 120.25252000, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712603', '2', '布袋镇', NULL, NULL, 23.39627500, 120.20091700, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712604', '2', '大林镇', NULL, NULL, 23.59354900, 120.48166400, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712605', '2', '民雄乡', NULL, NULL, 23.54041800, 120.46053700, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712606', '2', '溪口乡', NULL, NULL, 23.59480000, 120.40386100, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712607', '2', '新港乡', NULL, NULL, 23.54050100, 120.35400500, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712608', '2', '六脚乡', NULL, NULL, 23.50897800, 120.26777600, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712609', '2', '东石乡', NULL, NULL, 23.46008300, 120.19903500, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712610', '2', '义竹乡', NULL, NULL, 23.34963600, 120.22860900, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712611', '2', '鹿草乡', NULL, NULL, 23.41572000, 120.30087700, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712612', '2', '太保市', NULL, NULL, 23.47393300, 120.35193000, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712613', '2', '水上乡', NULL, NULL, 23.42140600, 120.43926600, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712614', '2', '中埔乡', NULL, NULL, 23.39845000, 120.51944100, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712615', '2', '竹崎乡', NULL, NULL, 23.50518600, 120.58434100, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712616', '2', '梅山乡', NULL, NULL, 23.55749100, 120.61201600, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712617', '2', '番路乡', NULL, NULL, 23.43447300, 120.62425500, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712618', '2', '大埔乡', NULL, NULL, 23.28744400, 120.59547500, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712619', '2', '吉安乡', NULL, NULL, 23.96047200, 121.56562100, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712620', '2', '阿里山乡', NULL, NULL, 23.43654900, 120.77420300, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712621', '2', '凤林镇', NULL, NULL, 23.74239600, 121.46668400, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712622', '2', '光复乡', NULL, NULL, 23.65254900, 121.44889100, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712623', '2', '丰滨乡', NULL, NULL, 23.57757400, 121.49301700, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712624', '2', '瑞穗乡', NULL, NULL, 23.51919200, 121.41073500, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712625', '2', '万荣乡', NULL, NULL, 23.70474400, 121.32602400, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712626', '2', '玉里镇', NULL, NULL, 23.36682000, 121.35880700, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712627', '2', '卓溪乡', NULL, NULL, 23.38753600, 121.18787100, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712628', '2', '富里乡', NULL, NULL, 23.19724200, 121.29973700, '712600');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712700', '1', '澎湖县', '澎湖', 'peng,hu', 23.56729700, 119.57070400, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712707', '2', '马公市', NULL, NULL, 23.55235100, 119.58457000, '712700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712708', '2', '西屿乡', NULL, NULL, 23.59916500, 119.50736900, '712700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712709', '2', '望安乡', NULL, NULL, 23.37087400, 119.50172900, '712700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712710', '2', '七美乡', NULL, NULL, 23.20282200, 119.42999500, '712700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712711', '2', '白沙乡', NULL, NULL, 23.65348900, 119.58631700, '712700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712712', '2', '湖西乡', NULL, NULL, 23.58199800, 119.63524500, '712700');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712900', '1', '屏东县', '屏东', 'ping,dong', 22.68332800, 120.48772100, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712901', '2', '屏东市', NULL, NULL, 22.66671600, 120.49200500, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712902', '2', '潮州镇', NULL, NULL, 22.54354000, 120.54435900, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712903', '2', '东港镇', NULL, NULL, 22.46741800, 120.48854100, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712904', '2', '恒春镇', NULL, NULL, 21.98980300, 120.73920000, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712905', '2', '万丹乡', NULL, NULL, 22.57836100, 120.48366400, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712906', '2', '长治乡', NULL, NULL, 22.68574000, 120.54265700, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712907', '2', '麟洛乡', NULL, NULL, 22.65031000, 120.52547000, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712908', '2', '九如乡', NULL, NULL, 22.72919800, 120.48969300, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712909', '2', '里港乡', NULL, NULL, 22.80035300, 120.50941900, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712910', '2', '盐埔乡', NULL, NULL, 22.74091000, 120.56046300, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712911', '2', '高树乡', NULL, NULL, 22.79863300, 120.61430100, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712912', '2', '万峦乡', NULL, NULL, 22.58091000, 120.61230500, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712913', '2', '内埔乡', NULL, NULL, 22.64180200, 120.59611600, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712914', '2', '竹田乡', NULL, NULL, 22.58493900, 120.52156600, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712915', '2', '新埤乡', NULL, NULL, 22.47546100, 120.59999600, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712916', '2', '枋寮乡', NULL, NULL, 22.39450600, 120.60646500, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712917', '2', '新园乡', NULL, NULL, 22.53403200, 120.46474100, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712918', '2', '崁顶乡', NULL, NULL, 22.51403200, 120.50557400, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712919', '2', '林边乡', NULL, NULL, 22.44496300, 120.51188800, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712920', '2', '南州乡', NULL, NULL, 22.48154600, 120.51721400, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712921', '2', '佳冬乡', NULL, NULL, 22.42704300, 120.54861400, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712922', '2', '琉球乡', NULL, NULL, 22.33990200, 120.37129100, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712923', '2', '车城乡', NULL, NULL, 22.07920500, 120.72788500, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712924', '2', '满州乡', NULL, NULL, 22.05046200, 120.83515200, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712925', '2', '枋山乡', NULL, NULL, 22.25544300, 120.65700400, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712926', '2', '三地门乡', NULL, NULL, 22.78942300, 120.67811100, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712927', '2', '雾台乡', NULL, NULL, 22.75620900, 120.79304600, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712928', '2', '玛家乡', NULL, NULL, 22.66511800, 120.67249700, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712929', '2', '泰武乡', NULL, NULL, 22.59264300, 120.65825900, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712930', '2', '来义乡', NULL, NULL, 22.49380200, 120.65483600, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712931', '2', '春日乡', NULL, NULL, 22.39660800, 120.67532900, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712932', '2', '狮子乡', NULL, NULL, 22.24614100, 120.73595500, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('712933', '2', '牡丹乡', NULL, NULL, 22.15295000, 120.81706700, '712900');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713000', '1', '花莲县', '花莲', 'hua,lian', 23.99133700, 121.62063600, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713001', '2', '花莲市', NULL, NULL, 24.00067400, 121.59729000, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713002', '2', '光复乡', NULL, NULL, 23.65254900, 121.44889100, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713003', '2', '玉里镇', NULL, NULL, 23.36682000, 121.35880700, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713004', '2', '新城乡', NULL, NULL, 24.05706800, 121.61241400, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713005', '2', '吉安乡', NULL, NULL, 23.96047200, 121.56562100, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713006', '2', '寿丰乡', NULL, NULL, 23.83680200, 121.53028500, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713007', '2', '凤林镇', NULL, NULL, 23.74239600, 121.46668400, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713008', '2', '丰滨乡', NULL, NULL, 23.57757400, 121.49301700, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713009', '2', '瑞穗乡', NULL, NULL, 23.51919200, 121.41073500, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713010', '2', '富里乡', NULL, NULL, 23.19724200, 121.29973700, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713011', '2', '卓溪乡', NULL, NULL, 23.38753600, 121.18787100, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713012', '2', '万荣乡', NULL, NULL, 23.70474400, 121.32602400, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713013', '2', '秀林乡', NULL, NULL, 24.15176800, 121.49835900, '713000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713100', '1', '台东县', '台东', 'tai,dong', 22.75533200, 121.15055200, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713101', '2', '台东市', NULL, NULL, 22.76436400, 121.11320700, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713102', '2', '成功镇', NULL, NULL, 23.11728900, 121.34597500, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713103', '2', '关山镇', NULL, NULL, 23.03725300, 121.17544400, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713104', '2', '卑南乡', NULL, NULL, 22.75862200, 121.01173800, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713105', '2', '大武乡', NULL, NULL, 22.38183200, 120.89347200, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713106', '2', '太麻里乡', NULL, NULL, 22.58747200, 120.97209900, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713107', '2', '东河乡', NULL, NULL, 22.97374200, 121.24939600, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713108', '2', '长滨乡', NULL, NULL, 23.32792500, 121.41998100, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713109', '2', '鹿野乡', NULL, NULL, 22.94935600, 121.15235100, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713110', '2', '池上乡', NULL, NULL, 23.08867300, 121.21697700, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713111', '2', '绿岛乡', NULL, NULL, 22.66291900, 121.49340700, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713112', '2', '延平乡', NULL, NULL, 22.90859700, 121.02191100, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713113', '2', '海端乡', NULL, NULL, 23.10411500, 121.03131600, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713114', '2', '达仁乡', NULL, NULL, 22.37340200, 120.84579100, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713115', '2', '金峰乡', NULL, NULL, 22.60231600, 120.90571300, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713116', '2', '兰屿乡', NULL, NULL, 22.04116900, 121.55010700, '713100');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713200', '1', '澎湖县', '澎湖', 'peng,hu', 23.56729700, 119.57070400, '710000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713201', '2', '马公市', NULL, NULL, 23.55235100, 119.58457000, '713200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713202', '2', '湖西乡', NULL, NULL, 23.58199800, 119.63524500, '713200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713203', '2', '白沙乡', NULL, NULL, 23.65348900, 119.58631700, '713200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713204', '2', '西屿乡', NULL, NULL, 23.59916500, 119.50736900, '713200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713205', '2', '望安乡', NULL, NULL, 23.37087400, 119.50172900, '713200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('713206', '2', '七美乡', NULL, NULL, 23.20282200, 119.42999500, '713200');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810000', '0', '香港特别行政区', '香港', 'xiang,gang', 22.27746800, 114.17120300, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810101', '1', '中西区', '中西区', 'zhong,xi,qu', 22.27622003, 114.16446035, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810102', '1', '东区', '东区', 'dong,qu', 22.28135362, 114.22910089, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810103', '1', '九龙城区', '九龙', 'jiu,long', 22.30899339, 114.19481061, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810104', '1', '观塘区', '观塘区', 'guan,tang,qu', 22.30674670, 114.23468946, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810105', '1', '南区', '南区', 'nan,qu', 22.24594584, 114.16089566, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810106', '1', '深水埗区', '深水埗区', 'shen,shui,bu,qu', 22.32916239, 114.16858880, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810107', '1', '湾仔区', '湾仔区', 'wan,zi,qu', 22.27742209, 114.17737803, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810108', '1', '黄大仙区', '黄大仙区', 'huang,da,xian,qu', 22.33916329, 114.19764567, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810109', '1', '油尖旺区', '油尖旺区', 'you,jian,wang,qu', 22.30670673, 114.17596347, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810110', '1', '离岛区', '离岛区', 'li,dao,qu', 22.28558162, 113.94399967, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810111', '1', '葵青区', '葵青区', 'kui,qing,qu', 22.36044285, 114.13659924, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810112', '1', '北区', '北区', 'bei,qu', 22.49223724, 114.14332872, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810113', '1', '西贡区', '西贡区', 'xi,gong,qu', 22.37902086, 114.27663621, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810114', '1', '沙田区', '沙田区', 'sha,tian,qu', 22.38266598, 114.19194430, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810115', '1', '屯门区', '屯门区', 'tun,men,qu', 22.38741192, 113.98130915, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810116', '1', '大埔区', '大埔区', 'da,pu,qu', 22.44825835, 114.16955959, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810117', '1', '荃湾区', '荃湾区', 'quan,wan,qu', 22.37149084, 114.12021000, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('810118', '1', '元朗区', '元朗区', 'yuan,lang,qu', 22.44244271, 114.03218146, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('811100', '1', '中西区', '中西区', 'zhong,xi,qu', 22.27622003, 114.16446035, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('811200', '1', '湾仔区', '湾仔区', 'wan,zi,qu', 22.27742209, 114.17737803, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('811300', '1', '东区', '东区', 'dong,qu', 22.28135362, 114.22910089, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('811400', '1', '南区', '南区', 'nan,qu', 22.24594584, 114.16089566, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('812100', '1', '油尖旺区', '油尖旺区', 'you,jian,wang,qu', 22.30670673, 114.17596347, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('812200', '1', '深水埗区', '深水埗区', 'shen,shui,bu,qu', 22.32916239, 114.16858880, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('812300', '1', '九龙城区', '九龙', 'jiu,long', 22.30899339, 114.19481061, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('812400', '1', '黄大仙区', '黄大仙区', 'huang,da,xian,qu', 22.33916329, 114.19764567, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('812500', '1', '观塘区', '观塘区', 'guan,tang,qu', 22.30674670, 114.23468946, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('813100', '1', '葵青区', '葵青区', 'kui,qing,qu', 22.36044285, 114.13659924, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('813200', '1', '荃湾区', '荃湾区', 'quan,wan,qu', 22.37149084, 114.12021000, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('813300', '1', '屯门区', '屯门区', 'tun,men,qu', 22.38741192, 113.98130915, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('813400', '1', '元朗区', '元朗区', 'yuan,lang,qu', 22.44244271, 114.03218146, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('813500', '1', '北区', '北区', 'bei,qu', 22.49223724, 114.14332872, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('813600', '1', '大埔区', '大埔区', 'da,pu,qu', 22.44825835, 114.16955959, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('813700', '1', '沙田区', '沙田区', 'sha,tian,qu', 22.38266598, 114.19194430, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('813800', '1', '西贡区', '西贡区', 'xi,gong,qu', 22.37902086, 114.27663621, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('813900', '1', '离岛区', '离岛区', 'li,dao,qu', 22.28558162, 113.94399967, '810000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('820000', '0', '澳门特别行政区', '澳门', 'ao,men', 22.18692700, 113.54307600, '0');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('820100', '1', '澳门半岛', '澳门半岛', 'ao,men,ban,dao', 22.19532800, 113.55282500, '820000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('820101', '1', '澳门半岛', '澳门半岛', 'ao,men,ban,dao', 22.18684000, 113.54294000, '820000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('820102', '1', '凼仔', '凼仔', 'dang,zi', 22.15473000, 113.55929000, '820000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('820103', '1', '路凼城', '路凼城', 'lu,dang,cheng', 22.13593695, 113.56365166, '820000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('820104', '1', '路环', '路环', 'lu,huan', 22.11501000, 113.55724000, '820000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('820200', '1', '氹仔岛', '氹仔岛', 'dang,zi,dao', 22.15402000, 113.56157000, '820000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('820300', '1', '路环岛', '路环岛', 'lu,huan,dao', 22.12346900, 113.57270500, '820000');
INSERT INTO `sys_district` (`id`, `type`, `name`, `short_name`, `pinyin`, `latitude`, `longitude`, `parent_id`)
VALUES ('820400', '1', '路氹城', '路氹城', 'lu,dang,cheng', 22.13864900, 113.56995700, '820000');
COMMIT;

-- ----------------------------
-- Table structure for sys_file
-- ----------------------------
DROP TABLE IF EXISTS `sys_file`;
CREATE TABLE `sys_file`
(
  `id`                bigint NOT NULL COMMENT '主键',
  `create_time`       datetime                                                      DEFAULT NULL COMMENT '创建时间',
  `create_id`         bigint                                                        DEFAULT NULL COMMENT '创建人',
  `create_name`       varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '创建人名称',
  `update_time`       datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`         bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name`       varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`         tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `url`               varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '文件访问地址',
  `size`              bigint                                                        DEFAULT NULL COMMENT '文件大小，单位字节',
  `filename`          varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '文件名称',
  `original_filename` varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '原始文件名',
  `base_path`         varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '基础存储路径',
  `path`              varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '存储路径',
  `ext`               varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci  DEFAULT NULL COMMENT '文件扩展名',
  `platform`          varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci  DEFAULT NULL COMMENT '存储平台',
  `th_url`            varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '缩略图访问路径',
  `th_filename`       varchar(256) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '缩略图名称',
  `th_size`           bigint                                                        DEFAULT NULL COMMENT '缩略图大小，单位字节',
  `th_content_type`   varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci  DEFAULT NULL COMMENT '缩略图MIME类型',
  `object_id`         varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '文件所属对象id,业务id',
  `object_type`       varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '文件所属对象类型，例如用户头像，评价图片',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='文件记录表';

-- ----------------------------
-- Records of sys_file
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for sys_group
-- ----------------------------
DROP TABLE IF EXISTS `sys_group`;
CREATE TABLE `sys_group`
(
  `id`            bigint                                                        NOT NULL COMMENT '主键',
  `create_time`   datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`     bigint                                                        NOT NULL COMMENT '创建人',
  `create_name`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time`   datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`     bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`     tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`     bigint                                                        NOT NULL COMMENT '租户id',
  `name`          varchar(255) COLLATE utf8mb4_general_ci                       NOT NULL COMMENT '名称',
  `description`   varchar(2555) COLLATE utf8mb4_general_ci                      DEFAULT NULL COMMENT '描述',
  `sort`          int                                                           NOT NULL COMMENT '排序值',
  `visible_scope` char(10) COLLATE utf8mb4_general_ci                           NOT NULL COMMENT '公开范围',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- ----------------------------
-- Records of sys_group
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for sys_group_user
-- ----------------------------
DROP TABLE IF EXISTS `sys_group_user`;
CREATE TABLE `sys_group_user`
(
  `id`          bigint                                                        NOT NULL COMMENT '主键',
  `create_time` datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`   bigint                                                        NOT NULL COMMENT '创建人',
  `create_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time` datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`   bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`   tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`   bigint                                                        NOT NULL COMMENT '租户id',
  `group_id`    bigint                                                        NOT NULL COMMENT '组id\n',
  `user_id`     bigint                                                        NOT NULL COMMENT '用户id\n',
  `type`        char(10) COLLATE utf8mb4_general_ci                           NOT NULL COMMENT '用户类型\n',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- ----------------------------
-- Records of sys_group_user
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for sys_menu
-- ----------------------------
DROP TABLE IF EXISTS `sys_menu`;
CREATE TABLE `sys_menu`
(
  `id`            bigint                                                        NOT NULL COMMENT '主键',
  `create_time`   datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`     bigint                                                        NOT NULL COMMENT '创建人',
  `create_name`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time`   datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`     bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`     tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `name`          varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '名称',
  `icon`          varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '图标',
  `path`          varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '路径',
  `permission`    varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '权限',
  `menu_type`     char(6) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci      NOT NULL COMMENT '类型(0菜单1按钮)',
  `platform_type` char(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci     NOT NULL COMMENT '平台类型(0平台1税务2服务商3商户)',
  `is_keep_alive` tinyint(1) NOT NULL COMMENT '是否缓冲',
  `sort`          int                                                           NOT NULL COMMENT '排序',
  `parent_id`     bigint                                                        DEFAULT NULL COMMENT '父id',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='菜单表';

-- ----------------------------
-- Records of sys_menu
-- ----------------------------
BEGIN;
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295052619781, '2021-11-03 14:00:33', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '组织架构',
        'fa fa-address-book-o', '/upms/sys', NULL, 'menu', 'sys', 0, 10, 0);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668357, '2021-11-03 14:01:21', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '成员管理', NULL,
        '/upms/user', '', 'menu', 'sys', 0, 10, 121173295052619781);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668358, '2021-11-03 14:01:31', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '角色管理', NULL,
        '/upms/role', '', 'menu', 'sys', 0, 20, 121173295052619781);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668359, '2021-11-03 14:01:45', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '菜单管理', NULL,
        '/upms/menu', '', 'menu', 'sys', 0, 10, 121173295053668363);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668360, '2021-11-03 14:51:39', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_user_add', 'button', 'sys', 0, 10, 121173295053668357);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668361, '2021-11-03 14:52:12', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_user_edit', 'button', 'sys', 0, 20, 121173295053668357);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668362, '2021-11-03 14:52:20', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_user_del', 'button', 'sys', 0, 30, 121173295053668357);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668363, '2021-11-04 17:00:36', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '系统管理',
        'fa fa-cog', '/upms/park', NULL, 'menu', 'sys', 0, 20, 0);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668364, '2021-11-04 18:06:54', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '租户管理', NULL,
        '/upms/tenant', '', 'menu', 'sys', 0, 0, 121173295053668363);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668365, '2021-11-05 09:19:30', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '套餐管理', NULL,
        '/upms/package', '', 'menu', 'sys', 0, 20, 121173295053668363);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668366, '2021-11-08 17:06:49', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL, '',
        'sys_role_add', 'button', 'sys', 0, 10, 121173295053668358);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668367, '2021-11-08 17:07:01', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_role_edit', 'button', 'sys', 0, 20, 121173295053668358);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668368, '2021-11-08 17:07:13', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_role_del', 'button', 'sys', 0, 30, 121173295053668358);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668369, '2021-11-08 17:07:27', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '权限', NULL,
        NULL, 'sys_role_permission', 'button', 'sys', 0, 40, 121173295053668358);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668370, '2021-11-09 16:31:43', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_package_add', 'button', 'sys', 0, 10, 121173295053668365);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668371, '2021-11-09 16:31:53', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_package_edit', 'button', 'sys', 0, 20, 121173295053668365);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668372, '2021-11-09 16:32:02', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_package_del', 'button', 'sys', 0, 30, 121173295053668365);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668373, '2021-11-09 16:32:19', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '权限', NULL,
        NULL, 'sys_package_permission', 'button', 'sys', 0, 40, 121173295053668365);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668374, '2021-11-11 16:33:03', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_menu_add', 'button', 'sys', 0, 1, 121173295053668359);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668375, '2021-11-11 16:33:16', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_menu_edit', 'button', 'sys', 0, 1, 121173295053668359);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668376, '2021-11-11 16:33:25', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_menu_del', 'button', 'sys', 0, 2, 121173295053668359);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668377, '2021-11-11 16:54:27', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_tenant_add', 'button', 'sys', 0, 10, 121173295053668364);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668378, '2021-11-11 16:54:35', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_tenant_edit', 'button', 'sys', 0, 20, 121173295053668364);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668379, '2021-11-11 16:54:52', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_tenant_del', 'button', 'sys', 0, 30, 121173295053668364);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668380, '2022-06-21 17:16:09', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '组织架构',
        'fa fa-address-book-o', '/upms/sys', NULL, 'menu', 'enterprise', 0, 10, 0);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668381, '2022-06-21 17:17:34', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '成员管理', NULL,
        '/upms/user', '', 'menu', 'enterprise', 0, 5, 121173295053668380);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668382, '2022-06-21 17:18:25', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL, '',
        'sys_user_add', 'button', 'enterprise', 0, 5, 121173295053668381);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668383, '2022-06-21 17:18:38', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_user_edit', 'button', 'enterprise', 0, 10, 121173295053668381);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668384, '2022-06-21 17:18:46', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_user_del', 'button', 'enterprise', 0, 20, 121173295053668381);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668385, '2022-06-21 17:19:05', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '角色管理', NULL,
        '/upms/role', '', 'menu', 'enterprise', 0, 10, 121173295053668380);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668386, '2022-06-21 17:20:18', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_role_add', 'button', 'enterprise', 0, 5, 121173295053668385);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668387, '2022-06-21 17:20:28', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_role_edit', 'button', 'enterprise', 0, 10, 121173295053668385);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668388, '2022-06-21 17:20:37', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_role_del', 'button', 'enterprise', 0, 20, 121173295053668385);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668389, '2022-06-22 18:35:21', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '权限', NULL,
        NULL, 'sys_role_permission', 'button', 'enterprise', 0, 30, 121173295053668385);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668390, '2022-06-24 17:19:09', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '通过', NULL,
        NULL, 'ent_enterprise_identity_pass', 'button', 'sys', 0, 5, 1540150360017477634);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668391, '2022-06-24 17:19:23', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '拒绝', NULL,
        NULL, 'ent_enterprise_identity_refuse', 'button', 'sys', 0, 10, 1540150360017477634);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668392, '2022-06-29 14:20:02', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '分类管理', NULL,
        '/ct/category', '', 'menu', 'enterprise', 0, 5, 1542029829737115650);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668393, '2022-06-29 14:20:21', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'ct_category_add', 'button', 'enterprise', 0, 5, 121173295053668392);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668394, '2022-06-29 14:20:36', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'ct_category_edit', 'button', 'enterprise', 0, 10, 121173295053668392);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668395, '2022-06-29 14:20:57', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'ct_category_del', 'button', 'enterprise', 0, 20, 121173295053668392);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668396, '2022-06-29 14:21:53', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '模版管理', NULL,
        '/ct/template', '', 'menu', 'enterprise', 0, 10, 1542029829737115650);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668397, '2022-06-29 14:22:09', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'ct_template_add', 'button', 'enterprise', 0, 5, 121173295053668396);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668398, '2022-06-29 14:22:21', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'ct_template_edit', 'button', 'enterprise', 0, 10, 121173295053668396);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668399, '2022-06-29 14:22:33', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'ct_template_del', 'button', 'enterprise', 0, 20, 121173295053668396);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668400, '2022-06-29 14:27:48', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '模版组管理',
        NULL, '/ct/template/group', '', 'menu', 'enterprise', 0, 20, 1542029829737115650);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668401, '2022-06-29 14:29:01', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'ct_template_group_add', 'button', 'enterprise', 0, 5, 121173295053668400);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668402, '2022-06-29 14:29:12', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'ct_template_group_edit', 'button', 'enterprise', 0, 10, 121173295053668400);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668403, '2022-06-29 14:29:25', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'ct_template_group_del', 'button', 'enterprise', 0, 20, 121173295053668400);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668404, '2022-06-30 09:43:57', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '部门管理', NULL,
        '/ent/dept', '', 'menu', 'enterprise', 0, 0, 1542322887179460610);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668405, '2022-06-30 09:45:39', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '岗位管理', NULL,
        '/ent/position', '', 'menu', 'enterprise', 0, 10, 1542322887179460610);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668406, '2022-06-30 09:45:57', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'ent_dept_add', 'button', 'enterprise', 0, 5, 121173295053668404);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668407, '2022-06-30 09:46:08', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'ent_dept_edit', 'button', 'enterprise', 0, 10, 121173295053668404);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668408, '2022-06-30 09:46:19', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'ent_dept_del', 'button', 'enterprise', 0, 20, 121173295053668404);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668409, '2022-06-30 09:46:37', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'ent_position_add', 'button', 'enterprise', 0, 5, 121173295053668405);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668410, '2022-06-30 09:46:48', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'ent_position_edit', 'button', 'enterprise', 0, 10, 121173295053668405);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668411, '2022-06-30 09:46:58', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'ent_position_del', 'button', 'enterprise', 0, 20, 121173295053668405);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668412, '2022-06-30 11:44:21', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '员工管理', NULL,
        '/ent/staff', '', 'menu', 'enterprise', 0, 20, 1542322887179460610);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668413, '2022-06-30 14:00:30', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '候选人管理',
        NULL, '/ent/candidate', '', 'menu', 'enterprise', 0, 0, 1544149052919685122);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668414, '2022-06-30 14:01:04', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'ent_candidate_add', 'button', 'enterprise', 0, 5, 121173295053668413);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668415, '2022-06-30 14:01:16', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'ent_candidate_edit', 'button', 'enterprise', 0, 10, 121173295053668413);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668416, '2022-06-30 14:01:24', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'ent_candidate_del', 'button', 'enterprise', 0, 20, 121173295053668413);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668417, '2022-07-04 21:21:07', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '合同库', NULL,
        '/ct/contract', '', 'menu', 'enterprise', 0, 0, 1542029829737115650);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668418, '2022-07-04 21:21:57', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '归档', NULL,
        NULL, 'ct_contract_filing', 'button', 'enterprise', 0, 5, 121173295053668417);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668419, '2022-07-05 10:44:09', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, 'Offer管理',
        NULL, '/ent/offer', '', 'menu', 'enterprise', 0, 10, 1544149052919685122);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668420, '2022-07-05 10:45:24', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '发送Offer',
        NULL, NULL, 'ent_candidate_send_offer', 'button', 'enterprise', 0, 40, 121173295053668413);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668421, '2022-07-05 10:46:26', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '撤销', NULL,
        NULL, 'ent_offer_del', 'button', 'enterprise', 0, 10, 121173295053668419);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668422, '2022-07-06 10:31:36', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '撤销', NULL,
        NULL, 'ct_contract_revoke', 'button', 'enterprise', 0, 10, 121173295053668417);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668423, '2022-07-06 15:04:55', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '转正', NULL,
        NULL, 'ent_staff_regular', 'button', 'enterprise', 0, 30, 121173295053668412);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668424, '2022-07-06 15:26:46', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '离职', NULL,
        NULL, 'ent_staff_leave', 'button', 'enterprise', 0, 50, 121173295053668412);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668425, '2022-07-25 10:50:43', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '入职管理', NULL,
        '/ent/induction', '', 'menu', 'enterprise', 0, 20, 1544149052919685122);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668426, '2022-07-25 11:04:09', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '办理入职', NULL,
        NULL, 'ent_induction_add', 'button', 'enterprise', 0, 10, 121173295053668425);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668427, '2022-07-25 17:49:32', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '消息通知配置',
        NULL, '/upms/notify/channel', '', 'menu', 'enterprise', 0, 20, 121173295053668476);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668428, '2022-07-25 17:50:08', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_notify_channel_edit', 'button', 'enterprise', 0, 0, 121173295053668427);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668429, '2022-07-25 18:29:26', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_notify_channel_del', 'button', 'enterprise', 0, 10, 121173295053668427);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668430, '2022-07-29 10:58:17', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '模版管理', NULL,
        NULL, 'ent_offer_template_manager', 'button', 'enterprise', 0, 5, 121173295053668419);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668431, '2022-08-04 14:30:19', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '调岗调薪', NULL,
        NULL, 'ent_staff_transfer', 'button', 'enterprise', 0, 40, 121173295053668412);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668432, '2022-08-12 15:40:27', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查看', NULL,
        NULL, 'sys_user_view', 'button', 'sys', 0, 0, 121173295053668357);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668433, '2022-08-12 16:22:35', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查看', NULL,
        NULL, 'sys_role_view', 'button', 'sys', 0, 0, 121173295053668358);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668434, '2022-08-12 17:14:38', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_menu_view', 'button', 'sys', 0, 0, 121173295053668359);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668435, '2022-08-12 17:15:05', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_package_view', 'button', 'sys', 0, 0, 121173295053668365);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668436, '2022-08-12 17:15:43', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_tenant_view', 'button', 'sys', 0, 0, 121173295053668364);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668437, '2022-08-12 17:16:14', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ent_enterprise_view', 'button', 'sys', 0, 0, 1540150360017477634);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668438, '2022-08-12 17:16:56', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_user_view', 'button', 'enterprise', 0, 0, 121173295053668381);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668439, '2022-08-12 17:17:14', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_role_view', 'button', 'enterprise', 0, 0, 121173295053668385);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668440, '2022-08-12 17:17:30', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_notify_channel_view', 'button', 'enterprise', 0, 0, 121173295053668427);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668441, '2022-08-12 17:17:57', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ent_dept_view', 'button', 'enterprise', 0, 0, 121173295053668404);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668442, '2022-08-12 17:18:14', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ent_position_view', 'button', 'enterprise', 0, 0, 121173295053668405);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668443, '2022-08-12 17:18:35', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ent_staff_view', 'button', 'enterprise', 0, 0, 121173295053668412);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668444, '2022-08-12 17:18:54', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ent_candidate_view', 'button', 'enterprise', 0, 0, 121173295053668413);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668445, '2022-08-12 17:19:43', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ent_offer_view', 'button', 'enterprise', 0, 0, 121173295053668419);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668446, '2022-08-12 17:19:58', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ent_induction_view', 'button', 'enterprise', 0, 0, 121173295053668425);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668447, '2022-08-12 17:20:17', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ct_contract_view', 'button', 'enterprise', 0, 0, 121173295053668417);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668448, '2022-08-12 17:20:33', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ct_category_view', 'button', 'enterprise', 0, 0, 121173295053668392);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668449, '2022-08-12 17:20:46', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ct_template_view', 'button', 'enterprise', 0, 0, 121173295053668396);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668450, '2022-08-12 17:21:00', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'ct_template_group_view', 'button', 'enterprise', 0, 0, 121173295053668400);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668451, '2022-08-22 17:36:28', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '招聘管理',
        'fa fa-skyatlas', '/recruit', NULL, 'menu', 'enterprise', 0, 30, 0);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668452, '2022-08-22 17:37:04', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '简历管理', NULL,
        '/recruit/resume', NULL, 'menu', 'enterprise', 0, 0, 121173295053668451);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668453, '2022-08-22 17:39:28', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查看', NULL,
        NULL, 'recruit_resume_view', 'button', 'enterprise', 0, 0, 121173295053668452);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668454, '2022-08-22 17:39:39', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'recruit_resume_add', 'button', 'enterprise', 0, 10, 121173295053668452);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668455, '2022-08-22 17:39:50', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'recruit_resume_edit', 'button', 'enterprise', 0, 20, 121173295053668452);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668456, '2022-08-22 17:39:59', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'recruit_resume_del', 'button', 'enterprise', 0, 30, 121173295053668452);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668457, '2022-12-02 11:32:32', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '部门管理', NULL,
        '/upms/dept', NULL, 'menu', 'enterprise', 0, 0, 121173295053668380);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668458, '2022-12-02 11:40:31', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_dept_view', 'button', 'enterprise', 0, 0, 121173295053668457);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668459, '2022-12-02 11:40:43', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_dept_add', 'button', 'enterprise', 0, 10, 121173295053668457);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668460, '2022-12-02 11:41:00', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', '', NULL,
        'sys_dept_edit', 'button', 'enterprise', 0, 20, 121173295053668457);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668461, '2022-12-02 11:41:10', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_dept_del', 'button', 'enterprise', 0, 30, 121173295053668457);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668462, '2022-12-07 17:59:58', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '成员管理', NULL,
        NULL, 'sys_dept_user_manager', 'button', 'enterprise', 0, 40, 121173295053668457);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668463, '2022-12-14 15:51:00', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '首页',
        'fa fa-home', '/', NULL, 'menu', 'enterprise', 0, 0, 0);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668464, '2022-12-14 15:56:38', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '首页',
        'fa fa-home', '/', NULL, 'menu', 'sys', 0, 0, 0);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668465, '2023-02-09 10:34:51', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '部门管理', NULL,
        '/upms/dept', NULL, 'menu', 'sys', 0, 0, 121173295052619781);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668466, '2023-02-09 10:35:27', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_dept_view', 'button', 'sys', 0, 0, 121173295053668465);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668467, '2023-02-09 10:35:39', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_dept_add', 'button', 'sys', 0, 10, 121173295053668465);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668468, '2023-02-09 10:35:51', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_dept_edit', 'button', 'sys', 0, 20, 121173295053668465);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668469, '2023-02-09 10:36:05', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_dept_del', 'button', 'sys', 0, 30, 121173295053668465);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668470, '2023-02-09 10:36:19', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '成员管理', NULL,
        NULL, 'sys_dept_user_manager', 'button', 'sys', 0, 40, 121173295053668465);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668471, '2023-07-14 14:23:33', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '字典管理', NULL,
        '/upms/dict', NULL, 'menu', 'sys', 0, 30, 121173295053668363);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668472, '2023-07-14 14:23:56', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_dict_view', 'button', 'sys', 0, 0, 121173295053668471);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668473, '2023-07-14 14:24:08', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_dict_add', 'button', 'sys', 0, 10, 121173295053668471);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668474, '2023-07-14 14:24:18', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_dict_edit', 'button', 'sys', 0, 20, 121173295053668471);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668475, '2023-07-14 14:24:29', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_dict_del', 'button', 'sys', 0, 30, 121173295053668471);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668476, '2023-08-09 11:01:06', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '系统管理',
        'fa fa-cog', '/upms/system', NULL, 'menu', 'enterprise', 0, 20, 0);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668477, '2023-08-10 11:05:13', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '字典管理', NULL,
        '/upms/dict', NULL, 'menu', 'enterprise', 0, 0, 121173295053668476);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668478, '2023-08-10 11:05:30', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_dict_view', 'button', 'enterprise', 0, 0, 121173295053668477);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668479, '2023-08-10 11:05:42', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_dict_add', 'button', 'enterprise', 0, 10, 121173295053668477);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668480, '2023-08-10 11:05:56', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_dict_edit', 'button', 'enterprise', 0, 20, 121173295053668477);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (121173295053668481, '2023-08-10 11:06:07', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_dict_del', 'button', 'enterprise', 0, 30, 121173295053668477);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122806790316359685, '2023-11-06 15:01:24', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '用户组管理',
        NULL, '/upms/group', NULL, 'menu', 'sys', 0, 30, 121173295052619781);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122806829931560965, '2023-11-06 15:02:02', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查看', NULL,
        NULL, 'sys_group_view', 'button', 'sys', 0, 0, 122806790316359685);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122806845622452229, '2023-11-06 15:02:17', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_group_add', 'button', 'sys', 0, 10, 122806790316359685);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122806857406349317, '2023-11-06 15:02:28', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_group_edit', 'button', 'sys', 0, 20, 122806790316359685);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122806873084657669, '2023-11-06 15:02:43', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_group_del', 'button', 'sys', 0, 30, 122806790316359685);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122806920419475461, '2023-11-06 15:03:28', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '成员管理', NULL,
        NULL, 'sys_group_user_manager', 'button', 'sys', 0, 40, 122806790316359685);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122806959145484293, '2023-11-06 15:04:05', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '用户组管理',
        NULL, '/upms/group', NULL, 'menu', 'enterprise', 0, 30, 121173295053668380);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122806977561624581, '2023-11-06 15:04:22', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '查询', NULL,
        NULL, 'sys_group_view', 'button', 'enterprise', 0, 0, 122806959145484293);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122806988066258949, '2023-11-06 15:04:32', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '新增', NULL,
        NULL, 'sys_group_add', 'button', 'enterprise', 0, 10, 122806959145484293);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122807000096571397, '2023-11-06 15:04:44', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '编辑', NULL,
        NULL, 'sys_group_edit', 'button', 'enterprise', 0, 20, 122806959145484293);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122807009333477381, '2023-11-06 15:04:53', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '删除', NULL,
        NULL, 'sys_group_del', 'button', 'enterprise', 0, 40, 122806959145484293);
INSERT INTO `sys_menu` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `name`, `icon`, `path`, `permission`, `menu_type`, `platform_type`,
                        `is_keep_alive`, `sort`, `parent_id`)
VALUES (122807195631878149, '2023-11-06 15:07:50', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '成员管理', NULL,
        NULL, 'sys_group_user_manager', 'button', 'enterprise', 0, 50, 122806959145484293);
COMMIT;

-- ----------------------------
-- Table structure for sys_notify_channel
-- ----------------------------
DROP TABLE IF EXISTS `sys_notify_channel`;
CREATE TABLE `sys_notify_channel`
(
  `id`          bigint                                                        NOT NULL COMMENT '主键',
  `create_time` datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`   bigint                                                        NOT NULL COMMENT '创建人',
  `create_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time` datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`   bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`   tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`   bigint                                                        NOT NULL COMMENT '租户id',
  `type`        char(6) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci      NOT NULL COMMENT '类型',
  `config`      text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci COMMENT '配置内容',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

-- ----------------------------
-- Records of sys_notify_channel
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for sys_package
-- ----------------------------
DROP TABLE IF EXISTS `sys_package`;
CREATE TABLE `sys_package`
(
  `id`          bigint                                                        NOT NULL COMMENT '主键',
  `create_time` datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`   bigint                                                        NOT NULL COMMENT '创建人',
  `create_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time` datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`   bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`   tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `name`        varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci  NOT NULL COMMENT '基础版、标准版、高级版',
  `description` varchar(512) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '描述',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='套餐表';

-- ----------------------------
-- Records of sys_package
-- ----------------------------
BEGIN;
INSERT INTO `sys_package` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                           `is_delete`, `name`, `description`)
VALUES (384098815180001, '2021-11-05 09:48:07', 1455466177605140000, '管理员', '2022-03-28 16:23:46',
        1455466177605140000, '管理员', 0, '基础版', '');
COMMIT;

-- ----------------------------
-- Table structure for sys_package_menu
-- ----------------------------
DROP TABLE IF EXISTS `sys_package_menu`;
CREATE TABLE `sys_package_menu`
(
  `package_id` bigint NOT NULL,
  `menu_id`    bigint NOT NULL,
  PRIMARY KEY (`package_id`, `menu_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='套餐菜单关联表';

-- ----------------------------
-- Records of sys_package_menu
-- ----------------------------
BEGIN;
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668380);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668381);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668382);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668383);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668384);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668385);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668386);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668387);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668388);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668389);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668427);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668428);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668429);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668438);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668439);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668440);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668451);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668452);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668453);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668454);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668455);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668456);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668457);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668458);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668459);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668460);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668461);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668462);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668463);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668476);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668477);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668478);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668479);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668480);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 121173295053668481);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 122806959145484293);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 122806977561624581);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 122806988066258949);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 122807000096571397);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 122807009333477381);
INSERT INTO `sys_package_menu` (`package_id`, `menu_id`)
VALUES (384098815180001, 122807195631878149);
COMMIT;

-- ----------------------------
-- Table structure for sys_role
-- ----------------------------
DROP TABLE IF EXISTS `sys_role`;
CREATE TABLE `sys_role`
(
  `id`            bigint                                                        NOT NULL COMMENT '主键',
  `create_time`   datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`     bigint                                                        NOT NULL COMMENT '创建人',
  `create_name`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time`   datetime                                                               DEFAULT NULL COMMENT '更新时间',
  `update_id`     bigint                                                                 DEFAULT NULL COMMENT '更新人',
  `update_name`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci          DEFAULT NULL COMMENT '更新人名称',
  `is_delete`     tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`     bigint                                                        NOT NULL COMMENT '租户id',
  `name`          varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '名称',
  `description`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci          DEFAULT NULL COMMENT '描述',
  `platform_type` char(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci     NOT NULL DEFAULT '0' COMMENT '平台类型(0平台1税务2服务商3商户)',
  `is_system`     tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否系统内置',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='角色表';

-- ----------------------------
-- Records of sys_role
-- ----------------------------
BEGIN;
INSERT INTO `sys_role` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `name`, `description`, `platform_type`, `is_system`)
VALUES (121172555985846277, '2023-10-19 14:05:56', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, 0, '运维', NULL,
        '0', 0);
INSERT INTO `sys_role` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `name`, `description`, `platform_type`, `is_system`)
VALUES (123695737932349445, '2023-11-16 10:30:50', 384098815180000, '平台管理员', NULL, NULL, NULL, 0,
        123695733642625029, '行政', NULL, 'enterprise', 0);
INSERT INTO `sys_role` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `name`, `description`, `platform_type`, `is_system`)
VALUES (123695737943883781, '2023-11-16 10:30:50', 384098815180000, '平台管理员', NULL, NULL, NULL, 0,
        123695733642625029, '人事', NULL, 'enterprise', 0);
INSERT INTO `sys_role` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `name`, `description`, `platform_type`, `is_system`)
VALUES (123695737955418117, '2023-11-16 10:30:50', 384098815180000, '平台管理员', NULL, NULL, NULL, 0,
        123695733642625029, '财务', NULL, 'enterprise', 0);
COMMIT;

-- ----------------------------
-- Table structure for sys_role_menu
-- ----------------------------
DROP TABLE IF EXISTS `sys_role_menu`;
CREATE TABLE `sys_role_menu`
(
  `role_id` bigint NOT NULL,
  `menu_id` bigint NOT NULL,
  PRIMARY KEY (`role_id`, `menu_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='角色菜单关联表';

-- ----------------------------
-- Records of sys_role_menu
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for sys_tenant
-- ----------------------------
DROP TABLE IF EXISTS `sys_tenant`;
CREATE TABLE `sys_tenant`
(
  `id`                       bigint                                                        NOT NULL COMMENT '主键',
  `create_time`              datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`                bigint                                                        NOT NULL COMMENT '创建人',
  `create_name`              varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time`              datetime                                                       DEFAULT NULL COMMENT '更新时间',
  `update_id`                bigint                                                         DEFAULT NULL COMMENT '更新人',
  `update_name`              varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci  DEFAULT NULL COMMENT '更新人名称',
  `is_delete`                tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `name`                     varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '名称',
  `short_name`               varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci   DEFAULT NULL COMMENT '简称',
  `logo`                     text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci COMMENT 'logo',
  `is_system`                tinyint(1) NOT NULL COMMENT '是否系统内置',
  `platform_type`            char(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci     NOT NULL COMMENT '平台类型(0平台1税务2服务商3商户)',
  `is_lock`                  tinyint(1) NOT NULL COMMENT '是否锁定',
  `package_ids`              varchar(2555) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '套餐ids',
  `enterprise_id`            bigint                                                         DEFAULT NULL COMMENT '企业端时对应的企业ID',
  `parent_id`                bigint                                                         DEFAULT NULL COMMENT '父级id（企业端对应园区的ID）',
  `expiration_date`          date                                                           DEFAULT NULL COMMENT '过期时间',
  `active_user_number_limit` int                                                            DEFAULT NULL COMMENT '活跃用户数限制(0表示不限制)',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='租户';

-- ----------------------------
-- Records of sys_tenant
-- ----------------------------
BEGIN;
INSERT INTO `sys_tenant` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                          `is_delete`, `name`, `short_name`, `logo`, `is_system`, `platform_type`, `is_lock`,
                          `package_ids`, `enterprise_id`, `parent_id`, `expiration_date`, `active_user_number_limit`)
VALUES (0, '2022-03-28 10:45:57', 384098815180000, '管理员', '2022-03-28 10:46:10', 384098815180000, '管理员', 0,
        '平台端', NULL, NULL, 1, 'sys', 0, NULL, NULL, NULL, '2999-12-31', 0);
INSERT INTO `sys_tenant` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                          `is_delete`, `name`, `short_name`, `logo`, `is_system`, `platform_type`, `is_lock`,
                          `package_ids`, `enterprise_id`, `parent_id`, `expiration_date`, `active_user_number_limit`)
VALUES (123695733642625029, '2023-11-16 10:30:46', 384098815180000, '平台管理员', NULL, NULL, NULL, 0, '苹果公司',
        '苹果公司', NULL, 0, 'enterprise', 0, '384098815180001', NULL, 0, '2999-12-31', 0);
COMMIT;

-- ----------------------------
-- Table structure for sys_user
-- ----------------------------
DROP TABLE IF EXISTS `sys_user`;
CREATE TABLE `sys_user`
(
  `id`            bigint                                                        NOT NULL COMMENT '主键',
  `create_time`   datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`     bigint                                                        NOT NULL COMMENT '创建人',
  `create_name`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time`   datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`     bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name`   varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`     tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`     bigint                                                        NOT NULL COMMENT '租户id',
  `phone`         char(11) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci     NOT NULL COMMENT '手机号',
  `email`         varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '电子邮件',
  `avatar_url`    text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci COMMENT '头像',
  `full_name`     varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '全名',
  `password`      varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '密码',
  `is_system`     tinyint(1) NOT NULL COMMENT '是否系统内置',
  `platform_type` varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci  NOT NULL COMMENT '平台类型(0平台1税务2服务商3商户)',
  `status`        varchar(20) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci  NOT NULL COMMENT '活动状态',
  `leader_id`     bigint                                                        DEFAULT NULL COMMENT '直属负责人id',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='平台用户表';

-- ----------------------------
-- Records of sys_user
-- ----------------------------
BEGIN;
INSERT INTO `sys_user` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `phone`, `email`, `avatar_url`, `full_name`, `password`, `is_system`,
                        `platform_type`, `status`, `leader_id`)
VALUES (384098815180000, '2021-11-02 17:15:33', 0, 'admin', '2021-11-09 16:58:23', 384098815180000, '管理员', 0, 0,
        '13685002786', 'super@admin.com', NULL, '平台管理员',
        'cdf4a007e2b02a0c49fc9b7ccfbb8a10c644f635e1765dcf2a7ab794ddc7edac', 1, 'sys', 'normal', NULL);
INSERT INTO `sys_user` (`id`, `create_time`, `create_id`, `create_name`, `update_time`, `update_id`, `update_name`,
                        `is_delete`, `tenant_id`, `phone`, `email`, `avatar_url`, `full_name`, `password`, `is_system`,
                        `platform_type`, `status`, `leader_id`)
VALUES (123695733730705413, '2023-11-16 10:30:46', 384098815180000, '平台管理员', NULL, NULL, NULL, 0,
        123695733642625029, '13685002786', NULL, NULL, '库克',
        'cdf4a007e2b02a0c49fc9b7ccfbb8a10c644f635e1765dcf2a7ab794ddc7edac', 1, 'enterprise', 'normal', NULL);
COMMIT;

-- ----------------------------
-- Table structure for sys_user_role
-- ----------------------------
DROP TABLE IF EXISTS `sys_user_role`;
CREATE TABLE `sys_user_role`
(
  `user_id` bigint NOT NULL COMMENT '用户id',
  `role_id` bigint NOT NULL COMMENT '角色id',
  PRIMARY KEY (`user_id`, `role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='用户角色关联表';

-- ----------------------------
-- Records of sys_user_role
-- ----------------------------
BEGIN;
COMMIT;

SET
FOREIGN_KEY_CHECKS = 1;


DROP TABLE IF EXISTS `sys_position`;
CREATE TABLE `sys_position`
(
  `id`          bigint                                                        NOT NULL COMMENT '主键',
  `create_time` datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`   bigint                                                        NOT NULL COMMENT '创建人',
  `create_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time` datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`   bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`   tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`   bigint                                                        NOT NULL COMMENT '租户id',
  `name`        varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '名称',
  `sort`        int                                                           DEFAULT NULL COMMENT '排序',
  `description` varchar(255) COLLATE utf8mb4_general_ci                       DEFAULT NULL COMMENT '说明',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;


DROP TABLE IF EXISTS `sys_position_user`;
CREATE TABLE `sys_position_user`
(
  `id`          bigint                                                        NOT NULL COMMENT '主键',
  `create_time` datetime                                                      NOT NULL COMMENT '创建时间',
  `create_id`   bigint                                                        NOT NULL COMMENT '创建人',
  `create_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '创建人名称',
  `update_time` datetime                                                      DEFAULT NULL COMMENT '更新时间',
  `update_id`   bigint                                                        DEFAULT NULL COMMENT '更新人',
  `update_name` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '更新人名称',
  `is_delete`   tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否删除(0否1是)',
  `tenant_id`   bigint                                                        NOT NULL COMMENT '租户id',
  `position_id` bigint                                                        DEFAULT NULL COMMENT '职位id',
  `user_id`     bigint                                                        DEFAULT NULL COMMENT '用户id',
  `type`        varchar(255) COLLATE utf8mb4_general_ci                       DEFAULT NULL COMMENT '岗位类型',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
